# -*- coding: utf-8 -*-
# This file is auto-generated, don't edit it. Thanks.
from Tea.model import TeaModel


class AddDataForApiSourceRequest(TeaModel):
    def __init__(self, api_id=None, content=None, iot_instance_id=None):
        self.api_id = api_id  # type: str
        self.content = content  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.api_id, 'api_id')
        self.validate_required(self.content, 'content')
        self.validate_required(self.iot_instance_id, 'iot_instance_id')

    def to_map(self):
        _map = super(AddDataForApiSourceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.api_id is not None:
            result['ApiId'] = self.api_id
        if self.content is not None:
            result['Content'] = self.content
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApiId') is not None:
            self.api_id = m.get('ApiId')
        if m.get('Content') is not None:
            self.content = m.get('Content')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class AddDataForApiSourceResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: long
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(AddDataForApiSourceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class AddShareTaskDeviceRequest(TeaModel):
    def __init__(self, iot_id_list=None, iot_instance_id=None, product_key=None, share_task_id=None):
        self.iot_id_list = iot_id_list  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.share_task_id = share_task_id  # type: str

    def validate(self):
        self.validate_required(self.share_task_id, 'share_task_id')

    def to_map(self):
        _map = super(AddShareTaskDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_id_list is not None:
            result['IotIdList'] = self.iot_id_list
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.share_task_id is not None:
            result['ShareTaskId'] = self.share_task_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotIdList') is not None:
            self.iot_id_list = m.get('IotIdList')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ShareTaskId') is not None:
            self.share_task_id = m.get('ShareTaskId')
        return self


class AddShareTaskDeviceResponseData(TeaModel):
    def __init__(self, progress=None, progress_id=None):
        self.progress = progress  # type: int
        self.progress_id = progress_id  # type: str

    def validate(self):
        self.validate_required(self.progress, 'progress')
        self.validate_required(self.progress_id, 'progress_id')

    def to_map(self):
        _map = super(AddShareTaskDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.progress is not None:
            result['Progress'] = self.progress
        if self.progress_id is not None:
            result['ProgressId'] = self.progress_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Progress') is not None:
            self.progress = m.get('Progress')
        if m.get('ProgressId') is not None:
            self.progress_id = m.get('ProgressId')
        return self


class AddShareTaskDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: AddShareTaskDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(AddShareTaskDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = AddShareTaskDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class AttachDestinationRequest(TeaModel):
    def __init__(self, destination_id=None, iot_instance_id=None, is_failover=None, parser_id=None):
        self.destination_id = destination_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str
        self.is_failover = is_failover  # type: bool
        self.parser_id = parser_id  # type: long

    def validate(self):
        self.validate_required(self.destination_id, 'destination_id')
        self.validate_required(self.is_failover, 'is_failover')
        self.validate_required(self.parser_id, 'parser_id')

    def to_map(self):
        _map = super(AttachDestinationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.destination_id is not None:
            result['DestinationId'] = self.destination_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.is_failover is not None:
            result['IsFailover'] = self.is_failover
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DestinationId') is not None:
            self.destination_id = m.get('DestinationId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('IsFailover') is not None:
            self.is_failover = m.get('IsFailover')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        return self


class AttachDestinationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(AttachDestinationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class AttachParserDataSourceRequest(TeaModel):
    def __init__(self, data_source_id=None, iot_instance_id=None, parser_id=None):
        self.data_source_id = data_source_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str
        self.parser_id = parser_id  # type: long

    def validate(self):
        self.validate_required(self.data_source_id, 'data_source_id')
        self.validate_required(self.parser_id, 'parser_id')

    def to_map(self):
        _map = super(AttachParserDataSourceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        return self


class AttachParserDataSourceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(AttachParserDataSourceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchAddDataForApiSourceRequest(TeaModel):
    def __init__(self, api_id=None, content_list=None, iot_instance_id=None):
        self.api_id = api_id  # type: str
        self.content_list = content_list  # type: dict[str, any]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.api_id, 'api_id')
        self.validate_required(self.content_list, 'content_list')
        self.validate_required(self.iot_instance_id, 'iot_instance_id')

    def to_map(self):
        _map = super(BatchAddDataForApiSourceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.api_id is not None:
            result['ApiId'] = self.api_id
        if self.content_list is not None:
            result['ContentList'] = self.content_list
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApiId') is not None:
            self.api_id = m.get('ApiId')
        if m.get('ContentList') is not None:
            self.content_list = m.get('ContentList')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchAddDataForApiSourceShrinkRequest(TeaModel):
    def __init__(self, api_id=None, content_list_shrink=None, iot_instance_id=None):
        self.api_id = api_id  # type: str
        self.content_list_shrink = content_list_shrink  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.api_id, 'api_id')
        self.validate_required(self.content_list_shrink, 'content_list_shrink')
        self.validate_required(self.iot_instance_id, 'iot_instance_id')

    def to_map(self):
        _map = super(BatchAddDataForApiSourceShrinkRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.api_id is not None:
            result['ApiId'] = self.api_id
        if self.content_list_shrink is not None:
            result['ContentList'] = self.content_list_shrink
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApiId') is not None:
            self.api_id = m.get('ApiId')
        if m.get('ContentList') is not None:
            self.content_list_shrink = m.get('ContentList')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchAddDataForApiSourceResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: dict[str, any]
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchAddDataForApiSourceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchAddDeviceGroupRelationsRequestDevice(TeaModel):
    def __init__(self, device_name=None, product_key=None):
        self.device_name = device_name  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchAddDeviceGroupRelationsRequestDevice, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchAddDeviceGroupRelationsRequest(TeaModel):
    def __init__(self, device=None, group_id=None, iot_instance_id=None):
        self.device = device  # type: list[BatchAddDeviceGroupRelationsRequestDevice]
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        if self.device:
            for k in self.device:
                if k:
                    k.validate()
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(BatchAddDeviceGroupRelationsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Device'] = []
        if self.device is not None:
            for k in self.device:
                result['Device'].append(k.to_map() if k else None)
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device = []
        if m.get('Device') is not None:
            for k in m.get('Device'):
                temp_model = BatchAddDeviceGroupRelationsRequestDevice()
                self.device.append(temp_model.from_map(k))
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchAddDeviceGroupRelationsResponse(TeaModel):
    def __init__(self, already_related_group_device_count=None, code=None, error_message=None,
                 exceed_ten_group_device_count=None, request_id=None, success=None, success_added_device_count=None, valid_device_count=None):
        self.already_related_group_device_count = already_related_group_device_count  # type: int
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.exceed_ten_group_device_count = exceed_ten_group_device_count  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.success_added_device_count = success_added_device_count  # type: int
        self.valid_device_count = valid_device_count  # type: int

    def validate(self):
        self.validate_required(self.already_related_group_device_count, 'already_related_group_device_count')
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.exceed_ten_group_device_count, 'exceed_ten_group_device_count')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.success_added_device_count, 'success_added_device_count')
        self.validate_required(self.valid_device_count, 'valid_device_count')

    def to_map(self):
        _map = super(BatchAddDeviceGroupRelationsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.already_related_group_device_count is not None:
            result['AlreadyRelatedGroupDeviceCount'] = self.already_related_group_device_count
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.exceed_ten_group_device_count is not None:
            result['ExceedTenGroupDeviceCount'] = self.exceed_ten_group_device_count
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.success_added_device_count is not None:
            result['SuccessAddedDeviceCount'] = self.success_added_device_count
        if self.valid_device_count is not None:
            result['ValidDeviceCount'] = self.valid_device_count
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AlreadyRelatedGroupDeviceCount') is not None:
            self.already_related_group_device_count = m.get('AlreadyRelatedGroupDeviceCount')
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('ExceedTenGroupDeviceCount') is not None:
            self.exceed_ten_group_device_count = m.get('ExceedTenGroupDeviceCount')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('SuccessAddedDeviceCount') is not None:
            self.success_added_device_count = m.get('SuccessAddedDeviceCount')
        if m.get('ValidDeviceCount') is not None:
            self.valid_device_count = m.get('ValidDeviceCount')
        return self


class BatchAddThingTopoRequestTopoAddItem(TeaModel):
    def __init__(self, client_id=None, device_name=None, product_key=None, sign=None, sign_method=None,
                 timestamp=None):
        self.client_id = client_id  # type: str
        self.device_name = device_name  # type: str
        self.product_key = product_key  # type: str
        self.sign = sign  # type: str
        self.sign_method = sign_method  # type: str
        self.timestamp = timestamp  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.sign, 'sign')
        self.validate_required(self.sign_method, 'sign_method')

    def to_map(self):
        _map = super(BatchAddThingTopoRequestTopoAddItem, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.client_id is not None:
            result['ClientId'] = self.client_id
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.sign is not None:
            result['Sign'] = self.sign
        if self.sign_method is not None:
            result['SignMethod'] = self.sign_method
        if self.timestamp is not None:
            result['Timestamp'] = self.timestamp
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ClientId') is not None:
            self.client_id = m.get('ClientId')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Sign') is not None:
            self.sign = m.get('Sign')
        if m.get('SignMethod') is not None:
            self.sign_method = m.get('SignMethod')
        if m.get('Timestamp') is not None:
            self.timestamp = m.get('Timestamp')
        return self


class BatchAddThingTopoRequest(TeaModel):
    def __init__(self, gw_device_name=None, gw_product_key=None, iot_instance_id=None, topo_add_item=None):
        self.gw_device_name = gw_device_name  # type: str
        self.gw_product_key = gw_product_key  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.topo_add_item = topo_add_item  # type: list[BatchAddThingTopoRequestTopoAddItem]

    def validate(self):
        self.validate_required(self.gw_device_name, 'gw_device_name')
        self.validate_required(self.gw_product_key, 'gw_product_key')
        self.validate_required(self.topo_add_item, 'topo_add_item')
        if self.topo_add_item:
            for k in self.topo_add_item:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchAddThingTopoRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gw_device_name is not None:
            result['GwDeviceName'] = self.gw_device_name
        if self.gw_product_key is not None:
            result['GwProductKey'] = self.gw_product_key
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        result['TopoAddItem'] = []
        if self.topo_add_item is not None:
            for k in self.topo_add_item:
                result['TopoAddItem'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GwDeviceName') is not None:
            self.gw_device_name = m.get('GwDeviceName')
        if m.get('GwProductKey') is not None:
            self.gw_product_key = m.get('GwProductKey')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        self.topo_add_item = []
        if m.get('TopoAddItem') is not None:
            for k in m.get('TopoAddItem'):
                temp_model = BatchAddThingTopoRequestTopoAddItem()
                self.topo_add_item.append(temp_model.from_map(k))
        return self


class BatchAddThingTopoResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchAddThingTopoResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchBindDeviceToEdgeInstanceWithDriverRequest(TeaModel):
    def __init__(self, driver_id=None, instance_id=None, iot_ids=None, iot_instance_id=None):
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_ids = iot_ids  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.iot_ids, 'iot_ids')

    def to_map(self):
        _map = super(BatchBindDeviceToEdgeInstanceWithDriverRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_ids is not None:
            result['IotIds'] = self.iot_ids
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotIds') is not None:
            self.iot_ids = m.get('IotIds')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchBindDeviceToEdgeInstanceWithDriverResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchBindDeviceToEdgeInstanceWithDriverResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchBindDevicesIntoProjectRequestDevices(TeaModel):
    def __init__(self, device_name=None, product_key=None):
        self.device_name = device_name  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchBindDevicesIntoProjectRequestDevices, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchBindDevicesIntoProjectRequest(TeaModel):
    def __init__(self, devices=None, iot_instance_id=None, project_id=None):
        self.devices = devices  # type: list[BatchBindDevicesIntoProjectRequestDevices]
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.devices, 'devices')
        if self.devices:
            for k in self.devices:
                if k:
                    k.validate()
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(BatchBindDevicesIntoProjectRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Devices'] = []
        if self.devices is not None:
            for k in self.devices:
                result['Devices'].append(k.to_map() if k else None)
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.devices = []
        if m.get('Devices') is not None:
            for k in m.get('Devices'):
                temp_model = BatchBindDevicesIntoProjectRequestDevices()
                self.devices.append(temp_model.from_map(k))
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class BatchBindDevicesIntoProjectResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: bool
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchBindDevicesIntoProjectResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchBindProductsIntoProjectRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_keys=None, project_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_keys = product_keys  # type: list[str]
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.product_keys, 'product_keys')
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(BatchBindProductsIntoProjectRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_keys is not None:
            result['ProductKeys'] = self.product_keys
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKeys') is not None:
            self.product_keys = m.get('ProductKeys')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class BatchBindProductsIntoProjectResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: bool
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchBindProductsIntoProjectResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchCheckDeviceNamesRequestDeviceNameList(TeaModel):
    def __init__(self, device_name=None, device_nickname=None):
        self.device_name = device_name  # type: str
        self.device_nickname = device_nickname  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(BatchCheckDeviceNamesRequestDeviceNameList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_nickname is not None:
            result['DeviceNickname'] = self.device_nickname
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceNickname') is not None:
            self.device_nickname = m.get('DeviceNickname')
        return self


class BatchCheckDeviceNamesRequest(TeaModel):
    def __init__(self, device_name=None, device_name_list=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: list[str]
        self.device_name_list = device_name_list  # type: list[BatchCheckDeviceNamesRequestDeviceNameList]
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        if self.device_name_list:
            for k in self.device_name_list:
                if k:
                    k.validate()
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchCheckDeviceNamesRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        result['DeviceNameList'] = []
        if self.device_name_list is not None:
            for k in self.device_name_list:
                result['DeviceNameList'].append(k.to_map() if k else None)
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        self.device_name_list = []
        if m.get('DeviceNameList') is not None:
            for k in m.get('DeviceNameList'):
                temp_model = BatchCheckDeviceNamesRequestDeviceNameList()
                self.device_name_list.append(temp_model.from_map(k))
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchCheckDeviceNamesResponseDataInvalidDeviceNameList(TeaModel):
    def __init__(self, invalid_device_name=None):
        # InvalidDeviceName
        self.invalid_device_name = invalid_device_name  # type: list[str]

    def validate(self):
        self.validate_required(self.invalid_device_name, 'invalid_device_name')

    def to_map(self):
        _map = super(BatchCheckDeviceNamesResponseDataInvalidDeviceNameList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.invalid_device_name is not None:
            result['InvalidDeviceName'] = self.invalid_device_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InvalidDeviceName') is not None:
            self.invalid_device_name = m.get('InvalidDeviceName')
        return self


class BatchCheckDeviceNamesResponseDataInvalidDeviceNicknameList(TeaModel):
    def __init__(self, invalid_device_nickname=None):
        # InvalidDeviceNickname
        self.invalid_device_nickname = invalid_device_nickname  # type: list[str]

    def validate(self):
        self.validate_required(self.invalid_device_nickname, 'invalid_device_nickname')

    def to_map(self):
        _map = super(BatchCheckDeviceNamesResponseDataInvalidDeviceNicknameList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.invalid_device_nickname is not None:
            result['InvalidDeviceNickname'] = self.invalid_device_nickname
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InvalidDeviceNickname') is not None:
            self.invalid_device_nickname = m.get('InvalidDeviceNickname')
        return self


class BatchCheckDeviceNamesResponseData(TeaModel):
    def __init__(self, apply_id=None, invalid_device_name_list=None, invalid_device_nickname_list=None):
        self.apply_id = apply_id  # type: long
        self.invalid_device_name_list = invalid_device_name_list  # type: BatchCheckDeviceNamesResponseDataInvalidDeviceNameList
        self.invalid_device_nickname_list = invalid_device_nickname_list  # type: BatchCheckDeviceNamesResponseDataInvalidDeviceNicknameList

    def validate(self):
        self.validate_required(self.apply_id, 'apply_id')
        self.validate_required(self.invalid_device_name_list, 'invalid_device_name_list')
        if self.invalid_device_name_list:
            self.invalid_device_name_list.validate()
        self.validate_required(self.invalid_device_nickname_list, 'invalid_device_nickname_list')
        if self.invalid_device_nickname_list:
            self.invalid_device_nickname_list.validate()

    def to_map(self):
        _map = super(BatchCheckDeviceNamesResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.apply_id is not None:
            result['ApplyId'] = self.apply_id
        if self.invalid_device_name_list is not None:
            result['InvalidDeviceNameList'] = self.invalid_device_name_list.to_map()
        if self.invalid_device_nickname_list is not None:
            result['InvalidDeviceNicknameList'] = self.invalid_device_nickname_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplyId') is not None:
            self.apply_id = m.get('ApplyId')
        if m.get('InvalidDeviceNameList') is not None:
            temp_model = BatchCheckDeviceNamesResponseDataInvalidDeviceNameList()
            self.invalid_device_name_list = temp_model.from_map(m['InvalidDeviceNameList'])
        if m.get('InvalidDeviceNicknameList') is not None:
            temp_model = BatchCheckDeviceNamesResponseDataInvalidDeviceNicknameList()
            self.invalid_device_nickname_list = temp_model.from_map(m['InvalidDeviceNicknameList'])
        return self


class BatchCheckDeviceNamesResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: BatchCheckDeviceNamesResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(BatchCheckDeviceNamesResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = BatchCheckDeviceNamesResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class BatchCheckImportDeviceRequestDeviceList(TeaModel):
    def __init__(self, device_name=None, device_secret=None, sn=None):
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.sn = sn  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')

    def to_map(self):
        _map = super(BatchCheckImportDeviceRequestDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.sn is not None:
            result['Sn'] = self.sn
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('Sn') is not None:
            self.sn = m.get('Sn')
        return self


class BatchCheckImportDeviceRequest(TeaModel):
    def __init__(self, device_list=None, iot_instance_id=None, product_key=None):
        self.device_list = device_list  # type: list[BatchCheckImportDeviceRequestDeviceList]
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_list, 'device_list')
        if self.device_list:
            for k in self.device_list:
                if k:
                    k.validate()
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchCheckImportDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DeviceList'] = []
        if self.device_list is not None:
            for k in self.device_list:
                result['DeviceList'].append(k.to_map() if k else None)
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_list = []
        if m.get('DeviceList') is not None:
            for k in m.get('DeviceList'):
                temp_model = BatchCheckImportDeviceRequestDeviceList()
                self.device_list.append(temp_model.from_map(k))
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchCheckImportDeviceResponseData(TeaModel):
    def __init__(self, invalid_device_name_list=None, invalid_device_secret_list=None, invalid_sn_list=None,
                 repeated_device_name_list=None):
        self.invalid_device_name_list = invalid_device_name_list  # type: list[str]
        self.invalid_device_secret_list = invalid_device_secret_list  # type: list[str]
        self.invalid_sn_list = invalid_sn_list  # type: list[str]
        self.repeated_device_name_list = repeated_device_name_list  # type: list[str]

    def validate(self):
        self.validate_required(self.invalid_device_name_list, 'invalid_device_name_list')
        self.validate_required(self.invalid_device_secret_list, 'invalid_device_secret_list')
        self.validate_required(self.invalid_sn_list, 'invalid_sn_list')
        self.validate_required(self.repeated_device_name_list, 'repeated_device_name_list')

    def to_map(self):
        _map = super(BatchCheckImportDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.invalid_device_name_list is not None:
            result['InvalidDeviceNameList'] = self.invalid_device_name_list
        if self.invalid_device_secret_list is not None:
            result['InvalidDeviceSecretList'] = self.invalid_device_secret_list
        if self.invalid_sn_list is not None:
            result['InvalidSnList'] = self.invalid_sn_list
        if self.repeated_device_name_list is not None:
            result['RepeatedDeviceNameList'] = self.repeated_device_name_list
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InvalidDeviceNameList') is not None:
            self.invalid_device_name_list = m.get('InvalidDeviceNameList')
        if m.get('InvalidDeviceSecretList') is not None:
            self.invalid_device_secret_list = m.get('InvalidDeviceSecretList')
        if m.get('InvalidSnList') is not None:
            self.invalid_sn_list = m.get('InvalidSnList')
        if m.get('RepeatedDeviceNameList') is not None:
            self.repeated_device_name_list = m.get('RepeatedDeviceNameList')
        return self


class BatchCheckImportDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: BatchCheckImportDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(BatchCheckImportDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = BatchCheckImportDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class BatchCheckVehicleDeviceRequestDeviceList(TeaModel):
    def __init__(self, device_id=None, device_model=None, manufacturer=None):
        self.device_id = device_id  # type: str
        self.device_model = device_model  # type: str
        self.manufacturer = manufacturer  # type: str

    def validate(self):
        self.validate_required(self.device_model, 'device_model')
        self.validate_required(self.manufacturer, 'manufacturer')

    def to_map(self):
        _map = super(BatchCheckVehicleDeviceRequestDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_id is not None:
            result['DeviceId'] = self.device_id
        if self.device_model is not None:
            result['DeviceModel'] = self.device_model
        if self.manufacturer is not None:
            result['Manufacturer'] = self.manufacturer
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceId') is not None:
            self.device_id = m.get('DeviceId')
        if m.get('DeviceModel') is not None:
            self.device_model = m.get('DeviceModel')
        if m.get('Manufacturer') is not None:
            self.manufacturer = m.get('Manufacturer')
        return self


class BatchCheckVehicleDeviceRequest(TeaModel):
    def __init__(self, device_list=None, iot_instance_id=None, product_key=None):
        self.device_list = device_list  # type: list[BatchCheckVehicleDeviceRequestDeviceList]
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_list, 'device_list')
        if self.device_list:
            for k in self.device_list:
                if k:
                    k.validate()
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchCheckVehicleDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DeviceList'] = []
        if self.device_list is not None:
            for k in self.device_list:
                result['DeviceList'].append(k.to_map() if k else None)
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_list = []
        if m.get('DeviceList') is not None:
            for k in m.get('DeviceList'):
                temp_model = BatchCheckVehicleDeviceRequestDeviceList()
                self.device_list.append(temp_model.from_map(k))
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchCheckVehicleDeviceResponseData(TeaModel):
    def __init__(self, invalid_device_id_list=None, invalid_device_model_list=None,
                 invalid_manufacturer_list=None, repeated_device_id_list=None):
        self.invalid_device_id_list = invalid_device_id_list  # type: list[str]
        self.invalid_device_model_list = invalid_device_model_list  # type: list[str]
        self.invalid_manufacturer_list = invalid_manufacturer_list  # type: list[str]
        self.repeated_device_id_list = repeated_device_id_list  # type: list[str]

    def validate(self):
        self.validate_required(self.invalid_device_id_list, 'invalid_device_id_list')
        self.validate_required(self.invalid_device_model_list, 'invalid_device_model_list')
        self.validate_required(self.invalid_manufacturer_list, 'invalid_manufacturer_list')
        self.validate_required(self.repeated_device_id_list, 'repeated_device_id_list')

    def to_map(self):
        _map = super(BatchCheckVehicleDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.invalid_device_id_list is not None:
            result['InvalidDeviceIdList'] = self.invalid_device_id_list
        if self.invalid_device_model_list is not None:
            result['InvalidDeviceModelList'] = self.invalid_device_model_list
        if self.invalid_manufacturer_list is not None:
            result['InvalidManufacturerList'] = self.invalid_manufacturer_list
        if self.repeated_device_id_list is not None:
            result['RepeatedDeviceIdList'] = self.repeated_device_id_list
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InvalidDeviceIdList') is not None:
            self.invalid_device_id_list = m.get('InvalidDeviceIdList')
        if m.get('InvalidDeviceModelList') is not None:
            self.invalid_device_model_list = m.get('InvalidDeviceModelList')
        if m.get('InvalidManufacturerList') is not None:
            self.invalid_manufacturer_list = m.get('InvalidManufacturerList')
        if m.get('RepeatedDeviceIdList') is not None:
            self.repeated_device_id_list = m.get('RepeatedDeviceIdList')
        return self


class BatchCheckVehicleDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: BatchCheckVehicleDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(BatchCheckVehicleDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = BatchCheckVehicleDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class BatchClearEdgeInstanceDeviceConfigRequest(TeaModel):
    def __init__(self, instance_id=None, iot_ids=None, iot_instance_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_ids = iot_ids  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.iot_ids, 'iot_ids')

    def to_map(self):
        _map = super(BatchClearEdgeInstanceDeviceConfigRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_ids is not None:
            result['IotIds'] = self.iot_ids
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotIds') is not None:
            self.iot_ids = m.get('IotIds')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchClearEdgeInstanceDeviceConfigResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchClearEdgeInstanceDeviceConfigResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchCreateSoundCodeLabelRequest(TeaModel):
    def __init__(self, description=None, iot_instance_id=None, schedule_code=None, total=None):
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.schedule_code = schedule_code  # type: str
        self.total = total  # type: int

    def validate(self):
        self.validate_required(self.schedule_code, 'schedule_code')
        self.validate_required(self.total, 'total')

    def to_map(self):
        _map = super(BatchCreateSoundCodeLabelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        if self.total is not None:
            result['Total'] = self.total
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        return self


class BatchCreateSoundCodeLabelResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchCreateSoundCodeLabelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchCreateSoundCodeLabelWithLabelsRequest(TeaModel):
    def __init__(self, description=None, iot_instance_id=None, labels=None, schedule_code=None):
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.labels = labels  # type: list[str]
        self.schedule_code = schedule_code  # type: str

    def validate(self):
        self.validate_required(self.labels, 'labels')
        self.validate_required(self.schedule_code, 'schedule_code')

    def to_map(self):
        _map = super(BatchCreateSoundCodeLabelWithLabelsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.labels is not None:
            result['Labels'] = self.labels
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Labels') is not None:
            self.labels = m.get('Labels')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        return self


class BatchCreateSoundCodeLabelWithLabelsResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchCreateSoundCodeLabelWithLabelsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchDeleteDeviceGroupRelationsRequestDevice(TeaModel):
    def __init__(self, device_name=None, product_key=None):
        self.device_name = device_name  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchDeleteDeviceGroupRelationsRequestDevice, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchDeleteDeviceGroupRelationsRequest(TeaModel):
    def __init__(self, device=None, group_id=None, iot_instance_id=None):
        self.device = device  # type: list[BatchDeleteDeviceGroupRelationsRequestDevice]
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        if self.device:
            for k in self.device:
                if k:
                    k.validate()
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(BatchDeleteDeviceGroupRelationsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Device'] = []
        if self.device is not None:
            for k in self.device:
                result['Device'].append(k.to_map() if k else None)
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device = []
        if m.get('Device') is not None:
            for k in m.get('Device'):
                temp_model = BatchDeleteDeviceGroupRelationsRequestDevice()
                self.device.append(temp_model.from_map(k))
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchDeleteDeviceGroupRelationsResponse(TeaModel):
    def __init__(self, already_related_group_device_count=None, code=None, error_message=None, request_id=None,
                 success=None, success_device_count=None, valid_device_count=None):
        self.already_related_group_device_count = already_related_group_device_count  # type: int
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.success_device_count = success_device_count  # type: int
        self.valid_device_count = valid_device_count  # type: int

    def validate(self):
        self.validate_required(self.already_related_group_device_count, 'already_related_group_device_count')
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.success_device_count, 'success_device_count')
        self.validate_required(self.valid_device_count, 'valid_device_count')

    def to_map(self):
        _map = super(BatchDeleteDeviceGroupRelationsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.already_related_group_device_count is not None:
            result['AlreadyRelatedGroupDeviceCount'] = self.already_related_group_device_count
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.success_device_count is not None:
            result['SuccessDeviceCount'] = self.success_device_count
        if self.valid_device_count is not None:
            result['ValidDeviceCount'] = self.valid_device_count
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AlreadyRelatedGroupDeviceCount') is not None:
            self.already_related_group_device_count = m.get('AlreadyRelatedGroupDeviceCount')
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('SuccessDeviceCount') is not None:
            self.success_device_count = m.get('SuccessDeviceCount')
        if m.get('ValidDeviceCount') is not None:
            self.valid_device_count = m.get('ValidDeviceCount')
        return self


class BatchDeleteEdgeInstanceChannelRequest(TeaModel):
    def __init__(self, channel_ids=None, driver_id=None, instance_id=None, iot_instance_id=None):
        self.channel_ids = channel_ids  # type: list[str]
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.channel_ids, 'channel_ids')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(BatchDeleteEdgeInstanceChannelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.channel_ids is not None:
            result['ChannelIds'] = self.channel_ids
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ChannelIds') is not None:
            self.channel_ids = m.get('ChannelIds')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchDeleteEdgeInstanceChannelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchDeleteEdgeInstanceChannelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchGetDeviceBindStatusRequest(TeaModel):
    def __init__(self, iot_ids=None, iot_instance_id=None):
        self.iot_ids = iot_ids  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.iot_ids, 'iot_ids')

    def to_map(self):
        _map = super(BatchGetDeviceBindStatusRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_ids is not None:
            result['IotIds'] = self.iot_ids
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotIds') is not None:
            self.iot_ids = m.get('IotIds')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchGetDeviceBindStatusResponseData(TeaModel):
    def __init__(self, bind_status=None, instance_id=None, iot_id=None):
        self.bind_status = bind_status  # type: int
        self.instance_id = instance_id  # type: str
        self.iot_id = iot_id  # type: str

    def validate(self):
        self.validate_required(self.bind_status, 'bind_status')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(BatchGetDeviceBindStatusResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.bind_status is not None:
            result['BindStatus'] = self.bind_status
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BindStatus') is not None:
            self.bind_status = m.get('BindStatus')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        return self


class BatchGetDeviceBindStatusResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: list[BatchGetDeviceBindStatusResponseData]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            for k in self.data:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchGetDeviceBindStatusResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        result['Data'] = []
        if self.data is not None:
            for k in self.data:
                result['Data'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        self.data = []
        if m.get('Data') is not None:
            for k in m.get('Data'):
                temp_model = BatchGetDeviceBindStatusResponseData()
                self.data.append(temp_model.from_map(k))
        return self


class BatchGetDeviceStateRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: list[str]
        self.iot_id = iot_id  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(BatchGetDeviceStateRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchGetDeviceStateResponseDeviceStatusListDeviceStatus(TeaModel):
    def __init__(self, as_address=None, device_id=None, device_name=None, iot_id=None, last_online_time=None,
                 status=None):
        self.as_address = as_address  # type: str
        self.device_id = device_id  # type: str
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.last_online_time = last_online_time  # type: str
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.as_address, 'as_address')
        self.validate_required(self.device_id, 'device_id')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.last_online_time, 'last_online_time')
        self.validate_required(self.status, 'status')

    def to_map(self):
        _map = super(BatchGetDeviceStateResponseDeviceStatusListDeviceStatus, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.as_address is not None:
            result['AsAddress'] = self.as_address
        if self.device_id is not None:
            result['DeviceId'] = self.device_id
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.last_online_time is not None:
            result['LastOnlineTime'] = self.last_online_time
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AsAddress') is not None:
            self.as_address = m.get('AsAddress')
        if m.get('DeviceId') is not None:
            self.device_id = m.get('DeviceId')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('LastOnlineTime') is not None:
            self.last_online_time = m.get('LastOnlineTime')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class BatchGetDeviceStateResponseDeviceStatusList(TeaModel):
    def __init__(self, device_status=None):
        self.device_status = device_status  # type: list[BatchGetDeviceStateResponseDeviceStatusListDeviceStatus]

    def validate(self):
        self.validate_required(self.device_status, 'device_status')
        if self.device_status:
            for k in self.device_status:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchGetDeviceStateResponseDeviceStatusList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DeviceStatus'] = []
        if self.device_status is not None:
            for k in self.device_status:
                result['DeviceStatus'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_status = []
        if m.get('DeviceStatus') is not None:
            for k in m.get('DeviceStatus'):
                temp_model = BatchGetDeviceStateResponseDeviceStatusListDeviceStatus()
                self.device_status.append(temp_model.from_map(k))
        return self


class BatchGetDeviceStateResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, device_status_list=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.device_status_list = device_status_list  # type: BatchGetDeviceStateResponseDeviceStatusList

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.device_status_list, 'device_status_list')
        if self.device_status_list:
            self.device_status_list.validate()

    def to_map(self):
        _map = super(BatchGetDeviceStateResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.device_status_list is not None:
            result['DeviceStatusList'] = self.device_status_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('DeviceStatusList') is not None:
            temp_model = BatchGetDeviceStateResponseDeviceStatusList()
            self.device_status_list = temp_model.from_map(m['DeviceStatusList'])
        return self


class BatchGetEdgeDriverRequest(TeaModel):
    def __init__(self, driver_ids=None, iot_instance_id=None):
        self.driver_ids = driver_ids  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.driver_ids, 'driver_ids')

    def to_map(self):
        _map = super(BatchGetEdgeDriverRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_ids is not None:
            result['DriverIds'] = self.driver_ids
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverIds') is not None:
            self.driver_ids = m.get('DriverIds')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchGetEdgeDriverResponseDriverList(TeaModel):
    def __init__(self, cpu_arch=None, driver_id=None, driver_name=None, driver_protocol=None,
                 gmt_create_timestamp=None, gmt_modified_timestamp=None, is_built_in=None, runtime=None, type=None):
        self.cpu_arch = cpu_arch  # type: str
        self.driver_id = driver_id  # type: str
        self.driver_name = driver_name  # type: str
        self.driver_protocol = driver_protocol  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.is_built_in = is_built_in  # type: bool
        self.runtime = runtime  # type: str
        self.type = type  # type: int

    def validate(self):
        self.validate_required(self.cpu_arch, 'cpu_arch')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.driver_name, 'driver_name')
        self.validate_required(self.driver_protocol, 'driver_protocol')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.is_built_in, 'is_built_in')
        self.validate_required(self.runtime, 'runtime')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(BatchGetEdgeDriverResponseDriverList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.cpu_arch is not None:
            result['CpuArch'] = self.cpu_arch
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_name is not None:
            result['DriverName'] = self.driver_name
        if self.driver_protocol is not None:
            result['DriverProtocol'] = self.driver_protocol
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.is_built_in is not None:
            result['IsBuiltIn'] = self.is_built_in
        if self.runtime is not None:
            result['Runtime'] = self.runtime
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CpuArch') is not None:
            self.cpu_arch = m.get('CpuArch')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverName') is not None:
            self.driver_name = m.get('DriverName')
        if m.get('DriverProtocol') is not None:
            self.driver_protocol = m.get('DriverProtocol')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('IsBuiltIn') is not None:
            self.is_built_in = m.get('IsBuiltIn')
        if m.get('Runtime') is not None:
            self.runtime = m.get('Runtime')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class BatchGetEdgeDriverResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, driver_list=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.driver_list = driver_list  # type: list[BatchGetEdgeDriverResponseDriverList]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.driver_list, 'driver_list')
        if self.driver_list:
            for k in self.driver_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchGetEdgeDriverResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        result['DriverList'] = []
        if self.driver_list is not None:
            for k in self.driver_list:
                result['DriverList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        self.driver_list = []
        if m.get('DriverList') is not None:
            for k in m.get('DriverList'):
                temp_model = BatchGetEdgeDriverResponseDriverList()
                self.driver_list.append(temp_model.from_map(k))
        return self


class BatchGetEdgeInstanceChannelRequest(TeaModel):
    def __init__(self, channel_ids=None, driver_id=None, instance_id=None, iot_instance_id=None):
        self.channel_ids = channel_ids  # type: list[str]
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.channel_ids, 'channel_ids')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(BatchGetEdgeInstanceChannelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.channel_ids is not None:
            result['ChannelIds'] = self.channel_ids
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ChannelIds') is not None:
            self.channel_ids = m.get('ChannelIds')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchGetEdgeInstanceChannelResponseDataChannelConfigListConfig(TeaModel):
    def __init__(self, config_id=None, content=None, format=None, key=None):
        self.config_id = config_id  # type: str
        self.content = content  # type: str
        self.format = format  # type: str
        self.key = key  # type: str

    def validate(self):
        self.validate_required(self.config_id, 'config_id')
        self.validate_required(self.content, 'content')
        self.validate_required(self.format, 'format')
        self.validate_required(self.key, 'key')

    def to_map(self):
        _map = super(BatchGetEdgeInstanceChannelResponseDataChannelConfigListConfig, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.config_id is not None:
            result['ConfigId'] = self.config_id
        if self.content is not None:
            result['Content'] = self.content
        if self.format is not None:
            result['Format'] = self.format
        if self.key is not None:
            result['Key'] = self.key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ConfigId') is not None:
            self.config_id = m.get('ConfigId')
        if m.get('Content') is not None:
            self.content = m.get('Content')
        if m.get('Format') is not None:
            self.format = m.get('Format')
        if m.get('Key') is not None:
            self.key = m.get('Key')
        return self


class BatchGetEdgeInstanceChannelResponseDataChannelConfigList(TeaModel):
    def __init__(self, config=None):
        self.config = config  # type: list[BatchGetEdgeInstanceChannelResponseDataChannelConfigListConfig]

    def validate(self):
        self.validate_required(self.config, 'config')
        if self.config:
            for k in self.config:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchGetEdgeInstanceChannelResponseDataChannelConfigList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Config'] = []
        if self.config is not None:
            for k in self.config:
                result['Config'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.config = []
        if m.get('Config') is not None:
            for k in m.get('Config'):
                temp_model = BatchGetEdgeInstanceChannelResponseDataChannelConfigListConfig()
                self.config.append(temp_model.from_map(k))
        return self


class BatchGetEdgeInstanceChannelResponseDataChannel(TeaModel):
    def __init__(self, channel_id=None, channel_name=None, config_list=None):
        self.channel_id = channel_id  # type: str
        self.channel_name = channel_name  # type: str
        self.config_list = config_list  # type: BatchGetEdgeInstanceChannelResponseDataChannelConfigList

    def validate(self):
        self.validate_required(self.channel_id, 'channel_id')
        self.validate_required(self.channel_name, 'channel_name')
        self.validate_required(self.config_list, 'config_list')
        if self.config_list:
            self.config_list.validate()

    def to_map(self):
        _map = super(BatchGetEdgeInstanceChannelResponseDataChannel, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.channel_id is not None:
            result['ChannelId'] = self.channel_id
        if self.channel_name is not None:
            result['ChannelName'] = self.channel_name
        if self.config_list is not None:
            result['ConfigList'] = self.config_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ChannelId') is not None:
            self.channel_id = m.get('ChannelId')
        if m.get('ChannelName') is not None:
            self.channel_name = m.get('ChannelName')
        if m.get('ConfigList') is not None:
            temp_model = BatchGetEdgeInstanceChannelResponseDataChannelConfigList()
            self.config_list = temp_model.from_map(m['ConfigList'])
        return self


class BatchGetEdgeInstanceChannelResponseData(TeaModel):
    def __init__(self, channel=None):
        self.channel = channel  # type: list[BatchGetEdgeInstanceChannelResponseDataChannel]

    def validate(self):
        self.validate_required(self.channel, 'channel')
        if self.channel:
            for k in self.channel:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchGetEdgeInstanceChannelResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Channel'] = []
        if self.channel is not None:
            for k in self.channel:
                result['Channel'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.channel = []
        if m.get('Channel') is not None:
            for k in m.get('Channel'):
                temp_model = BatchGetEdgeInstanceChannelResponseDataChannel()
                self.channel.append(temp_model.from_map(k))
        return self


class BatchGetEdgeInstanceChannelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: BatchGetEdgeInstanceChannelResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(BatchGetEdgeInstanceChannelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = BatchGetEdgeInstanceChannelResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class BatchGetEdgeInstanceDeviceChannelRequest(TeaModel):
    def __init__(self, driver_id=None, instance_id=None, iot_ids=None, iot_instance_id=None):
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_ids = iot_ids  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.iot_ids, 'iot_ids')

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDeviceChannelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_ids is not None:
            result['IotIds'] = self.iot_ids
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotIds') is not None:
            self.iot_ids = m.get('IotIds')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchGetEdgeInstanceDeviceChannelResponseDeviceChannelList(TeaModel):
    def __init__(self, channel_id=None, channel_name=None, iot_id=None):
        self.channel_id = channel_id  # type: str
        self.channel_name = channel_name  # type: str
        self.iot_id = iot_id  # type: str

    def validate(self):
        self.validate_required(self.channel_id, 'channel_id')
        self.validate_required(self.channel_name, 'channel_name')
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDeviceChannelResponseDeviceChannelList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.channel_id is not None:
            result['ChannelId'] = self.channel_id
        if self.channel_name is not None:
            result['ChannelName'] = self.channel_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ChannelId') is not None:
            self.channel_id = m.get('ChannelId')
        if m.get('ChannelName') is not None:
            self.channel_name = m.get('ChannelName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        return self


class BatchGetEdgeInstanceDeviceChannelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, device_channel_list=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.device_channel_list = device_channel_list  # type: list[BatchGetEdgeInstanceDeviceChannelResponseDeviceChannelList]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.device_channel_list, 'device_channel_list')
        if self.device_channel_list:
            for k in self.device_channel_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDeviceChannelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        result['DeviceChannelList'] = []
        if self.device_channel_list is not None:
            for k in self.device_channel_list:
                result['DeviceChannelList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        self.device_channel_list = []
        if m.get('DeviceChannelList') is not None:
            for k in m.get('DeviceChannelList'):
                temp_model = BatchGetEdgeInstanceDeviceChannelResponseDeviceChannelList()
                self.device_channel_list.append(temp_model.from_map(k))
        return self


class BatchGetEdgeInstanceDeviceConfigRequest(TeaModel):
    def __init__(self, instance_id=None, iot_ids=None, iot_instance_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_ids = iot_ids  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.iot_ids, 'iot_ids')

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDeviceConfigRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_ids is not None:
            result['IotIds'] = self.iot_ids
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotIds') is not None:
            self.iot_ids = m.get('IotIds')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchGetEdgeInstanceDeviceConfigResponseDeviceConfigListConfig(TeaModel):
    def __init__(self, content=None, format=None):
        self.content = content  # type: str
        self.format = format  # type: str

    def validate(self):
        self.validate_required(self.content, 'content')
        self.validate_required(self.format, 'format')

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDeviceConfigResponseDeviceConfigListConfig, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.content is not None:
            result['Content'] = self.content
        if self.format is not None:
            result['Format'] = self.format
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Content') is not None:
            self.content = m.get('Content')
        if m.get('Format') is not None:
            self.format = m.get('Format')
        return self


class BatchGetEdgeInstanceDeviceConfigResponseDeviceConfigList(TeaModel):
    def __init__(self, iot_id=None, config=None):
        self.iot_id = iot_id  # type: str
        self.config = config  # type: BatchGetEdgeInstanceDeviceConfigResponseDeviceConfigListConfig

    def validate(self):
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.config, 'config')
        if self.config:
            self.config.validate()

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDeviceConfigResponseDeviceConfigList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.config is not None:
            result['Config'] = self.config.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('Config') is not None:
            temp_model = BatchGetEdgeInstanceDeviceConfigResponseDeviceConfigListConfig()
            self.config = temp_model.from_map(m['Config'])
        return self


class BatchGetEdgeInstanceDeviceConfigResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, device_config_list=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.device_config_list = device_config_list  # type: list[BatchGetEdgeInstanceDeviceConfigResponseDeviceConfigList]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.device_config_list, 'device_config_list')
        if self.device_config_list:
            for k in self.device_config_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDeviceConfigResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        result['DeviceConfigList'] = []
        if self.device_config_list is not None:
            for k in self.device_config_list:
                result['DeviceConfigList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        self.device_config_list = []
        if m.get('DeviceConfigList') is not None:
            for k in m.get('DeviceConfigList'):
                temp_model = BatchGetEdgeInstanceDeviceConfigResponseDeviceConfigList()
                self.device_config_list.append(temp_model.from_map(k))
        return self


class BatchGetEdgeInstanceDeviceDriverRequest(TeaModel):
    def __init__(self, instance_id=None, iot_ids=None, iot_instance_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_ids = iot_ids  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.iot_ids, 'iot_ids')

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDeviceDriverRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_ids is not None:
            result['IotIds'] = self.iot_ids
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotIds') is not None:
            self.iot_ids = m.get('IotIds')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchGetEdgeInstanceDeviceDriverResponseDeviceDriverList(TeaModel):
    def __init__(self, driver_id=None, iot_id=None):
        self.driver_id = driver_id  # type: str
        self.iot_id = iot_id  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDeviceDriverResponseDeviceDriverList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        return self


class BatchGetEdgeInstanceDeviceDriverResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, device_driver_list=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.device_driver_list = device_driver_list  # type: list[BatchGetEdgeInstanceDeviceDriverResponseDeviceDriverList]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.device_driver_list, 'device_driver_list')
        if self.device_driver_list:
            for k in self.device_driver_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDeviceDriverResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        result['DeviceDriverList'] = []
        if self.device_driver_list is not None:
            for k in self.device_driver_list:
                result['DeviceDriverList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        self.device_driver_list = []
        if m.get('DeviceDriverList') is not None:
            for k in m.get('DeviceDriverList'):
                temp_model = BatchGetEdgeInstanceDeviceDriverResponseDeviceDriverList()
                self.device_driver_list.append(temp_model.from_map(k))
        return self


class BatchGetEdgeInstanceDriverConfigsRequest(TeaModel):
    def __init__(self, driver_ids=None, instance_id=None, iot_instance_id=None):
        self.driver_ids = driver_ids  # type: list[str]
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.driver_ids, 'driver_ids')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDriverConfigsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_ids is not None:
            result['DriverIds'] = self.driver_ids
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverIds') is not None:
            self.driver_ids = m.get('DriverIds')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchGetEdgeInstanceDriverConfigsResponseDriverConfigListConfigList(TeaModel):
    def __init__(self, config_id=None, content=None, format=None, key=None):
        self.config_id = config_id  # type: str
        self.content = content  # type: str
        self.format = format  # type: str
        self.key = key  # type: str

    def validate(self):
        self.validate_required(self.config_id, 'config_id')
        self.validate_required(self.content, 'content')
        self.validate_required(self.format, 'format')
        self.validate_required(self.key, 'key')

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDriverConfigsResponseDriverConfigListConfigList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.config_id is not None:
            result['ConfigId'] = self.config_id
        if self.content is not None:
            result['Content'] = self.content
        if self.format is not None:
            result['Format'] = self.format
        if self.key is not None:
            result['Key'] = self.key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ConfigId') is not None:
            self.config_id = m.get('ConfigId')
        if m.get('Content') is not None:
            self.content = m.get('Content')
        if m.get('Format') is not None:
            self.format = m.get('Format')
        if m.get('Key') is not None:
            self.key = m.get('Key')
        return self


class BatchGetEdgeInstanceDriverConfigsResponseDriverConfigList(TeaModel):
    def __init__(self, driver_id=None, config_list=None):
        self.driver_id = driver_id  # type: str
        self.config_list = config_list  # type: list[BatchGetEdgeInstanceDriverConfigsResponseDriverConfigListConfigList]

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.config_list, 'config_list')
        if self.config_list:
            for k in self.config_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDriverConfigsResponseDriverConfigList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        result['ConfigList'] = []
        if self.config_list is not None:
            for k in self.config_list:
                result['ConfigList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        self.config_list = []
        if m.get('ConfigList') is not None:
            for k in m.get('ConfigList'):
                temp_model = BatchGetEdgeInstanceDriverConfigsResponseDriverConfigListConfigList()
                self.config_list.append(temp_model.from_map(k))
        return self


class BatchGetEdgeInstanceDriverConfigsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, driver_config_list=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.driver_config_list = driver_config_list  # type: list[BatchGetEdgeInstanceDriverConfigsResponseDriverConfigList]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.driver_config_list, 'driver_config_list')
        if self.driver_config_list:
            for k in self.driver_config_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchGetEdgeInstanceDriverConfigsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        result['DriverConfigList'] = []
        if self.driver_config_list is not None:
            for k in self.driver_config_list:
                result['DriverConfigList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        self.driver_config_list = []
        if m.get('DriverConfigList') is not None:
            for k in m.get('DriverConfigList'):
                temp_model = BatchGetEdgeInstanceDriverConfigsResponseDriverConfigList()
                self.driver_config_list.append(temp_model.from_map(k))
        return self


class BatchImportDeviceRequestDeviceList(TeaModel):
    def __init__(self, device_name=None, device_secret=None, sn=None):
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.sn = sn  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')

    def to_map(self):
        _map = super(BatchImportDeviceRequestDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.sn is not None:
            result['Sn'] = self.sn
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('Sn') is not None:
            self.sn = m.get('Sn')
        return self


class BatchImportDeviceRequest(TeaModel):
    def __init__(self, device_list=None, iot_instance_id=None, product_key=None):
        self.device_list = device_list  # type: list[BatchImportDeviceRequestDeviceList]
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_list, 'device_list')
        if self.device_list:
            for k in self.device_list:
                if k:
                    k.validate()
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchImportDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DeviceList'] = []
        if self.device_list is not None:
            for k in self.device_list:
                result['DeviceList'].append(k.to_map() if k else None)
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_list = []
        if m.get('DeviceList') is not None:
            for k in m.get('DeviceList'):
                temp_model = BatchImportDeviceRequestDeviceList()
                self.device_list.append(temp_model.from_map(k))
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchImportDeviceResponseDataInvalidDeviceNameList(TeaModel):
    def __init__(self, invalid_device_name=None):
        # invalidDeviceName
        self.invalid_device_name = invalid_device_name  # type: list[str]

    def validate(self):
        self.validate_required(self.invalid_device_name, 'invalid_device_name')

    def to_map(self):
        _map = super(BatchImportDeviceResponseDataInvalidDeviceNameList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.invalid_device_name is not None:
            result['invalidDeviceName'] = self.invalid_device_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('invalidDeviceName') is not None:
            self.invalid_device_name = m.get('invalidDeviceName')
        return self


class BatchImportDeviceResponseDataInvalidDeviceSecretList(TeaModel):
    def __init__(self, invalid_device_secret=None):
        # invalidDeviceSecret
        self.invalid_device_secret = invalid_device_secret  # type: list[str]

    def validate(self):
        self.validate_required(self.invalid_device_secret, 'invalid_device_secret')

    def to_map(self):
        _map = super(BatchImportDeviceResponseDataInvalidDeviceSecretList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.invalid_device_secret is not None:
            result['invalidDeviceSecret'] = self.invalid_device_secret
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('invalidDeviceSecret') is not None:
            self.invalid_device_secret = m.get('invalidDeviceSecret')
        return self


class BatchImportDeviceResponseDataInvalidSnList(TeaModel):
    def __init__(self, invalid_sn=None):
        # invalidSn
        self.invalid_sn = invalid_sn  # type: list[str]

    def validate(self):
        self.validate_required(self.invalid_sn, 'invalid_sn')

    def to_map(self):
        _map = super(BatchImportDeviceResponseDataInvalidSnList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.invalid_sn is not None:
            result['invalidSn'] = self.invalid_sn
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('invalidSn') is not None:
            self.invalid_sn = m.get('invalidSn')
        return self


class BatchImportDeviceResponseDataRepeatedDeviceNameList(TeaModel):
    def __init__(self, repeated_device_name=None):
        # repeatedDeviceName
        self.repeated_device_name = repeated_device_name  # type: list[str]

    def validate(self):
        self.validate_required(self.repeated_device_name, 'repeated_device_name')

    def to_map(self):
        _map = super(BatchImportDeviceResponseDataRepeatedDeviceNameList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.repeated_device_name is not None:
            result['repeatedDeviceName'] = self.repeated_device_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('repeatedDeviceName') is not None:
            self.repeated_device_name = m.get('repeatedDeviceName')
        return self


class BatchImportDeviceResponseData(TeaModel):
    def __init__(self, apply_id=None, invalid_device_name_list=None, invalid_device_secret_list=None,
                 invalid_sn_list=None, repeated_device_name_list=None):
        self.apply_id = apply_id  # type: long
        self.invalid_device_name_list = invalid_device_name_list  # type: BatchImportDeviceResponseDataInvalidDeviceNameList
        self.invalid_device_secret_list = invalid_device_secret_list  # type: BatchImportDeviceResponseDataInvalidDeviceSecretList
        self.invalid_sn_list = invalid_sn_list  # type: BatchImportDeviceResponseDataInvalidSnList
        self.repeated_device_name_list = repeated_device_name_list  # type: BatchImportDeviceResponseDataRepeatedDeviceNameList

    def validate(self):
        self.validate_required(self.apply_id, 'apply_id')
        self.validate_required(self.invalid_device_name_list, 'invalid_device_name_list')
        if self.invalid_device_name_list:
            self.invalid_device_name_list.validate()
        self.validate_required(self.invalid_device_secret_list, 'invalid_device_secret_list')
        if self.invalid_device_secret_list:
            self.invalid_device_secret_list.validate()
        self.validate_required(self.invalid_sn_list, 'invalid_sn_list')
        if self.invalid_sn_list:
            self.invalid_sn_list.validate()
        self.validate_required(self.repeated_device_name_list, 'repeated_device_name_list')
        if self.repeated_device_name_list:
            self.repeated_device_name_list.validate()

    def to_map(self):
        _map = super(BatchImportDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.apply_id is not None:
            result['ApplyId'] = self.apply_id
        if self.invalid_device_name_list is not None:
            result['InvalidDeviceNameList'] = self.invalid_device_name_list.to_map()
        if self.invalid_device_secret_list is not None:
            result['InvalidDeviceSecretList'] = self.invalid_device_secret_list.to_map()
        if self.invalid_sn_list is not None:
            result['InvalidSnList'] = self.invalid_sn_list.to_map()
        if self.repeated_device_name_list is not None:
            result['RepeatedDeviceNameList'] = self.repeated_device_name_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplyId') is not None:
            self.apply_id = m.get('ApplyId')
        if m.get('InvalidDeviceNameList') is not None:
            temp_model = BatchImportDeviceResponseDataInvalidDeviceNameList()
            self.invalid_device_name_list = temp_model.from_map(m['InvalidDeviceNameList'])
        if m.get('InvalidDeviceSecretList') is not None:
            temp_model = BatchImportDeviceResponseDataInvalidDeviceSecretList()
            self.invalid_device_secret_list = temp_model.from_map(m['InvalidDeviceSecretList'])
        if m.get('InvalidSnList') is not None:
            temp_model = BatchImportDeviceResponseDataInvalidSnList()
            self.invalid_sn_list = temp_model.from_map(m['InvalidSnList'])
        if m.get('RepeatedDeviceNameList') is not None:
            temp_model = BatchImportDeviceResponseDataRepeatedDeviceNameList()
            self.repeated_device_name_list = temp_model.from_map(m['RepeatedDeviceNameList'])
        return self


class BatchImportDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: BatchImportDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(BatchImportDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = BatchImportDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class BatchImportVehicleDeviceRequestDeviceList(TeaModel):
    def __init__(self, device_id=None, device_model=None, manufacturer=None):
        self.device_id = device_id  # type: str
        self.device_model = device_model  # type: str
        self.manufacturer = manufacturer  # type: str

    def validate(self):
        self.validate_required(self.device_model, 'device_model')
        self.validate_required(self.manufacturer, 'manufacturer')

    def to_map(self):
        _map = super(BatchImportVehicleDeviceRequestDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_id is not None:
            result['DeviceId'] = self.device_id
        if self.device_model is not None:
            result['DeviceModel'] = self.device_model
        if self.manufacturer is not None:
            result['Manufacturer'] = self.manufacturer
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceId') is not None:
            self.device_id = m.get('DeviceId')
        if m.get('DeviceModel') is not None:
            self.device_model = m.get('DeviceModel')
        if m.get('Manufacturer') is not None:
            self.manufacturer = m.get('Manufacturer')
        return self


class BatchImportVehicleDeviceRequest(TeaModel):
    def __init__(self, device_list=None, iot_instance_id=None, product_key=None):
        self.device_list = device_list  # type: list[BatchImportVehicleDeviceRequestDeviceList]
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_list, 'device_list')
        if self.device_list:
            for k in self.device_list:
                if k:
                    k.validate()
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchImportVehicleDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DeviceList'] = []
        if self.device_list is not None:
            for k in self.device_list:
                result['DeviceList'].append(k.to_map() if k else None)
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_list = []
        if m.get('DeviceList') is not None:
            for k in m.get('DeviceList'):
                temp_model = BatchImportVehicleDeviceRequestDeviceList()
                self.device_list.append(temp_model.from_map(k))
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchImportVehicleDeviceResponseData(TeaModel):
    def __init__(self, apply_id=None):
        self.apply_id = apply_id  # type: long

    def validate(self):
        self.validate_required(self.apply_id, 'apply_id')

    def to_map(self):
        _map = super(BatchImportVehicleDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.apply_id is not None:
            result['ApplyId'] = self.apply_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplyId') is not None:
            self.apply_id = m.get('ApplyId')
        return self


class BatchImportVehicleDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: BatchImportVehicleDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(BatchImportVehicleDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = BatchImportVehicleDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class BatchPubRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, message_content=None, product_key=None, qos=None,
                 topic_short_name=None):
        self.device_name = device_name  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.message_content = message_content  # type: str
        self.product_key = product_key  # type: str
        self.qos = qos  # type: int
        self.topic_short_name = topic_short_name  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.message_content, 'message_content')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.topic_short_name, 'topic_short_name')

    def to_map(self):
        _map = super(BatchPubRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.message_content is not None:
            result['MessageContent'] = self.message_content
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.qos is not None:
            result['Qos'] = self.qos
        if self.topic_short_name is not None:
            result['TopicShortName'] = self.topic_short_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('MessageContent') is not None:
            self.message_content = m.get('MessageContent')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Qos') is not None:
            self.qos = m.get('Qos')
        if m.get('TopicShortName') is not None:
            self.topic_short_name = m.get('TopicShortName')
        return self


class BatchPubResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchPubResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchQueryDeviceDetailRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchQueryDeviceDetailRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchQueryDeviceDetailResponseDataData(TeaModel):
    def __init__(self, device_name=None, device_secret=None, firmware_version=None, gmt_active=None,
                 gmt_create=None, iot_id=None, nickname=None, node_type=None, product_key=None, product_name=None, region=None,
                 status=None, utc_active=None, utc_create=None):
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.firmware_version = firmware_version  # type: str
        self.gmt_active = gmt_active  # type: str
        self.gmt_create = gmt_create  # type: str
        self.iot_id = iot_id  # type: str
        self.nickname = nickname  # type: str
        self.node_type = node_type  # type: int
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str
        self.region = region  # type: str
        self.status = status  # type: str
        self.utc_active = utc_active  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')
        self.validate_required(self.firmware_version, 'firmware_version')
        self.validate_required(self.gmt_active, 'gmt_active')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.nickname, 'nickname')
        self.validate_required(self.node_type, 'node_type')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')
        self.validate_required(self.region, 'region')
        self.validate_required(self.status, 'status')
        self.validate_required(self.utc_active, 'utc_active')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(BatchQueryDeviceDetailResponseDataData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.firmware_version is not None:
            result['FirmwareVersion'] = self.firmware_version
        if self.gmt_active is not None:
            result['GmtActive'] = self.gmt_active
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.node_type is not None:
            result['NodeType'] = self.node_type
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.region is not None:
            result['Region'] = self.region
        if self.status is not None:
            result['Status'] = self.status
        if self.utc_active is not None:
            result['UtcActive'] = self.utc_active
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('FirmwareVersion') is not None:
            self.firmware_version = m.get('FirmwareVersion')
        if m.get('GmtActive') is not None:
            self.gmt_active = m.get('GmtActive')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('NodeType') is not None:
            self.node_type = m.get('NodeType')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('Region') is not None:
            self.region = m.get('Region')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('UtcActive') is not None:
            self.utc_active = m.get('UtcActive')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class BatchQueryDeviceDetailResponseData(TeaModel):
    def __init__(self, data=None):
        self.data = data  # type: list[BatchQueryDeviceDetailResponseDataData]

    def validate(self):
        self.validate_required(self.data, 'data')
        if self.data:
            for k in self.data:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchQueryDeviceDetailResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Data'] = []
        if self.data is not None:
            for k in self.data:
                result['Data'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.data = []
        if m.get('Data') is not None:
            for k in m.get('Data'):
                temp_model = BatchQueryDeviceDetailResponseDataData()
                self.data.append(temp_model.from_map(k))
        return self


class BatchQueryDeviceDetailResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: BatchQueryDeviceDetailResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(BatchQueryDeviceDetailResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = BatchQueryDeviceDetailResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class BatchRegisterDeviceRequest(TeaModel):
    def __init__(self, count=None, iot_instance_id=None, product_key=None):
        self.count = count  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.count, 'count')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchRegisterDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.count is not None:
            result['Count'] = self.count
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Count') is not None:
            self.count = m.get('Count')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchRegisterDeviceResponseData(TeaModel):
    def __init__(self, apply_id=None):
        self.apply_id = apply_id  # type: long

    def validate(self):
        self.validate_required(self.apply_id, 'apply_id')

    def to_map(self):
        _map = super(BatchRegisterDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.apply_id is not None:
            result['ApplyId'] = self.apply_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplyId') is not None:
            self.apply_id = m.get('ApplyId')
        return self


class BatchRegisterDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: BatchRegisterDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(BatchRegisterDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = BatchRegisterDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class BatchRegisterDeviceWithApplyIdRequest(TeaModel):
    def __init__(self, apply_id=None, iot_instance_id=None, product_key=None):
        self.apply_id = apply_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.apply_id, 'apply_id')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchRegisterDeviceWithApplyIdRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.apply_id is not None:
            result['ApplyId'] = self.apply_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplyId') is not None:
            self.apply_id = m.get('ApplyId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchRegisterDeviceWithApplyIdResponseData(TeaModel):
    def __init__(self, apply_id=None):
        self.apply_id = apply_id  # type: long

    def validate(self):
        self.validate_required(self.apply_id, 'apply_id')

    def to_map(self):
        _map = super(BatchRegisterDeviceWithApplyIdResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.apply_id is not None:
            result['ApplyId'] = self.apply_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplyId') is not None:
            self.apply_id = m.get('ApplyId')
        return self


class BatchRegisterDeviceWithApplyIdResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: BatchRegisterDeviceWithApplyIdResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(BatchRegisterDeviceWithApplyIdResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = BatchRegisterDeviceWithApplyIdResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class BatchSetEdgeInstanceDeviceChannelRequest(TeaModel):
    def __init__(self, channel_id=None, driver_id=None, instance_id=None, iot_ids=None, iot_instance_id=None):
        self.channel_id = channel_id  # type: str
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_ids = iot_ids  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.channel_id, 'channel_id')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.iot_ids, 'iot_ids')

    def to_map(self):
        _map = super(BatchSetEdgeInstanceDeviceChannelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.channel_id is not None:
            result['ChannelId'] = self.channel_id
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_ids is not None:
            result['IotIds'] = self.iot_ids
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ChannelId') is not None:
            self.channel_id = m.get('ChannelId')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotIds') is not None:
            self.iot_ids = m.get('IotIds')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchSetEdgeInstanceDeviceChannelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchSetEdgeInstanceDeviceChannelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchSetEdgeInstanceDeviceConfigRequestDeviceConfigs(TeaModel):
    def __init__(self, content=None, iot_id=None):
        self.content = content  # type: str
        self.iot_id = iot_id  # type: str

    def validate(self):
        self.validate_required(self.content, 'content')
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(BatchSetEdgeInstanceDeviceConfigRequestDeviceConfigs, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.content is not None:
            result['Content'] = self.content
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Content') is not None:
            self.content = m.get('Content')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        return self


class BatchSetEdgeInstanceDeviceConfigRequest(TeaModel):
    def __init__(self, device_configs=None, instance_id=None, iot_instance_id=None):
        self.device_configs = device_configs  # type: list[BatchSetEdgeInstanceDeviceConfigRequestDeviceConfigs]
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.device_configs, 'device_configs')
        if self.device_configs:
            for k in self.device_configs:
                if k:
                    k.validate()
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(BatchSetEdgeInstanceDeviceConfigRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DeviceConfigs'] = []
        if self.device_configs is not None:
            for k in self.device_configs:
                result['DeviceConfigs'].append(k.to_map() if k else None)
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_configs = []
        if m.get('DeviceConfigs') is not None:
            for k in m.get('DeviceConfigs'):
                temp_model = BatchSetEdgeInstanceDeviceConfigRequestDeviceConfigs()
                self.device_configs.append(temp_model.from_map(k))
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchSetEdgeInstanceDeviceConfigResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchSetEdgeInstanceDeviceConfigResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchUnbindDeviceFromEdgeInstanceRequest(TeaModel):
    def __init__(self, instance_id=None, iot_ids=None, iot_instance_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_ids = iot_ids  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.iot_ids, 'iot_ids')

    def to_map(self):
        _map = super(BatchUnbindDeviceFromEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_ids is not None:
            result['IotIds'] = self.iot_ids
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotIds') is not None:
            self.iot_ids = m.get('IotIds')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchUnbindDeviceFromEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchUnbindDeviceFromEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchUnbindProjectDevicesRequestDevices(TeaModel):
    def __init__(self, device_name=None, product_key=None):
        self.device_name = device_name  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BatchUnbindProjectDevicesRequestDevices, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchUnbindProjectDevicesRequest(TeaModel):
    def __init__(self, devices=None, iot_instance_id=None, project_id=None):
        self.devices = devices  # type: list[BatchUnbindProjectDevicesRequestDevices]
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.devices, 'devices')
        if self.devices:
            for k in self.devices:
                if k:
                    k.validate()
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(BatchUnbindProjectDevicesRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Devices'] = []
        if self.devices is not None:
            for k in self.devices:
                result['Devices'].append(k.to_map() if k else None)
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.devices = []
        if m.get('Devices') is not None:
            for k in m.get('Devices'):
                temp_model = BatchUnbindProjectDevicesRequestDevices()
                self.devices.append(temp_model.from_map(k))
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class BatchUnbindProjectDevicesResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: bool
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchUnbindProjectDevicesResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchUnbindProjectProductsRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_keys=None, project_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_keys = product_keys  # type: list[str]
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.product_keys, 'product_keys')
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(BatchUnbindProjectProductsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_keys is not None:
            result['ProductKeys'] = self.product_keys
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKeys') is not None:
            self.product_keys = m.get('ProductKeys')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class BatchUnbindProjectProductsResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: bool
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchUnbindProjectProductsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BatchUpdateDeviceNicknameRequestDeviceNicknameInfo(TeaModel):
    def __init__(self, device_name=None, iot_id=None, nickname=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.nickname = nickname  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(BatchUpdateDeviceNicknameRequestDeviceNicknameInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BatchUpdateDeviceNicknameRequest(TeaModel):
    def __init__(self, device_nickname_info=None, iot_instance_id=None):
        self.device_nickname_info = device_nickname_info  # type: list[BatchUpdateDeviceNicknameRequestDeviceNicknameInfo]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.device_nickname_info, 'device_nickname_info')
        if self.device_nickname_info:
            for k in self.device_nickname_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(BatchUpdateDeviceNicknameRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DeviceNicknameInfo'] = []
        if self.device_nickname_info is not None:
            for k in self.device_nickname_info:
                result['DeviceNicknameInfo'].append(k.to_map() if k else None)
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_nickname_info = []
        if m.get('DeviceNicknameInfo') is not None:
            for k in m.get('DeviceNicknameInfo'):
                temp_model = BatchUpdateDeviceNicknameRequestDeviceNicknameInfo()
                self.device_nickname_info.append(temp_model.from_map(k))
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BatchUpdateDeviceNicknameResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BatchUpdateDeviceNicknameResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BindApplicationToEdgeInstanceRequest(TeaModel):
    def __init__(self, application_id=None, application_version=None, instance_id=None, iot_instance_id=None):
        self.application_id = application_id  # type: str
        self.application_version = application_version  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.application_id, 'application_id')
        self.validate_required(self.application_version, 'application_version')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(BindApplicationToEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.application_id is not None:
            result['ApplicationId'] = self.application_id
        if self.application_version is not None:
            result['ApplicationVersion'] = self.application_version
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplicationId') is not None:
            self.application_id = m.get('ApplicationId')
        if m.get('ApplicationVersion') is not None:
            self.application_version = m.get('ApplicationVersion')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class BindApplicationToEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BindApplicationToEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BindDriverToEdgeInstanceRequest(TeaModel):
    def __init__(self, driver_id=None, driver_version=None, instance_id=None, iot_instance_id=None, order_id=None):
        self.driver_id = driver_id  # type: str
        self.driver_version = driver_version  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.order_id = order_id  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(BindDriverToEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_version is not None:
            result['DriverVersion'] = self.driver_version
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.order_id is not None:
            result['OrderId'] = self.order_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverVersion') is not None:
            self.driver_version = m.get('DriverVersion')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('OrderId') is not None:
            self.order_id = m.get('OrderId')
        return self


class BindDriverToEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BindDriverToEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BindGatewayToEdgeInstanceRequest(TeaModel):
    def __init__(self, device_name=None, instance_id=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(BindGatewayToEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BindGatewayToEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BindGatewayToEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BindLicenseDeviceRequest(TeaModel):
    def __init__(self, device_name_list=None, iot_id_list=None, iot_instance_id=None, license_code=None,
                 product_key=None):
        self.device_name_list = device_name_list  # type: list[str]
        self.iot_id_list = iot_id_list  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.license_code = license_code  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.license_code, 'license_code')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BindLicenseDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name_list is not None:
            result['DeviceNameList'] = self.device_name_list
        if self.iot_id_list is not None:
            result['IotIdList'] = self.iot_id_list
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.license_code is not None:
            result['LicenseCode'] = self.license_code
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceNameList') is not None:
            self.device_name_list = m.get('DeviceNameList')
        if m.get('IotIdList') is not None:
            self.iot_id_list = m.get('IotIdList')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('LicenseCode') is not None:
            self.license_code = m.get('LicenseCode')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BindLicenseDeviceResponseData(TeaModel):
    def __init__(self, check_progress_id=None, fail_sum=None, progress=None, result_csv_file=None, success_sum=None):
        self.check_progress_id = check_progress_id  # type: str
        self.fail_sum = fail_sum  # type: long
        self.progress = progress  # type: int
        self.result_csv_file = result_csv_file  # type: str
        self.success_sum = success_sum  # type: long

    def validate(self):
        self.validate_required(self.check_progress_id, 'check_progress_id')
        self.validate_required(self.fail_sum, 'fail_sum')
        self.validate_required(self.progress, 'progress')
        self.validate_required(self.result_csv_file, 'result_csv_file')
        self.validate_required(self.success_sum, 'success_sum')

    def to_map(self):
        _map = super(BindLicenseDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.check_progress_id is not None:
            result['CheckProgressId'] = self.check_progress_id
        if self.fail_sum is not None:
            result['FailSum'] = self.fail_sum
        if self.progress is not None:
            result['Progress'] = self.progress
        if self.result_csv_file is not None:
            result['ResultCsvFile'] = self.result_csv_file
        if self.success_sum is not None:
            result['SuccessSum'] = self.success_sum
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CheckProgressId') is not None:
            self.check_progress_id = m.get('CheckProgressId')
        if m.get('FailSum') is not None:
            self.fail_sum = m.get('FailSum')
        if m.get('Progress') is not None:
            self.progress = m.get('Progress')
        if m.get('ResultCsvFile') is not None:
            self.result_csv_file = m.get('ResultCsvFile')
        if m.get('SuccessSum') is not None:
            self.success_sum = m.get('SuccessSum')
        return self


class BindLicenseDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: BindLicenseDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(BindLicenseDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = BindLicenseDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class BindLicenseProductRequest(TeaModel):
    def __init__(self, iot_instance_id=None, license_code=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.license_code = license_code  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.license_code, 'license_code')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(BindLicenseProductRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.license_code is not None:
            result['LicenseCode'] = self.license_code
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('LicenseCode') is not None:
            self.license_code = m.get('LicenseCode')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class BindLicenseProductResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: bool
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BindLicenseProductResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BindRoleToEdgeInstanceRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None, role_arn=None, role_name=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.role_arn = role_arn  # type: str
        self.role_name = role_name  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.role_arn, 'role_arn')
        self.validate_required(self.role_name, 'role_name')

    def to_map(self):
        _map = super(BindRoleToEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.role_arn is not None:
            result['RoleArn'] = self.role_arn
        if self.role_name is not None:
            result['RoleName'] = self.role_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RoleArn') is not None:
            self.role_arn = m.get('RoleArn')
        if m.get('RoleName') is not None:
            self.role_name = m.get('RoleName')
        return self


class BindRoleToEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BindRoleToEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class BindSceneRuleToEdgeInstanceRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None, rule_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(BindSceneRuleToEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class BindSceneRuleToEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(BindSceneRuleToEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CancelJobRequest(TeaModel):
    def __init__(self, iot_instance_id=None, job_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(CancelJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        return self


class CancelJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CancelJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CancelOTAStrategyByJobRequest(TeaModel):
    def __init__(self, iot_instance_id=None, job_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(CancelOTAStrategyByJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        return self


class CancelOTAStrategyByJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CancelOTAStrategyByJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CancelOTATaskByDeviceRequest(TeaModel):
    def __init__(self, device_name=None, firmware_id=None, iot_instance_id=None, job_id=None, product_key=None):
        self.device_name = device_name  # type: list[str]
        self.firmware_id = firmware_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(CancelOTATaskByDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class CancelOTATaskByDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CancelOTATaskByDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CancelOTATaskByJobRequest(TeaModel):
    def __init__(self, cancel_in_progress_task=None, cancel_notified_task=None, cancel_queued_task=None,
                 cancel_scheduled_task=None, cancel_unconfirmed_task=None, iot_instance_id=None, job_id=None):
        self.cancel_in_progress_task = cancel_in_progress_task  # type: bool
        self.cancel_notified_task = cancel_notified_task  # type: bool
        self.cancel_queued_task = cancel_queued_task  # type: bool
        self.cancel_scheduled_task = cancel_scheduled_task  # type: bool
        self.cancel_unconfirmed_task = cancel_unconfirmed_task  # type: bool
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(CancelOTATaskByJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.cancel_in_progress_task is not None:
            result['CancelInProgressTask'] = self.cancel_in_progress_task
        if self.cancel_notified_task is not None:
            result['CancelNotifiedTask'] = self.cancel_notified_task
        if self.cancel_queued_task is not None:
            result['CancelQueuedTask'] = self.cancel_queued_task
        if self.cancel_scheduled_task is not None:
            result['CancelScheduledTask'] = self.cancel_scheduled_task
        if self.cancel_unconfirmed_task is not None:
            result['CancelUnconfirmedTask'] = self.cancel_unconfirmed_task
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CancelInProgressTask') is not None:
            self.cancel_in_progress_task = m.get('CancelInProgressTask')
        if m.get('CancelNotifiedTask') is not None:
            self.cancel_notified_task = m.get('CancelNotifiedTask')
        if m.get('CancelQueuedTask') is not None:
            self.cancel_queued_task = m.get('CancelQueuedTask')
        if m.get('CancelScheduledTask') is not None:
            self.cancel_scheduled_task = m.get('CancelScheduledTask')
        if m.get('CancelUnconfirmedTask') is not None:
            self.cancel_unconfirmed_task = m.get('CancelUnconfirmedTask')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        return self


class CancelOTATaskByJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CancelOTATaskByJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CancelReleaseProductRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(CancelReleaseProductRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class CancelReleaseProductResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CancelReleaseProductResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CheckBindLicenseDeviceProgressRequest(TeaModel):
    def __init__(self, check_progress_id=None, iot_instance_id=None, license_code=None, product_key=None):
        self.check_progress_id = check_progress_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.license_code = license_code  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.check_progress_id, 'check_progress_id')
        self.validate_required(self.license_code, 'license_code')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(CheckBindLicenseDeviceProgressRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.check_progress_id is not None:
            result['CheckProgressId'] = self.check_progress_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.license_code is not None:
            result['LicenseCode'] = self.license_code
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CheckProgressId') is not None:
            self.check_progress_id = m.get('CheckProgressId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('LicenseCode') is not None:
            self.license_code = m.get('LicenseCode')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class CheckBindLicenseDeviceProgressResponseData(TeaModel):
    def __init__(self, fail_sum=None, progress=None, result_csv_file=None, success_sum=None):
        self.fail_sum = fail_sum  # type: long
        self.progress = progress  # type: int
        self.result_csv_file = result_csv_file  # type: str
        self.success_sum = success_sum  # type: long

    def validate(self):
        self.validate_required(self.fail_sum, 'fail_sum')
        self.validate_required(self.progress, 'progress')
        self.validate_required(self.result_csv_file, 'result_csv_file')
        self.validate_required(self.success_sum, 'success_sum')

    def to_map(self):
        _map = super(CheckBindLicenseDeviceProgressResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.fail_sum is not None:
            result['FailSum'] = self.fail_sum
        if self.progress is not None:
            result['Progress'] = self.progress
        if self.result_csv_file is not None:
            result['ResultCsvFile'] = self.result_csv_file
        if self.success_sum is not None:
            result['SuccessSum'] = self.success_sum
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FailSum') is not None:
            self.fail_sum = m.get('FailSum')
        if m.get('Progress') is not None:
            self.progress = m.get('Progress')
        if m.get('ResultCsvFile') is not None:
            self.result_csv_file = m.get('ResultCsvFile')
        if m.get('SuccessSum') is not None:
            self.success_sum = m.get('SuccessSum')
        return self


class CheckBindLicenseDeviceProgressResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CheckBindLicenseDeviceProgressResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CheckBindLicenseDeviceProgressResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CheckBindLicenseDeviceProgressResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ClearDeviceDesiredPropertyRequest(TeaModel):
    def __init__(self, device_name=None, identifies=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.identifies = identifies  # type: list[str]
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(ClearDeviceDesiredPropertyRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.identifies is not None:
            result['Identifies'] = self.identifies
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('Identifies') is not None:
            self.identifies = m.get('Identifies')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ClearDeviceDesiredPropertyResponseData(TeaModel):
    def __init__(self, versions=None):
        self.versions = versions  # type: str

    def validate(self):
        self.validate_required(self.versions, 'versions')

    def to_map(self):
        _map = super(ClearDeviceDesiredPropertyResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.versions is not None:
            result['Versions'] = self.versions
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Versions') is not None:
            self.versions = m.get('Versions')
        return self


class ClearDeviceDesiredPropertyResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ClearDeviceDesiredPropertyResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ClearDeviceDesiredPropertyResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ClearDeviceDesiredPropertyResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ClearEdgeInstanceDriverConfigsRequest(TeaModel):
    def __init__(self, driver_id=None, instance_id=None, iot_instance_id=None):
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(ClearEdgeInstanceDriverConfigsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class ClearEdgeInstanceDriverConfigsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(ClearEdgeInstanceDriverConfigsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CloseDeviceTunnelRequest(TeaModel):
    def __init__(self, tunnel_id=None, iot_instance_id=None):
        self.tunnel_id = tunnel_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.tunnel_id, 'tunnel_id')

    def to_map(self):
        _map = super(CloseDeviceTunnelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tunnel_id is not None:
            result['TunnelId'] = self.tunnel_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TunnelId') is not None:
            self.tunnel_id = m.get('TunnelId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class CloseDeviceTunnelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CloseDeviceTunnelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CloseEdgeInstanceDeploymentRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(CloseEdgeInstanceDeploymentRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class CloseEdgeInstanceDeploymentResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CloseEdgeInstanceDeploymentResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class ConfirmOTATaskRequest(TeaModel):
    def __init__(self, iot_instance_id=None, task_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.task_id = task_id  # type: list[str]

    def validate(self):
        self.validate_required(self.task_id, 'task_id')

    def to_map(self):
        _map = super(ConfirmOTATaskRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.task_id is not None:
            result['TaskId'] = self.task_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('TaskId') is not None:
            self.task_id = m.get('TaskId')
        return self


class ConfirmOTATaskResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(ConfirmOTATaskResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CopyThingModelRequest(TeaModel):
    def __init__(self, iot_instance_id=None, resource_group_id=None, source_model_version=None,
                 source_product_key=None, target_product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.resource_group_id = resource_group_id  # type: str
        self.source_model_version = source_model_version  # type: str
        self.source_product_key = source_product_key  # type: str
        self.target_product_key = target_product_key  # type: str

    def validate(self):
        self.validate_required(self.source_product_key, 'source_product_key')
        self.validate_required(self.target_product_key, 'target_product_key')

    def to_map(self):
        _map = super(CopyThingModelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        if self.source_model_version is not None:
            result['SourceModelVersion'] = self.source_model_version
        if self.source_product_key is not None:
            result['SourceProductKey'] = self.source_product_key
        if self.target_product_key is not None:
            result['TargetProductKey'] = self.target_product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        if m.get('SourceModelVersion') is not None:
            self.source_model_version = m.get('SourceModelVersion')
        if m.get('SourceProductKey') is not None:
            self.source_product_key = m.get('SourceProductKey')
        if m.get('TargetProductKey') is not None:
            self.target_product_key = m.get('TargetProductKey')
        return self


class CopyThingModelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CopyThingModelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CountSpeechBroadcastHourRequest(TeaModel):
    def __init__(self, iot_instance_id=None, query_date_time_hour=None, share_task_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.query_date_time_hour = query_date_time_hour  # type: str
        self.share_task_code = share_task_code  # type: str

    def validate(self):
        self.validate_required(self.query_date_time_hour, 'query_date_time_hour')
        self.validate_required(self.share_task_code, 'share_task_code')

    def to_map(self):
        _map = super(CountSpeechBroadcastHourRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.query_date_time_hour is not None:
            result['QueryDateTimeHour'] = self.query_date_time_hour
        if self.share_task_code is not None:
            result['ShareTaskCode'] = self.share_task_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('QueryDateTimeHour') is not None:
            self.query_date_time_hour = m.get('QueryDateTimeHour')
        if m.get('ShareTaskCode') is not None:
            self.share_task_code = m.get('ShareTaskCode')
        return self


class CountSpeechBroadcastHourResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: int
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CountSpeechBroadcastHourResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateConsumerGroupRequest(TeaModel):
    def __init__(self, group_name=None, iot_instance_id=None):
        self.group_name = group_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.group_name, 'group_name')

    def to_map(self):
        _map = super(CreateConsumerGroupRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class CreateConsumerGroupResponse(TeaModel):
    def __init__(self, code=None, error_message=None, group_id=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.group_id = group_id  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateConsumerGroupResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateConsumerGroupSubscribeRelationRequest(TeaModel):
    def __init__(self, consumer_group_id=None, iot_instance_id=None, product_key=None):
        self.consumer_group_id = consumer_group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.consumer_group_id, 'consumer_group_id')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(CreateConsumerGroupSubscribeRelationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.consumer_group_id is not None:
            result['ConsumerGroupId'] = self.consumer_group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ConsumerGroupId') is not None:
            self.consumer_group_id = m.get('ConsumerGroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class CreateConsumerGroupSubscribeRelationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateConsumerGroupSubscribeRelationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateDataAPIServiceRequestRequestParam(TeaModel):
    def __init__(self, name=None, type=None, desc=None, example=None, required=None):
        self.name = name  # type: str
        self.type = type  # type: str
        self.desc = desc  # type: str
        self.example = example  # type: str
        self.required = required  # type: bool

    def validate(self):
        pass

    def to_map(self):
        _map = super(CreateDataAPIServiceRequestRequestParam, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.name is not None:
            result['Name'] = self.name
        if self.type is not None:
            result['Type'] = self.type
        if self.desc is not None:
            result['Desc'] = self.desc
        if self.example is not None:
            result['Example'] = self.example
        if self.required is not None:
            result['Required'] = self.required
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('Desc') is not None:
            self.desc = m.get('Desc')
        if m.get('Example') is not None:
            self.example = m.get('Example')
        if m.get('Required') is not None:
            self.required = m.get('Required')
        return self


class CreateDataAPIServiceRequestResponseParam(TeaModel):
    def __init__(self, name=None, type=None, desc=None, example=None, required=None):
        self.name = name  # type: str
        self.type = type  # type: str
        self.desc = desc  # type: str
        self.example = example  # type: str
        self.required = required  # type: bool

    def validate(self):
        pass

    def to_map(self):
        _map = super(CreateDataAPIServiceRequestResponseParam, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.name is not None:
            result['Name'] = self.name
        if self.type is not None:
            result['Type'] = self.type
        if self.desc is not None:
            result['Desc'] = self.desc
        if self.example is not None:
            result['Example'] = self.example
        if self.required is not None:
            result['Required'] = self.required
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('Desc') is not None:
            self.desc = m.get('Desc')
        if m.get('Example') is not None:
            self.example = m.get('Example')
        if m.get('Required') is not None:
            self.required = m.get('Required')
        return self


class CreateDataAPIServiceRequest(TeaModel):
    def __init__(self, display_name=None, origin_sql=None, request_param=None, desc=None, response_param=None,
                 template_sql=None, api_path=None, iot_instance_id=None):
        self.display_name = display_name  # type: str
        self.origin_sql = origin_sql  # type: str
        self.request_param = request_param  # type: list[CreateDataAPIServiceRequestRequestParam]
        self.desc = desc  # type: str
        self.response_param = response_param  # type: list[CreateDataAPIServiceRequestResponseParam]
        self.template_sql = template_sql  # type: str
        self.api_path = api_path  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.display_name, 'display_name')
        self.validate_required(self.origin_sql, 'origin_sql')
        if self.request_param:
            for k in self.request_param:
                if k:
                    k.validate()
        if self.response_param:
            for k in self.response_param:
                if k:
                    k.validate()
        self.validate_required(self.template_sql, 'template_sql')
        self.validate_required(self.api_path, 'api_path')

    def to_map(self):
        _map = super(CreateDataAPIServiceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.display_name is not None:
            result['DisplayName'] = self.display_name
        if self.origin_sql is not None:
            result['OriginSql'] = self.origin_sql
        result['RequestParam'] = []
        if self.request_param is not None:
            for k in self.request_param:
                result['RequestParam'].append(k.to_map() if k else None)
        if self.desc is not None:
            result['Desc'] = self.desc
        result['ResponseParam'] = []
        if self.response_param is not None:
            for k in self.response_param:
                result['ResponseParam'].append(k.to_map() if k else None)
        if self.template_sql is not None:
            result['TemplateSql'] = self.template_sql
        if self.api_path is not None:
            result['ApiPath'] = self.api_path
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DisplayName') is not None:
            self.display_name = m.get('DisplayName')
        if m.get('OriginSql') is not None:
            self.origin_sql = m.get('OriginSql')
        self.request_param = []
        if m.get('RequestParam') is not None:
            for k in m.get('RequestParam'):
                temp_model = CreateDataAPIServiceRequestRequestParam()
                self.request_param.append(temp_model.from_map(k))
        if m.get('Desc') is not None:
            self.desc = m.get('Desc')
        self.response_param = []
        if m.get('ResponseParam') is not None:
            for k in m.get('ResponseParam'):
                temp_model = CreateDataAPIServiceRequestResponseParam()
                self.response_param.append(temp_model.from_map(k))
        if m.get('TemplateSql') is not None:
            self.template_sql = m.get('TemplateSql')
        if m.get('ApiPath') is not None:
            self.api_path = m.get('ApiPath')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class CreateDataAPIServiceResponseData(TeaModel):
    def __init__(self, api_srn=None, create_time=None, last_update_time=None):
        self.api_srn = api_srn  # type: str
        self.create_time = create_time  # type: long
        self.last_update_time = last_update_time  # type: long

    def validate(self):
        self.validate_required(self.api_srn, 'api_srn')
        self.validate_required(self.create_time, 'create_time')
        self.validate_required(self.last_update_time, 'last_update_time')

    def to_map(self):
        _map = super(CreateDataAPIServiceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.api_srn is not None:
            result['ApiSrn'] = self.api_srn
        if self.create_time is not None:
            result['CreateTime'] = self.create_time
        if self.last_update_time is not None:
            result['LastUpdateTime'] = self.last_update_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApiSrn') is not None:
            self.api_srn = m.get('ApiSrn')
        if m.get('CreateTime') is not None:
            self.create_time = m.get('CreateTime')
        if m.get('LastUpdateTime') is not None:
            self.last_update_time = m.get('LastUpdateTime')
        return self


class CreateDataAPIServiceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateDataAPIServiceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateDataAPIServiceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateDataAPIServiceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateDataSourceItemRequest(TeaModel):
    def __init__(self, data_source_id=None, device_name=None, iot_instance_id=None, product_key=None,
                 scope_type=None, topic=None):
        self.data_source_id = data_source_id  # type: long
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.scope_type = scope_type  # type: str
        self.topic = topic  # type: str

    def validate(self):
        self.validate_required(self.data_source_id, 'data_source_id')
        self.validate_required(self.topic, 'topic')

    def to_map(self):
        _map = super(CreateDataSourceItemRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.scope_type is not None:
            result['ScopeType'] = self.scope_type
        if self.topic is not None:
            result['Topic'] = self.topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ScopeType') is not None:
            self.scope_type = m.get('ScopeType')
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        return self


class CreateDataSourceItemResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateDataSourceItemResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateDestinationRequest(TeaModel):
    def __init__(self, configuration=None, description=None, iot_instance_id=None, name=None, type=None):
        self.configuration = configuration  # type: str
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.configuration, 'configuration')
        self.validate_required(self.name, 'name')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(CreateDestinationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class CreateDestinationResponseDestination(TeaModel):
    def __init__(self, configuration=None, destination_id=None, is_failover=None, name=None, type=None,
                 utc_created=None):
        self.configuration = configuration  # type: str
        self.destination_id = destination_id  # type: long
        self.is_failover = is_failover  # type: bool
        self.name = name  # type: str
        self.type = type  # type: str
        self.utc_created = utc_created  # type: str

    def validate(self):
        self.validate_required(self.configuration, 'configuration')
        self.validate_required(self.destination_id, 'destination_id')
        self.validate_required(self.is_failover, 'is_failover')
        self.validate_required(self.name, 'name')
        self.validate_required(self.type, 'type')
        self.validate_required(self.utc_created, 'utc_created')

    def to_map(self):
        _map = super(CreateDestinationResponseDestination, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        if self.destination_id is not None:
            result['DestinationId'] = self.destination_id
        if self.is_failover is not None:
            result['IsFailover'] = self.is_failover
        if self.name is not None:
            result['Name'] = self.name
        if self.type is not None:
            result['Type'] = self.type
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        if m.get('DestinationId') is not None:
            self.destination_id = m.get('DestinationId')
        if m.get('IsFailover') is not None:
            self.is_failover = m.get('IsFailover')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        return self


class CreateDestinationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, destination=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.destination = destination  # type: CreateDestinationResponseDestination

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.destination, 'destination')
        if self.destination:
            self.destination.validate()

    def to_map(self):
        _map = super(CreateDestinationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.destination is not None:
            result['Destination'] = self.destination.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Destination') is not None:
            temp_model = CreateDestinationResponseDestination()
            self.destination = temp_model.from_map(m['Destination'])
        return self


class CreateDeviceDistributeJobRequestTargetInstanceConfig(TeaModel):
    def __init__(self, target_instance_id=None):
        self.target_instance_id = target_instance_id  # type: str

    def validate(self):
        self.validate_required(self.target_instance_id, 'target_instance_id')

    def to_map(self):
        _map = super(CreateDeviceDistributeJobRequestTargetInstanceConfig, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.target_instance_id is not None:
            result['TargetInstanceId'] = self.target_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TargetInstanceId') is not None:
            self.target_instance_id = m.get('TargetInstanceId')
        return self


class CreateDeviceDistributeJobRequest(TeaModel):
    def __init__(self, device_name=None, source_instance_id=None, product_key=None, target_uid=None,
                 target_aliyun_id=None, target_instance_config=None, strategy=None):
        self.device_name = device_name  # type: list[str]
        self.source_instance_id = source_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.target_uid = target_uid  # type: str
        self.target_aliyun_id = target_aliyun_id  # type: str
        self.target_instance_config = target_instance_config  # type: list[CreateDeviceDistributeJobRequestTargetInstanceConfig]
        self.strategy = strategy  # type: int

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.source_instance_id, 'source_instance_id')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.target_instance_config, 'target_instance_config')
        if self.target_instance_config:
            for k in self.target_instance_config:
                if k:
                    k.validate()
        self.validate_required(self.strategy, 'strategy')

    def to_map(self):
        _map = super(CreateDeviceDistributeJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.source_instance_id is not None:
            result['SourceInstanceId'] = self.source_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.target_uid is not None:
            result['TargetUid'] = self.target_uid
        if self.target_aliyun_id is not None:
            result['TargetAliyunId'] = self.target_aliyun_id
        result['TargetInstanceConfig'] = []
        if self.target_instance_config is not None:
            for k in self.target_instance_config:
                result['TargetInstanceConfig'].append(k.to_map() if k else None)
        if self.strategy is not None:
            result['Strategy'] = self.strategy
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('SourceInstanceId') is not None:
            self.source_instance_id = m.get('SourceInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('TargetUid') is not None:
            self.target_uid = m.get('TargetUid')
        if m.get('TargetAliyunId') is not None:
            self.target_aliyun_id = m.get('TargetAliyunId')
        self.target_instance_config = []
        if m.get('TargetInstanceConfig') is not None:
            for k in m.get('TargetInstanceConfig'):
                temp_model = CreateDeviceDistributeJobRequestTargetInstanceConfig()
                self.target_instance_config.append(temp_model.from_map(k))
        if m.get('Strategy') is not None:
            self.strategy = m.get('Strategy')
        return self


class CreateDeviceDistributeJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, job_id=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.job_id = job_id  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateDeviceDistributeJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateDeviceDynamicGroupRequest(TeaModel):
    def __init__(self, dynamic_group_expression=None, group_desc=None, group_name=None, iot_instance_id=None):
        self.dynamic_group_expression = dynamic_group_expression  # type: str
        self.group_desc = group_desc  # type: str
        self.group_name = group_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.dynamic_group_expression, 'dynamic_group_expression')
        self.validate_required(self.group_name, 'group_name')
        self.validate_required(self.iot_instance_id, 'iot_instance_id')

    def to_map(self):
        _map = super(CreateDeviceDynamicGroupRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dynamic_group_expression is not None:
            result['DynamicGroupExpression'] = self.dynamic_group_expression
        if self.group_desc is not None:
            result['GroupDesc'] = self.group_desc
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DynamicGroupExpression') is not None:
            self.dynamic_group_expression = m.get('DynamicGroupExpression')
        if m.get('GroupDesc') is not None:
            self.group_desc = m.get('GroupDesc')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class CreateDeviceDynamicGroupResponseData(TeaModel):
    def __init__(self, dynamic_group_expression=None, group_desc=None, group_id=None, group_name=None,
                 utc_create=None):
        self.dynamic_group_expression = dynamic_group_expression  # type: str
        self.group_desc = group_desc  # type: str
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.dynamic_group_expression, 'dynamic_group_expression')
        self.validate_required(self.group_desc, 'group_desc')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(CreateDeviceDynamicGroupResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dynamic_group_expression is not None:
            result['DynamicGroupExpression'] = self.dynamic_group_expression
        if self.group_desc is not None:
            result['GroupDesc'] = self.group_desc
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DynamicGroupExpression') is not None:
            self.dynamic_group_expression = m.get('DynamicGroupExpression')
        if m.get('GroupDesc') is not None:
            self.group_desc = m.get('GroupDesc')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class CreateDeviceDynamicGroupResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateDeviceDynamicGroupResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateDeviceDynamicGroupResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateDeviceDynamicGroupResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateDeviceGroupRequest(TeaModel):
    def __init__(self, group_desc=None, group_name=None, iot_instance_id=None, super_group_id=None):
        self.group_desc = group_desc  # type: str
        self.group_name = group_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.super_group_id = super_group_id  # type: str

    def validate(self):
        self.validate_required(self.group_name, 'group_name')

    def to_map(self):
        _map = super(CreateDeviceGroupRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_desc is not None:
            result['GroupDesc'] = self.group_desc
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.super_group_id is not None:
            result['SuperGroupId'] = self.super_group_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupDesc') is not None:
            self.group_desc = m.get('GroupDesc')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('SuperGroupId') is not None:
            self.super_group_id = m.get('SuperGroupId')
        return self


class CreateDeviceGroupResponseData(TeaModel):
    def __init__(self, group_desc=None, group_id=None, group_name=None, utc_create=None):
        self.group_desc = group_desc  # type: str
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.group_desc, 'group_desc')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(CreateDeviceGroupResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_desc is not None:
            result['GroupDesc'] = self.group_desc
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupDesc') is not None:
            self.group_desc = m.get('GroupDesc')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class CreateDeviceGroupResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateDeviceGroupResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateDeviceGroupResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateDeviceGroupResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateDeviceTunnelRequest(TeaModel):
    def __init__(self, iot_id=None, description=None, udi=None, product_key=None, device_name=None,
                 iot_instance_id=None):
        self.iot_id = iot_id  # type: str
        self.description = description  # type: str
        self.udi = udi  # type: str
        self.product_key = product_key  # type: str
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(CreateDeviceTunnelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.description is not None:
            result['Description'] = self.description
        if self.udi is not None:
            result['Udi'] = self.udi
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('Udi') is not None:
            self.udi = m.get('Udi')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class CreateDeviceTunnelResponseData(TeaModel):
    def __init__(self, source_access_token=None, source_uri=None, tunnel_id=None):
        self.source_access_token = source_access_token  # type: str
        self.source_uri = source_uri  # type: str
        self.tunnel_id = tunnel_id  # type: str

    def validate(self):
        self.validate_required(self.source_access_token, 'source_access_token')
        self.validate_required(self.source_uri, 'source_uri')
        self.validate_required(self.tunnel_id, 'tunnel_id')

    def to_map(self):
        _map = super(CreateDeviceTunnelResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.source_access_token is not None:
            result['SourceAccessToken'] = self.source_access_token
        if self.source_uri is not None:
            result['SourceURI'] = self.source_uri
        if self.tunnel_id is not None:
            result['TunnelId'] = self.tunnel_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('SourceAccessToken') is not None:
            self.source_access_token = m.get('SourceAccessToken')
        if m.get('SourceURI') is not None:
            self.source_uri = m.get('SourceURI')
        if m.get('TunnelId') is not None:
            self.tunnel_id = m.get('TunnelId')
        return self


class CreateDeviceTunnelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateDeviceTunnelResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateDeviceTunnelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateDeviceTunnelResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateDownloadDataJobRequest(TeaModel):
    def __init__(self, context=None, download_data_type=None, end_time=None, file_config=None, iot_instance_id=None,
                 start_time=None, table_name=None):
        self.context = context  # type: dict[str, any]
        self.download_data_type = download_data_type  # type: str
        self.end_time = end_time  # type: long
        self.file_config = file_config  # type: dict[str, any]
        self.iot_instance_id = iot_instance_id  # type: str
        self.start_time = start_time  # type: long
        self.table_name = table_name  # type: str

    def validate(self):
        self.validate_required(self.download_data_type, 'download_data_type')
        self.validate_required(self.table_name, 'table_name')

    def to_map(self):
        _map = super(CreateDownloadDataJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.context is not None:
            result['Context'] = self.context
        if self.download_data_type is not None:
            result['DownloadDataType'] = self.download_data_type
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.file_config is not None:
            result['FileConfig'] = self.file_config
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        if self.table_name is not None:
            result['TableName'] = self.table_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Context') is not None:
            self.context = m.get('Context')
        if m.get('DownloadDataType') is not None:
            self.download_data_type = m.get('DownloadDataType')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('FileConfig') is not None:
            self.file_config = m.get('FileConfig')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        if m.get('TableName') is not None:
            self.table_name = m.get('TableName')
        return self


class CreateDownloadDataJobShrinkRequest(TeaModel):
    def __init__(self, context_shrink=None, download_data_type=None, end_time=None, file_config_shrink=None,
                 iot_instance_id=None, start_time=None, table_name=None):
        self.context_shrink = context_shrink  # type: str
        self.download_data_type = download_data_type  # type: str
        self.end_time = end_time  # type: long
        self.file_config_shrink = file_config_shrink  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.start_time = start_time  # type: long
        self.table_name = table_name  # type: str

    def validate(self):
        self.validate_required(self.download_data_type, 'download_data_type')
        self.validate_required(self.table_name, 'table_name')

    def to_map(self):
        _map = super(CreateDownloadDataJobShrinkRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.context_shrink is not None:
            result['Context'] = self.context_shrink
        if self.download_data_type is not None:
            result['DownloadDataType'] = self.download_data_type
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.file_config_shrink is not None:
            result['FileConfig'] = self.file_config_shrink
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        if self.table_name is not None:
            result['TableName'] = self.table_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Context') is not None:
            self.context_shrink = m.get('Context')
        if m.get('DownloadDataType') is not None:
            self.download_data_type = m.get('DownloadDataType')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('FileConfig') is not None:
            self.file_config_shrink = m.get('FileConfig')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        if m.get('TableName') is not None:
            self.table_name = m.get('TableName')
        return self


class CreateDownloadDataJobResponseDataHeader(TeaModel):
    def __init__(self, alias=None, data_precision=None, dim_date_class=None, field_name=None, field_type=None,
                 geo_class=None, time_class=None, type_class=None):
        self.alias = alias  # type: str
        self.data_precision = data_precision  # type: str
        self.dim_date_class = dim_date_class  # type: str
        self.field_name = field_name  # type: str
        self.field_type = field_type  # type: str
        self.geo_class = geo_class  # type: str
        self.time_class = time_class  # type: str
        self.type_class = type_class  # type: str

    def validate(self):
        self.validate_required(self.alias, 'alias')
        self.validate_required(self.data_precision, 'data_precision')
        self.validate_required(self.dim_date_class, 'dim_date_class')
        self.validate_required(self.field_name, 'field_name')
        self.validate_required(self.field_type, 'field_type')
        self.validate_required(self.geo_class, 'geo_class')
        self.validate_required(self.time_class, 'time_class')
        self.validate_required(self.type_class, 'type_class')

    def to_map(self):
        _map = super(CreateDownloadDataJobResponseDataHeader, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.alias is not None:
            result['Alias'] = self.alias
        if self.data_precision is not None:
            result['DataPrecision'] = self.data_precision
        if self.dim_date_class is not None:
            result['DimDateClass'] = self.dim_date_class
        if self.field_name is not None:
            result['FieldName'] = self.field_name
        if self.field_type is not None:
            result['FieldType'] = self.field_type
        if self.geo_class is not None:
            result['GeoClass'] = self.geo_class
        if self.time_class is not None:
            result['TimeClass'] = self.time_class
        if self.type_class is not None:
            result['TypeClass'] = self.type_class
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Alias') is not None:
            self.alias = m.get('Alias')
        if m.get('DataPrecision') is not None:
            self.data_precision = m.get('DataPrecision')
        if m.get('DimDateClass') is not None:
            self.dim_date_class = m.get('DimDateClass')
        if m.get('FieldName') is not None:
            self.field_name = m.get('FieldName')
        if m.get('FieldType') is not None:
            self.field_type = m.get('FieldType')
        if m.get('GeoClass') is not None:
            self.geo_class = m.get('GeoClass')
        if m.get('TimeClass') is not None:
            self.time_class = m.get('TimeClass')
        if m.get('TypeClass') is not None:
            self.type_class = m.get('TypeClass')
        return self


class CreateDownloadDataJobResponseDataQuerySettingAstExpr(TeaModel):
    def __init__(self, expr=None, expr_type=None):
        self.expr = expr  # type: str
        self.expr_type = expr_type  # type: str

    def validate(self):
        self.validate_required(self.expr, 'expr')
        self.validate_required(self.expr_type, 'expr_type')

    def to_map(self):
        _map = super(CreateDownloadDataJobResponseDataQuerySettingAstExpr, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.expr is not None:
            result['Expr'] = self.expr
        if self.expr_type is not None:
            result['ExprType'] = self.expr_type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Expr') is not None:
            self.expr = m.get('Expr')
        if m.get('ExprType') is not None:
            self.expr_type = m.get('ExprType')
        return self


class CreateDownloadDataJobResponseDataQuerySettingSelectedHeaders(TeaModel):
    def __init__(self, alias=None, dim_date_class=None, field_name=None, field_type=None, geo_class=None,
                 time_class=None):
        self.alias = alias  # type: str
        self.dim_date_class = dim_date_class  # type: str
        self.field_name = field_name  # type: str
        self.field_type = field_type  # type: str
        self.geo_class = geo_class  # type: str
        self.time_class = time_class  # type: str

    def validate(self):
        self.validate_required(self.alias, 'alias')
        self.validate_required(self.dim_date_class, 'dim_date_class')
        self.validate_required(self.field_name, 'field_name')
        self.validate_required(self.field_type, 'field_type')
        self.validate_required(self.geo_class, 'geo_class')
        self.validate_required(self.time_class, 'time_class')

    def to_map(self):
        _map = super(CreateDownloadDataJobResponseDataQuerySettingSelectedHeaders, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.alias is not None:
            result['Alias'] = self.alias
        if self.dim_date_class is not None:
            result['DimDateClass'] = self.dim_date_class
        if self.field_name is not None:
            result['FieldName'] = self.field_name
        if self.field_type is not None:
            result['FieldType'] = self.field_type
        if self.geo_class is not None:
            result['GeoClass'] = self.geo_class
        if self.time_class is not None:
            result['TimeClass'] = self.time_class
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Alias') is not None:
            self.alias = m.get('Alias')
        if m.get('DimDateClass') is not None:
            self.dim_date_class = m.get('DimDateClass')
        if m.get('FieldName') is not None:
            self.field_name = m.get('FieldName')
        if m.get('FieldType') is not None:
            self.field_type = m.get('FieldType')
        if m.get('GeoClass') is not None:
            self.geo_class = m.get('GeoClass')
        if m.get('TimeClass') is not None:
            self.time_class = m.get('TimeClass')
        return self


class CreateDownloadDataJobResponseDataQuerySetting(TeaModel):
    def __init__(self, ast_expr=None, selected_headers=None):
        self.ast_expr = ast_expr  # type: list[CreateDownloadDataJobResponseDataQuerySettingAstExpr]
        self.selected_headers = selected_headers  # type: list[CreateDownloadDataJobResponseDataQuerySettingSelectedHeaders]

    def validate(self):
        self.validate_required(self.ast_expr, 'ast_expr')
        if self.ast_expr:
            for k in self.ast_expr:
                if k:
                    k.validate()
        self.validate_required(self.selected_headers, 'selected_headers')
        if self.selected_headers:
            for k in self.selected_headers:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(CreateDownloadDataJobResponseDataQuerySetting, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['AstExpr'] = []
        if self.ast_expr is not None:
            for k in self.ast_expr:
                result['AstExpr'].append(k.to_map() if k else None)
        result['SelectedHeaders'] = []
        if self.selected_headers is not None:
            for k in self.selected_headers:
                result['SelectedHeaders'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.ast_expr = []
        if m.get('AstExpr') is not None:
            for k in m.get('AstExpr'):
                temp_model = CreateDownloadDataJobResponseDataQuerySettingAstExpr()
                self.ast_expr.append(temp_model.from_map(k))
        self.selected_headers = []
        if m.get('SelectedHeaders') is not None:
            for k in m.get('SelectedHeaders'):
                temp_model = CreateDownloadDataJobResponseDataQuerySettingSelectedHeaders()
                self.selected_headers.append(temp_model.from_map(k))
        return self


class CreateDownloadDataJobResponseData(TeaModel):
    def __init__(self, async_execute=None, begin_time=None, csv_file_name=None, csv_url=None, dataset_id=None,
                 end_time=None, long_job_id=None, page_no=None, page_size=None, preview_size=None,
                 result_data_in_string=None, status=None, total_count=None, header=None, query_setting=None):
        self.async_execute = async_execute  # type: bool
        self.begin_time = begin_time  # type: long
        self.csv_file_name = csv_file_name  # type: str
        self.csv_url = csv_url  # type: str
        self.dataset_id = dataset_id  # type: str
        self.end_time = end_time  # type: long
        self.long_job_id = long_job_id  # type: str
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int
        self.preview_size = preview_size  # type: int
        self.result_data_in_string = result_data_in_string  # type: str
        self.status = status  # type: int
        self.total_count = total_count  # type: long
        self.header = header  # type: list[CreateDownloadDataJobResponseDataHeader]
        self.query_setting = query_setting  # type: CreateDownloadDataJobResponseDataQuerySetting

    def validate(self):
        self.validate_required(self.async_execute, 'async_execute')
        self.validate_required(self.begin_time, 'begin_time')
        self.validate_required(self.csv_file_name, 'csv_file_name')
        self.validate_required(self.csv_url, 'csv_url')
        self.validate_required(self.dataset_id, 'dataset_id')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.long_job_id, 'long_job_id')
        self.validate_required(self.page_no, 'page_no')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.preview_size, 'preview_size')
        self.validate_required(self.result_data_in_string, 'result_data_in_string')
        self.validate_required(self.status, 'status')
        self.validate_required(self.total_count, 'total_count')
        self.validate_required(self.header, 'header')
        if self.header:
            for k in self.header:
                if k:
                    k.validate()
        self.validate_required(self.query_setting, 'query_setting')
        if self.query_setting:
            self.query_setting.validate()

    def to_map(self):
        _map = super(CreateDownloadDataJobResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.async_execute is not None:
            result['AsyncExecute'] = self.async_execute
        if self.begin_time is not None:
            result['BeginTime'] = self.begin_time
        if self.csv_file_name is not None:
            result['CsvFileName'] = self.csv_file_name
        if self.csv_url is not None:
            result['CsvUrl'] = self.csv_url
        if self.dataset_id is not None:
            result['DatasetId'] = self.dataset_id
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.long_job_id is not None:
            result['LongJobId'] = self.long_job_id
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.preview_size is not None:
            result['PreviewSize'] = self.preview_size
        if self.result_data_in_string is not None:
            result['ResultDataInString'] = self.result_data_in_string
        if self.status is not None:
            result['Status'] = self.status
        if self.total_count is not None:
            result['TotalCount'] = self.total_count
        result['Header'] = []
        if self.header is not None:
            for k in self.header:
                result['Header'].append(k.to_map() if k else None)
        if self.query_setting is not None:
            result['QuerySetting'] = self.query_setting.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AsyncExecute') is not None:
            self.async_execute = m.get('AsyncExecute')
        if m.get('BeginTime') is not None:
            self.begin_time = m.get('BeginTime')
        if m.get('CsvFileName') is not None:
            self.csv_file_name = m.get('CsvFileName')
        if m.get('CsvUrl') is not None:
            self.csv_url = m.get('CsvUrl')
        if m.get('DatasetId') is not None:
            self.dataset_id = m.get('DatasetId')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('LongJobId') is not None:
            self.long_job_id = m.get('LongJobId')
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('PreviewSize') is not None:
            self.preview_size = m.get('PreviewSize')
        if m.get('ResultDataInString') is not None:
            self.result_data_in_string = m.get('ResultDataInString')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('TotalCount') is not None:
            self.total_count = m.get('TotalCount')
        self.header = []
        if m.get('Header') is not None:
            for k in m.get('Header'):
                temp_model = CreateDownloadDataJobResponseDataHeader()
                self.header.append(temp_model.from_map(k))
        if m.get('QuerySetting') is not None:
            temp_model = CreateDownloadDataJobResponseDataQuerySetting()
            self.query_setting = temp_model.from_map(m['QuerySetting'])
        return self


class CreateDownloadDataJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateDownloadDataJobResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateDownloadDataJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateDownloadDataJobResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateEdgeDriverRequest(TeaModel):
    def __init__(self, cpu_arch=None, driver_name=None, driver_protocol=None, iot_instance_id=None,
                 is_built_in=None, runtime=None):
        self.cpu_arch = cpu_arch  # type: str
        self.driver_name = driver_name  # type: str
        self.driver_protocol = driver_protocol  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.is_built_in = is_built_in  # type: bool
        self.runtime = runtime  # type: str

    def validate(self):
        self.validate_required(self.driver_name, 'driver_name')
        self.validate_required(self.driver_protocol, 'driver_protocol')
        self.validate_required(self.runtime, 'runtime')

    def to_map(self):
        _map = super(CreateEdgeDriverRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.cpu_arch is not None:
            result['CpuArch'] = self.cpu_arch
        if self.driver_name is not None:
            result['DriverName'] = self.driver_name
        if self.driver_protocol is not None:
            result['DriverProtocol'] = self.driver_protocol
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.is_built_in is not None:
            result['IsBuiltIn'] = self.is_built_in
        if self.runtime is not None:
            result['Runtime'] = self.runtime
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CpuArch') is not None:
            self.cpu_arch = m.get('CpuArch')
        if m.get('DriverName') is not None:
            self.driver_name = m.get('DriverName')
        if m.get('DriverProtocol') is not None:
            self.driver_protocol = m.get('DriverProtocol')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('IsBuiltIn') is not None:
            self.is_built_in = m.get('IsBuiltIn')
        if m.get('Runtime') is not None:
            self.runtime = m.get('Runtime')
        return self


class CreateEdgeDriverResponse(TeaModel):
    def __init__(self, code=None, driver_id=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.driver_id = driver_id  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateEdgeDriverResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateEdgeDriverVersionRequest(TeaModel):
    def __init__(self, argument=None, config_check_rule=None, container_config=None, description=None,
                 driver_config=None, driver_id=None, driver_version=None, edge_version=None, iot_instance_id=None,
                 source_config=None):
        self.argument = argument  # type: str
        self.config_check_rule = config_check_rule  # type: str
        self.container_config = container_config  # type: str
        self.description = description  # type: str
        self.driver_config = driver_config  # type: str
        self.driver_id = driver_id  # type: str
        self.driver_version = driver_version  # type: str
        self.edge_version = edge_version  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.source_config = source_config  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.driver_version, 'driver_version')
        self.validate_required(self.edge_version, 'edge_version')

    def to_map(self):
        _map = super(CreateEdgeDriverVersionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.argument is not None:
            result['Argument'] = self.argument
        if self.config_check_rule is not None:
            result['ConfigCheckRule'] = self.config_check_rule
        if self.container_config is not None:
            result['ContainerConfig'] = self.container_config
        if self.description is not None:
            result['Description'] = self.description
        if self.driver_config is not None:
            result['DriverConfig'] = self.driver_config
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_version is not None:
            result['DriverVersion'] = self.driver_version
        if self.edge_version is not None:
            result['EdgeVersion'] = self.edge_version
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.source_config is not None:
            result['SourceConfig'] = self.source_config
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Argument') is not None:
            self.argument = m.get('Argument')
        if m.get('ConfigCheckRule') is not None:
            self.config_check_rule = m.get('ConfigCheckRule')
        if m.get('ContainerConfig') is not None:
            self.container_config = m.get('ContainerConfig')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('DriverConfig') is not None:
            self.driver_config = m.get('DriverConfig')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverVersion') is not None:
            self.driver_version = m.get('DriverVersion')
        if m.get('EdgeVersion') is not None:
            self.edge_version = m.get('EdgeVersion')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('SourceConfig') is not None:
            self.source_config = m.get('SourceConfig')
        return self


class CreateEdgeDriverVersionResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateEdgeDriverVersionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateEdgeInstanceRequest(TeaModel):
    def __init__(self, iot_instance_id=None, name=None, spec=None, tags=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.spec = spec  # type: int
        self.tags = tags  # type: str

    def validate(self):
        self.validate_required(self.name, 'name')

    def to_map(self):
        _map = super(CreateEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.spec is not None:
            result['Spec'] = self.spec
        if self.tags is not None:
            result['Tags'] = self.tags
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Spec') is not None:
            self.spec = m.get('Spec')
        if m.get('Tags') is not None:
            self.tags = m.get('Tags')
        return self


class CreateEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, instance_id=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.instance_id = instance_id  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateEdgeInstanceChannelRequestConfigs(TeaModel):
    def __init__(self, content=None, format=None, key=None):
        self.content = content  # type: str
        self.format = format  # type: str
        self.key = key  # type: str

    def validate(self):
        self.validate_required(self.content, 'content')
        self.validate_required(self.format, 'format')

    def to_map(self):
        _map = super(CreateEdgeInstanceChannelRequestConfigs, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.content is not None:
            result['Content'] = self.content
        if self.format is not None:
            result['Format'] = self.format
        if self.key is not None:
            result['Key'] = self.key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Content') is not None:
            self.content = m.get('Content')
        if m.get('Format') is not None:
            self.format = m.get('Format')
        if m.get('Key') is not None:
            self.key = m.get('Key')
        return self


class CreateEdgeInstanceChannelRequest(TeaModel):
    def __init__(self, channel_name=None, configs=None, driver_id=None, instance_id=None, iot_instance_id=None):
        self.channel_name = channel_name  # type: str
        self.configs = configs  # type: list[CreateEdgeInstanceChannelRequestConfigs]
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.channel_name, 'channel_name')
        self.validate_required(self.configs, 'configs')
        if self.configs:
            for k in self.configs:
                if k:
                    k.validate()
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(CreateEdgeInstanceChannelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.channel_name is not None:
            result['ChannelName'] = self.channel_name
        result['Configs'] = []
        if self.configs is not None:
            for k in self.configs:
                result['Configs'].append(k.to_map() if k else None)
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ChannelName') is not None:
            self.channel_name = m.get('ChannelName')
        self.configs = []
        if m.get('Configs') is not None:
            for k in m.get('Configs'):
                temp_model = CreateEdgeInstanceChannelRequestConfigs()
                self.configs.append(temp_model.from_map(k))
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class CreateEdgeInstanceChannelResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateEdgeInstanceChannelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateEdgeInstanceDeploymentRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None, type=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(CreateEdgeInstanceDeploymentRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class CreateEdgeInstanceDeploymentResponse(TeaModel):
    def __init__(self, code=None, deployment_id=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.deployment_id = deployment_id  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.deployment_id, 'deployment_id')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateEdgeInstanceDeploymentResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.deployment_id is not None:
            result['DeploymentId'] = self.deployment_id
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('DeploymentId') is not None:
            self.deployment_id = m.get('DeploymentId')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateEdgeInstanceMessageRoutingRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None, name=None, source_data=None, source_type=None,
                 target_data=None, target_iot_hub_qos=None, target_type=None, topic_filter=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.source_data = source_data  # type: str
        self.source_type = source_type  # type: str
        self.target_data = target_data  # type: str
        self.target_iot_hub_qos = target_iot_hub_qos  # type: int
        self.target_type = target_type  # type: str
        self.topic_filter = topic_filter  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.source_type, 'source_type')
        self.validate_required(self.target_type, 'target_type')

    def to_map(self):
        _map = super(CreateEdgeInstanceMessageRoutingRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.source_data is not None:
            result['SourceData'] = self.source_data
        if self.source_type is not None:
            result['SourceType'] = self.source_type
        if self.target_data is not None:
            result['TargetData'] = self.target_data
        if self.target_iot_hub_qos is not None:
            result['TargetIotHubQos'] = self.target_iot_hub_qos
        if self.target_type is not None:
            result['TargetType'] = self.target_type
        if self.topic_filter is not None:
            result['TopicFilter'] = self.topic_filter
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('SourceData') is not None:
            self.source_data = m.get('SourceData')
        if m.get('SourceType') is not None:
            self.source_type = m.get('SourceType')
        if m.get('TargetData') is not None:
            self.target_data = m.get('TargetData')
        if m.get('TargetIotHubQos') is not None:
            self.target_iot_hub_qos = m.get('TargetIotHubQos')
        if m.get('TargetType') is not None:
            self.target_type = m.get('TargetType')
        if m.get('TopicFilter') is not None:
            self.topic_filter = m.get('TopicFilter')
        return self


class CreateEdgeInstanceMessageRoutingResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, route_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.route_id = route_id  # type: long
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.route_id, 'route_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateEdgeInstanceMessageRoutingResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.route_id is not None:
            result['RouteId'] = self.route_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('RouteId') is not None:
            self.route_id = m.get('RouteId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateEdgeOssPreSignedAddressRequest(TeaModel):
    def __init__(self, file_name=None, instance_id=None, iot_instance_id=None, resource_id=None,
                 resource_version=None, type=None):
        self.file_name = file_name  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.resource_id = resource_id  # type: str
        self.resource_version = resource_version  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.file_name, 'file_name')
        self.validate_required(self.resource_id, 'resource_id')
        self.validate_required(self.resource_version, 'resource_version')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(CreateEdgeOssPreSignedAddressRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.file_name is not None:
            result['FileName'] = self.file_name
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.resource_id is not None:
            result['ResourceId'] = self.resource_id
        if self.resource_version is not None:
            result['ResourceVersion'] = self.resource_version
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FileName') is not None:
            self.file_name = m.get('FileName')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ResourceId') is not None:
            self.resource_id = m.get('ResourceId')
        if m.get('ResourceVersion') is not None:
            self.resource_version = m.get('ResourceVersion')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class CreateEdgeOssPreSignedAddressResponseData(TeaModel):
    def __init__(self, oss_address=None, oss_pre_signed_address=None):
        self.oss_address = oss_address  # type: str
        self.oss_pre_signed_address = oss_pre_signed_address  # type: str

    def validate(self):
        self.validate_required(self.oss_address, 'oss_address')
        self.validate_required(self.oss_pre_signed_address, 'oss_pre_signed_address')

    def to_map(self):
        _map = super(CreateEdgeOssPreSignedAddressResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.oss_address is not None:
            result['OssAddress'] = self.oss_address
        if self.oss_pre_signed_address is not None:
            result['OssPreSignedAddress'] = self.oss_pre_signed_address
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('OssAddress') is not None:
            self.oss_address = m.get('OssAddress')
        if m.get('OssPreSignedAddress') is not None:
            self.oss_pre_signed_address = m.get('OssPreSignedAddress')
        return self


class CreateEdgeOssPreSignedAddressResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateEdgeOssPreSignedAddressResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateEdgeOssPreSignedAddressResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateEdgeOssPreSignedAddressResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateJobRequest(TeaModel):
    def __init__(self, description=None, iot_instance_id=None, job_document=None, job_file=None, job_name=None,
                 rollout_config=None, scheduled_time=None, target_config=None, timeout_config=None, type=None):
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_document = job_document  # type: str
        self.job_file = job_file  # type: dict[str, any]
        self.job_name = job_name  # type: str
        self.rollout_config = rollout_config  # type: dict[str, any]
        self.scheduled_time = scheduled_time  # type: long
        self.target_config = target_config  # type: dict[str, any]
        self.timeout_config = timeout_config  # type: dict[str, any]
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.job_document, 'job_document')
        self.validate_required(self.job_name, 'job_name')
        self.validate_required(self.target_config, 'target_config')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(CreateJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_document is not None:
            result['JobDocument'] = self.job_document
        if self.job_file is not None:
            result['JobFile'] = self.job_file
        if self.job_name is not None:
            result['JobName'] = self.job_name
        if self.rollout_config is not None:
            result['RolloutConfig'] = self.rollout_config
        if self.scheduled_time is not None:
            result['ScheduledTime'] = self.scheduled_time
        if self.target_config is not None:
            result['TargetConfig'] = self.target_config
        if self.timeout_config is not None:
            result['TimeoutConfig'] = self.timeout_config
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobDocument') is not None:
            self.job_document = m.get('JobDocument')
        if m.get('JobFile') is not None:
            self.job_file = m.get('JobFile')
        if m.get('JobName') is not None:
            self.job_name = m.get('JobName')
        if m.get('RolloutConfig') is not None:
            self.rollout_config = m.get('RolloutConfig')
        if m.get('ScheduledTime') is not None:
            self.scheduled_time = m.get('ScheduledTime')
        if m.get('TargetConfig') is not None:
            self.target_config = m.get('TargetConfig')
        if m.get('TimeoutConfig') is not None:
            self.timeout_config = m.get('TimeoutConfig')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class CreateJobShrinkRequest(TeaModel):
    def __init__(self, description=None, iot_instance_id=None, job_document=None, job_file_shrink=None,
                 job_name=None, rollout_config_shrink=None, scheduled_time=None, target_config_shrink=None,
                 timeout_config_shrink=None, type=None):
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_document = job_document  # type: str
        self.job_file_shrink = job_file_shrink  # type: str
        self.job_name = job_name  # type: str
        self.rollout_config_shrink = rollout_config_shrink  # type: str
        self.scheduled_time = scheduled_time  # type: long
        self.target_config_shrink = target_config_shrink  # type: str
        self.timeout_config_shrink = timeout_config_shrink  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.job_document, 'job_document')
        self.validate_required(self.job_name, 'job_name')
        self.validate_required(self.target_config_shrink, 'target_config_shrink')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(CreateJobShrinkRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_document is not None:
            result['JobDocument'] = self.job_document
        if self.job_file_shrink is not None:
            result['JobFile'] = self.job_file_shrink
        if self.job_name is not None:
            result['JobName'] = self.job_name
        if self.rollout_config_shrink is not None:
            result['RolloutConfig'] = self.rollout_config_shrink
        if self.scheduled_time is not None:
            result['ScheduledTime'] = self.scheduled_time
        if self.target_config_shrink is not None:
            result['TargetConfig'] = self.target_config_shrink
        if self.timeout_config_shrink is not None:
            result['TimeoutConfig'] = self.timeout_config_shrink
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobDocument') is not None:
            self.job_document = m.get('JobDocument')
        if m.get('JobFile') is not None:
            self.job_file_shrink = m.get('JobFile')
        if m.get('JobName') is not None:
            self.job_name = m.get('JobName')
        if m.get('RolloutConfig') is not None:
            self.rollout_config_shrink = m.get('RolloutConfig')
        if m.get('ScheduledTime') is not None:
            self.scheduled_time = m.get('ScheduledTime')
        if m.get('TargetConfig') is not None:
            self.target_config_shrink = m.get('TargetConfig')
        if m.get('TimeoutConfig') is not None:
            self.timeout_config_shrink = m.get('TimeoutConfig')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class CreateJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, job_id=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.job_id = job_id  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateLoRaNodesTaskRequestDeviceInfo(TeaModel):
    def __init__(self, dev_eui=None, pin_code=None):
        self.dev_eui = dev_eui  # type: str
        self.pin_code = pin_code  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(CreateLoRaNodesTaskRequestDeviceInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dev_eui is not None:
            result['DevEui'] = self.dev_eui
        if self.pin_code is not None:
            result['PinCode'] = self.pin_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DevEui') is not None:
            self.dev_eui = m.get('DevEui')
        if m.get('PinCode') is not None:
            self.pin_code = m.get('PinCode')
        return self


class CreateLoRaNodesTaskRequest(TeaModel):
    def __init__(self, device_info=None, iot_instance_id=None, product_key=None):
        self.device_info = device_info  # type: list[CreateLoRaNodesTaskRequestDeviceInfo]
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_info, 'device_info')
        if self.device_info:
            for k in self.device_info:
                if k:
                    k.validate()
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(CreateLoRaNodesTaskRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DeviceInfo'] = []
        if self.device_info is not None:
            for k in self.device_info:
                result['DeviceInfo'].append(k.to_map() if k else None)
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_info = []
        if m.get('DeviceInfo') is not None:
            for k in m.get('DeviceInfo'):
                temp_model = CreateLoRaNodesTaskRequestDeviceInfo()
                self.device_info.append(temp_model.from_map(k))
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class CreateLoRaNodesTaskResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, task_id=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.task_id = task_id  # type: str

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.task_id, 'task_id')

    def to_map(self):
        _map = super(CreateLoRaNodesTaskResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.task_id is not None:
            result['TaskId'] = self.task_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('TaskId') is not None:
            self.task_id = m.get('TaskId')
        return self


class CreateOTADynamicUpgradeJobRequestTag(TeaModel):
    def __init__(self, key=None, value=None):
        self.key = key  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.key, 'key')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(CreateOTADynamicUpgradeJobRequestTag, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.key is not None:
            result['Key'] = self.key
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Key') is not None:
            self.key = m.get('Key')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class CreateOTADynamicUpgradeJobRequest(TeaModel):
    def __init__(self, download_protocol=None, dynamic_mode=None, firmware_id=None, group_id=None, group_type=None,
                 iot_instance_id=None, maximum_per_minute=None, multi_module_mode=None, need_confirm=None, need_push=None,
                 overwrite_mode=None, product_key=None, retry_count=None, retry_interval=None, src_version=None, tag=None,
                 timeout_in_minutes=None):
        self.download_protocol = download_protocol  # type: str
        self.dynamic_mode = dynamic_mode  # type: int
        self.firmware_id = firmware_id  # type: str
        self.group_id = group_id  # type: str
        self.group_type = group_type  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.maximum_per_minute = maximum_per_minute  # type: int
        self.multi_module_mode = multi_module_mode  # type: bool
        self.need_confirm = need_confirm  # type: bool
        self.need_push = need_push  # type: bool
        self.overwrite_mode = overwrite_mode  # type: int
        self.product_key = product_key  # type: str
        self.retry_count = retry_count  # type: int
        self.retry_interval = retry_interval  # type: int
        self.src_version = src_version  # type: list[str]
        self.tag = tag  # type: list[CreateOTADynamicUpgradeJobRequestTag]
        self.timeout_in_minutes = timeout_in_minutes  # type: int

    def validate(self):
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.product_key, 'product_key')
        if self.tag:
            for k in self.tag:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(CreateOTADynamicUpgradeJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.download_protocol is not None:
            result['DownloadProtocol'] = self.download_protocol
        if self.dynamic_mode is not None:
            result['DynamicMode'] = self.dynamic_mode
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_type is not None:
            result['GroupType'] = self.group_type
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.maximum_per_minute is not None:
            result['MaximumPerMinute'] = self.maximum_per_minute
        if self.multi_module_mode is not None:
            result['MultiModuleMode'] = self.multi_module_mode
        if self.need_confirm is not None:
            result['NeedConfirm'] = self.need_confirm
        if self.need_push is not None:
            result['NeedPush'] = self.need_push
        if self.overwrite_mode is not None:
            result['OverwriteMode'] = self.overwrite_mode
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.retry_count is not None:
            result['RetryCount'] = self.retry_count
        if self.retry_interval is not None:
            result['RetryInterval'] = self.retry_interval
        if self.src_version is not None:
            result['SrcVersion'] = self.src_version
        result['Tag'] = []
        if self.tag is not None:
            for k in self.tag:
                result['Tag'].append(k.to_map() if k else None)
        if self.timeout_in_minutes is not None:
            result['TimeoutInMinutes'] = self.timeout_in_minutes
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DownloadProtocol') is not None:
            self.download_protocol = m.get('DownloadProtocol')
        if m.get('DynamicMode') is not None:
            self.dynamic_mode = m.get('DynamicMode')
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupType') is not None:
            self.group_type = m.get('GroupType')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('MaximumPerMinute') is not None:
            self.maximum_per_minute = m.get('MaximumPerMinute')
        if m.get('MultiModuleMode') is not None:
            self.multi_module_mode = m.get('MultiModuleMode')
        if m.get('NeedConfirm') is not None:
            self.need_confirm = m.get('NeedConfirm')
        if m.get('NeedPush') is not None:
            self.need_push = m.get('NeedPush')
        if m.get('OverwriteMode') is not None:
            self.overwrite_mode = m.get('OverwriteMode')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RetryCount') is not None:
            self.retry_count = m.get('RetryCount')
        if m.get('RetryInterval') is not None:
            self.retry_interval = m.get('RetryInterval')
        if m.get('SrcVersion') is not None:
            self.src_version = m.get('SrcVersion')
        self.tag = []
        if m.get('Tag') is not None:
            for k in m.get('Tag'):
                temp_model = CreateOTADynamicUpgradeJobRequestTag()
                self.tag.append(temp_model.from_map(k))
        if m.get('TimeoutInMinutes') is not None:
            self.timeout_in_minutes = m.get('TimeoutInMinutes')
        return self


class CreateOTADynamicUpgradeJobResponseData(TeaModel):
    def __init__(self, job_id=None, utc_create=None):
        self.job_id = job_id  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(CreateOTADynamicUpgradeJobResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class CreateOTADynamicUpgradeJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateOTADynamicUpgradeJobResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateOTADynamicUpgradeJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateOTADynamicUpgradeJobResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateOTAFirmwareRequestMultiFiles(TeaModel):
    def __init__(self, file_md_5=None, name=None, sign_value=None, size=None, url=None):
        self.file_md_5 = file_md_5  # type: str
        self.name = name  # type: str
        self.sign_value = sign_value  # type: str
        self.size = size  # type: int
        self.url = url  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(CreateOTAFirmwareRequestMultiFiles, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.file_md_5 is not None:
            result['FileMd5'] = self.file_md_5
        if self.name is not None:
            result['Name'] = self.name
        if self.sign_value is not None:
            result['SignValue'] = self.sign_value
        if self.size is not None:
            result['Size'] = self.size
        if self.url is not None:
            result['Url'] = self.url
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FileMd5') is not None:
            self.file_md_5 = m.get('FileMd5')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('SignValue') is not None:
            self.sign_value = m.get('SignValue')
        if m.get('Size') is not None:
            self.size = m.get('Size')
        if m.get('Url') is not None:
            self.url = m.get('Url')
        return self


class CreateOTAFirmwareRequest(TeaModel):
    def __init__(self, dest_version=None, firmware_desc=None, firmware_name=None, firmware_sign=None,
                 firmware_size=None, firmware_url=None, iot_instance_id=None, module_name=None, multi_files=None,
                 need_to_verify=None, product_key=None, sign_method=None, src_version=None, type=None, udi=None):
        self.dest_version = dest_version  # type: str
        self.firmware_desc = firmware_desc  # type: str
        self.firmware_name = firmware_name  # type: str
        self.firmware_sign = firmware_sign  # type: str
        self.firmware_size = firmware_size  # type: int
        self.firmware_url = firmware_url  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.module_name = module_name  # type: str
        self.multi_files = multi_files  # type: list[CreateOTAFirmwareRequestMultiFiles]
        self.need_to_verify = need_to_verify  # type: bool
        self.product_key = product_key  # type: str
        self.sign_method = sign_method  # type: str
        self.src_version = src_version  # type: str
        self.type = type  # type: int
        self.udi = udi  # type: str

    def validate(self):
        self.validate_required(self.dest_version, 'dest_version')
        self.validate_required(self.firmware_name, 'firmware_name')
        if self.multi_files:
            for k in self.multi_files:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(CreateOTAFirmwareRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dest_version is not None:
            result['DestVersion'] = self.dest_version
        if self.firmware_desc is not None:
            result['FirmwareDesc'] = self.firmware_desc
        if self.firmware_name is not None:
            result['FirmwareName'] = self.firmware_name
        if self.firmware_sign is not None:
            result['FirmwareSign'] = self.firmware_sign
        if self.firmware_size is not None:
            result['FirmwareSize'] = self.firmware_size
        if self.firmware_url is not None:
            result['FirmwareUrl'] = self.firmware_url
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.module_name is not None:
            result['ModuleName'] = self.module_name
        result['MultiFiles'] = []
        if self.multi_files is not None:
            for k in self.multi_files:
                result['MultiFiles'].append(k.to_map() if k else None)
        if self.need_to_verify is not None:
            result['NeedToVerify'] = self.need_to_verify
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.sign_method is not None:
            result['SignMethod'] = self.sign_method
        if self.src_version is not None:
            result['SrcVersion'] = self.src_version
        if self.type is not None:
            result['Type'] = self.type
        if self.udi is not None:
            result['Udi'] = self.udi
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DestVersion') is not None:
            self.dest_version = m.get('DestVersion')
        if m.get('FirmwareDesc') is not None:
            self.firmware_desc = m.get('FirmwareDesc')
        if m.get('FirmwareName') is not None:
            self.firmware_name = m.get('FirmwareName')
        if m.get('FirmwareSign') is not None:
            self.firmware_sign = m.get('FirmwareSign')
        if m.get('FirmwareSize') is not None:
            self.firmware_size = m.get('FirmwareSize')
        if m.get('FirmwareUrl') is not None:
            self.firmware_url = m.get('FirmwareUrl')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModuleName') is not None:
            self.module_name = m.get('ModuleName')
        self.multi_files = []
        if m.get('MultiFiles') is not None:
            for k in m.get('MultiFiles'):
                temp_model = CreateOTAFirmwareRequestMultiFiles()
                self.multi_files.append(temp_model.from_map(k))
        if m.get('NeedToVerify') is not None:
            self.need_to_verify = m.get('NeedToVerify')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SignMethod') is not None:
            self.sign_method = m.get('SignMethod')
        if m.get('SrcVersion') is not None:
            self.src_version = m.get('SrcVersion')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('Udi') is not None:
            self.udi = m.get('Udi')
        return self


class CreateOTAFirmwareResponseData(TeaModel):
    def __init__(self, firmware_id=None, utc_create=None):
        self.firmware_id = firmware_id  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(CreateOTAFirmwareResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class CreateOTAFirmwareResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateOTAFirmwareResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateOTAFirmwareResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateOTAFirmwareResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateOTAModuleRequest(TeaModel):
    def __init__(self, alias_name=None, desc=None, iot_instance_id=None, module_name=None, product_key=None):
        self.alias_name = alias_name  # type: str
        self.desc = desc  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.module_name = module_name  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.module_name, 'module_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(CreateOTAModuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.alias_name is not None:
            result['AliasName'] = self.alias_name
        if self.desc is not None:
            result['Desc'] = self.desc
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.module_name is not None:
            result['ModuleName'] = self.module_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AliasName') is not None:
            self.alias_name = m.get('AliasName')
        if m.get('Desc') is not None:
            self.desc = m.get('Desc')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModuleName') is not None:
            self.module_name = m.get('ModuleName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class CreateOTAModuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateOTAModuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateOTAStaticUpgradeJobRequestTag(TeaModel):
    def __init__(self, key=None, value=None):
        self.key = key  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.key, 'key')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(CreateOTAStaticUpgradeJobRequestTag, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.key is not None:
            result['Key'] = self.key
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Key') is not None:
            self.key = m.get('Key')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class CreateOTAStaticUpgradeJobRequest(TeaModel):
    def __init__(self, dn_list_file_url=None, download_protocol=None, firmware_id=None, gray_percent=None,
                 group_id=None, group_type=None, iot_instance_id=None, maximum_per_minute=None, multi_module_mode=None,
                 need_confirm=None, need_push=None, overwrite_mode=None, product_key=None, retry_count=None, retry_interval=None,
                 schedule_finish_time=None, schedule_time=None, src_version=None, tag=None, target_device_name=None,
                 target_selection=None, timeout_in_minutes=None):
        self.dn_list_file_url = dn_list_file_url  # type: str
        self.download_protocol = download_protocol  # type: str
        self.firmware_id = firmware_id  # type: str
        self.gray_percent = gray_percent  # type: str
        self.group_id = group_id  # type: str
        self.group_type = group_type  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.maximum_per_minute = maximum_per_minute  # type: int
        self.multi_module_mode = multi_module_mode  # type: bool
        self.need_confirm = need_confirm  # type: bool
        self.need_push = need_push  # type: bool
        self.overwrite_mode = overwrite_mode  # type: int
        self.product_key = product_key  # type: str
        self.retry_count = retry_count  # type: int
        self.retry_interval = retry_interval  # type: int
        self.schedule_finish_time = schedule_finish_time  # type: long
        self.schedule_time = schedule_time  # type: long
        self.src_version = src_version  # type: list[str]
        self.tag = tag  # type: list[CreateOTAStaticUpgradeJobRequestTag]
        self.target_device_name = target_device_name  # type: list[str]
        self.target_selection = target_selection  # type: str
        self.timeout_in_minutes = timeout_in_minutes  # type: int

    def validate(self):
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.product_key, 'product_key')
        if self.tag:
            for k in self.tag:
                if k:
                    k.validate()
        self.validate_required(self.target_selection, 'target_selection')

    def to_map(self):
        _map = super(CreateOTAStaticUpgradeJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dn_list_file_url is not None:
            result['DnListFileUrl'] = self.dn_list_file_url
        if self.download_protocol is not None:
            result['DownloadProtocol'] = self.download_protocol
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.gray_percent is not None:
            result['GrayPercent'] = self.gray_percent
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_type is not None:
            result['GroupType'] = self.group_type
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.maximum_per_minute is not None:
            result['MaximumPerMinute'] = self.maximum_per_minute
        if self.multi_module_mode is not None:
            result['MultiModuleMode'] = self.multi_module_mode
        if self.need_confirm is not None:
            result['NeedConfirm'] = self.need_confirm
        if self.need_push is not None:
            result['NeedPush'] = self.need_push
        if self.overwrite_mode is not None:
            result['OverwriteMode'] = self.overwrite_mode
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.retry_count is not None:
            result['RetryCount'] = self.retry_count
        if self.retry_interval is not None:
            result['RetryInterval'] = self.retry_interval
        if self.schedule_finish_time is not None:
            result['ScheduleFinishTime'] = self.schedule_finish_time
        if self.schedule_time is not None:
            result['ScheduleTime'] = self.schedule_time
        if self.src_version is not None:
            result['SrcVersion'] = self.src_version
        result['Tag'] = []
        if self.tag is not None:
            for k in self.tag:
                result['Tag'].append(k.to_map() if k else None)
        if self.target_device_name is not None:
            result['TargetDeviceName'] = self.target_device_name
        if self.target_selection is not None:
            result['TargetSelection'] = self.target_selection
        if self.timeout_in_minutes is not None:
            result['TimeoutInMinutes'] = self.timeout_in_minutes
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DnListFileUrl') is not None:
            self.dn_list_file_url = m.get('DnListFileUrl')
        if m.get('DownloadProtocol') is not None:
            self.download_protocol = m.get('DownloadProtocol')
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('GrayPercent') is not None:
            self.gray_percent = m.get('GrayPercent')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupType') is not None:
            self.group_type = m.get('GroupType')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('MaximumPerMinute') is not None:
            self.maximum_per_minute = m.get('MaximumPerMinute')
        if m.get('MultiModuleMode') is not None:
            self.multi_module_mode = m.get('MultiModuleMode')
        if m.get('NeedConfirm') is not None:
            self.need_confirm = m.get('NeedConfirm')
        if m.get('NeedPush') is not None:
            self.need_push = m.get('NeedPush')
        if m.get('OverwriteMode') is not None:
            self.overwrite_mode = m.get('OverwriteMode')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RetryCount') is not None:
            self.retry_count = m.get('RetryCount')
        if m.get('RetryInterval') is not None:
            self.retry_interval = m.get('RetryInterval')
        if m.get('ScheduleFinishTime') is not None:
            self.schedule_finish_time = m.get('ScheduleFinishTime')
        if m.get('ScheduleTime') is not None:
            self.schedule_time = m.get('ScheduleTime')
        if m.get('SrcVersion') is not None:
            self.src_version = m.get('SrcVersion')
        self.tag = []
        if m.get('Tag') is not None:
            for k in m.get('Tag'):
                temp_model = CreateOTAStaticUpgradeJobRequestTag()
                self.tag.append(temp_model.from_map(k))
        if m.get('TargetDeviceName') is not None:
            self.target_device_name = m.get('TargetDeviceName')
        if m.get('TargetSelection') is not None:
            self.target_selection = m.get('TargetSelection')
        if m.get('TimeoutInMinutes') is not None:
            self.timeout_in_minutes = m.get('TimeoutInMinutes')
        return self


class CreateOTAStaticUpgradeJobResponseData(TeaModel):
    def __init__(self, job_id=None, utc_create=None):
        self.job_id = job_id  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(CreateOTAStaticUpgradeJobResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class CreateOTAStaticUpgradeJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateOTAStaticUpgradeJobResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateOTAStaticUpgradeJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateOTAStaticUpgradeJobResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateOTAVerifyJobRequestTag(TeaModel):
    def __init__(self, key=None, value=None):
        self.key = key  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.key, 'key')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(CreateOTAVerifyJobRequestTag, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.key is not None:
            result['Key'] = self.key
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Key') is not None:
            self.key = m.get('Key')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class CreateOTAVerifyJobRequest(TeaModel):
    def __init__(self, download_protocol=None, firmware_id=None, iot_instance_id=None, need_confirm=None,
                 need_push=None, product_key=None, tag=None, target_device_name=None, timeout_in_minutes=None):
        self.download_protocol = download_protocol  # type: str
        self.firmware_id = firmware_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.need_confirm = need_confirm  # type: bool
        self.need_push = need_push  # type: bool
        self.product_key = product_key  # type: str
        self.tag = tag  # type: list[CreateOTAVerifyJobRequestTag]
        self.target_device_name = target_device_name  # type: list[str]
        self.timeout_in_minutes = timeout_in_minutes  # type: int

    def validate(self):
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.product_key, 'product_key')
        if self.tag:
            for k in self.tag:
                if k:
                    k.validate()
        self.validate_required(self.target_device_name, 'target_device_name')

    def to_map(self):
        _map = super(CreateOTAVerifyJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.download_protocol is not None:
            result['DownloadProtocol'] = self.download_protocol
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.need_confirm is not None:
            result['NeedConfirm'] = self.need_confirm
        if self.need_push is not None:
            result['NeedPush'] = self.need_push
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        result['Tag'] = []
        if self.tag is not None:
            for k in self.tag:
                result['Tag'].append(k.to_map() if k else None)
        if self.target_device_name is not None:
            result['TargetDeviceName'] = self.target_device_name
        if self.timeout_in_minutes is not None:
            result['TimeoutInMinutes'] = self.timeout_in_minutes
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DownloadProtocol') is not None:
            self.download_protocol = m.get('DownloadProtocol')
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('NeedConfirm') is not None:
            self.need_confirm = m.get('NeedConfirm')
        if m.get('NeedPush') is not None:
            self.need_push = m.get('NeedPush')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        self.tag = []
        if m.get('Tag') is not None:
            for k in m.get('Tag'):
                temp_model = CreateOTAVerifyJobRequestTag()
                self.tag.append(temp_model.from_map(k))
        if m.get('TargetDeviceName') is not None:
            self.target_device_name = m.get('TargetDeviceName')
        if m.get('TimeoutInMinutes') is not None:
            self.timeout_in_minutes = m.get('TimeoutInMinutes')
        return self


class CreateOTAVerifyJobResponseData(TeaModel):
    def __init__(self, job_id=None, utc_create=None):
        self.job_id = job_id  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(CreateOTAVerifyJobResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class CreateOTAVerifyJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateOTAVerifyJobResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateOTAVerifyJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateOTAVerifyJobResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateParserRequest(TeaModel):
    def __init__(self, description=None, iot_instance_id=None, name=None):
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str

    def validate(self):
        self.validate_required(self.name, 'name')

    def to_map(self):
        _map = super(CreateParserRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        return self


class CreateParserResponse(TeaModel):
    def __init__(self, code=None, error_message=None, parser_id=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.parser_id = parser_id  # type: long
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.parser_id, 'parser_id')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateParserResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateParserDataSourceRequest(TeaModel):
    def __init__(self, description=None, iot_instance_id=None, name=None):
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str

    def validate(self):
        self.validate_required(self.name, 'name')

    def to_map(self):
        _map = super(CreateParserDataSourceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        return self


class CreateParserDataSourceResponseDataSource(TeaModel):
    def __init__(self, data_source_id=None, description=None, name=None, utc_created=None):
        self.data_source_id = data_source_id  # type: long
        self.description = description  # type: str
        self.name = name  # type: str
        self.utc_created = utc_created  # type: str

    def validate(self):
        self.validate_required(self.data_source_id, 'data_source_id')
        self.validate_required(self.description, 'description')
        self.validate_required(self.name, 'name')
        self.validate_required(self.utc_created, 'utc_created')

    def to_map(self):
        _map = super(CreateParserDataSourceResponseDataSource, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.description is not None:
            result['Description'] = self.description
        if self.name is not None:
            result['Name'] = self.name
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        return self


class CreateParserDataSourceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data_source=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data_source = data_source  # type: CreateParserDataSourceResponseDataSource

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data_source, 'data_source')
        if self.data_source:
            self.data_source.validate()

    def to_map(self):
        _map = super(CreateParserDataSourceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data_source is not None:
            result['DataSource'] = self.data_source.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('DataSource') is not None:
            temp_model = CreateParserDataSourceResponseDataSource()
            self.data_source = temp_model.from_map(m['DataSource'])
        return self


class CreateProductRequest(TeaModel):
    def __init__(self, aliyun_commodity_code=None, auth_type=None, category_key=None, data_format=None,
                 description=None, id_2=None, iot_instance_id=None, join_permission_id=None, net_type=None, node_type=None,
                 product_name=None, protocol_type=None, publish_auto=None, resource_group_id=None, validate_type=None):
        self.aliyun_commodity_code = aliyun_commodity_code  # type: str
        self.auth_type = auth_type  # type: str
        self.category_key = category_key  # type: str
        self.data_format = data_format  # type: int
        self.description = description  # type: str
        self.id_2 = id_2  # type: bool
        self.iot_instance_id = iot_instance_id  # type: str
        self.join_permission_id = join_permission_id  # type: str
        self.net_type = net_type  # type: str
        self.node_type = node_type  # type: int
        self.product_name = product_name  # type: str
        self.protocol_type = protocol_type  # type: str
        self.publish_auto = publish_auto  # type: bool
        self.resource_group_id = resource_group_id  # type: str
        self.validate_type = validate_type  # type: int

    def validate(self):
        self.validate_required(self.node_type, 'node_type')
        self.validate_required(self.product_name, 'product_name')

    def to_map(self):
        _map = super(CreateProductRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.aliyun_commodity_code is not None:
            result['AliyunCommodityCode'] = self.aliyun_commodity_code
        if self.auth_type is not None:
            result['AuthType'] = self.auth_type
        if self.category_key is not None:
            result['CategoryKey'] = self.category_key
        if self.data_format is not None:
            result['DataFormat'] = self.data_format
        if self.description is not None:
            result['Description'] = self.description
        if self.id_2 is not None:
            result['Id2'] = self.id_2
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.join_permission_id is not None:
            result['JoinPermissionId'] = self.join_permission_id
        if self.net_type is not None:
            result['NetType'] = self.net_type
        if self.node_type is not None:
            result['NodeType'] = self.node_type
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.protocol_type is not None:
            result['ProtocolType'] = self.protocol_type
        if self.publish_auto is not None:
            result['PublishAuto'] = self.publish_auto
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        if self.validate_type is not None:
            result['ValidateType'] = self.validate_type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AliyunCommodityCode') is not None:
            self.aliyun_commodity_code = m.get('AliyunCommodityCode')
        if m.get('AuthType') is not None:
            self.auth_type = m.get('AuthType')
        if m.get('CategoryKey') is not None:
            self.category_key = m.get('CategoryKey')
        if m.get('DataFormat') is not None:
            self.data_format = m.get('DataFormat')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('Id2') is not None:
            self.id_2 = m.get('Id2')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JoinPermissionId') is not None:
            self.join_permission_id = m.get('JoinPermissionId')
        if m.get('NetType') is not None:
            self.net_type = m.get('NetType')
        if m.get('NodeType') is not None:
            self.node_type = m.get('NodeType')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('ProtocolType') is not None:
            self.protocol_type = m.get('ProtocolType')
        if m.get('PublishAuto') is not None:
            self.publish_auto = m.get('PublishAuto')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        if m.get('ValidateType') is not None:
            self.validate_type = m.get('ValidateType')
        return self


class CreateProductResponseData(TeaModel):
    def __init__(self, aliyun_commodity_code=None, auth_type=None, data_format=None, description=None, id_2=None,
                 node_type=None, product_key=None, product_name=None, product_secret=None, protocol_type=None):
        self.aliyun_commodity_code = aliyun_commodity_code  # type: str
        self.auth_type = auth_type  # type: str
        self.data_format = data_format  # type: int
        self.description = description  # type: str
        self.id_2 = id_2  # type: bool
        self.node_type = node_type  # type: int
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str
        self.product_secret = product_secret  # type: str
        self.protocol_type = protocol_type  # type: str

    def validate(self):
        self.validate_required(self.aliyun_commodity_code, 'aliyun_commodity_code')
        self.validate_required(self.auth_type, 'auth_type')
        self.validate_required(self.data_format, 'data_format')
        self.validate_required(self.description, 'description')
        self.validate_required(self.id_2, 'id_2')
        self.validate_required(self.node_type, 'node_type')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')
        self.validate_required(self.product_secret, 'product_secret')
        self.validate_required(self.protocol_type, 'protocol_type')

    def to_map(self):
        _map = super(CreateProductResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.aliyun_commodity_code is not None:
            result['AliyunCommodityCode'] = self.aliyun_commodity_code
        if self.auth_type is not None:
            result['AuthType'] = self.auth_type
        if self.data_format is not None:
            result['DataFormat'] = self.data_format
        if self.description is not None:
            result['Description'] = self.description
        if self.id_2 is not None:
            result['Id2'] = self.id_2
        if self.node_type is not None:
            result['NodeType'] = self.node_type
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.product_secret is not None:
            result['ProductSecret'] = self.product_secret
        if self.protocol_type is not None:
            result['ProtocolType'] = self.protocol_type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AliyunCommodityCode') is not None:
            self.aliyun_commodity_code = m.get('AliyunCommodityCode')
        if m.get('AuthType') is not None:
            self.auth_type = m.get('AuthType')
        if m.get('DataFormat') is not None:
            self.data_format = m.get('DataFormat')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('Id2') is not None:
            self.id_2 = m.get('Id2')
        if m.get('NodeType') is not None:
            self.node_type = m.get('NodeType')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('ProductSecret') is not None:
            self.product_secret = m.get('ProductSecret')
        if m.get('ProtocolType') is not None:
            self.protocol_type = m.get('ProtocolType')
        return self


class CreateProductResponse(TeaModel):
    def __init__(self, code=None, error_message=None, product_key=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.product_key = product_key  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateProductResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateProductResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateProductResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateProductDistributeJobRequest(TeaModel):
    def __init__(self, product_key=None, source_instance_id=None, target_aliyun_id=None, target_instance_id=None,
                 target_uid=None):
        self.product_key = product_key  # type: str
        self.source_instance_id = source_instance_id  # type: str
        self.target_aliyun_id = target_aliyun_id  # type: str
        self.target_instance_id = target_instance_id  # type: str
        self.target_uid = target_uid  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.source_instance_id, 'source_instance_id')
        self.validate_required(self.target_instance_id, 'target_instance_id')

    def to_map(self):
        _map = super(CreateProductDistributeJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.source_instance_id is not None:
            result['SourceInstanceId'] = self.source_instance_id
        if self.target_aliyun_id is not None:
            result['TargetAliyunId'] = self.target_aliyun_id
        if self.target_instance_id is not None:
            result['TargetInstanceId'] = self.target_instance_id
        if self.target_uid is not None:
            result['TargetUid'] = self.target_uid
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SourceInstanceId') is not None:
            self.source_instance_id = m.get('SourceInstanceId')
        if m.get('TargetAliyunId') is not None:
            self.target_aliyun_id = m.get('TargetAliyunId')
        if m.get('TargetInstanceId') is not None:
            self.target_instance_id = m.get('TargetInstanceId')
        if m.get('TargetUid') is not None:
            self.target_uid = m.get('TargetUid')
        return self


class CreateProductDistributeJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, job_id=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.job_id = job_id  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateProductDistributeJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateProductTagsRequestProductTag(TeaModel):
    def __init__(self, tag_key=None, tag_value=None):
        self.tag_key = tag_key  # type: str
        self.tag_value = tag_value  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(CreateProductTagsRequestProductTag, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tag_key is not None:
            result['TagKey'] = self.tag_key
        if self.tag_value is not None:
            result['TagValue'] = self.tag_value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TagKey') is not None:
            self.tag_key = m.get('TagKey')
        if m.get('TagValue') is not None:
            self.tag_value = m.get('TagValue')
        return self


class CreateProductTagsRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None, product_tag=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.product_tag = product_tag  # type: list[CreateProductTagsRequestProductTag]

    def validate(self):
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_tag, 'product_tag')
        if self.product_tag:
            for k in self.product_tag:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(CreateProductTagsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        result['ProductTag'] = []
        if self.product_tag is not None:
            for k in self.product_tag:
                result['ProductTag'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        self.product_tag = []
        if m.get('ProductTag') is not None:
            for k in m.get('ProductTag'):
                temp_model = CreateProductTagsRequestProductTag()
                self.product_tag.append(temp_model.from_map(k))
        return self


class CreateProductTagsResponseInvalidProductTagsProductTag(TeaModel):
    def __init__(self, tag_key=None, tag_value=None):
        self.tag_key = tag_key  # type: str
        self.tag_value = tag_value  # type: str

    def validate(self):
        self.validate_required(self.tag_key, 'tag_key')
        self.validate_required(self.tag_value, 'tag_value')

    def to_map(self):
        _map = super(CreateProductTagsResponseInvalidProductTagsProductTag, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tag_key is not None:
            result['TagKey'] = self.tag_key
        if self.tag_value is not None:
            result['TagValue'] = self.tag_value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TagKey') is not None:
            self.tag_key = m.get('TagKey')
        if m.get('TagValue') is not None:
            self.tag_value = m.get('TagValue')
        return self


class CreateProductTagsResponseInvalidProductTags(TeaModel):
    def __init__(self, product_tag=None):
        self.product_tag = product_tag  # type: list[CreateProductTagsResponseInvalidProductTagsProductTag]

    def validate(self):
        self.validate_required(self.product_tag, 'product_tag')
        if self.product_tag:
            for k in self.product_tag:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(CreateProductTagsResponseInvalidProductTags, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ProductTag'] = []
        if self.product_tag is not None:
            for k in self.product_tag:
                result['ProductTag'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.product_tag = []
        if m.get('ProductTag') is not None:
            for k in m.get('ProductTag'):
                temp_model = CreateProductTagsResponseInvalidProductTagsProductTag()
                self.product_tag.append(temp_model.from_map(k))
        return self


class CreateProductTagsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, invalid_product_tags=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.invalid_product_tags = invalid_product_tags  # type: CreateProductTagsResponseInvalidProductTags

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.invalid_product_tags, 'invalid_product_tags')
        if self.invalid_product_tags:
            self.invalid_product_tags.validate()

    def to_map(self):
        _map = super(CreateProductTagsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.invalid_product_tags is not None:
            result['InvalidProductTags'] = self.invalid_product_tags.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('InvalidProductTags') is not None:
            temp_model = CreateProductTagsResponseInvalidProductTags()
            self.invalid_product_tags = temp_model.from_map(m['InvalidProductTags'])
        return self


class CreateProductTopicRequest(TeaModel):
    def __init__(self, desc=None, iot_instance_id=None, operation=None, product_key=None, topic_short_name=None):
        self.desc = desc  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.operation = operation  # type: str
        self.product_key = product_key  # type: str
        self.topic_short_name = topic_short_name  # type: str

    def validate(self):
        self.validate_required(self.operation, 'operation')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.topic_short_name, 'topic_short_name')

    def to_map(self):
        _map = super(CreateProductTopicRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.desc is not None:
            result['Desc'] = self.desc
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.operation is not None:
            result['Operation'] = self.operation
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.topic_short_name is not None:
            result['TopicShortName'] = self.topic_short_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Desc') is not None:
            self.desc = m.get('Desc')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Operation') is not None:
            self.operation = m.get('Operation')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('TopicShortName') is not None:
            self.topic_short_name = m.get('TopicShortName')
        return self


class CreateProductTopicResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, topic_id=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.topic_id = topic_id  # type: long

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.topic_id, 'topic_id')

    def to_map(self):
        _map = super(CreateProductTopicResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.topic_id is not None:
            result['TopicId'] = self.topic_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('TopicId') is not None:
            self.topic_id = m.get('TopicId')
        return self


class CreateRuleRequest(TeaModel):
    def __init__(self, data_type=None, iot_instance_id=None, name=None, product_key=None, resource_group_id=None,
                 rule_desc=None, select=None, short_topic=None, topic=None, topic_type=None, where=None):
        self.data_type = data_type  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.product_key = product_key  # type: str
        self.resource_group_id = resource_group_id  # type: str
        self.rule_desc = rule_desc  # type: str
        self.select = select  # type: str
        self.short_topic = short_topic  # type: str
        self.topic = topic  # type: str
        self.topic_type = topic_type  # type: int
        self.where = where  # type: str

    def validate(self):
        self.validate_required(self.name, 'name')

    def to_map(self):
        _map = super(CreateRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_type is not None:
            result['DataType'] = self.data_type
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        if self.rule_desc is not None:
            result['RuleDesc'] = self.rule_desc
        if self.select is not None:
            result['Select'] = self.select
        if self.short_topic is not None:
            result['ShortTopic'] = self.short_topic
        if self.topic is not None:
            result['Topic'] = self.topic
        if self.topic_type is not None:
            result['TopicType'] = self.topic_type
        if self.where is not None:
            result['Where'] = self.where
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataType') is not None:
            self.data_type = m.get('DataType')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        if m.get('RuleDesc') is not None:
            self.rule_desc = m.get('RuleDesc')
        if m.get('Select') is not None:
            self.select = m.get('Select')
        if m.get('ShortTopic') is not None:
            self.short_topic = m.get('ShortTopic')
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        if m.get('TopicType') is not None:
            self.topic_type = m.get('TopicType')
        if m.get('Where') is not None:
            self.where = m.get('Where')
        return self


class CreateRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, rule_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.rule_id = rule_id  # type: long
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.rule_id, 'rule_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateRuleActionRequest(TeaModel):
    def __init__(self, configuration=None, error_action_flag=None, iot_instance_id=None, rule_id=None, type=None):
        self.configuration = configuration  # type: str
        self.error_action_flag = error_action_flag  # type: bool
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: long
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.configuration, 'configuration')
        self.validate_required(self.rule_id, 'rule_id')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(CreateRuleActionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        if self.error_action_flag is not None:
            result['ErrorActionFlag'] = self.error_action_flag
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        if m.get('ErrorActionFlag') is not None:
            self.error_action_flag = m.get('ErrorActionFlag')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class CreateRuleActionResponse(TeaModel):
    def __init__(self, action_id=None, code=None, error_message=None, request_id=None, success=None):
        self.action_id = action_id  # type: long
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.action_id, 'action_id')
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateRuleActionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.action_id is not None:
            result['ActionId'] = self.action_id
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ActionId') is not None:
            self.action_id = m.get('ActionId')
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateSceneRuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, rule_content=None, rule_description=None, rule_name=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_content = rule_content  # type: str
        self.rule_description = rule_description  # type: str
        self.rule_name = rule_name  # type: str

    def validate(self):
        self.validate_required(self.rule_name, 'rule_name')

    def to_map(self):
        _map = super(CreateSceneRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_content is not None:
            result['RuleContent'] = self.rule_content
        if self.rule_description is not None:
            result['RuleDescription'] = self.rule_description
        if self.rule_name is not None:
            result['RuleName'] = self.rule_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleContent') is not None:
            self.rule_content = m.get('RuleContent')
        if m.get('RuleDescription') is not None:
            self.rule_description = m.get('RuleDescription')
        if m.get('RuleName') is not None:
            self.rule_name = m.get('RuleName')
        return self


class CreateSceneRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, rule_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.rule_id = rule_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.rule_id, 'rule_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateSceneRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateSchedulePeriodRequest(TeaModel):
    def __init__(self, description=None, end_time=None, iot_instance_id=None, schedule_code=None,
                 sound_code_content=None, start_time=None):
        self.description = description  # type: str
        self.end_time = end_time  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.schedule_code = schedule_code  # type: str
        self.sound_code_content = sound_code_content  # type: str
        self.start_time = start_time  # type: str

    def validate(self):
        self.validate_required(self.description, 'description')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.schedule_code, 'schedule_code')
        self.validate_required(self.sound_code_content, 'sound_code_content')
        self.validate_required(self.start_time, 'start_time')

    def to_map(self):
        _map = super(CreateSchedulePeriodRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        if self.sound_code_content is not None:
            result['SoundCodeContent'] = self.sound_code_content
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        if m.get('SoundCodeContent') is not None:
            self.sound_code_content = m.get('SoundCodeContent')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class CreateSchedulePeriodResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateSchedulePeriodResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateSoundCodeRequest(TeaModel):
    def __init__(self, duration=None, iot_instance_id=None, name=None, open_type=None, sound_code_content=None):
        self.duration = duration  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.open_type = open_type  # type: str
        self.sound_code_content = sound_code_content  # type: str

    def validate(self):
        self.validate_required(self.duration, 'duration')
        self.validate_required(self.sound_code_content, 'sound_code_content')

    def to_map(self):
        _map = super(CreateSoundCodeRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.duration is not None:
            result['Duration'] = self.duration
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.open_type is not None:
            result['OpenType'] = self.open_type
        if self.sound_code_content is not None:
            result['SoundCodeContent'] = self.sound_code_content
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Duration') is not None:
            self.duration = m.get('Duration')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('OpenType') is not None:
            self.open_type = m.get('OpenType')
        if m.get('SoundCodeContent') is not None:
            self.sound_code_content = m.get('SoundCodeContent')
        return self


class CreateSoundCodeResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateSoundCodeResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateSoundCodeLabelRequest(TeaModel):
    def __init__(self, iot_instance_id=None, label=None, schedule_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.label = label  # type: str
        self.schedule_code = schedule_code  # type: str

    def validate(self):
        self.validate_required(self.label, 'label')
        self.validate_required(self.schedule_code, 'schedule_code')

    def to_map(self):
        _map = super(CreateSoundCodeLabelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.label is not None:
            result['Label'] = self.label
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Label') is not None:
            self.label = m.get('Label')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        return self


class CreateSoundCodeLabelResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateSoundCodeLabelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateSoundCodeScheduleRequest(TeaModel):
    def __init__(self, description=None, end_date=None, iot_instance_id=None, name=None, open_type=None,
                 start_date=None):
        self.description = description  # type: str
        self.end_date = end_date  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.open_type = open_type  # type: str
        self.start_date = start_date  # type: str

    def validate(self):
        self.validate_required(self.end_date, 'end_date')
        self.validate_required(self.name, 'name')
        self.validate_required(self.start_date, 'start_date')

    def to_map(self):
        _map = super(CreateSoundCodeScheduleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.end_date is not None:
            result['EndDate'] = self.end_date
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.open_type is not None:
            result['OpenType'] = self.open_type
        if self.start_date is not None:
            result['StartDate'] = self.start_date
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('EndDate') is not None:
            self.end_date = m.get('EndDate')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('OpenType') is not None:
            self.open_type = m.get('OpenType')
        if m.get('StartDate') is not None:
            self.start_date = m.get('StartDate')
        return self


class CreateSoundCodeScheduleResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateSoundCodeScheduleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateSpeechRequest(TeaModel):
    def __init__(self, audio_format=None, biz_code=None, enable_sound_code=None, iot_instance_id=None,
                 project_code=None, sound_code_config=None, speech_rate=None, speech_type=None, text=None, voice=None,
                 volume=None):
        self.audio_format = audio_format  # type: str
        self.biz_code = biz_code  # type: str
        self.enable_sound_code = enable_sound_code  # type: bool
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_code = project_code  # type: str
        self.sound_code_config = sound_code_config  # type: dict[str, any]
        self.speech_rate = speech_rate  # type: int
        self.speech_type = speech_type  # type: str
        self.text = text  # type: str
        self.voice = voice  # type: str
        self.volume = volume  # type: int

    def validate(self):
        self.validate_required(self.project_code, 'project_code')
        self.validate_required(self.voice, 'voice')

    def to_map(self):
        _map = super(CreateSpeechRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.biz_code is not None:
            result['BizCode'] = self.biz_code
        if self.enable_sound_code is not None:
            result['EnableSoundCode'] = self.enable_sound_code
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_code is not None:
            result['ProjectCode'] = self.project_code
        if self.sound_code_config is not None:
            result['SoundCodeConfig'] = self.sound_code_config
        if self.speech_rate is not None:
            result['SpeechRate'] = self.speech_rate
        if self.speech_type is not None:
            result['SpeechType'] = self.speech_type
        if self.text is not None:
            result['Text'] = self.text
        if self.voice is not None:
            result['Voice'] = self.voice
        if self.volume is not None:
            result['Volume'] = self.volume
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('BizCode') is not None:
            self.biz_code = m.get('BizCode')
        if m.get('EnableSoundCode') is not None:
            self.enable_sound_code = m.get('EnableSoundCode')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectCode') is not None:
            self.project_code = m.get('ProjectCode')
        if m.get('SoundCodeConfig') is not None:
            self.sound_code_config = m.get('SoundCodeConfig')
        if m.get('SpeechRate') is not None:
            self.speech_rate = m.get('SpeechRate')
        if m.get('SpeechType') is not None:
            self.speech_type = m.get('SpeechType')
        if m.get('Text') is not None:
            self.text = m.get('Text')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        if m.get('Volume') is not None:
            self.volume = m.get('Volume')
        return self


class CreateSpeechShrinkRequest(TeaModel):
    def __init__(self, audio_format=None, biz_code=None, enable_sound_code=None, iot_instance_id=None,
                 project_code=None, sound_code_config_shrink=None, speech_rate=None, speech_type=None, text=None, voice=None,
                 volume=None):
        self.audio_format = audio_format  # type: str
        self.biz_code = biz_code  # type: str
        self.enable_sound_code = enable_sound_code  # type: bool
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_code = project_code  # type: str
        self.sound_code_config_shrink = sound_code_config_shrink  # type: str
        self.speech_rate = speech_rate  # type: int
        self.speech_type = speech_type  # type: str
        self.text = text  # type: str
        self.voice = voice  # type: str
        self.volume = volume  # type: int

    def validate(self):
        self.validate_required(self.project_code, 'project_code')
        self.validate_required(self.voice, 'voice')

    def to_map(self):
        _map = super(CreateSpeechShrinkRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.biz_code is not None:
            result['BizCode'] = self.biz_code
        if self.enable_sound_code is not None:
            result['EnableSoundCode'] = self.enable_sound_code
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_code is not None:
            result['ProjectCode'] = self.project_code
        if self.sound_code_config_shrink is not None:
            result['SoundCodeConfig'] = self.sound_code_config_shrink
        if self.speech_rate is not None:
            result['SpeechRate'] = self.speech_rate
        if self.speech_type is not None:
            result['SpeechType'] = self.speech_type
        if self.text is not None:
            result['Text'] = self.text
        if self.voice is not None:
            result['Voice'] = self.voice
        if self.volume is not None:
            result['Volume'] = self.volume
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('BizCode') is not None:
            self.biz_code = m.get('BizCode')
        if m.get('EnableSoundCode') is not None:
            self.enable_sound_code = m.get('EnableSoundCode')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectCode') is not None:
            self.project_code = m.get('ProjectCode')
        if m.get('SoundCodeConfig') is not None:
            self.sound_code_config_shrink = m.get('SoundCodeConfig')
        if m.get('SpeechRate') is not None:
            self.speech_rate = m.get('SpeechRate')
        if m.get('SpeechType') is not None:
            self.speech_type = m.get('SpeechType')
        if m.get('Text') is not None:
            self.text = m.get('Text')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        if m.get('Volume') is not None:
            self.volume = m.get('Volume')
        return self


class CreateSpeechResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateSpeechResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateStudioAppDomainOpenRequest(TeaModel):
    def __init__(self, app_id=None, host=None, iot_instance_id=None, project_id=None, protocol=None):
        self.app_id = app_id  # type: str
        self.host = host  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_id = project_id  # type: str
        self.protocol = protocol  # type: str

    def validate(self):
        self.validate_required(self.app_id, 'app_id')
        self.validate_required(self.host, 'host')
        self.validate_required(self.project_id, 'project_id')
        self.validate_required(self.protocol, 'protocol')

    def to_map(self):
        _map = super(CreateStudioAppDomainOpenRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_id is not None:
            result['AppId'] = self.app_id
        if self.host is not None:
            result['Host'] = self.host
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        if self.protocol is not None:
            result['Protocol'] = self.protocol
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppId') is not None:
            self.app_id = m.get('AppId')
        if m.get('Host') is not None:
            self.host = m.get('Host')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        if m.get('Protocol') is not None:
            self.protocol = m.get('Protocol')
        return self


class CreateStudioAppDomainOpenResponseData(TeaModel):
    def __init__(self, app_id=None, host=None, id=None, is_beian=None, project_id=None, protocol=None, tenant_id=None):
        self.app_id = app_id  # type: str
        self.host = host  # type: str
        self.id = id  # type: int
        self.is_beian = is_beian  # type: str
        self.project_id = project_id  # type: str
        self.protocol = protocol  # type: str
        self.tenant_id = tenant_id  # type: str

    def validate(self):
        self.validate_required(self.app_id, 'app_id')
        self.validate_required(self.host, 'host')
        self.validate_required(self.id, 'id')
        self.validate_required(self.is_beian, 'is_beian')
        self.validate_required(self.project_id, 'project_id')
        self.validate_required(self.protocol, 'protocol')
        self.validate_required(self.tenant_id, 'tenant_id')

    def to_map(self):
        _map = super(CreateStudioAppDomainOpenResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_id is not None:
            result['AppId'] = self.app_id
        if self.host is not None:
            result['Host'] = self.host
        if self.id is not None:
            result['Id'] = self.id
        if self.is_beian is not None:
            result['IsBeian'] = self.is_beian
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        if self.protocol is not None:
            result['Protocol'] = self.protocol
        if self.tenant_id is not None:
            result['TenantId'] = self.tenant_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppId') is not None:
            self.app_id = m.get('AppId')
        if m.get('Host') is not None:
            self.host = m.get('Host')
        if m.get('Id') is not None:
            self.id = m.get('Id')
        if m.get('IsBeian') is not None:
            self.is_beian = m.get('IsBeian')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        if m.get('Protocol') is not None:
            self.protocol = m.get('Protocol')
        if m.get('TenantId') is not None:
            self.tenant_id = m.get('TenantId')
        return self


class CreateStudioAppDomainOpenResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: CreateStudioAppDomainOpenResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(CreateStudioAppDomainOpenResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = CreateStudioAppDomainOpenResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class CreateSubscribeRelationRequest(TeaModel):
    def __init__(self, consumer_group_ids=None, device_data_flag=None, device_life_cycle_flag=None,
                 device_status_change_flag=None, device_tag_flag=None, device_topo_life_cycle_flag=None, found_device_list_flag=None,
                 iot_instance_id=None, mns_configuration=None, ota_event_flag=None, ota_job_flag=None, ota_version_flag=None,
                 product_key=None, subscribe_flags=None, thing_history_flag=None, type=None):
        self.consumer_group_ids = consumer_group_ids  # type: list[str]
        self.device_data_flag = device_data_flag  # type: bool
        self.device_life_cycle_flag = device_life_cycle_flag  # type: bool
        self.device_status_change_flag = device_status_change_flag  # type: bool
        self.device_tag_flag = device_tag_flag  # type: bool
        self.device_topo_life_cycle_flag = device_topo_life_cycle_flag  # type: bool
        self.found_device_list_flag = found_device_list_flag  # type: bool
        self.iot_instance_id = iot_instance_id  # type: str
        self.mns_configuration = mns_configuration  # type: str
        self.ota_event_flag = ota_event_flag  # type: bool
        self.ota_job_flag = ota_job_flag  # type: bool
        self.ota_version_flag = ota_version_flag  # type: bool
        self.product_key = product_key  # type: str
        self.subscribe_flags = subscribe_flags  # type: str
        self.thing_history_flag = thing_history_flag  # type: bool
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(CreateSubscribeRelationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.consumer_group_ids is not None:
            result['ConsumerGroupIds'] = self.consumer_group_ids
        if self.device_data_flag is not None:
            result['DeviceDataFlag'] = self.device_data_flag
        if self.device_life_cycle_flag is not None:
            result['DeviceLifeCycleFlag'] = self.device_life_cycle_flag
        if self.device_status_change_flag is not None:
            result['DeviceStatusChangeFlag'] = self.device_status_change_flag
        if self.device_tag_flag is not None:
            result['DeviceTagFlag'] = self.device_tag_flag
        if self.device_topo_life_cycle_flag is not None:
            result['DeviceTopoLifeCycleFlag'] = self.device_topo_life_cycle_flag
        if self.found_device_list_flag is not None:
            result['FoundDeviceListFlag'] = self.found_device_list_flag
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.mns_configuration is not None:
            result['MnsConfiguration'] = self.mns_configuration
        if self.ota_event_flag is not None:
            result['OtaEventFlag'] = self.ota_event_flag
        if self.ota_job_flag is not None:
            result['OtaJobFlag'] = self.ota_job_flag
        if self.ota_version_flag is not None:
            result['OtaVersionFlag'] = self.ota_version_flag
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.subscribe_flags is not None:
            result['SubscribeFlags'] = self.subscribe_flags
        if self.thing_history_flag is not None:
            result['ThingHistoryFlag'] = self.thing_history_flag
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ConsumerGroupIds') is not None:
            self.consumer_group_ids = m.get('ConsumerGroupIds')
        if m.get('DeviceDataFlag') is not None:
            self.device_data_flag = m.get('DeviceDataFlag')
        if m.get('DeviceLifeCycleFlag') is not None:
            self.device_life_cycle_flag = m.get('DeviceLifeCycleFlag')
        if m.get('DeviceStatusChangeFlag') is not None:
            self.device_status_change_flag = m.get('DeviceStatusChangeFlag')
        if m.get('DeviceTagFlag') is not None:
            self.device_tag_flag = m.get('DeviceTagFlag')
        if m.get('DeviceTopoLifeCycleFlag') is not None:
            self.device_topo_life_cycle_flag = m.get('DeviceTopoLifeCycleFlag')
        if m.get('FoundDeviceListFlag') is not None:
            self.found_device_list_flag = m.get('FoundDeviceListFlag')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('MnsConfiguration') is not None:
            self.mns_configuration = m.get('MnsConfiguration')
        if m.get('OtaEventFlag') is not None:
            self.ota_event_flag = m.get('OtaEventFlag')
        if m.get('OtaJobFlag') is not None:
            self.ota_job_flag = m.get('OtaJobFlag')
        if m.get('OtaVersionFlag') is not None:
            self.ota_version_flag = m.get('OtaVersionFlag')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SubscribeFlags') is not None:
            self.subscribe_flags = m.get('SubscribeFlags')
        if m.get('ThingHistoryFlag') is not None:
            self.thing_history_flag = m.get('ThingHistoryFlag')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class CreateSubscribeRelationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateSubscribeRelationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateThingModelRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None, thing_model_json=None, function_block_id=None,
                 function_block_name=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.thing_model_json = thing_model_json  # type: str
        self.function_block_id = function_block_id  # type: str
        self.function_block_name = function_block_name  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(CreateThingModelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.thing_model_json is not None:
            result['ThingModelJson'] = self.thing_model_json
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.function_block_name is not None:
            result['FunctionBlockName'] = self.function_block_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ThingModelJson') is not None:
            self.thing_model_json = m.get('ThingModelJson')
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('FunctionBlockName') is not None:
            self.function_block_name = m.get('FunctionBlockName')
        return self


class CreateThingModelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateThingModelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateThingScriptRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None, script_content=None, script_type=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.script_content = script_content  # type: str
        self.script_type = script_type  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.script_content, 'script_content')
        self.validate_required(self.script_type, 'script_type')

    def to_map(self):
        _map = super(CreateThingScriptRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.script_content is not None:
            result['ScriptContent'] = self.script_content
        if self.script_type is not None:
            result['ScriptType'] = self.script_type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ScriptContent') is not None:
            self.script_content = m.get('ScriptContent')
        if m.get('ScriptType') is not None:
            self.script_type = m.get('ScriptType')
        return self


class CreateThingScriptResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(CreateThingScriptResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class CreateTopicRouteTableRequest(TeaModel):
    def __init__(self, dst_topic=None, iot_instance_id=None, src_topic=None):
        self.dst_topic = dst_topic  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.src_topic = src_topic  # type: str

    def validate(self):
        self.validate_required(self.dst_topic, 'dst_topic')
        self.validate_required(self.src_topic, 'src_topic')

    def to_map(self):
        _map = super(CreateTopicRouteTableRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dst_topic is not None:
            result['DstTopic'] = self.dst_topic
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.src_topic is not None:
            result['SrcTopic'] = self.src_topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DstTopic') is not None:
            self.dst_topic = m.get('DstTopic')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('SrcTopic') is not None:
            self.src_topic = m.get('SrcTopic')
        return self


class CreateTopicRouteTableResponseFailureTopics(TeaModel):
    def __init__(self, topic=None):
        self.topic = topic  # type: list[dict[str, any]]

    def validate(self):
        self.validate_required(self.topic, 'topic')

    def to_map(self):
        _map = super(CreateTopicRouteTableResponseFailureTopics, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.topic is not None:
            result['Topic'] = self.topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        return self


class CreateTopicRouteTableResponse(TeaModel):
    def __init__(self, code=None, error_message=None, is_all_succeed=None, request_id=None, success=None,
                 failure_topics=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.is_all_succeed = is_all_succeed  # type: bool
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.failure_topics = failure_topics  # type: CreateTopicRouteTableResponseFailureTopics

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.is_all_succeed, 'is_all_succeed')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.failure_topics, 'failure_topics')
        if self.failure_topics:
            self.failure_topics.validate()

    def to_map(self):
        _map = super(CreateTopicRouteTableResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.is_all_succeed is not None:
            result['IsAllSucceed'] = self.is_all_succeed
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.failure_topics is not None:
            result['FailureTopics'] = self.failure_topics.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('IsAllSucceed') is not None:
            self.is_all_succeed = m.get('IsAllSucceed')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('FailureTopics') is not None:
            temp_model = CreateTopicRouteTableResponseFailureTopics()
            self.failure_topics = temp_model.from_map(m['FailureTopics'])
        return self


class DeleteClientIdsRequest(TeaModel):
    def __init__(self, iot_id=None, iot_instance_id=None):
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(DeleteClientIdsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteClientIdsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteClientIdsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteConsumerGroupRequest(TeaModel):
    def __init__(self, group_id=None, iot_instance_id=None):
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(DeleteConsumerGroupRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteConsumerGroupResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteConsumerGroupResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteConsumerGroupSubscribeRelationRequest(TeaModel):
    def __init__(self, consumer_group_id=None, iot_instance_id=None, product_key=None):
        self.consumer_group_id = consumer_group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.consumer_group_id, 'consumer_group_id')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(DeleteConsumerGroupSubscribeRelationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.consumer_group_id is not None:
            result['ConsumerGroupId'] = self.consumer_group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ConsumerGroupId') is not None:
            self.consumer_group_id = m.get('ConsumerGroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class DeleteConsumerGroupSubscribeRelationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteConsumerGroupSubscribeRelationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteDataSourceItemRequest(TeaModel):
    def __init__(self, data_source_id=None, data_source_item_id=None, iot_instance_id=None):
        self.data_source_id = data_source_id  # type: long
        self.data_source_item_id = data_source_item_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.data_source_id, 'data_source_id')
        self.validate_required(self.data_source_item_id, 'data_source_item_id')

    def to_map(self):
        _map = super(DeleteDataSourceItemRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.data_source_item_id is not None:
            result['DataSourceItemId'] = self.data_source_item_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('DataSourceItemId') is not None:
            self.data_source_item_id = m.get('DataSourceItemId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteDataSourceItemResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteDataSourceItemResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteDestinationRequest(TeaModel):
    def __init__(self, destination_id=None, iot_instance_id=None):
        self.destination_id = destination_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.destination_id, 'destination_id')

    def to_map(self):
        _map = super(DeleteDestinationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.destination_id is not None:
            result['DestinationId'] = self.destination_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DestinationId') is not None:
            self.destination_id = m.get('DestinationId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteDestinationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteDestinationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteDeviceRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(DeleteDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class DeleteDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteDeviceDistributeJobRequest(TeaModel):
    def __init__(self, job_id=None):
        self.job_id = job_id  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(DeleteDeviceDistributeJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.job_id is not None:
            result['JobId'] = self.job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        return self


class DeleteDeviceDistributeJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteDeviceDistributeJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteDeviceDynamicGroupRequest(TeaModel):
    def __init__(self, group_id=None, iot_instance_id=None):
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.iot_instance_id, 'iot_instance_id')

    def to_map(self):
        _map = super(DeleteDeviceDynamicGroupRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteDeviceDynamicGroupResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteDeviceDynamicGroupResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteDeviceFileRequest(TeaModel):
    def __init__(self, device_name=None, file_id=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.file_id = file_id  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.file_id, 'file_id')

    def to_map(self):
        _map = super(DeleteDeviceFileRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.file_id is not None:
            result['FileId'] = self.file_id
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('FileId') is not None:
            self.file_id = m.get('FileId')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class DeleteDeviceFileResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteDeviceFileResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteDeviceGroupRequest(TeaModel):
    def __init__(self, group_id=None, iot_instance_id=None):
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(DeleteDeviceGroupRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteDeviceGroupResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteDeviceGroupResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteDevicePropRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None, prop_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.prop_key = prop_key  # type: str

    def validate(self):
        self.validate_required(self.prop_key, 'prop_key')

    def to_map(self):
        _map = super(DeleteDevicePropRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.prop_key is not None:
            result['PropKey'] = self.prop_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('PropKey') is not None:
            self.prop_key = m.get('PropKey')
        return self


class DeleteDevicePropResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteDevicePropResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteDeviceSpeechRequestDeviceSpeechList(TeaModel):
    def __init__(self, audio_format=None, biz_code=None):
        self.audio_format = audio_format  # type: str
        self.biz_code = biz_code  # type: str

    def validate(self):
        self.validate_required(self.audio_format, 'audio_format')
        self.validate_required(self.biz_code, 'biz_code')

    def to_map(self):
        _map = super(DeleteDeviceSpeechRequestDeviceSpeechList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.biz_code is not None:
            result['BizCode'] = self.biz_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('BizCode') is not None:
            self.biz_code = m.get('BizCode')
        return self


class DeleteDeviceSpeechRequest(TeaModel):
    def __init__(self, device_speech_list=None, iot_id=None, iot_instance_id=None):
        self.device_speech_list = device_speech_list  # type: list[DeleteDeviceSpeechRequestDeviceSpeechList]
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.device_speech_list, 'device_speech_list')
        if self.device_speech_list:
            for k in self.device_speech_list:
                if k:
                    k.validate()
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(DeleteDeviceSpeechRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DeviceSpeechList'] = []
        if self.device_speech_list is not None:
            for k in self.device_speech_list:
                result['DeviceSpeechList'].append(k.to_map() if k else None)
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_speech_list = []
        if m.get('DeviceSpeechList') is not None:
            for k in m.get('DeviceSpeechList'):
                temp_model = DeleteDeviceSpeechRequestDeviceSpeechList()
                self.device_speech_list.append(temp_model.from_map(k))
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteDeviceSpeechResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteDeviceSpeechResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteDeviceTunnelRequest(TeaModel):
    def __init__(self, tunnel_id=None, iot_instance_id=None):
        self.tunnel_id = tunnel_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.tunnel_id, 'tunnel_id')

    def to_map(self):
        _map = super(DeleteDeviceTunnelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tunnel_id is not None:
            result['TunnelId'] = self.tunnel_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TunnelId') is not None:
            self.tunnel_id = m.get('TunnelId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteDeviceTunnelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteDeviceTunnelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteEdgeDriverRequest(TeaModel):
    def __init__(self, driver_id=None, iot_instance_id=None):
        self.driver_id = driver_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')

    def to_map(self):
        _map = super(DeleteEdgeDriverRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteEdgeDriverResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteEdgeDriverResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteEdgeDriverVersionRequest(TeaModel):
    def __init__(self, driver_id=None, driver_version=None, iot_instance_id=None):
        self.driver_id = driver_id  # type: str
        self.driver_version = driver_version  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.driver_version, 'driver_version')

    def to_map(self):
        _map = super(DeleteEdgeDriverVersionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_version is not None:
            result['DriverVersion'] = self.driver_version
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverVersion') is not None:
            self.driver_version = m.get('DriverVersion')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteEdgeDriverVersionResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteEdgeDriverVersionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteEdgeInstanceRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(DeleteEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteEdgeInstanceMessageRoutingRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None, route_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.route_id = route_id  # type: long

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.route_id, 'route_id')

    def to_map(self):
        _map = super(DeleteEdgeInstanceMessageRoutingRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.route_id is not None:
            result['RouteId'] = self.route_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RouteId') is not None:
            self.route_id = m.get('RouteId')
        return self


class DeleteEdgeInstanceMessageRoutingResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteEdgeInstanceMessageRoutingResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteJobRequest(TeaModel):
    def __init__(self, iot_instance_id=None, job_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(DeleteJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        return self


class DeleteJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteOTAFirmwareRequest(TeaModel):
    def __init__(self, firmware_id=None, iot_instance_id=None):
        self.firmware_id = firmware_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.firmware_id, 'firmware_id')

    def to_map(self):
        _map = super(DeleteOTAFirmwareRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteOTAFirmwareResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteOTAFirmwareResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteOTAModuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, module_name=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.module_name = module_name  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.module_name, 'module_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(DeleteOTAModuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.module_name is not None:
            result['ModuleName'] = self.module_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModuleName') is not None:
            self.module_name = m.get('ModuleName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class DeleteOTAModuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteOTAModuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteParserRequest(TeaModel):
    def __init__(self, iot_instance_id=None, parser_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.parser_id = parser_id  # type: long

    def validate(self):
        self.validate_required(self.parser_id, 'parser_id')

    def to_map(self):
        _map = super(DeleteParserRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        return self


class DeleteParserResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteParserResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteParserDataSourceRequest(TeaModel):
    def __init__(self, data_source_id=None, iot_instance_id=None):
        self.data_source_id = data_source_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.data_source_id, 'data_source_id')

    def to_map(self):
        _map = super(DeleteParserDataSourceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteParserDataSourceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteParserDataSourceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteProductRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(DeleteProductRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class DeleteProductResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteProductResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteProductTagsRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None, product_tag_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.product_tag_key = product_tag_key  # type: list[str]

    def validate(self):
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_tag_key, 'product_tag_key')

    def to_map(self):
        _map = super(DeleteProductTagsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_tag_key is not None:
            result['ProductTagKey'] = self.product_tag_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductTagKey') is not None:
            self.product_tag_key = m.get('ProductTagKey')
        return self


class DeleteProductTagsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteProductTagsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteProductTopicRequest(TeaModel):
    def __init__(self, iot_instance_id=None, topic_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.topic_id = topic_id  # type: str

    def validate(self):
        self.validate_required(self.topic_id, 'topic_id')

    def to_map(self):
        _map = super(DeleteProductTopicRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.topic_id is not None:
            result['TopicId'] = self.topic_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('TopicId') is not None:
            self.topic_id = m.get('TopicId')
        return self


class DeleteProductTopicResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteProductTopicResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteRuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, rule_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: long

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(DeleteRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class DeleteRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteRuleActionRequest(TeaModel):
    def __init__(self, action_id=None, iot_instance_id=None):
        self.action_id = action_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.action_id, 'action_id')

    def to_map(self):
        _map = super(DeleteRuleActionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.action_id is not None:
            result['ActionId'] = self.action_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ActionId') is not None:
            self.action_id = m.get('ActionId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class DeleteRuleActionResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteRuleActionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteSceneRuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, rule_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: str

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(DeleteSceneRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class DeleteSceneRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteSceneRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteSchedulePeriodRequest(TeaModel):
    def __init__(self, iot_instance_id=None, period_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.period_code = period_code  # type: str

    def validate(self):
        self.validate_required(self.period_code, 'period_code')

    def to_map(self):
        _map = super(DeleteSchedulePeriodRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.period_code is not None:
            result['PeriodCode'] = self.period_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PeriodCode') is not None:
            self.period_code = m.get('PeriodCode')
        return self


class DeleteSchedulePeriodResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteSchedulePeriodResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteShareTaskDeviceRequest(TeaModel):
    def __init__(self, iot_id_list=None, iot_instance_id=None, share_task_id=None):
        self.iot_id_list = iot_id_list  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.share_task_id = share_task_id  # type: str

    def validate(self):
        self.validate_required(self.share_task_id, 'share_task_id')

    def to_map(self):
        _map = super(DeleteShareTaskDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_id_list is not None:
            result['IotIdList'] = self.iot_id_list
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.share_task_id is not None:
            result['ShareTaskId'] = self.share_task_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotIdList') is not None:
            self.iot_id_list = m.get('IotIdList')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ShareTaskId') is not None:
            self.share_task_id = m.get('ShareTaskId')
        return self


class DeleteShareTaskDeviceResponseData(TeaModel):
    def __init__(self, progress=None, progress_id=None):
        self.progress = progress  # type: int
        self.progress_id = progress_id  # type: str

    def validate(self):
        self.validate_required(self.progress, 'progress')
        self.validate_required(self.progress_id, 'progress_id')

    def to_map(self):
        _map = super(DeleteShareTaskDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.progress is not None:
            result['Progress'] = self.progress
        if self.progress_id is not None:
            result['ProgressId'] = self.progress_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Progress') is not None:
            self.progress = m.get('Progress')
        if m.get('ProgressId') is not None:
            self.progress_id = m.get('ProgressId')
        return self


class DeleteShareTaskDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: DeleteShareTaskDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(DeleteShareTaskDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = DeleteShareTaskDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class DeleteSoundCodeRequest(TeaModel):
    def __init__(self, iot_instance_id=None, sound_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.sound_code = sound_code  # type: str

    def validate(self):
        self.validate_required(self.sound_code, 'sound_code')

    def to_map(self):
        _map = super(DeleteSoundCodeRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.sound_code is not None:
            result['SoundCode'] = self.sound_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('SoundCode') is not None:
            self.sound_code = m.get('SoundCode')
        return self


class DeleteSoundCodeResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteSoundCodeResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteSoundCodeLabelRequest(TeaModel):
    def __init__(self, iot_instance_id=None, sound_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.sound_code = sound_code  # type: str

    def validate(self):
        self.validate_required(self.sound_code, 'sound_code')

    def to_map(self):
        _map = super(DeleteSoundCodeLabelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.sound_code is not None:
            result['SoundCode'] = self.sound_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('SoundCode') is not None:
            self.sound_code = m.get('SoundCode')
        return self


class DeleteSoundCodeLabelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteSoundCodeLabelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteSoundCodeScheduleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, schedule_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.schedule_code = schedule_code  # type: str

    def validate(self):
        self.validate_required(self.schedule_code, 'schedule_code')

    def to_map(self):
        _map = super(DeleteSoundCodeScheduleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        return self


class DeleteSoundCodeScheduleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteSoundCodeScheduleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteSpeechRequest(TeaModel):
    def __init__(self, iot_instance_id=None, speech_code_list=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.speech_code_list = speech_code_list  # type: list[str]

    def validate(self):
        self.validate_required(self.speech_code_list, 'speech_code_list')

    def to_map(self):
        _map = super(DeleteSpeechRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.speech_code_list is not None:
            result['SpeechCodeList'] = self.speech_code_list
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('SpeechCodeList') is not None:
            self.speech_code_list = m.get('SpeechCodeList')
        return self


class DeleteSpeechResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteSpeechResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteStudioAppDomainOpenRequest(TeaModel):
    def __init__(self, app_id=None, domain_id=None, iot_instance_id=None, project_id=None):
        self.app_id = app_id  # type: str
        self.domain_id = domain_id  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.app_id, 'app_id')
        self.validate_required(self.domain_id, 'domain_id')
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(DeleteStudioAppDomainOpenRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_id is not None:
            result['AppId'] = self.app_id
        if self.domain_id is not None:
            result['DomainId'] = self.domain_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppId') is not None:
            self.app_id = m.get('AppId')
        if m.get('DomainId') is not None:
            self.domain_id = m.get('DomainId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class DeleteStudioAppDomainOpenResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: bool
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteStudioAppDomainOpenResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteSubscribeRelationRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None, type=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(DeleteSubscribeRelationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class DeleteSubscribeRelationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteSubscribeRelationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteThingModelRequest(TeaModel):
    def __init__(self, event_identifier=None, function_block_id=None, iot_instance_id=None, product_key=None,
                 property_identifier=None, resource_group_id=None, service_identifier=None):
        self.event_identifier = event_identifier  # type: list[str]
        self.function_block_id = function_block_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.property_identifier = property_identifier  # type: list[str]
        self.resource_group_id = resource_group_id  # type: str
        self.service_identifier = service_identifier  # type: list[str]

    def validate(self):
        pass

    def to_map(self):
        _map = super(DeleteThingModelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.event_identifier is not None:
            result['EventIdentifier'] = self.event_identifier
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.property_identifier is not None:
            result['PropertyIdentifier'] = self.property_identifier
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        if self.service_identifier is not None:
            result['ServiceIdentifier'] = self.service_identifier
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('EventIdentifier') is not None:
            self.event_identifier = m.get('EventIdentifier')
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('PropertyIdentifier') is not None:
            self.property_identifier = m.get('PropertyIdentifier')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        if m.get('ServiceIdentifier') is not None:
            self.service_identifier = m.get('ServiceIdentifier')
        return self


class DeleteThingModelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DeleteThingModelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DeleteTopicRouteTableRequest(TeaModel):
    def __init__(self, dst_topic=None, iot_instance_id=None, src_topic=None):
        self.dst_topic = dst_topic  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.src_topic = src_topic  # type: str

    def validate(self):
        self.validate_required(self.dst_topic, 'dst_topic')
        self.validate_required(self.src_topic, 'src_topic')

    def to_map(self):
        _map = super(DeleteTopicRouteTableRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dst_topic is not None:
            result['DstTopic'] = self.dst_topic
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.src_topic is not None:
            result['SrcTopic'] = self.src_topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DstTopic') is not None:
            self.dst_topic = m.get('DstTopic')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('SrcTopic') is not None:
            self.src_topic = m.get('SrcTopic')
        return self


class DeleteTopicRouteTableResponseFailureTopics(TeaModel):
    def __init__(self, topic=None):
        self.topic = topic  # type: list[dict[str, any]]

    def validate(self):
        self.validate_required(self.topic, 'topic')

    def to_map(self):
        _map = super(DeleteTopicRouteTableResponseFailureTopics, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.topic is not None:
            result['Topic'] = self.topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        return self


class DeleteTopicRouteTableResponse(TeaModel):
    def __init__(self, code=None, error_message=None, is_all_succeed=None, request_id=None, success=None,
                 failure_topics=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.is_all_succeed = is_all_succeed  # type: bool
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.failure_topics = failure_topics  # type: DeleteTopicRouteTableResponseFailureTopics

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.is_all_succeed, 'is_all_succeed')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.failure_topics, 'failure_topics')
        if self.failure_topics:
            self.failure_topics.validate()

    def to_map(self):
        _map = super(DeleteTopicRouteTableResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.is_all_succeed is not None:
            result['IsAllSucceed'] = self.is_all_succeed
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.failure_topics is not None:
            result['FailureTopics'] = self.failure_topics.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('IsAllSucceed') is not None:
            self.is_all_succeed = m.get('IsAllSucceed')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('FailureTopics') is not None:
            temp_model = DeleteTopicRouteTableResponseFailureTopics()
            self.failure_topics = temp_model.from_map(m['FailureTopics'])
        return self


class DetachDestinationRequest(TeaModel):
    def __init__(self, destination_id=None, iot_instance_id=None, parser_id=None):
        self.destination_id = destination_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str
        self.parser_id = parser_id  # type: long

    def validate(self):
        self.validate_required(self.destination_id, 'destination_id')
        self.validate_required(self.parser_id, 'parser_id')

    def to_map(self):
        _map = super(DetachDestinationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.destination_id is not None:
            result['DestinationId'] = self.destination_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DestinationId') is not None:
            self.destination_id = m.get('DestinationId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        return self


class DetachDestinationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DetachDestinationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DetachParserDataSourceRequest(TeaModel):
    def __init__(self, data_source_id=None, iot_instance_id=None, parser_id=None):
        self.data_source_id = data_source_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str
        self.parser_id = parser_id  # type: long

    def validate(self):
        self.validate_required(self.data_source_id, 'data_source_id')
        self.validate_required(self.parser_id, 'parser_id')

    def to_map(self):
        _map = super(DetachParserDataSourceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        return self


class DetachParserDataSourceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DetachParserDataSourceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DisableDeviceTunnelRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(DisableDeviceTunnelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class DisableDeviceTunnelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DisableDeviceTunnelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DisableDeviceTunnelShareRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(DisableDeviceTunnelShareRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class DisableDeviceTunnelShareResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DisableDeviceTunnelShareResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DisableSceneRuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, rule_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: str

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(DisableSceneRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class DisableSceneRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DisableSceneRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class DisableThingRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(DisableThingRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class DisableThingResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(DisableThingResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class EnableDeviceTunnelRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(EnableDeviceTunnelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class EnableDeviceTunnelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(EnableDeviceTunnelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class EnableDeviceTunnelShareRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(EnableDeviceTunnelShareRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class EnableDeviceTunnelShareResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(EnableDeviceTunnelShareResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class EnableSceneRuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, rule_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: str

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(EnableSceneRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class EnableSceneRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(EnableSceneRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class EnableThingRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(EnableThingRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class EnableThingResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(EnableThingResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class GenerateDeviceNameListURLRequest(TeaModel):
    def __init__(self, iot_instance_id=None):
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(GenerateDeviceNameListURLRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GenerateDeviceNameListURLResponseData(TeaModel):
    def __init__(self, access_key_id=None, file_url=None, host=None, key=None, object_storage=None, policy=None,
                 signature=None, utc_create=None):
        self.access_key_id = access_key_id  # type: str
        self.file_url = file_url  # type: str
        self.host = host  # type: str
        self.key = key  # type: str
        self.object_storage = object_storage  # type: str
        self.policy = policy  # type: str
        self.signature = signature  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.access_key_id, 'access_key_id')
        self.validate_required(self.file_url, 'file_url')
        self.validate_required(self.host, 'host')
        self.validate_required(self.key, 'key')
        self.validate_required(self.object_storage, 'object_storage')
        self.validate_required(self.policy, 'policy')
        self.validate_required(self.signature, 'signature')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(GenerateDeviceNameListURLResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.access_key_id is not None:
            result['AccessKeyId'] = self.access_key_id
        if self.file_url is not None:
            result['FileUrl'] = self.file_url
        if self.host is not None:
            result['Host'] = self.host
        if self.key is not None:
            result['Key'] = self.key
        if self.object_storage is not None:
            result['ObjectStorage'] = self.object_storage
        if self.policy is not None:
            result['Policy'] = self.policy
        if self.signature is not None:
            result['Signature'] = self.signature
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AccessKeyId') is not None:
            self.access_key_id = m.get('AccessKeyId')
        if m.get('FileUrl') is not None:
            self.file_url = m.get('FileUrl')
        if m.get('Host') is not None:
            self.host = m.get('Host')
        if m.get('Key') is not None:
            self.key = m.get('Key')
        if m.get('ObjectStorage') is not None:
            self.object_storage = m.get('ObjectStorage')
        if m.get('Policy') is not None:
            self.policy = m.get('Policy')
        if m.get('Signature') is not None:
            self.signature = m.get('Signature')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class GenerateDeviceNameListURLResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GenerateDeviceNameListURLResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GenerateDeviceNameListURLResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GenerateDeviceNameListURLResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GenerateFileUploadURLRequest(TeaModel):
    def __init__(self, biz_code=None, file_name=None, file_suffix=None, iot_instance_id=None):
        self.biz_code = biz_code  # type: str
        self.file_name = file_name  # type: str
        self.file_suffix = file_suffix  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.biz_code, 'biz_code')
        self.validate_required(self.file_suffix, 'file_suffix')

    def to_map(self):
        _map = super(GenerateFileUploadURLRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.biz_code is not None:
            result['BizCode'] = self.biz_code
        if self.file_name is not None:
            result['FileName'] = self.file_name
        if self.file_suffix is not None:
            result['FileSuffix'] = self.file_suffix
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BizCode') is not None:
            self.biz_code = m.get('BizCode')
        if m.get('FileName') is not None:
            self.file_name = m.get('FileName')
        if m.get('FileSuffix') is not None:
            self.file_suffix = m.get('FileSuffix')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GenerateFileUploadURLResponseData(TeaModel):
    def __init__(self, host=None, key=None, object_storage=None, oss_access_key_id=None, policy=None, signature=None):
        self.host = host  # type: str
        self.key = key  # type: str
        self.object_storage = object_storage  # type: str
        self.oss_access_key_id = oss_access_key_id  # type: str
        self.policy = policy  # type: str
        self.signature = signature  # type: str

    def validate(self):
        self.validate_required(self.host, 'host')
        self.validate_required(self.key, 'key')
        self.validate_required(self.object_storage, 'object_storage')
        self.validate_required(self.oss_access_key_id, 'oss_access_key_id')
        self.validate_required(self.policy, 'policy')
        self.validate_required(self.signature, 'signature')

    def to_map(self):
        _map = super(GenerateFileUploadURLResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.host is not None:
            result['Host'] = self.host
        if self.key is not None:
            result['Key'] = self.key
        if self.object_storage is not None:
            result['ObjectStorage'] = self.object_storage
        if self.oss_access_key_id is not None:
            result['OssAccessKeyId'] = self.oss_access_key_id
        if self.policy is not None:
            result['Policy'] = self.policy
        if self.signature is not None:
            result['Signature'] = self.signature
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Host') is not None:
            self.host = m.get('Host')
        if m.get('Key') is not None:
            self.key = m.get('Key')
        if m.get('ObjectStorage') is not None:
            self.object_storage = m.get('ObjectStorage')
        if m.get('OssAccessKeyId') is not None:
            self.oss_access_key_id = m.get('OssAccessKeyId')
        if m.get('Policy') is not None:
            self.policy = m.get('Policy')
        if m.get('Signature') is not None:
            self.signature = m.get('Signature')
        return self


class GenerateFileUploadURLResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GenerateFileUploadURLResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GenerateFileUploadURLResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GenerateFileUploadURLResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GenerateOTAUploadURLRequest(TeaModel):
    def __init__(self, file_suffix=None, iot_instance_id=None):
        self.file_suffix = file_suffix  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(GenerateOTAUploadURLRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.file_suffix is not None:
            result['FileSuffix'] = self.file_suffix
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FileSuffix') is not None:
            self.file_suffix = m.get('FileSuffix')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GenerateOTAUploadURLResponseData(TeaModel):
    def __init__(self, firmware_url=None, host=None, key=None, ossaccess_key_id=None, object_storage=None,
                 policy=None, signature=None, utc_create=None):
        self.firmware_url = firmware_url  # type: str
        self.host = host  # type: str
        self.key = key  # type: str
        self.ossaccess_key_id = ossaccess_key_id  # type: str
        self.object_storage = object_storage  # type: str
        self.policy = policy  # type: str
        self.signature = signature  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.firmware_url, 'firmware_url')
        self.validate_required(self.host, 'host')
        self.validate_required(self.key, 'key')
        self.validate_required(self.ossaccess_key_id, 'ossaccess_key_id')
        self.validate_required(self.object_storage, 'object_storage')
        self.validate_required(self.policy, 'policy')
        self.validate_required(self.signature, 'signature')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(GenerateOTAUploadURLResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.firmware_url is not None:
            result['FirmwareUrl'] = self.firmware_url
        if self.host is not None:
            result['Host'] = self.host
        if self.key is not None:
            result['Key'] = self.key
        if self.ossaccess_key_id is not None:
            result['OSSAccessKeyId'] = self.ossaccess_key_id
        if self.object_storage is not None:
            result['ObjectStorage'] = self.object_storage
        if self.policy is not None:
            result['Policy'] = self.policy
        if self.signature is not None:
            result['Signature'] = self.signature
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FirmwareUrl') is not None:
            self.firmware_url = m.get('FirmwareUrl')
        if m.get('Host') is not None:
            self.host = m.get('Host')
        if m.get('Key') is not None:
            self.key = m.get('Key')
        if m.get('OSSAccessKeyId') is not None:
            self.ossaccess_key_id = m.get('OSSAccessKeyId')
        if m.get('ObjectStorage') is not None:
            self.object_storage = m.get('ObjectStorage')
        if m.get('Policy') is not None:
            self.policy = m.get('Policy')
        if m.get('Signature') is not None:
            self.signature = m.get('Signature')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class GenerateOTAUploadURLResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GenerateOTAUploadURLResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GenerateOTAUploadURLResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GenerateOTAUploadURLResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetDataAPIServiceDetailRequest(TeaModel):
    def __init__(self, api_srn=None, iot_instance_id=None):
        self.api_srn = api_srn  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.api_srn, 'api_srn')

    def to_map(self):
        _map = super(GetDataAPIServiceDetailRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.api_srn is not None:
            result['ApiSrn'] = self.api_srn
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApiSrn') is not None:
            self.api_srn = m.get('ApiSrn')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GetDataAPIServiceDetailResponseDataSqlTemplateDTORequestParamsRequestParams(TeaModel):
    def __init__(self, desc=None, example=None, name=None, required=None, type=None):
        self.desc = desc  # type: str
        self.example = example  # type: str
        self.name = name  # type: str
        self.required = required  # type: bool
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.desc, 'desc')
        self.validate_required(self.example, 'example')
        self.validate_required(self.name, 'name')
        self.validate_required(self.required, 'required')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(GetDataAPIServiceDetailResponseDataSqlTemplateDTORequestParamsRequestParams, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.desc is not None:
            result['Desc'] = self.desc
        if self.example is not None:
            result['Example'] = self.example
        if self.name is not None:
            result['Name'] = self.name
        if self.required is not None:
            result['Required'] = self.required
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Desc') is not None:
            self.desc = m.get('Desc')
        if m.get('Example') is not None:
            self.example = m.get('Example')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Required') is not None:
            self.required = m.get('Required')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class GetDataAPIServiceDetailResponseDataSqlTemplateDTORequestParams(TeaModel):
    def __init__(self, request_params=None):
        self.request_params = request_params  # type: list[GetDataAPIServiceDetailResponseDataSqlTemplateDTORequestParamsRequestParams]

    def validate(self):
        self.validate_required(self.request_params, 'request_params')
        if self.request_params:
            for k in self.request_params:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(GetDataAPIServiceDetailResponseDataSqlTemplateDTORequestParams, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['RequestParams'] = []
        if self.request_params is not None:
            for k in self.request_params:
                result['RequestParams'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.request_params = []
        if m.get('RequestParams') is not None:
            for k in m.get('RequestParams'):
                temp_model = GetDataAPIServiceDetailResponseDataSqlTemplateDTORequestParamsRequestParams()
                self.request_params.append(temp_model.from_map(k))
        return self


class GetDataAPIServiceDetailResponseDataSqlTemplateDTOResponseParamsResponseParams(TeaModel):
    def __init__(self, desc=None, example=None, name=None, required=None, type=None):
        self.desc = desc  # type: str
        self.example = example  # type: str
        self.name = name  # type: str
        self.required = required  # type: bool
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.desc, 'desc')
        self.validate_required(self.example, 'example')
        self.validate_required(self.name, 'name')
        self.validate_required(self.required, 'required')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(GetDataAPIServiceDetailResponseDataSqlTemplateDTOResponseParamsResponseParams, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.desc is not None:
            result['Desc'] = self.desc
        if self.example is not None:
            result['Example'] = self.example
        if self.name is not None:
            result['Name'] = self.name
        if self.required is not None:
            result['Required'] = self.required
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Desc') is not None:
            self.desc = m.get('Desc')
        if m.get('Example') is not None:
            self.example = m.get('Example')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Required') is not None:
            self.required = m.get('Required')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class GetDataAPIServiceDetailResponseDataSqlTemplateDTOResponseParams(TeaModel):
    def __init__(self, response_params=None):
        self.response_params = response_params  # type: list[GetDataAPIServiceDetailResponseDataSqlTemplateDTOResponseParamsResponseParams]

    def validate(self):
        self.validate_required(self.response_params, 'response_params')
        if self.response_params:
            for k in self.response_params:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(GetDataAPIServiceDetailResponseDataSqlTemplateDTOResponseParams, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ResponseParams'] = []
        if self.response_params is not None:
            for k in self.response_params:
                result['ResponseParams'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.response_params = []
        if m.get('ResponseParams') is not None:
            for k in m.get('ResponseParams'):
                temp_model = GetDataAPIServiceDetailResponseDataSqlTemplateDTOResponseParamsResponseParams()
                self.response_params.append(temp_model.from_map(k))
        return self


class GetDataAPIServiceDetailResponseDataSqlTemplateDTO(TeaModel):
    def __init__(self, origin_sql=None, template_sql=None, request_params=None, response_params=None):
        self.origin_sql = origin_sql  # type: str
        self.template_sql = template_sql  # type: str
        self.request_params = request_params  # type: GetDataAPIServiceDetailResponseDataSqlTemplateDTORequestParams
        self.response_params = response_params  # type: GetDataAPIServiceDetailResponseDataSqlTemplateDTOResponseParams

    def validate(self):
        self.validate_required(self.origin_sql, 'origin_sql')
        self.validate_required(self.template_sql, 'template_sql')
        self.validate_required(self.request_params, 'request_params')
        if self.request_params:
            self.request_params.validate()
        self.validate_required(self.response_params, 'response_params')
        if self.response_params:
            self.response_params.validate()

    def to_map(self):
        _map = super(GetDataAPIServiceDetailResponseDataSqlTemplateDTO, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.origin_sql is not None:
            result['OriginSql'] = self.origin_sql
        if self.template_sql is not None:
            result['TemplateSql'] = self.template_sql
        if self.request_params is not None:
            result['RequestParams'] = self.request_params.to_map()
        if self.response_params is not None:
            result['ResponseParams'] = self.response_params.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('OriginSql') is not None:
            self.origin_sql = m.get('OriginSql')
        if m.get('TemplateSql') is not None:
            self.template_sql = m.get('TemplateSql')
        if m.get('RequestParams') is not None:
            temp_model = GetDataAPIServiceDetailResponseDataSqlTemplateDTORequestParams()
            self.request_params = temp_model.from_map(m['RequestParams'])
        if m.get('ResponseParams') is not None:
            temp_model = GetDataAPIServiceDetailResponseDataSqlTemplateDTOResponseParams()
            self.response_params = temp_model.from_map(m['ResponseParams'])
        return self


class GetDataAPIServiceDetailResponseData(TeaModel):
    def __init__(self, api_path=None, api_srn=None, create_time=None, date_format=None, description=None,
                 display_name=None, last_update_time=None, request_method=None, request_protocol=None, status=None,
                 sql_template_dto=None):
        self.api_path = api_path  # type: str
        self.api_srn = api_srn  # type: str
        self.create_time = create_time  # type: long
        self.date_format = date_format  # type: str
        self.description = description  # type: str
        self.display_name = display_name  # type: str
        self.last_update_time = last_update_time  # type: long
        self.request_method = request_method  # type: str
        self.request_protocol = request_protocol  # type: str
        self.status = status  # type: int
        self.sql_template_dto = sql_template_dto  # type: GetDataAPIServiceDetailResponseDataSqlTemplateDTO

    def validate(self):
        self.validate_required(self.api_path, 'api_path')
        self.validate_required(self.api_srn, 'api_srn')
        self.validate_required(self.create_time, 'create_time')
        self.validate_required(self.date_format, 'date_format')
        self.validate_required(self.description, 'description')
        self.validate_required(self.display_name, 'display_name')
        self.validate_required(self.last_update_time, 'last_update_time')
        self.validate_required(self.request_method, 'request_method')
        self.validate_required(self.request_protocol, 'request_protocol')
        self.validate_required(self.status, 'status')
        self.validate_required(self.sql_template_dto, 'sql_template_dto')
        if self.sql_template_dto:
            self.sql_template_dto.validate()

    def to_map(self):
        _map = super(GetDataAPIServiceDetailResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.api_path is not None:
            result['ApiPath'] = self.api_path
        if self.api_srn is not None:
            result['ApiSrn'] = self.api_srn
        if self.create_time is not None:
            result['CreateTime'] = self.create_time
        if self.date_format is not None:
            result['DateFormat'] = self.date_format
        if self.description is not None:
            result['Description'] = self.description
        if self.display_name is not None:
            result['DisplayName'] = self.display_name
        if self.last_update_time is not None:
            result['LastUpdateTime'] = self.last_update_time
        if self.request_method is not None:
            result['RequestMethod'] = self.request_method
        if self.request_protocol is not None:
            result['RequestProtocol'] = self.request_protocol
        if self.status is not None:
            result['Status'] = self.status
        if self.sql_template_dto is not None:
            result['SqlTemplateDTO'] = self.sql_template_dto.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApiPath') is not None:
            self.api_path = m.get('ApiPath')
        if m.get('ApiSrn') is not None:
            self.api_srn = m.get('ApiSrn')
        if m.get('CreateTime') is not None:
            self.create_time = m.get('CreateTime')
        if m.get('DateFormat') is not None:
            self.date_format = m.get('DateFormat')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('DisplayName') is not None:
            self.display_name = m.get('DisplayName')
        if m.get('LastUpdateTime') is not None:
            self.last_update_time = m.get('LastUpdateTime')
        if m.get('RequestMethod') is not None:
            self.request_method = m.get('RequestMethod')
        if m.get('RequestProtocol') is not None:
            self.request_protocol = m.get('RequestProtocol')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('SqlTemplateDTO') is not None:
            temp_model = GetDataAPIServiceDetailResponseDataSqlTemplateDTO()
            self.sql_template_dto = temp_model.from_map(m['SqlTemplateDTO'])
        return self


class GetDataAPIServiceDetailResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetDataAPIServiceDetailResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetDataAPIServiceDetailResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetDataAPIServiceDetailResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetDestinationRequest(TeaModel):
    def __init__(self, destination_id=None, iot_instance_id=None):
        self.destination_id = destination_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.destination_id, 'destination_id')

    def to_map(self):
        _map = super(GetDestinationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.destination_id is not None:
            result['DestinationId'] = self.destination_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DestinationId') is not None:
            self.destination_id = m.get('DestinationId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GetDestinationResponseDestination(TeaModel):
    def __init__(self, configuration=None, destination_id=None, is_failover=None, name=None, status=None, type=None,
                 utc_created=None):
        self.configuration = configuration  # type: str
        self.destination_id = destination_id  # type: str
        self.is_failover = is_failover  # type: bool
        self.name = name  # type: str
        self.status = status  # type: str
        self.type = type  # type: str
        self.utc_created = utc_created  # type: str

    def validate(self):
        self.validate_required(self.configuration, 'configuration')
        self.validate_required(self.destination_id, 'destination_id')
        self.validate_required(self.is_failover, 'is_failover')
        self.validate_required(self.name, 'name')
        self.validate_required(self.status, 'status')
        self.validate_required(self.type, 'type')
        self.validate_required(self.utc_created, 'utc_created')

    def to_map(self):
        _map = super(GetDestinationResponseDestination, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        if self.destination_id is not None:
            result['DestinationId'] = self.destination_id
        if self.is_failover is not None:
            result['IsFailover'] = self.is_failover
        if self.name is not None:
            result['Name'] = self.name
        if self.status is not None:
            result['Status'] = self.status
        if self.type is not None:
            result['Type'] = self.type
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        if m.get('DestinationId') is not None:
            self.destination_id = m.get('DestinationId')
        if m.get('IsFailover') is not None:
            self.is_failover = m.get('IsFailover')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        return self


class GetDestinationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, destination=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.destination = destination  # type: GetDestinationResponseDestination

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.destination, 'destination')
        if self.destination:
            self.destination.validate()

    def to_map(self):
        _map = super(GetDestinationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.destination is not None:
            result['Destination'] = self.destination.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Destination') is not None:
            temp_model = GetDestinationResponseDestination()
            self.destination = temp_model.from_map(m['Destination'])
        return self


class GetDeviceShadowRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(GetDeviceShadowRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class GetDeviceShadowResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, shadow_message=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.shadow_message = shadow_message  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.shadow_message, 'shadow_message')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(GetDeviceShadowResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.shadow_message is not None:
            result['ShadowMessage'] = self.shadow_message
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('ShadowMessage') is not None:
            self.shadow_message = m.get('ShadowMessage')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class GetDeviceStatusRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(GetDeviceStatusRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class GetDeviceStatusResponseData(TeaModel):
    def __init__(self, status=None, timestamp=None):
        self.status = status  # type: str
        self.timestamp = timestamp  # type: long

    def validate(self):
        self.validate_required(self.status, 'status')
        self.validate_required(self.timestamp, 'timestamp')

    def to_map(self):
        _map = super(GetDeviceStatusResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.status is not None:
            result['Status'] = self.status
        if self.timestamp is not None:
            result['Timestamp'] = self.timestamp
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Timestamp') is not None:
            self.timestamp = m.get('Timestamp')
        return self


class GetDeviceStatusResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetDeviceStatusResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetDeviceStatusResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetDeviceStatusResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetDeviceTunnelShareStatusRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(GetDeviceTunnelShareStatusRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class GetDeviceTunnelShareStatusResponseData(TeaModel):
    def __init__(self, gmt_opened=None, is_open=None, password=None, share_id=None):
        self.gmt_opened = gmt_opened  # type: long
        self.is_open = is_open  # type: bool
        self.password = password  # type: str
        self.share_id = share_id  # type: str

    def validate(self):
        self.validate_required(self.gmt_opened, 'gmt_opened')
        self.validate_required(self.is_open, 'is_open')
        self.validate_required(self.password, 'password')
        self.validate_required(self.share_id, 'share_id')

    def to_map(self):
        _map = super(GetDeviceTunnelShareStatusResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gmt_opened is not None:
            result['GmtOpened'] = self.gmt_opened
        if self.is_open is not None:
            result['IsOpen'] = self.is_open
        if self.password is not None:
            result['Password'] = self.password
        if self.share_id is not None:
            result['ShareId'] = self.share_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GmtOpened') is not None:
            self.gmt_opened = m.get('GmtOpened')
        if m.get('IsOpen') is not None:
            self.is_open = m.get('IsOpen')
        if m.get('Password') is not None:
            self.password = m.get('Password')
        if m.get('ShareId') is not None:
            self.share_id = m.get('ShareId')
        return self


class GetDeviceTunnelShareStatusResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetDeviceTunnelShareStatusResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetDeviceTunnelShareStatusResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetDeviceTunnelShareStatusResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetDeviceTunnelStatusRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(GetDeviceTunnelStatusRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class GetDeviceTunnelStatusResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(GetDeviceTunnelStatusResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class GetDownloadFileRequest(TeaModel):
    def __init__(self, context=None, iot_instance_id=None, long_job_id=None):
        self.context = context  # type: dict[str, any]
        self.iot_instance_id = iot_instance_id  # type: str
        self.long_job_id = long_job_id  # type: str

    def validate(self):
        self.validate_required(self.long_job_id, 'long_job_id')

    def to_map(self):
        _map = super(GetDownloadFileRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.context is not None:
            result['Context'] = self.context
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.long_job_id is not None:
            result['LongJobId'] = self.long_job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Context') is not None:
            self.context = m.get('Context')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('LongJobId') is not None:
            self.long_job_id = m.get('LongJobId')
        return self


class GetDownloadFileShrinkRequest(TeaModel):
    def __init__(self, context_shrink=None, iot_instance_id=None, long_job_id=None):
        self.context_shrink = context_shrink  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.long_job_id = long_job_id  # type: str

    def validate(self):
        self.validate_required(self.long_job_id, 'long_job_id')

    def to_map(self):
        _map = super(GetDownloadFileShrinkRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.context_shrink is not None:
            result['Context'] = self.context_shrink
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.long_job_id is not None:
            result['LongJobId'] = self.long_job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Context') is not None:
            self.context_shrink = m.get('Context')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('LongJobId') is not None:
            self.long_job_id = m.get('LongJobId')
        return self


class GetDownloadFileResponseDataHeader(TeaModel):
    def __init__(self, alias=None, dim_date_class=None, field_name=None, field_type=None, geo_class=None,
                 time_class=None, type_class=None):
        self.alias = alias  # type: str
        self.dim_date_class = dim_date_class  # type: str
        self.field_name = field_name  # type: str
        self.field_type = field_type  # type: str
        self.geo_class = geo_class  # type: str
        self.time_class = time_class  # type: str
        self.type_class = type_class  # type: str

    def validate(self):
        self.validate_required(self.alias, 'alias')
        self.validate_required(self.dim_date_class, 'dim_date_class')
        self.validate_required(self.field_name, 'field_name')
        self.validate_required(self.field_type, 'field_type')
        self.validate_required(self.geo_class, 'geo_class')
        self.validate_required(self.time_class, 'time_class')
        self.validate_required(self.type_class, 'type_class')

    def to_map(self):
        _map = super(GetDownloadFileResponseDataHeader, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.alias is not None:
            result['Alias'] = self.alias
        if self.dim_date_class is not None:
            result['DimDateClass'] = self.dim_date_class
        if self.field_name is not None:
            result['FieldName'] = self.field_name
        if self.field_type is not None:
            result['FieldType'] = self.field_type
        if self.geo_class is not None:
            result['GeoClass'] = self.geo_class
        if self.time_class is not None:
            result['TimeClass'] = self.time_class
        if self.type_class is not None:
            result['TypeClass'] = self.type_class
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Alias') is not None:
            self.alias = m.get('Alias')
        if m.get('DimDateClass') is not None:
            self.dim_date_class = m.get('DimDateClass')
        if m.get('FieldName') is not None:
            self.field_name = m.get('FieldName')
        if m.get('FieldType') is not None:
            self.field_type = m.get('FieldType')
        if m.get('GeoClass') is not None:
            self.geo_class = m.get('GeoClass')
        if m.get('TimeClass') is not None:
            self.time_class = m.get('TimeClass')
        if m.get('TypeClass') is not None:
            self.type_class = m.get('TypeClass')
        return self


class GetDownloadFileResponseDataQuerySettingAstExpr(TeaModel):
    def __init__(self, expr=None, expr_type=None):
        self.expr = expr  # type: str
        self.expr_type = expr_type  # type: str

    def validate(self):
        self.validate_required(self.expr, 'expr')
        self.validate_required(self.expr_type, 'expr_type')

    def to_map(self):
        _map = super(GetDownloadFileResponseDataQuerySettingAstExpr, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.expr is not None:
            result['Expr'] = self.expr
        if self.expr_type is not None:
            result['ExprType'] = self.expr_type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Expr') is not None:
            self.expr = m.get('Expr')
        if m.get('ExprType') is not None:
            self.expr_type = m.get('ExprType')
        return self


class GetDownloadFileResponseDataQuerySettingSelectedHeaders(TeaModel):
    def __init__(self, alias=None, dim_date_class=None, field_name=None, field_type=None, geo_class=None,
                 time_class=None):
        self.alias = alias  # type: str
        self.dim_date_class = dim_date_class  # type: str
        self.field_name = field_name  # type: str
        self.field_type = field_type  # type: str
        self.geo_class = geo_class  # type: str
        self.time_class = time_class  # type: str

    def validate(self):
        self.validate_required(self.alias, 'alias')
        self.validate_required(self.dim_date_class, 'dim_date_class')
        self.validate_required(self.field_name, 'field_name')
        self.validate_required(self.field_type, 'field_type')
        self.validate_required(self.geo_class, 'geo_class')
        self.validate_required(self.time_class, 'time_class')

    def to_map(self):
        _map = super(GetDownloadFileResponseDataQuerySettingSelectedHeaders, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.alias is not None:
            result['Alias'] = self.alias
        if self.dim_date_class is not None:
            result['DimDateClass'] = self.dim_date_class
        if self.field_name is not None:
            result['FieldName'] = self.field_name
        if self.field_type is not None:
            result['FieldType'] = self.field_type
        if self.geo_class is not None:
            result['GeoClass'] = self.geo_class
        if self.time_class is not None:
            result['TimeClass'] = self.time_class
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Alias') is not None:
            self.alias = m.get('Alias')
        if m.get('DimDateClass') is not None:
            self.dim_date_class = m.get('DimDateClass')
        if m.get('FieldName') is not None:
            self.field_name = m.get('FieldName')
        if m.get('FieldType') is not None:
            self.field_type = m.get('FieldType')
        if m.get('GeoClass') is not None:
            self.geo_class = m.get('GeoClass')
        if m.get('TimeClass') is not None:
            self.time_class = m.get('TimeClass')
        return self


class GetDownloadFileResponseDataQuerySetting(TeaModel):
    def __init__(self, ast_expr=None, selected_headers=None):
        self.ast_expr = ast_expr  # type: list[GetDownloadFileResponseDataQuerySettingAstExpr]
        self.selected_headers = selected_headers  # type: list[GetDownloadFileResponseDataQuerySettingSelectedHeaders]

    def validate(self):
        self.validate_required(self.ast_expr, 'ast_expr')
        if self.ast_expr:
            for k in self.ast_expr:
                if k:
                    k.validate()
        self.validate_required(self.selected_headers, 'selected_headers')
        if self.selected_headers:
            for k in self.selected_headers:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(GetDownloadFileResponseDataQuerySetting, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['AstExpr'] = []
        if self.ast_expr is not None:
            for k in self.ast_expr:
                result['AstExpr'].append(k.to_map() if k else None)
        result['SelectedHeaders'] = []
        if self.selected_headers is not None:
            for k in self.selected_headers:
                result['SelectedHeaders'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.ast_expr = []
        if m.get('AstExpr') is not None:
            for k in m.get('AstExpr'):
                temp_model = GetDownloadFileResponseDataQuerySettingAstExpr()
                self.ast_expr.append(temp_model.from_map(k))
        self.selected_headers = []
        if m.get('SelectedHeaders') is not None:
            for k in m.get('SelectedHeaders'):
                temp_model = GetDownloadFileResponseDataQuerySettingSelectedHeaders()
                self.selected_headers.append(temp_model.from_map(k))
        return self


class GetDownloadFileResponseData(TeaModel):
    def __init__(self, async_execute=None, begin_time=None, csv_file_name=None, csv_url=None, dataset_id=None,
                 end_time=None, long_job_id=None, page_no=None, page_size=None, preview_size=None,
                 result_data_in_string=None, status=None, total_count=None, header=None, query_setting=None, result=None):
        self.async_execute = async_execute  # type: bool
        self.begin_time = begin_time  # type: long
        self.csv_file_name = csv_file_name  # type: str
        self.csv_url = csv_url  # type: str
        self.dataset_id = dataset_id  # type: str
        self.end_time = end_time  # type: long
        self.long_job_id = long_job_id  # type: str
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int
        self.preview_size = preview_size  # type: int
        self.result_data_in_string = result_data_in_string  # type: str
        self.status = status  # type: int
        self.total_count = total_count  # type: long
        self.header = header  # type: list[GetDownloadFileResponseDataHeader]
        self.query_setting = query_setting  # type: GetDownloadFileResponseDataQuerySetting
        self.result = result  # type: list[dict[str, any]]

    def validate(self):
        self.validate_required(self.async_execute, 'async_execute')
        self.validate_required(self.begin_time, 'begin_time')
        self.validate_required(self.csv_file_name, 'csv_file_name')
        self.validate_required(self.csv_url, 'csv_url')
        self.validate_required(self.dataset_id, 'dataset_id')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.long_job_id, 'long_job_id')
        self.validate_required(self.page_no, 'page_no')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.preview_size, 'preview_size')
        self.validate_required(self.result_data_in_string, 'result_data_in_string')
        self.validate_required(self.status, 'status')
        self.validate_required(self.total_count, 'total_count')
        self.validate_required(self.header, 'header')
        if self.header:
            for k in self.header:
                if k:
                    k.validate()
        self.validate_required(self.query_setting, 'query_setting')
        if self.query_setting:
            self.query_setting.validate()
        self.validate_required(self.result, 'result')

    def to_map(self):
        _map = super(GetDownloadFileResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.async_execute is not None:
            result['AsyncExecute'] = self.async_execute
        if self.begin_time is not None:
            result['BeginTime'] = self.begin_time
        if self.csv_file_name is not None:
            result['CsvFileName'] = self.csv_file_name
        if self.csv_url is not None:
            result['CsvUrl'] = self.csv_url
        if self.dataset_id is not None:
            result['DatasetId'] = self.dataset_id
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.long_job_id is not None:
            result['LongJobId'] = self.long_job_id
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.preview_size is not None:
            result['PreviewSize'] = self.preview_size
        if self.result_data_in_string is not None:
            result['ResultDataInString'] = self.result_data_in_string
        if self.status is not None:
            result['Status'] = self.status
        if self.total_count is not None:
            result['TotalCount'] = self.total_count
        result['Header'] = []
        if self.header is not None:
            for k in self.header:
                result['Header'].append(k.to_map() if k else None)
        if self.query_setting is not None:
            result['QuerySetting'] = self.query_setting.to_map()
        if self.result is not None:
            result['Result'] = self.result
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AsyncExecute') is not None:
            self.async_execute = m.get('AsyncExecute')
        if m.get('BeginTime') is not None:
            self.begin_time = m.get('BeginTime')
        if m.get('CsvFileName') is not None:
            self.csv_file_name = m.get('CsvFileName')
        if m.get('CsvUrl') is not None:
            self.csv_url = m.get('CsvUrl')
        if m.get('DatasetId') is not None:
            self.dataset_id = m.get('DatasetId')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('LongJobId') is not None:
            self.long_job_id = m.get('LongJobId')
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('PreviewSize') is not None:
            self.preview_size = m.get('PreviewSize')
        if m.get('ResultDataInString') is not None:
            self.result_data_in_string = m.get('ResultDataInString')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('TotalCount') is not None:
            self.total_count = m.get('TotalCount')
        self.header = []
        if m.get('Header') is not None:
            for k in m.get('Header'):
                temp_model = GetDownloadFileResponseDataHeader()
                self.header.append(temp_model.from_map(k))
        if m.get('QuerySetting') is not None:
            temp_model = GetDownloadFileResponseDataQuerySetting()
            self.query_setting = temp_model.from_map(m['QuerySetting'])
        if m.get('Result') is not None:
            self.result = m.get('Result')
        return self


class GetDownloadFileResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetDownloadFileResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetDownloadFileResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetDownloadFileResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetEdgeDriverVersionRequest(TeaModel):
    def __init__(self, driver_id=None, driver_version=None, iot_instance_id=None):
        self.driver_id = driver_id  # type: str
        self.driver_version = driver_version  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.driver_version, 'driver_version')

    def to_map(self):
        _map = super(GetEdgeDriverVersionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_version is not None:
            result['DriverVersion'] = self.driver_version
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverVersion') is not None:
            self.driver_version = m.get('DriverVersion')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GetEdgeDriverVersionResponseData(TeaModel):
    def __init__(self, argument=None, config_check_rule=None, container_config=None, description=None,
                 driver_config=None, driver_id=None, driver_version=None, edge_version=None, gmt_create_timestamp=None,
                 gmt_modified_timestamp=None, source_config=None, version_state=None):
        self.argument = argument  # type: str
        self.config_check_rule = config_check_rule  # type: str
        self.container_config = container_config  # type: str
        self.description = description  # type: str
        self.driver_config = driver_config  # type: str
        self.driver_id = driver_id  # type: str
        self.driver_version = driver_version  # type: str
        self.edge_version = edge_version  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.source_config = source_config  # type: str
        self.version_state = version_state  # type: str

    def validate(self):
        self.validate_required(self.argument, 'argument')
        self.validate_required(self.config_check_rule, 'config_check_rule')
        self.validate_required(self.container_config, 'container_config')
        self.validate_required(self.description, 'description')
        self.validate_required(self.driver_config, 'driver_config')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.driver_version, 'driver_version')
        self.validate_required(self.edge_version, 'edge_version')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.source_config, 'source_config')
        self.validate_required(self.version_state, 'version_state')

    def to_map(self):
        _map = super(GetEdgeDriverVersionResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.argument is not None:
            result['Argument'] = self.argument
        if self.config_check_rule is not None:
            result['ConfigCheckRule'] = self.config_check_rule
        if self.container_config is not None:
            result['ContainerConfig'] = self.container_config
        if self.description is not None:
            result['Description'] = self.description
        if self.driver_config is not None:
            result['DriverConfig'] = self.driver_config
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_version is not None:
            result['DriverVersion'] = self.driver_version
        if self.edge_version is not None:
            result['EdgeVersion'] = self.edge_version
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.source_config is not None:
            result['SourceConfig'] = self.source_config
        if self.version_state is not None:
            result['VersionState'] = self.version_state
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Argument') is not None:
            self.argument = m.get('Argument')
        if m.get('ConfigCheckRule') is not None:
            self.config_check_rule = m.get('ConfigCheckRule')
        if m.get('ContainerConfig') is not None:
            self.container_config = m.get('ContainerConfig')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('DriverConfig') is not None:
            self.driver_config = m.get('DriverConfig')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverVersion') is not None:
            self.driver_version = m.get('DriverVersion')
        if m.get('EdgeVersion') is not None:
            self.edge_version = m.get('EdgeVersion')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('SourceConfig') is not None:
            self.source_config = m.get('SourceConfig')
        if m.get('VersionState') is not None:
            self.version_state = m.get('VersionState')
        return self


class GetEdgeDriverVersionResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetEdgeDriverVersionResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetEdgeDriverVersionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetEdgeDriverVersionResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetEdgeInstanceRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(GetEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GetEdgeInstanceResponseData(TeaModel):
    def __init__(self, biz_enable=None, gmt_create=None, gmt_create_timestamp=None, gmt_modified=None,
                 gmt_modified_timestamp=None, instance_id=None, latest_deployment_status=None, latest_deployment_type=None, name=None,
                 role_arn=None, role_attach_time=None, role_attach_timestamp=None, role_name=None, spec=None, tags=None,
                 type=None):
        self.biz_enable = biz_enable  # type: bool
        self.gmt_create = gmt_create  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified = gmt_modified  # type: str
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.instance_id = instance_id  # type: str
        self.latest_deployment_status = latest_deployment_status  # type: int
        self.latest_deployment_type = latest_deployment_type  # type: str
        self.name = name  # type: str
        self.role_arn = role_arn  # type: str
        self.role_attach_time = role_attach_time  # type: str
        self.role_attach_timestamp = role_attach_timestamp  # type: long
        self.role_name = role_name  # type: str
        self.spec = spec  # type: int
        self.tags = tags  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.biz_enable, 'biz_enable')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.latest_deployment_status, 'latest_deployment_status')
        self.validate_required(self.latest_deployment_type, 'latest_deployment_type')
        self.validate_required(self.name, 'name')
        self.validate_required(self.role_arn, 'role_arn')
        self.validate_required(self.role_attach_time, 'role_attach_time')
        self.validate_required(self.role_attach_timestamp, 'role_attach_timestamp')
        self.validate_required(self.role_name, 'role_name')
        self.validate_required(self.spec, 'spec')
        self.validate_required(self.tags, 'tags')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(GetEdgeInstanceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.biz_enable is not None:
            result['BizEnable'] = self.biz_enable
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.latest_deployment_status is not None:
            result['LatestDeploymentStatus'] = self.latest_deployment_status
        if self.latest_deployment_type is not None:
            result['LatestDeploymentType'] = self.latest_deployment_type
        if self.name is not None:
            result['Name'] = self.name
        if self.role_arn is not None:
            result['RoleArn'] = self.role_arn
        if self.role_attach_time is not None:
            result['RoleAttachTime'] = self.role_attach_time
        if self.role_attach_timestamp is not None:
            result['RoleAttachTimestamp'] = self.role_attach_timestamp
        if self.role_name is not None:
            result['RoleName'] = self.role_name
        if self.spec is not None:
            result['Spec'] = self.spec
        if self.tags is not None:
            result['Tags'] = self.tags
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BizEnable') is not None:
            self.biz_enable = m.get('BizEnable')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('LatestDeploymentStatus') is not None:
            self.latest_deployment_status = m.get('LatestDeploymentStatus')
        if m.get('LatestDeploymentType') is not None:
            self.latest_deployment_type = m.get('LatestDeploymentType')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('RoleArn') is not None:
            self.role_arn = m.get('RoleArn')
        if m.get('RoleAttachTime') is not None:
            self.role_attach_time = m.get('RoleAttachTime')
        if m.get('RoleAttachTimestamp') is not None:
            self.role_attach_timestamp = m.get('RoleAttachTimestamp')
        if m.get('RoleName') is not None:
            self.role_name = m.get('RoleName')
        if m.get('Spec') is not None:
            self.spec = m.get('Spec')
        if m.get('Tags') is not None:
            self.tags = m.get('Tags')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class GetEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetEdgeInstanceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetEdgeInstanceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetEdgeInstanceDeploymentRequest(TeaModel):
    def __init__(self, deployment_id=None, instance_id=None, iot_instance_id=None):
        self.deployment_id = deployment_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.deployment_id, 'deployment_id')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(GetEdgeInstanceDeploymentRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.deployment_id is not None:
            result['DeploymentId'] = self.deployment_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeploymentId') is not None:
            self.deployment_id = m.get('DeploymentId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GetEdgeInstanceDeploymentResponseDataTaskListResourceSnapshotList(TeaModel):
    def __init__(self, gmt_completed=None, gmt_completed_timestamp=None, gmt_create=None,
                 gmt_create_timestamp=None, gmt_modified=None, gmt_modified_timestamp=None, log=None, operate_type=None,
                 resource_id=None, resource_name=None, resource_type=None, snapshot_id=None, stage=None, status=None):
        self.gmt_completed = gmt_completed  # type: str
        self.gmt_completed_timestamp = gmt_completed_timestamp  # type: long
        self.gmt_create = gmt_create  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified = gmt_modified  # type: str
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.log = log  # type: str
        self.operate_type = operate_type  # type: int
        self.resource_id = resource_id  # type: str
        self.resource_name = resource_name  # type: str
        self.resource_type = resource_type  # type: str
        self.snapshot_id = snapshot_id  # type: str
        self.stage = stage  # type: int
        self.status = status  # type: int

    def validate(self):
        self.validate_required(self.gmt_completed, 'gmt_completed')
        self.validate_required(self.gmt_completed_timestamp, 'gmt_completed_timestamp')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.log, 'log')
        self.validate_required(self.operate_type, 'operate_type')
        self.validate_required(self.resource_id, 'resource_id')
        self.validate_required(self.resource_name, 'resource_name')
        self.validate_required(self.resource_type, 'resource_type')
        self.validate_required(self.snapshot_id, 'snapshot_id')
        self.validate_required(self.stage, 'stage')
        self.validate_required(self.status, 'status')

    def to_map(self):
        _map = super(GetEdgeInstanceDeploymentResponseDataTaskListResourceSnapshotList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gmt_completed is not None:
            result['GmtCompleted'] = self.gmt_completed
        if self.gmt_completed_timestamp is not None:
            result['GmtCompletedTimestamp'] = self.gmt_completed_timestamp
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.log is not None:
            result['Log'] = self.log
        if self.operate_type is not None:
            result['OperateType'] = self.operate_type
        if self.resource_id is not None:
            result['ResourceId'] = self.resource_id
        if self.resource_name is not None:
            result['ResourceName'] = self.resource_name
        if self.resource_type is not None:
            result['ResourceType'] = self.resource_type
        if self.snapshot_id is not None:
            result['SnapshotId'] = self.snapshot_id
        if self.stage is not None:
            result['Stage'] = self.stage
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GmtCompleted') is not None:
            self.gmt_completed = m.get('GmtCompleted')
        if m.get('GmtCompletedTimestamp') is not None:
            self.gmt_completed_timestamp = m.get('GmtCompletedTimestamp')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('Log') is not None:
            self.log = m.get('Log')
        if m.get('OperateType') is not None:
            self.operate_type = m.get('OperateType')
        if m.get('ResourceId') is not None:
            self.resource_id = m.get('ResourceId')
        if m.get('ResourceName') is not None:
            self.resource_name = m.get('ResourceName')
        if m.get('ResourceType') is not None:
            self.resource_type = m.get('ResourceType')
        if m.get('SnapshotId') is not None:
            self.snapshot_id = m.get('SnapshotId')
        if m.get('Stage') is not None:
            self.stage = m.get('Stage')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class GetEdgeInstanceDeploymentResponseDataTaskList(TeaModel):
    def __init__(self, gateway_id=None, gmt_completed=None, gmt_completed_timestamp=None, gmt_create=None,
                 gmt_create_timestamp=None, gmt_modified=None, gmt_modified_timestamp=None, stage=None, status=None, task_id=None,
                 resource_snapshot_list=None):
        self.gateway_id = gateway_id  # type: str
        self.gmt_completed = gmt_completed  # type: str
        self.gmt_completed_timestamp = gmt_completed_timestamp  # type: long
        self.gmt_create = gmt_create  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified = gmt_modified  # type: str
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.stage = stage  # type: int
        self.status = status  # type: int
        self.task_id = task_id  # type: str
        self.resource_snapshot_list = resource_snapshot_list  # type: list[GetEdgeInstanceDeploymentResponseDataTaskListResourceSnapshotList]

    def validate(self):
        self.validate_required(self.gateway_id, 'gateway_id')
        self.validate_required(self.gmt_completed, 'gmt_completed')
        self.validate_required(self.gmt_completed_timestamp, 'gmt_completed_timestamp')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.stage, 'stage')
        self.validate_required(self.status, 'status')
        self.validate_required(self.task_id, 'task_id')
        self.validate_required(self.resource_snapshot_list, 'resource_snapshot_list')
        if self.resource_snapshot_list:
            for k in self.resource_snapshot_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(GetEdgeInstanceDeploymentResponseDataTaskList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gateway_id is not None:
            result['GatewayId'] = self.gateway_id
        if self.gmt_completed is not None:
            result['GmtCompleted'] = self.gmt_completed
        if self.gmt_completed_timestamp is not None:
            result['GmtCompletedTimestamp'] = self.gmt_completed_timestamp
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.stage is not None:
            result['Stage'] = self.stage
        if self.status is not None:
            result['Status'] = self.status
        if self.task_id is not None:
            result['TaskId'] = self.task_id
        result['ResourceSnapshotList'] = []
        if self.resource_snapshot_list is not None:
            for k in self.resource_snapshot_list:
                result['ResourceSnapshotList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GatewayId') is not None:
            self.gateway_id = m.get('GatewayId')
        if m.get('GmtCompleted') is not None:
            self.gmt_completed = m.get('GmtCompleted')
        if m.get('GmtCompletedTimestamp') is not None:
            self.gmt_completed_timestamp = m.get('GmtCompletedTimestamp')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('Stage') is not None:
            self.stage = m.get('Stage')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('TaskId') is not None:
            self.task_id = m.get('TaskId')
        self.resource_snapshot_list = []
        if m.get('ResourceSnapshotList') is not None:
            for k in m.get('ResourceSnapshotList'):
                temp_model = GetEdgeInstanceDeploymentResponseDataTaskListResourceSnapshotList()
                self.resource_snapshot_list.append(temp_model.from_map(k))
        return self


class GetEdgeInstanceDeploymentResponseData(TeaModel):
    def __init__(self, deployment_id=None, description=None, gmt_completed=None, gmt_completed_timestamp=None,
                 gmt_create=None, gmt_create_timestamp=None, gmt_modified=None, gmt_modified_timestamp=None, status=None,
                 type=None, task_list=None):
        self.deployment_id = deployment_id  # type: str
        self.description = description  # type: str
        self.gmt_completed = gmt_completed  # type: str
        self.gmt_completed_timestamp = gmt_completed_timestamp  # type: long
        self.gmt_create = gmt_create  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified = gmt_modified  # type: str
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.status = status  # type: int
        self.type = type  # type: str
        self.task_list = task_list  # type: list[GetEdgeInstanceDeploymentResponseDataTaskList]

    def validate(self):
        self.validate_required(self.deployment_id, 'deployment_id')
        self.validate_required(self.description, 'description')
        self.validate_required(self.gmt_completed, 'gmt_completed')
        self.validate_required(self.gmt_completed_timestamp, 'gmt_completed_timestamp')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.status, 'status')
        self.validate_required(self.type, 'type')
        self.validate_required(self.task_list, 'task_list')
        if self.task_list:
            for k in self.task_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(GetEdgeInstanceDeploymentResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.deployment_id is not None:
            result['DeploymentId'] = self.deployment_id
        if self.description is not None:
            result['Description'] = self.description
        if self.gmt_completed is not None:
            result['GmtCompleted'] = self.gmt_completed
        if self.gmt_completed_timestamp is not None:
            result['GmtCompletedTimestamp'] = self.gmt_completed_timestamp
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.status is not None:
            result['Status'] = self.status
        if self.type is not None:
            result['Type'] = self.type
        result['TaskList'] = []
        if self.task_list is not None:
            for k in self.task_list:
                result['TaskList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeploymentId') is not None:
            self.deployment_id = m.get('DeploymentId')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('GmtCompleted') is not None:
            self.gmt_completed = m.get('GmtCompleted')
        if m.get('GmtCompletedTimestamp') is not None:
            self.gmt_completed_timestamp = m.get('GmtCompletedTimestamp')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        self.task_list = []
        if m.get('TaskList') is not None:
            for k in m.get('TaskList'):
                temp_model = GetEdgeInstanceDeploymentResponseDataTaskList()
                self.task_list.append(temp_model.from_map(k))
        return self


class GetEdgeInstanceDeploymentResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetEdgeInstanceDeploymentResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetEdgeInstanceDeploymentResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetEdgeInstanceDeploymentResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetEdgeInstanceMessageRoutingRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None, route_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.route_id = route_id  # type: long

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.route_id, 'route_id')

    def to_map(self):
        _map = super(GetEdgeInstanceMessageRoutingRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.route_id is not None:
            result['RouteId'] = self.route_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RouteId') is not None:
            self.route_id = m.get('RouteId')
        return self


class GetEdgeInstanceMessageRoutingResponseDataRouteContext(TeaModel):
    def __init__(self, qos=None, source_application_name=None, source_fc_function_name=None,
                 source_fc_service_name=None, target_application_name=None, target_fc_function_name=None, target_fc_service_name=None):
        self.qos = qos  # type: str
        self.source_application_name = source_application_name  # type: str
        self.source_fc_function_name = source_fc_function_name  # type: str
        self.source_fc_service_name = source_fc_service_name  # type: str
        self.target_application_name = target_application_name  # type: str
        self.target_fc_function_name = target_fc_function_name  # type: str
        self.target_fc_service_name = target_fc_service_name  # type: str

    def validate(self):
        self.validate_required(self.qos, 'qos')
        self.validate_required(self.source_application_name, 'source_application_name')
        self.validate_required(self.source_fc_function_name, 'source_fc_function_name')
        self.validate_required(self.source_fc_service_name, 'source_fc_service_name')
        self.validate_required(self.target_application_name, 'target_application_name')
        self.validate_required(self.target_fc_function_name, 'target_fc_function_name')
        self.validate_required(self.target_fc_service_name, 'target_fc_service_name')

    def to_map(self):
        _map = super(GetEdgeInstanceMessageRoutingResponseDataRouteContext, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.qos is not None:
            result['Qos'] = self.qos
        if self.source_application_name is not None:
            result['SourceApplicationName'] = self.source_application_name
        if self.source_fc_function_name is not None:
            result['SourceFcFunctionName'] = self.source_fc_function_name
        if self.source_fc_service_name is not None:
            result['SourceFcServiceName'] = self.source_fc_service_name
        if self.target_application_name is not None:
            result['TargetApplicationName'] = self.target_application_name
        if self.target_fc_function_name is not None:
            result['TargetFcFunctionName'] = self.target_fc_function_name
        if self.target_fc_service_name is not None:
            result['TargetFcServiceName'] = self.target_fc_service_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Qos') is not None:
            self.qos = m.get('Qos')
        if m.get('SourceApplicationName') is not None:
            self.source_application_name = m.get('SourceApplicationName')
        if m.get('SourceFcFunctionName') is not None:
            self.source_fc_function_name = m.get('SourceFcFunctionName')
        if m.get('SourceFcServiceName') is not None:
            self.source_fc_service_name = m.get('SourceFcServiceName')
        if m.get('TargetApplicationName') is not None:
            self.target_application_name = m.get('TargetApplicationName')
        if m.get('TargetFcFunctionName') is not None:
            self.target_fc_function_name = m.get('TargetFcFunctionName')
        if m.get('TargetFcServiceName') is not None:
            self.target_fc_service_name = m.get('TargetFcServiceName')
        return self


class GetEdgeInstanceMessageRoutingResponseData(TeaModel):
    def __init__(self, gmt_create=None, gmt_create_timestamp=None, gmt_modified=None, gmt_modified_timestamp=None,
                 name=None, source_data=None, source_type=None, target_data=None, target_type=None, topic_filter=None,
                 route_context=None):
        self.gmt_create = gmt_create  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified = gmt_modified  # type: str
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.name = name  # type: str
        self.source_data = source_data  # type: str
        self.source_type = source_type  # type: str
        self.target_data = target_data  # type: str
        self.target_type = target_type  # type: str
        self.topic_filter = topic_filter  # type: str
        self.route_context = route_context  # type: GetEdgeInstanceMessageRoutingResponseDataRouteContext

    def validate(self):
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.name, 'name')
        self.validate_required(self.source_data, 'source_data')
        self.validate_required(self.source_type, 'source_type')
        self.validate_required(self.target_data, 'target_data')
        self.validate_required(self.target_type, 'target_type')
        self.validate_required(self.topic_filter, 'topic_filter')
        self.validate_required(self.route_context, 'route_context')
        if self.route_context:
            self.route_context.validate()

    def to_map(self):
        _map = super(GetEdgeInstanceMessageRoutingResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.name is not None:
            result['Name'] = self.name
        if self.source_data is not None:
            result['SourceData'] = self.source_data
        if self.source_type is not None:
            result['SourceType'] = self.source_type
        if self.target_data is not None:
            result['TargetData'] = self.target_data
        if self.target_type is not None:
            result['TargetType'] = self.target_type
        if self.topic_filter is not None:
            result['TopicFilter'] = self.topic_filter
        if self.route_context is not None:
            result['RouteContext'] = self.route_context.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('SourceData') is not None:
            self.source_data = m.get('SourceData')
        if m.get('SourceType') is not None:
            self.source_type = m.get('SourceType')
        if m.get('TargetData') is not None:
            self.target_data = m.get('TargetData')
        if m.get('TargetType') is not None:
            self.target_type = m.get('TargetType')
        if m.get('TopicFilter') is not None:
            self.topic_filter = m.get('TopicFilter')
        if m.get('RouteContext') is not None:
            temp_model = GetEdgeInstanceMessageRoutingResponseDataRouteContext()
            self.route_context = temp_model.from_map(m['RouteContext'])
        return self


class GetEdgeInstanceMessageRoutingResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetEdgeInstanceMessageRoutingResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetEdgeInstanceMessageRoutingResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetEdgeInstanceMessageRoutingResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetGatewayBySubDeviceRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(GetGatewayBySubDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class GetGatewayBySubDeviceResponseData(TeaModel):
    def __init__(self, device_name=None, device_secret=None, firmware_version=None, gmt_active=None,
                 gmt_create=None, gmt_online=None, ip_address=None, node_type=None, product_key=None, product_name=None,
                 status=None, utc_active=None, utc_create=None, utc_online=None, iot_id=None, region=None):
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.firmware_version = firmware_version  # type: str
        self.gmt_active = gmt_active  # type: str
        self.gmt_create = gmt_create  # type: str
        self.gmt_online = gmt_online  # type: str
        self.ip_address = ip_address  # type: str
        self.node_type = node_type  # type: str
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str
        self.status = status  # type: str
        self.utc_active = utc_active  # type: str
        self.utc_create = utc_create  # type: str
        self.utc_online = utc_online  # type: str
        self.iot_id = iot_id  # type: str
        self.region = region  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')
        self.validate_required(self.firmware_version, 'firmware_version')
        self.validate_required(self.gmt_active, 'gmt_active')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_online, 'gmt_online')
        self.validate_required(self.ip_address, 'ip_address')
        self.validate_required(self.node_type, 'node_type')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')
        self.validate_required(self.status, 'status')
        self.validate_required(self.utc_active, 'utc_active')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_online, 'utc_online')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.region, 'region')

    def to_map(self):
        _map = super(GetGatewayBySubDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.firmware_version is not None:
            result['FirmwareVersion'] = self.firmware_version
        if self.gmt_active is not None:
            result['GmtActive'] = self.gmt_active
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_online is not None:
            result['GmtOnline'] = self.gmt_online
        if self.ip_address is not None:
            result['IpAddress'] = self.ip_address
        if self.node_type is not None:
            result['NodeType'] = self.node_type
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.status is not None:
            result['Status'] = self.status
        if self.utc_active is not None:
            result['UtcActive'] = self.utc_active
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_online is not None:
            result['UtcOnline'] = self.utc_online
        if self.iot_id is not None:
            result['iotId'] = self.iot_id
        if self.region is not None:
            result['region'] = self.region
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('FirmwareVersion') is not None:
            self.firmware_version = m.get('FirmwareVersion')
        if m.get('GmtActive') is not None:
            self.gmt_active = m.get('GmtActive')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtOnline') is not None:
            self.gmt_online = m.get('GmtOnline')
        if m.get('IpAddress') is not None:
            self.ip_address = m.get('IpAddress')
        if m.get('NodeType') is not None:
            self.node_type = m.get('NodeType')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('UtcActive') is not None:
            self.utc_active = m.get('UtcActive')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcOnline') is not None:
            self.utc_online = m.get('UtcOnline')
        if m.get('iotId') is not None:
            self.iot_id = m.get('iotId')
        if m.get('region') is not None:
            self.region = m.get('region')
        return self


class GetGatewayBySubDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetGatewayBySubDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetGatewayBySubDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetGatewayBySubDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetLoraNodesTaskRequest(TeaModel):
    def __init__(self, iot_instance_id=None, task_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.task_id = task_id  # type: str

    def validate(self):
        self.validate_required(self.task_id, 'task_id')

    def to_map(self):
        _map = super(GetLoraNodesTaskRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.task_id is not None:
            result['TaskId'] = self.task_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('TaskId') is not None:
            self.task_id = m.get('TaskId')
        return self


class GetLoraNodesTaskResponseSuccessDevEuis(TeaModel):
    def __init__(self, success_dev_eui=None):
        self.success_dev_eui = success_dev_eui  # type: list[str]

    def validate(self):
        self.validate_required(self.success_dev_eui, 'success_dev_eui')

    def to_map(self):
        _map = super(GetLoraNodesTaskResponseSuccessDevEuis, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.success_dev_eui is not None:
            result['SuccessDevEui'] = self.success_dev_eui
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('SuccessDevEui') is not None:
            self.success_dev_eui = m.get('SuccessDevEui')
        return self


class GetLoraNodesTaskResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, success_count=None,
                 task_id=None, task_state=None, total_count=None, success_dev_euis=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.success_count = success_count  # type: long
        self.task_id = task_id  # type: str
        self.task_state = task_state  # type: str
        self.total_count = total_count  # type: long
        self.success_dev_euis = success_dev_euis  # type: GetLoraNodesTaskResponseSuccessDevEuis

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.success_count, 'success_count')
        self.validate_required(self.task_id, 'task_id')
        self.validate_required(self.task_state, 'task_state')
        self.validate_required(self.total_count, 'total_count')
        self.validate_required(self.success_dev_euis, 'success_dev_euis')
        if self.success_dev_euis:
            self.success_dev_euis.validate()

    def to_map(self):
        _map = super(GetLoraNodesTaskResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.success_count is not None:
            result['SuccessCount'] = self.success_count
        if self.task_id is not None:
            result['TaskId'] = self.task_id
        if self.task_state is not None:
            result['TaskState'] = self.task_state
        if self.total_count is not None:
            result['TotalCount'] = self.total_count
        if self.success_dev_euis is not None:
            result['SuccessDevEuis'] = self.success_dev_euis.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('SuccessCount') is not None:
            self.success_count = m.get('SuccessCount')
        if m.get('TaskId') is not None:
            self.task_id = m.get('TaskId')
        if m.get('TaskState') is not None:
            self.task_state = m.get('TaskState')
        if m.get('TotalCount') is not None:
            self.total_count = m.get('TotalCount')
        if m.get('SuccessDevEuis') is not None:
            temp_model = GetLoraNodesTaskResponseSuccessDevEuis()
            self.success_dev_euis = temp_model.from_map(m['SuccessDevEuis'])
        return self


class GetParserRequest(TeaModel):
    def __init__(self, iot_instance_id=None, parser_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.parser_id = parser_id  # type: long

    def validate(self):
        self.validate_required(self.parser_id, 'parser_id')

    def to_map(self):
        _map = super(GetParserRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        return self


class GetParserResponseData(TeaModel):
    def __init__(self, data_source_id=None, description=None, name=None, parser_id=None, script=None,
                 script_draft=None, status=None, utc_created=None, utc_modified=None):
        self.data_source_id = data_source_id  # type: long
        self.description = description  # type: str
        self.name = name  # type: str
        self.parser_id = parser_id  # type: long
        self.script = script  # type: str
        self.script_draft = script_draft  # type: str
        self.status = status  # type: str
        self.utc_created = utc_created  # type: str
        self.utc_modified = utc_modified  # type: str

    def validate(self):
        self.validate_required(self.data_source_id, 'data_source_id')
        self.validate_required(self.description, 'description')
        self.validate_required(self.name, 'name')
        self.validate_required(self.parser_id, 'parser_id')
        self.validate_required(self.script, 'script')
        self.validate_required(self.script_draft, 'script_draft')
        self.validate_required(self.status, 'status')
        self.validate_required(self.utc_created, 'utc_created')
        self.validate_required(self.utc_modified, 'utc_modified')

    def to_map(self):
        _map = super(GetParserResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.description is not None:
            result['Description'] = self.description
        if self.name is not None:
            result['Name'] = self.name
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        if self.script is not None:
            result['Script'] = self.script
        if self.script_draft is not None:
            result['ScriptDraft'] = self.script_draft
        if self.status is not None:
            result['Status'] = self.status
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        if m.get('Script') is not None:
            self.script = m.get('Script')
        if m.get('ScriptDraft') is not None:
            self.script_draft = m.get('ScriptDraft')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        return self


class GetParserResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetParserResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetParserResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetParserResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetParserDataSourceRequest(TeaModel):
    def __init__(self, data_source_id=None, iot_instance_id=None):
        self.data_source_id = data_source_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.data_source_id, 'data_source_id')

    def to_map(self):
        _map = super(GetParserDataSourceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GetParserDataSourceResponseDataSource(TeaModel):
    def __init__(self, create_user_id=None, data_source_id=None, description=None, name=None, utc_created=None):
        self.create_user_id = create_user_id  # type: long
        self.data_source_id = data_source_id  # type: long
        self.description = description  # type: str
        self.name = name  # type: str
        self.utc_created = utc_created  # type: str

    def validate(self):
        self.validate_required(self.create_user_id, 'create_user_id')
        self.validate_required(self.data_source_id, 'data_source_id')
        self.validate_required(self.description, 'description')
        self.validate_required(self.name, 'name')
        self.validate_required(self.utc_created, 'utc_created')

    def to_map(self):
        _map = super(GetParserDataSourceResponseDataSource, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.create_user_id is not None:
            result['CreateUserId'] = self.create_user_id
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.description is not None:
            result['Description'] = self.description
        if self.name is not None:
            result['Name'] = self.name
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CreateUserId') is not None:
            self.create_user_id = m.get('CreateUserId')
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        return self


class GetParserDataSourceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data_source=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data_source = data_source  # type: GetParserDataSourceResponseDataSource

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data_source, 'data_source')
        if self.data_source:
            self.data_source.validate()

    def to_map(self):
        _map = super(GetParserDataSourceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data_source is not None:
            result['DataSource'] = self.data_source.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('DataSource') is not None:
            temp_model = GetParserDataSourceResponseDataSource()
            self.data_source = temp_model.from_map(m['DataSource'])
        return self


class GetRuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, rule_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: long

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(GetRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class GetRuleResponseRuleInfo(TeaModel):
    def __init__(self, create_user_id=None, created=None, data_type=None, id=None, modified=None, name=None,
                 product_key=None, rule_desc=None, select=None, short_topic=None, status=None, topic=None, topic_type=None,
                 utc_created=None, utc_modified=None, where=None):
        self.create_user_id = create_user_id  # type: long
        self.created = created  # type: str
        self.data_type = data_type  # type: str
        self.id = id  # type: long
        self.modified = modified  # type: str
        self.name = name  # type: str
        self.product_key = product_key  # type: str
        self.rule_desc = rule_desc  # type: str
        self.select = select  # type: str
        self.short_topic = short_topic  # type: str
        self.status = status  # type: str
        self.topic = topic  # type: str
        self.topic_type = topic_type  # type: int
        self.utc_created = utc_created  # type: str
        self.utc_modified = utc_modified  # type: str
        self.where = where  # type: str

    def validate(self):
        self.validate_required(self.create_user_id, 'create_user_id')
        self.validate_required(self.created, 'created')
        self.validate_required(self.data_type, 'data_type')
        self.validate_required(self.id, 'id')
        self.validate_required(self.modified, 'modified')
        self.validate_required(self.name, 'name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.rule_desc, 'rule_desc')
        self.validate_required(self.select, 'select')
        self.validate_required(self.short_topic, 'short_topic')
        self.validate_required(self.status, 'status')
        self.validate_required(self.topic, 'topic')
        self.validate_required(self.topic_type, 'topic_type')
        self.validate_required(self.utc_created, 'utc_created')
        self.validate_required(self.utc_modified, 'utc_modified')
        self.validate_required(self.where, 'where')

    def to_map(self):
        _map = super(GetRuleResponseRuleInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.create_user_id is not None:
            result['CreateUserId'] = self.create_user_id
        if self.created is not None:
            result['Created'] = self.created
        if self.data_type is not None:
            result['DataType'] = self.data_type
        if self.id is not None:
            result['Id'] = self.id
        if self.modified is not None:
            result['Modified'] = self.modified
        if self.name is not None:
            result['Name'] = self.name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.rule_desc is not None:
            result['RuleDesc'] = self.rule_desc
        if self.select is not None:
            result['Select'] = self.select
        if self.short_topic is not None:
            result['ShortTopic'] = self.short_topic
        if self.status is not None:
            result['Status'] = self.status
        if self.topic is not None:
            result['Topic'] = self.topic
        if self.topic_type is not None:
            result['TopicType'] = self.topic_type
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        if self.where is not None:
            result['Where'] = self.where
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CreateUserId') is not None:
            self.create_user_id = m.get('CreateUserId')
        if m.get('Created') is not None:
            self.created = m.get('Created')
        if m.get('DataType') is not None:
            self.data_type = m.get('DataType')
        if m.get('Id') is not None:
            self.id = m.get('Id')
        if m.get('Modified') is not None:
            self.modified = m.get('Modified')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RuleDesc') is not None:
            self.rule_desc = m.get('RuleDesc')
        if m.get('Select') is not None:
            self.select = m.get('Select')
        if m.get('ShortTopic') is not None:
            self.short_topic = m.get('ShortTopic')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        if m.get('TopicType') is not None:
            self.topic_type = m.get('TopicType')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        if m.get('Where') is not None:
            self.where = m.get('Where')
        return self


class GetRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, rule_info=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.rule_info = rule_info  # type: GetRuleResponseRuleInfo

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.rule_info, 'rule_info')
        if self.rule_info:
            self.rule_info.validate()

    def to_map(self):
        _map = super(GetRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.rule_info is not None:
            result['RuleInfo'] = self.rule_info.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('RuleInfo') is not None:
            temp_model = GetRuleResponseRuleInfo()
            self.rule_info = temp_model.from_map(m['RuleInfo'])
        return self


class GetRuleActionRequest(TeaModel):
    def __init__(self, action_id=None, iot_instance_id=None):
        self.action_id = action_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.action_id, 'action_id')

    def to_map(self):
        _map = super(GetRuleActionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.action_id is not None:
            result['ActionId'] = self.action_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ActionId') is not None:
            self.action_id = m.get('ActionId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GetRuleActionResponseRuleActionInfo(TeaModel):
    def __init__(self, configuration=None, error_action_flag=None, id=None, rule_id=None, type=None):
        self.configuration = configuration  # type: str
        self.error_action_flag = error_action_flag  # type: bool
        self.id = id  # type: long
        self.rule_id = rule_id  # type: long
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.configuration, 'configuration')
        self.validate_required(self.error_action_flag, 'error_action_flag')
        self.validate_required(self.id, 'id')
        self.validate_required(self.rule_id, 'rule_id')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(GetRuleActionResponseRuleActionInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        if self.error_action_flag is not None:
            result['ErrorActionFlag'] = self.error_action_flag
        if self.id is not None:
            result['Id'] = self.id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        if m.get('ErrorActionFlag') is not None:
            self.error_action_flag = m.get('ErrorActionFlag')
        if m.get('Id') is not None:
            self.id = m.get('Id')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class GetRuleActionResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, rule_action_info=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.rule_action_info = rule_action_info  # type: GetRuleActionResponseRuleActionInfo

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.rule_action_info, 'rule_action_info')
        if self.rule_action_info:
            self.rule_action_info.validate()

    def to_map(self):
        _map = super(GetRuleActionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.rule_action_info is not None:
            result['RuleActionInfo'] = self.rule_action_info.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('RuleActionInfo') is not None:
            temp_model = GetRuleActionResponseRuleActionInfo()
            self.rule_action_info = temp_model.from_map(m['RuleActionInfo'])
        return self


class GetSceneRuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, rule_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: str

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(GetSceneRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class GetSceneRuleResponseData(TeaModel):
    def __init__(self, gmt_create=None, gmt_modified=None, rule_content=None, rule_description=None, rule_name=None,
                 rule_status=None):
        self.gmt_create = gmt_create  # type: long
        self.gmt_modified = gmt_modified  # type: long
        self.rule_content = rule_content  # type: str
        self.rule_description = rule_description  # type: str
        self.rule_name = rule_name  # type: str
        self.rule_status = rule_status  # type: int

    def validate(self):
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.rule_content, 'rule_content')
        self.validate_required(self.rule_description, 'rule_description')
        self.validate_required(self.rule_name, 'rule_name')
        self.validate_required(self.rule_status, 'rule_status')

    def to_map(self):
        _map = super(GetSceneRuleResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.rule_content is not None:
            result['RuleContent'] = self.rule_content
        if self.rule_description is not None:
            result['RuleDescription'] = self.rule_description
        if self.rule_name is not None:
            result['RuleName'] = self.rule_name
        if self.rule_status is not None:
            result['RuleStatus'] = self.rule_status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('RuleContent') is not None:
            self.rule_content = m.get('RuleContent')
        if m.get('RuleDescription') is not None:
            self.rule_description = m.get('RuleDescription')
        if m.get('RuleName') is not None:
            self.rule_name = m.get('RuleName')
        if m.get('RuleStatus') is not None:
            self.rule_status = m.get('RuleStatus')
        return self


class GetSceneRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetSceneRuleResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetSceneRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetSceneRuleResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetShareTaskByDeviceOpenRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(GetShareTaskByDeviceOpenRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class GetShareTaskByDeviceOpenResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(GetShareTaskByDeviceOpenResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class GetSoundCodeAudioRequest(TeaModel):
    def __init__(self, iot_instance_id=None, sound_code_list=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.sound_code_list = sound_code_list  # type: list[str]

    def validate(self):
        self.validate_required(self.sound_code_list, 'sound_code_list')

    def to_map(self):
        _map = super(GetSoundCodeAudioRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.sound_code_list is not None:
            result['SoundCodeList'] = self.sound_code_list
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('SoundCodeList') is not None:
            self.sound_code_list = m.get('SoundCodeList')
        return self


class GetSoundCodeAudioResponseData(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[str]

    def validate(self):
        self.validate_required(self.items, 'items')

    def to_map(self):
        _map = super(GetSoundCodeAudioResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.items is not None:
            result['Items'] = self.items
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Items') is not None:
            self.items = m.get('Items')
        return self


class GetSoundCodeAudioResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetSoundCodeAudioResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetSoundCodeAudioResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetSoundCodeAudioResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetSoundCodeScheduleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, schedule_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.schedule_code = schedule_code  # type: str

    def validate(self):
        self.validate_required(self.schedule_code, 'schedule_code')

    def to_map(self):
        _map = super(GetSoundCodeScheduleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        return self


class GetSoundCodeScheduleResponseData(TeaModel):
    def __init__(self, description=None, end_date=None, end_time=None, gmt_create=None, name=None, open_type=None,
                 schedule_code=None, start_date=None, start_time=None, status=None):
        self.description = description  # type: str
        self.end_date = end_date  # type: str
        self.end_time = end_time  # type: str
        self.gmt_create = gmt_create  # type: long
        self.name = name  # type: str
        self.open_type = open_type  # type: str
        self.schedule_code = schedule_code  # type: str
        self.start_date = start_date  # type: str
        self.start_time = start_time  # type: str
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.description, 'description')
        self.validate_required(self.end_date, 'end_date')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.name, 'name')
        self.validate_required(self.open_type, 'open_type')
        self.validate_required(self.schedule_code, 'schedule_code')
        self.validate_required(self.start_date, 'start_date')
        self.validate_required(self.start_time, 'start_time')
        self.validate_required(self.status, 'status')

    def to_map(self):
        _map = super(GetSoundCodeScheduleResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.end_date is not None:
            result['EndDate'] = self.end_date
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.name is not None:
            result['Name'] = self.name
        if self.open_type is not None:
            result['OpenType'] = self.open_type
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        if self.start_date is not None:
            result['StartDate'] = self.start_date
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('EndDate') is not None:
            self.end_date = m.get('EndDate')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('OpenType') is not None:
            self.open_type = m.get('OpenType')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        if m.get('StartDate') is not None:
            self.start_date = m.get('StartDate')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class GetSoundCodeScheduleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetSoundCodeScheduleResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetSoundCodeScheduleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetSoundCodeScheduleResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetSpeechDeviceDetailRequest(TeaModel):
    def __init__(self, iot_id=None, iot_instance_id=None):
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(GetSpeechDeviceDetailRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GetSpeechDeviceDetailResponseData(TeaModel):
    def __init__(self, available_space=None, device_name=None, iot_id=None, product_key=None,
                 speech_list_update_time=None, status=None, total_space=None):
        self.available_space = available_space  # type: float
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.product_key = product_key  # type: str
        self.speech_list_update_time = speech_list_update_time  # type: long
        self.status = status  # type: str
        self.total_space = total_space  # type: float

    def validate(self):
        self.validate_required(self.available_space, 'available_space')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.speech_list_update_time, 'speech_list_update_time')
        self.validate_required(self.status, 'status')
        self.validate_required(self.total_space, 'total_space')

    def to_map(self):
        _map = super(GetSpeechDeviceDetailResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.available_space is not None:
            result['AvailableSpace'] = self.available_space
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.speech_list_update_time is not None:
            result['SpeechListUpdateTime'] = self.speech_list_update_time
        if self.status is not None:
            result['Status'] = self.status
        if self.total_space is not None:
            result['TotalSpace'] = self.total_space
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AvailableSpace') is not None:
            self.available_space = m.get('AvailableSpace')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SpeechListUpdateTime') is not None:
            self.speech_list_update_time = m.get('SpeechListUpdateTime')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('TotalSpace') is not None:
            self.total_space = m.get('TotalSpace')
        return self


class GetSpeechDeviceDetailResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetSpeechDeviceDetailResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetSpeechDeviceDetailResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetSpeechDeviceDetailResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetSpeechLicenseDeviceStatisticsRequest(TeaModel):
    def __init__(self, iot_instance_id=None):
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(GetSpeechLicenseDeviceStatisticsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class GetSpeechLicenseDeviceStatisticsResponseData(TeaModel):
    def __init__(self, available_quota=None, expired_quota=None, expiring_quota=None):
        self.available_quota = available_quota  # type: int
        self.expired_quota = expired_quota  # type: int
        self.expiring_quota = expiring_quota  # type: int

    def validate(self):
        self.validate_required(self.available_quota, 'available_quota')
        self.validate_required(self.expired_quota, 'expired_quota')
        self.validate_required(self.expiring_quota, 'expiring_quota')

    def to_map(self):
        _map = super(GetSpeechLicenseDeviceStatisticsResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.available_quota is not None:
            result['AvailableQuota'] = self.available_quota
        if self.expired_quota is not None:
            result['ExpiredQuota'] = self.expired_quota
        if self.expiring_quota is not None:
            result['ExpiringQuota'] = self.expiring_quota
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AvailableQuota') is not None:
            self.available_quota = m.get('AvailableQuota')
        if m.get('ExpiredQuota') is not None:
            self.expired_quota = m.get('ExpiredQuota')
        if m.get('ExpiringQuota') is not None:
            self.expiring_quota = m.get('ExpiringQuota')
        return self


class GetSpeechLicenseDeviceStatisticsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetSpeechLicenseDeviceStatisticsResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetSpeechLicenseDeviceStatisticsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetSpeechLicenseDeviceStatisticsResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetSpeechVoiceRequest(TeaModel):
    def __init__(self):
        pass

    def validate(self):
        pass

    def to_map(self):
        _map = super(GetSpeechVoiceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        return result

    def from_map(self, m=None):
        m = m or dict()
        return self


class GetSpeechVoiceResponseDataItemsVoiceListItems(TeaModel):
    def __init__(self, label=None, value=None):
        self.label = label  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.label, 'label')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(GetSpeechVoiceResponseDataItemsVoiceListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.label is not None:
            result['Label'] = self.label
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Label') is not None:
            self.label = m.get('Label')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class GetSpeechVoiceResponseDataItemsVoiceList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[GetSpeechVoiceResponseDataItemsVoiceListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(GetSpeechVoiceResponseDataItemsVoiceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = GetSpeechVoiceResponseDataItemsVoiceListItems()
                self.items.append(temp_model.from_map(k))
        return self


class GetSpeechVoiceResponseDataItems(TeaModel):
    def __init__(self, label=None, value=None, voice_list=None):
        self.label = label  # type: str
        self.value = value  # type: str
        self.voice_list = voice_list  # type: GetSpeechVoiceResponseDataItemsVoiceList

    def validate(self):
        self.validate_required(self.label, 'label')
        self.validate_required(self.value, 'value')
        self.validate_required(self.voice_list, 'voice_list')
        if self.voice_list:
            self.voice_list.validate()

    def to_map(self):
        _map = super(GetSpeechVoiceResponseDataItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.label is not None:
            result['Label'] = self.label
        if self.value is not None:
            result['Value'] = self.value
        if self.voice_list is not None:
            result['VoiceList'] = self.voice_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Label') is not None:
            self.label = m.get('Label')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        if m.get('VoiceList') is not None:
            temp_model = GetSpeechVoiceResponseDataItemsVoiceList()
            self.voice_list = temp_model.from_map(m['VoiceList'])
        return self


class GetSpeechVoiceResponseData(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[GetSpeechVoiceResponseDataItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(GetSpeechVoiceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = GetSpeechVoiceResponseDataItems()
                self.items.append(temp_model.from_map(k))
        return self


class GetSpeechVoiceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetSpeechVoiceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetSpeechVoiceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetSpeechVoiceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetStudioAppTokenOpenRequest(TeaModel):
    def __init__(self, app_id=None, iot_instance_id=None, project_id=None):
        self.app_id = app_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.app_id, 'app_id')
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(GetStudioAppTokenOpenRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_id is not None:
            result['AppId'] = self.app_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppId') is not None:
            self.app_id = m.get('AppId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class GetStudioAppTokenOpenResponseData(TeaModel):
    def __init__(self, biz_id=None, biz_type=None, is_enable=None, token=None, type=None):
        self.biz_id = biz_id  # type: str
        self.biz_type = biz_type  # type: str
        self.is_enable = is_enable  # type: str
        self.token = token  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.biz_id, 'biz_id')
        self.validate_required(self.biz_type, 'biz_type')
        self.validate_required(self.is_enable, 'is_enable')
        self.validate_required(self.token, 'token')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(GetStudioAppTokenOpenResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.biz_id is not None:
            result['BizId'] = self.biz_id
        if self.biz_type is not None:
            result['BizType'] = self.biz_type
        if self.is_enable is not None:
            result['IsEnable'] = self.is_enable
        if self.token is not None:
            result['Token'] = self.token
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BizId') is not None:
            self.biz_id = m.get('BizId')
        if m.get('BizType') is not None:
            self.biz_type = m.get('BizType')
        if m.get('IsEnable') is not None:
            self.is_enable = m.get('IsEnable')
        if m.get('Token') is not None:
            self.token = m.get('Token')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class GetStudioAppTokenOpenResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetStudioAppTokenOpenResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetStudioAppTokenOpenResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetStudioAppTokenOpenResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetThingModelTslRequest(TeaModel):
    def __init__(self, function_block_id=None, iot_instance_id=None, model_version=None, product_key=None,
                 simple=None):
        self.function_block_id = function_block_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.model_version = model_version  # type: str
        self.product_key = product_key  # type: str
        self.simple = simple  # type: bool

    def validate(self):
        pass

    def to_map(self):
        _map = super(GetThingModelTslRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.model_version is not None:
            result['ModelVersion'] = self.model_version
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.simple is not None:
            result['Simple'] = self.simple
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModelVersion') is not None:
            self.model_version = m.get('ModelVersion')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Simple') is not None:
            self.simple = m.get('Simple')
        return self


class GetThingModelTslResponseData(TeaModel):
    def __init__(self, tsl_str=None, tsl_uri=None):
        self.tsl_str = tsl_str  # type: str
        self.tsl_uri = tsl_uri  # type: str

    def validate(self):
        self.validate_required(self.tsl_str, 'tsl_str')
        self.validate_required(self.tsl_uri, 'tsl_uri')

    def to_map(self):
        _map = super(GetThingModelTslResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tsl_str is not None:
            result['TslStr'] = self.tsl_str
        if self.tsl_uri is not None:
            result['TslUri'] = self.tsl_uri
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TslStr') is not None:
            self.tsl_str = m.get('TslStr')
        if m.get('TslUri') is not None:
            self.tsl_uri = m.get('TslUri')
        return self


class GetThingModelTslResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetThingModelTslResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetThingModelTslResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetThingModelTslResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetThingModelTslPublishedRequest(TeaModel):
    def __init__(self, function_block_id=None, iot_instance_id=None, model_version=None, product_key=None,
                 resource_group_id=None, simple=None):
        self.function_block_id = function_block_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.model_version = model_version  # type: str
        self.product_key = product_key  # type: str
        self.resource_group_id = resource_group_id  # type: str
        self.simple = simple  # type: bool

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(GetThingModelTslPublishedRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.model_version is not None:
            result['ModelVersion'] = self.model_version
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        if self.simple is not None:
            result['Simple'] = self.simple
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModelVersion') is not None:
            self.model_version = m.get('ModelVersion')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        if m.get('Simple') is not None:
            self.simple = m.get('Simple')
        return self


class GetThingModelTslPublishedResponseData(TeaModel):
    def __init__(self, tsl_str=None, tsl_uri=None):
        self.tsl_str = tsl_str  # type: str
        self.tsl_uri = tsl_uri  # type: str

    def validate(self):
        self.validate_required(self.tsl_str, 'tsl_str')
        self.validate_required(self.tsl_uri, 'tsl_uri')

    def to_map(self):
        _map = super(GetThingModelTslPublishedResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tsl_str is not None:
            result['TslStr'] = self.tsl_str
        if self.tsl_uri is not None:
            result['TslUri'] = self.tsl_uri
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TslStr') is not None:
            self.tsl_str = m.get('TslStr')
        if m.get('TslUri') is not None:
            self.tsl_uri = m.get('TslUri')
        return self


class GetThingModelTslPublishedResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetThingModelTslPublishedResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetThingModelTslPublishedResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetThingModelTslPublishedResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetThingScriptRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(GetThingScriptRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class GetThingScriptResponseData(TeaModel):
    def __init__(self, script_type=None, script_url=None):
        self.script_type = script_type  # type: str
        self.script_url = script_url  # type: str

    def validate(self):
        self.validate_required(self.script_type, 'script_type')
        self.validate_required(self.script_url, 'script_url')

    def to_map(self):
        _map = super(GetThingScriptResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.script_type is not None:
            result['ScriptType'] = self.script_type
        if self.script_url is not None:
            result['ScriptUrl'] = self.script_url
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ScriptType') is not None:
            self.script_type = m.get('ScriptType')
        if m.get('ScriptUrl') is not None:
            self.script_url = m.get('ScriptUrl')
        return self


class GetThingScriptResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetThingScriptResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetThingScriptResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetThingScriptResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GetThingTemplateRequest(TeaModel):
    def __init__(self, category_key=None, iot_instance_id=None, resource_group_id=None):
        self.category_key = category_key  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.resource_group_id = resource_group_id  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(GetThingTemplateRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.category_key is not None:
            result['CategoryKey'] = self.category_key
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CategoryKey') is not None:
            self.category_key = m.get('CategoryKey')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        return self


class GetThingTemplateResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, thing_model_json=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.thing_model_json = thing_model_json  # type: str

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.thing_model_json, 'thing_model_json')

    def to_map(self):
        _map = super(GetThingTemplateResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.thing_model_json is not None:
            result['ThingModelJSON'] = self.thing_model_json
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('ThingModelJSON') is not None:
            self.thing_model_json = m.get('ThingModelJSON')
        return self


class GetThingTopoRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, page_no=None, page_size=None,
                 product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.page_no, 'page_no')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(GetThingTopoRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class GetThingTopoResponseDataListDeviceInfo(TeaModel):
    def __init__(self, device_name=None, iot_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(GetThingTopoResponseDataListDeviceInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class GetThingTopoResponseDataList(TeaModel):
    def __init__(self, device_info=None):
        self.device_info = device_info  # type: list[GetThingTopoResponseDataListDeviceInfo]

    def validate(self):
        self.validate_required(self.device_info, 'device_info')
        if self.device_info:
            for k in self.device_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(GetThingTopoResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['deviceInfo'] = []
        if self.device_info is not None:
            for k in self.device_info:
                result['deviceInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_info = []
        if m.get('deviceInfo') is not None:
            for k in m.get('deviceInfo'):
                temp_model = GetThingTopoResponseDataListDeviceInfo()
                self.device_info.append(temp_model.from_map(k))
        return self


class GetThingTopoResponseData(TeaModel):
    def __init__(self, current_page=None, page_count=None, page_size=None, total=None, list=None):
        self.current_page = current_page  # type: int
        self.page_count = page_count  # type: long
        self.page_size = page_size  # type: int
        self.total = total  # type: long
        self.list = list  # type: GetThingTopoResponseDataList

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(GetThingTopoResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = GetThingTopoResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class GetThingTopoResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GetThingTopoResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GetThingTopoResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GetThingTopoResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class GisQueryDeviceLocationRequestThingList(TeaModel):
    def __init__(self, product_key=None, device_name=None):
        self.product_key = product_key  # type: str
        self.device_name = device_name  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(GisQueryDeviceLocationRequestThingList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        return self


class GisQueryDeviceLocationRequest(TeaModel):
    def __init__(self, iot_instance_id=None, thing_list=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.thing_list = thing_list  # type: list[GisQueryDeviceLocationRequestThingList]

    def validate(self):
        self.validate_required(self.thing_list, 'thing_list')
        if self.thing_list:
            for k in self.thing_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(GisQueryDeviceLocationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        result['ThingList'] = []
        if self.thing_list is not None:
            for k in self.thing_list:
                result['ThingList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        self.thing_list = []
        if m.get('ThingList') is not None:
            for k in m.get('ThingList'):
                temp_model = GisQueryDeviceLocationRequestThingList()
                self.thing_list.append(temp_model.from_map(k))
        return self


class GisQueryDeviceLocationResponseData(TeaModel):
    def __init__(self, adcode=None, city=None, coordinate_system=None, country=None, device_name=None, ip=None,
                 latitude=None, longitude=None, product_key=None, province=None):
        self.adcode = adcode  # type: long
        self.city = city  # type: str
        self.coordinate_system = coordinate_system  # type: int
        self.country = country  # type: str
        self.device_name = device_name  # type: str
        self.ip = ip  # type: str
        self.latitude = latitude  # type: float
        self.longitude = longitude  # type: float
        self.product_key = product_key  # type: str
        self.province = province  # type: str

    def validate(self):
        self.validate_required(self.adcode, 'adcode')
        self.validate_required(self.city, 'city')
        self.validate_required(self.coordinate_system, 'coordinate_system')
        self.validate_required(self.country, 'country')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.ip, 'ip')
        self.validate_required(self.latitude, 'latitude')
        self.validate_required(self.longitude, 'longitude')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.province, 'province')

    def to_map(self):
        _map = super(GisQueryDeviceLocationResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.adcode is not None:
            result['Adcode'] = self.adcode
        if self.city is not None:
            result['City'] = self.city
        if self.coordinate_system is not None:
            result['CoordinateSystem'] = self.coordinate_system
        if self.country is not None:
            result['Country'] = self.country
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.ip is not None:
            result['Ip'] = self.ip
        if self.latitude is not None:
            result['Latitude'] = self.latitude
        if self.longitude is not None:
            result['Longitude'] = self.longitude
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.province is not None:
            result['Province'] = self.province
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Adcode') is not None:
            self.adcode = m.get('Adcode')
        if m.get('City') is not None:
            self.city = m.get('City')
        if m.get('CoordinateSystem') is not None:
            self.coordinate_system = m.get('CoordinateSystem')
        if m.get('Country') is not None:
            self.country = m.get('Country')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('Ip') is not None:
            self.ip = m.get('Ip')
        if m.get('Latitude') is not None:
            self.latitude = m.get('Latitude')
        if m.get('Longitude') is not None:
            self.longitude = m.get('Longitude')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Province') is not None:
            self.province = m.get('Province')
        return self


class GisQueryDeviceLocationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: list[GisQueryDeviceLocationResponseData]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            for k in self.data:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(GisQueryDeviceLocationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        result['Data'] = []
        if self.data is not None:
            for k in self.data:
                result['Data'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        self.data = []
        if m.get('Data') is not None:
            for k in m.get('Data'):
                temp_model = GisQueryDeviceLocationResponseData()
                self.data.append(temp_model.from_map(k))
        return self


class GisSearchDeviceTraceRequest(TeaModel):
    def __init__(self, map_match=None, iot_instance_id=None, end_time=None, start_time=None, product_key=None,
                 device_name=None):
        self.map_match = map_match  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.end_time = end_time  # type: long
        self.start_time = start_time  # type: long
        self.product_key = product_key  # type: str
        self.device_name = device_name  # type: str

    def validate(self):
        self.validate_required(self.map_match, 'map_match')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.start_time, 'start_time')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.device_name, 'device_name')

    def to_map(self):
        _map = super(GisSearchDeviceTraceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.map_match is not None:
            result['MapMatch'] = self.map_match
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('MapMatch') is not None:
            self.map_match = m.get('MapMatch')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        return self


class GisSearchDeviceTraceResponseDataPoints(TeaModel):
    def __init__(self, locate_time=None, location=None):
        self.locate_time = locate_time  # type: long
        self.location = location  # type: str

    def validate(self):
        self.validate_required(self.locate_time, 'locate_time')
        self.validate_required(self.location, 'location')

    def to_map(self):
        _map = super(GisSearchDeviceTraceResponseDataPoints, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.locate_time is not None:
            result['LocateTime'] = self.locate_time
        if self.location is not None:
            result['Location'] = self.location
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('LocateTime') is not None:
            self.locate_time = m.get('LocateTime')
        if m.get('Location') is not None:
            self.location = m.get('Location')
        return self


class GisSearchDeviceTraceResponseData(TeaModel):
    def __init__(self, device_name=None, product_key=None, points=None):
        self.device_name = device_name  # type: str
        self.product_key = product_key  # type: str
        self.points = points  # type: list[GisSearchDeviceTraceResponseDataPoints]

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.points, 'points')
        if self.points:
            for k in self.points:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(GisSearchDeviceTraceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        result['Points'] = []
        if self.points is not None:
            for k in self.points:
                result['Points'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        self.points = []
        if m.get('Points') is not None:
            for k in m.get('Points'):
                temp_model = GisSearchDeviceTraceResponseDataPoints()
                self.points.append(temp_model.from_map(k))
        return self


class GisSearchDeviceTraceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: GisSearchDeviceTraceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(GisSearchDeviceTraceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = GisSearchDeviceTraceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ImportDTDataRequestItems(TeaModel):
    def __init__(self, device_name=None, params=None):
        self.device_name = device_name  # type: str
        self.params = params  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.params, 'params')

    def to_map(self):
        _map = super(ImportDTDataRequestItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.params is not None:
            result['Params'] = self.params
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('Params') is not None:
            self.params = m.get('Params')
        return self


class ImportDTDataRequest(TeaModel):
    def __init__(self, iot_instance_id=None, items=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.items = items  # type: list[ImportDTDataRequestItems]
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(ImportDTDataRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = ImportDTDataRequestItems()
                self.items.append(temp_model.from_map(k))
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ImportDTDataResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(ImportDTDataResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class ImportDeviceRequest(TeaModel):
    def __init__(self, device_name=None, device_secret=None, iot_instance_id=None, nickname=None, product_key=None,
                 sn=None):
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.nickname = nickname  # type: str
        self.product_key = product_key  # type: str
        self.sn = sn  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(ImportDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.sn is not None:
            result['Sn'] = self.sn
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Sn') is not None:
            self.sn = m.get('Sn')
        return self


class ImportDeviceResponseData(TeaModel):
    def __init__(self, device_name=None, device_secret=None, iot_id=None, nickname=None, product_key=None, sn=None):
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.iot_id = iot_id  # type: str
        self.nickname = nickname  # type: str
        self.product_key = product_key  # type: str
        self.sn = sn  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.nickname, 'nickname')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.sn, 'sn')

    def to_map(self):
        _map = super(ImportDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.sn is not None:
            result['Sn'] = self.sn
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Sn') is not None:
            self.sn = m.get('Sn')
        return self


class ImportDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ImportDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ImportDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ImportDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ImportThingModelTslRequest(TeaModel):
    def __init__(self, function_block_id=None, function_block_name=None, iot_instance_id=None, product_key=None,
                 resource_group_id=None, tsl_str=None, tsl_url=None):
        self.function_block_id = function_block_id  # type: str
        self.function_block_name = function_block_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.resource_group_id = resource_group_id  # type: str
        self.tsl_str = tsl_str  # type: str
        self.tsl_url = tsl_url  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(ImportThingModelTslRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.function_block_name is not None:
            result['FunctionBlockName'] = self.function_block_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        if self.tsl_str is not None:
            result['TslStr'] = self.tsl_str
        if self.tsl_url is not None:
            result['TslUrl'] = self.tsl_url
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('FunctionBlockName') is not None:
            self.function_block_name = m.get('FunctionBlockName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        if m.get('TslStr') is not None:
            self.tsl_str = m.get('TslStr')
        if m.get('TslUrl') is not None:
            self.tsl_url = m.get('TslUrl')
        return self


class ImportThingModelTslResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(ImportThingModelTslResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class InvokeDataAPIServiceRequestParam(TeaModel):
    def __init__(self, param_type=None, list_param_value=None, list_param_type=None, param_name=None,
                 param_value=None):
        self.param_type = param_type  # type: str
        self.list_param_value = list_param_value  # type: list[str]
        self.list_param_type = list_param_type  # type: str
        self.param_name = param_name  # type: str
        self.param_value = param_value  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(InvokeDataAPIServiceRequestParam, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.param_type is not None:
            result['ParamType'] = self.param_type
        if self.list_param_value is not None:
            result['ListParamValue'] = self.list_param_value
        if self.list_param_type is not None:
            result['ListParamType'] = self.list_param_type
        if self.param_name is not None:
            result['ParamName'] = self.param_name
        if self.param_value is not None:
            result['ParamValue'] = self.param_value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ParamType') is not None:
            self.param_type = m.get('ParamType')
        if m.get('ListParamValue') is not None:
            self.list_param_value = m.get('ListParamValue')
        if m.get('ListParamType') is not None:
            self.list_param_type = m.get('ListParamType')
        if m.get('ParamName') is not None:
            self.param_name = m.get('ParamName')
        if m.get('ParamValue') is not None:
            self.param_value = m.get('ParamValue')
        return self


class InvokeDataAPIServiceRequest(TeaModel):
    def __init__(self, api_srn=None, param=None, iot_instance_id=None):
        self.api_srn = api_srn  # type: str
        self.param = param  # type: list[InvokeDataAPIServiceRequestParam]
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.api_srn, 'api_srn')
        if self.param:
            for k in self.param:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(InvokeDataAPIServiceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.api_srn is not None:
            result['ApiSrn'] = self.api_srn
        result['Param'] = []
        if self.param is not None:
            for k in self.param:
                result['Param'].append(k.to_map() if k else None)
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApiSrn') is not None:
            self.api_srn = m.get('ApiSrn')
        self.param = []
        if m.get('Param') is not None:
            for k in m.get('Param'):
                temp_model = InvokeDataAPIServiceRequestParam()
                self.param.append(temp_model.from_map(k))
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class InvokeDataAPIServiceResponseDataFieldNameList(TeaModel):
    def __init__(self, field_name_list=None):
        # FieldNameList
        self.field_name_list = field_name_list  # type: list[str]

    def validate(self):
        self.validate_required(self.field_name_list, 'field_name_list')

    def to_map(self):
        _map = super(InvokeDataAPIServiceResponseDataFieldNameList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.field_name_list is not None:
            result['FieldNameList'] = self.field_name_list
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FieldNameList') is not None:
            self.field_name_list = m.get('FieldNameList')
        return self


class InvokeDataAPIServiceResponseDataResultList(TeaModel):
    def __init__(self, result_list=None):
        # ResultList
        self.result_list = result_list  # type: list[dict[str, any]]

    def validate(self):
        self.validate_required(self.result_list, 'result_list')

    def to_map(self):
        _map = super(InvokeDataAPIServiceResponseDataResultList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.result_list is not None:
            result['ResultList'] = self.result_list
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ResultList') is not None:
            self.result_list = m.get('ResultList')
        return self


class InvokeDataAPIServiceResponseData(TeaModel):
    def __init__(self, api_srn=None, page_no=None, page_size=None, total_size=None, field_name_list=None,
                 result_list=None):
        self.api_srn = api_srn  # type: str
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int
        self.total_size = total_size  # type: int
        self.field_name_list = field_name_list  # type: InvokeDataAPIServiceResponseDataFieldNameList
        self.result_list = result_list  # type: InvokeDataAPIServiceResponseDataResultList

    def validate(self):
        self.validate_required(self.api_srn, 'api_srn')
        self.validate_required(self.page_no, 'page_no')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total_size, 'total_size')
        self.validate_required(self.field_name_list, 'field_name_list')
        if self.field_name_list:
            self.field_name_list.validate()
        self.validate_required(self.result_list, 'result_list')
        if self.result_list:
            self.result_list.validate()

    def to_map(self):
        _map = super(InvokeDataAPIServiceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.api_srn is not None:
            result['ApiSrn'] = self.api_srn
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total_size is not None:
            result['TotalSize'] = self.total_size
        if self.field_name_list is not None:
            result['FieldNameList'] = self.field_name_list.to_map()
        if self.result_list is not None:
            result['ResultList'] = self.result_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApiSrn') is not None:
            self.api_srn = m.get('ApiSrn')
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('TotalSize') is not None:
            self.total_size = m.get('TotalSize')
        if m.get('FieldNameList') is not None:
            temp_model = InvokeDataAPIServiceResponseDataFieldNameList()
            self.field_name_list = temp_model.from_map(m['FieldNameList'])
        if m.get('ResultList') is not None:
            temp_model = InvokeDataAPIServiceResponseDataResultList()
            self.result_list = temp_model.from_map(m['ResultList'])
        return self


class InvokeDataAPIServiceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: InvokeDataAPIServiceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(InvokeDataAPIServiceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = InvokeDataAPIServiceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class InvokeThingServiceRequest(TeaModel):
    def __init__(self, args=None, device_name=None, identifier=None, iot_id=None, iot_instance_id=None,
                 product_key=None):
        self.args = args  # type: str
        self.device_name = device_name  # type: str
        self.identifier = identifier  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.args, 'args')
        self.validate_required(self.identifier, 'identifier')

    def to_map(self):
        _map = super(InvokeThingServiceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.args is not None:
            result['Args'] = self.args
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Args') is not None:
            self.args = m.get('Args')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class InvokeThingServiceResponseData(TeaModel):
    def __init__(self, message_id=None, result=None):
        self.message_id = message_id  # type: str
        self.result = result  # type: str

    def validate(self):
        self.validate_required(self.message_id, 'message_id')
        self.validate_required(self.result, 'result')

    def to_map(self):
        _map = super(InvokeThingServiceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.message_id is not None:
            result['MessageId'] = self.message_id
        if self.result is not None:
            result['Result'] = self.result
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('MessageId') is not None:
            self.message_id = m.get('MessageId')
        if m.get('Result') is not None:
            self.result = m.get('Result')
        return self


class InvokeThingServiceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: InvokeThingServiceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(InvokeThingServiceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = InvokeThingServiceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class InvokeThingsServiceRequest(TeaModel):
    def __init__(self, args=None, device_name=None, identifier=None, iot_instance_id=None, product_key=None):
        self.args = args  # type: str
        self.device_name = device_name  # type: list[str]
        self.identifier = identifier  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.args, 'args')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(InvokeThingsServiceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.args is not None:
            result['Args'] = self.args
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Args') is not None:
            self.args = m.get('Args')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class InvokeThingsServiceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(InvokeThingsServiceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class ListAnalyticsDataRequestCondition(TeaModel):
    def __init__(self, between_end=None, between_start=None, field_name=None, operate=None, value=None):
        self.between_end = between_end  # type: str
        self.between_start = between_start  # type: str
        self.field_name = field_name  # type: str
        self.operate = operate  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.field_name, 'field_name')
        self.validate_required(self.operate, 'operate')

    def to_map(self):
        _map = super(ListAnalyticsDataRequestCondition, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.between_end is not None:
            result['BetweenEnd'] = self.between_end
        if self.between_start is not None:
            result['BetweenStart'] = self.between_start
        if self.field_name is not None:
            result['FieldName'] = self.field_name
        if self.operate is not None:
            result['Operate'] = self.operate
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BetweenEnd') is not None:
            self.between_end = m.get('BetweenEnd')
        if m.get('BetweenStart') is not None:
            self.between_start = m.get('BetweenStart')
        if m.get('FieldName') is not None:
            self.field_name = m.get('FieldName')
        if m.get('Operate') is not None:
            self.operate = m.get('Operate')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class ListAnalyticsDataRequest(TeaModel):
    def __init__(self, api_path=None, condition=None, iot_instance_id=None, iso_id=None, page_num=None,
                 page_size=None):
        self.api_path = api_path  # type: str
        self.condition = condition  # type: list[ListAnalyticsDataRequestCondition]
        self.iot_instance_id = iot_instance_id  # type: str
        self.iso_id = iso_id  # type: str
        self.page_num = page_num  # type: int
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.api_path, 'api_path')
        if self.condition:
            for k in self.condition:
                if k:
                    k.validate()
        self.validate_required(self.iot_instance_id, 'iot_instance_id')

    def to_map(self):
        _map = super(ListAnalyticsDataRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.api_path is not None:
            result['ApiPath'] = self.api_path
        result['Condition'] = []
        if self.condition is not None:
            for k in self.condition:
                result['Condition'].append(k.to_map() if k else None)
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.iso_id is not None:
            result['IsoId'] = self.iso_id
        if self.page_num is not None:
            result['PageNum'] = self.page_num
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApiPath') is not None:
            self.api_path = m.get('ApiPath')
        self.condition = []
        if m.get('Condition') is not None:
            for k in m.get('Condition'):
                temp_model = ListAnalyticsDataRequestCondition()
                self.condition.append(temp_model.from_map(k))
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('IsoId') is not None:
            self.iso_id = m.get('IsoId')
        if m.get('PageNum') is not None:
            self.page_num = m.get('PageNum')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class ListAnalyticsDataResponseData(TeaModel):
    def __init__(self, count=None, has_next=None, page_num=None, page_size=None, result_json=None):
        self.count = count  # type: long
        self.has_next = has_next  # type: bool
        self.page_num = page_num  # type: int
        self.page_size = page_size  # type: int
        self.result_json = result_json  # type: str

    def validate(self):
        self.validate_required(self.count, 'count')
        self.validate_required(self.has_next, 'has_next')
        self.validate_required(self.page_num, 'page_num')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.result_json, 'result_json')

    def to_map(self):
        _map = super(ListAnalyticsDataResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.count is not None:
            result['Count'] = self.count
        if self.has_next is not None:
            result['HasNext'] = self.has_next
        if self.page_num is not None:
            result['PageNum'] = self.page_num
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.result_json is not None:
            result['ResultJson'] = self.result_json
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Count') is not None:
            self.count = m.get('Count')
        if m.get('HasNext') is not None:
            self.has_next = m.get('HasNext')
        if m.get('PageNum') is not None:
            self.page_num = m.get('PageNum')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ResultJson') is not None:
            self.result_json = m.get('ResultJson')
        return self


class ListAnalyticsDataResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ListAnalyticsDataResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListAnalyticsDataResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ListAnalyticsDataResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListDataSourceItemRequest(TeaModel):
    def __init__(self, data_source_id=None, iot_instance_id=None, page=None, page_size=None, search_name=None):
        self.data_source_id = data_source_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str
        self.page = page  # type: int
        self.page_size = page_size  # type: int
        self.search_name = search_name  # type: str

    def validate(self):
        self.validate_required(self.data_source_id, 'data_source_id')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(ListDataSourceItemRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page is not None:
            result['Page'] = self.page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.search_name is not None:
            result['SearchName'] = self.search_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('SearchName') is not None:
            self.search_name = m.get('SearchName')
        return self


class ListDataSourceItemResponseDataSourceItemsDataSourceItem(TeaModel):
    def __init__(self, data_source_item_id=None, device_name=None, product_key=None, scope_type=None, topic=None):
        self.data_source_item_id = data_source_item_id  # type: long
        self.device_name = device_name  # type: str
        self.product_key = product_key  # type: str
        self.scope_type = scope_type  # type: str
        self.topic = topic  # type: str

    def validate(self):
        self.validate_required(self.data_source_item_id, 'data_source_item_id')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.scope_type, 'scope_type')
        self.validate_required(self.topic, 'topic')

    def to_map(self):
        _map = super(ListDataSourceItemResponseDataSourceItemsDataSourceItem, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_item_id is not None:
            result['DataSourceItemId'] = self.data_source_item_id
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.scope_type is not None:
            result['ScopeType'] = self.scope_type
        if self.topic is not None:
            result['Topic'] = self.topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceItemId') is not None:
            self.data_source_item_id = m.get('DataSourceItemId')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ScopeType') is not None:
            self.scope_type = m.get('ScopeType')
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        return self


class ListDataSourceItemResponseDataSourceItems(TeaModel):
    def __init__(self, data_source_item=None):
        self.data_source_item = data_source_item  # type: list[ListDataSourceItemResponseDataSourceItemsDataSourceItem]

    def validate(self):
        self.validate_required(self.data_source_item, 'data_source_item')
        if self.data_source_item:
            for k in self.data_source_item:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListDataSourceItemResponseDataSourceItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['dataSourceItem'] = []
        if self.data_source_item is not None:
            for k in self.data_source_item:
                result['dataSourceItem'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.data_source_item = []
        if m.get('dataSourceItem') is not None:
            for k in m.get('dataSourceItem'):
                temp_model = ListDataSourceItemResponseDataSourceItemsDataSourceItem()
                self.data_source_item.append(temp_model.from_map(k))
        return self


class ListDataSourceItemResponse(TeaModel):
    def __init__(self, code=None, error_message=None, page=None, page_size=None, request_id=None, success=None,
                 total=None, data_source_items=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.page = page  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data_source_items = data_source_items  # type: ListDataSourceItemResponseDataSourceItems

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data_source_items, 'data_source_items')
        if self.data_source_items:
            self.data_source_items.validate()

    def to_map(self):
        _map = super(ListDataSourceItemResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page is not None:
            result['Page'] = self.page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data_source_items is not None:
            result['DataSourceItems'] = self.data_source_items.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('DataSourceItems') is not None:
            temp_model = ListDataSourceItemResponseDataSourceItems()
            self.data_source_items = temp_model.from_map(m['DataSourceItems'])
        return self


class ListDestinationRequest(TeaModel):
    def __init__(self, iot_instance_id=None, page=None, page_size=None, search_name=None, types=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.page = page  # type: int
        self.page_size = page_size  # type: int
        self.search_name = search_name  # type: str
        self.types = types  # type: list[str]

    def validate(self):
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(ListDestinationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page is not None:
            result['Page'] = self.page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.search_name is not None:
            result['SearchName'] = self.search_name
        if self.types is not None:
            result['Types'] = self.types
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('SearchName') is not None:
            self.search_name = m.get('SearchName')
        if m.get('Types') is not None:
            self.types = m.get('Types')
        return self


class ListDestinationResponseDestinationsDestinations(TeaModel):
    def __init__(self, configuration=None, description=None, destination_id=None, is_failover=None, name=None,
                 status=None, type=None, utc_created=None):
        self.configuration = configuration  # type: str
        self.description = description  # type: str
        self.destination_id = destination_id  # type: long
        self.is_failover = is_failover  # type: bool
        self.name = name  # type: str
        self.status = status  # type: str
        self.type = type  # type: str
        self.utc_created = utc_created  # type: str

    def validate(self):
        self.validate_required(self.configuration, 'configuration')
        self.validate_required(self.description, 'description')
        self.validate_required(self.destination_id, 'destination_id')
        self.validate_required(self.is_failover, 'is_failover')
        self.validate_required(self.name, 'name')
        self.validate_required(self.status, 'status')
        self.validate_required(self.type, 'type')
        self.validate_required(self.utc_created, 'utc_created')

    def to_map(self):
        _map = super(ListDestinationResponseDestinationsDestinations, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        if self.description is not None:
            result['Description'] = self.description
        if self.destination_id is not None:
            result['DestinationId'] = self.destination_id
        if self.is_failover is not None:
            result['IsFailover'] = self.is_failover
        if self.name is not None:
            result['Name'] = self.name
        if self.status is not None:
            result['Status'] = self.status
        if self.type is not None:
            result['Type'] = self.type
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('DestinationId') is not None:
            self.destination_id = m.get('DestinationId')
        if m.get('IsFailover') is not None:
            self.is_failover = m.get('IsFailover')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        return self


class ListDestinationResponseDestinations(TeaModel):
    def __init__(self, destinations=None):
        self.destinations = destinations  # type: list[ListDestinationResponseDestinationsDestinations]

    def validate(self):
        self.validate_required(self.destinations, 'destinations')
        if self.destinations:
            for k in self.destinations:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListDestinationResponseDestinations, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['destinations'] = []
        if self.destinations is not None:
            for k in self.destinations:
                result['destinations'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.destinations = []
        if m.get('destinations') is not None:
            for k in m.get('destinations'):
                temp_model = ListDestinationResponseDestinationsDestinations()
                self.destinations.append(temp_model.from_map(k))
        return self


class ListDestinationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, page=None, page_size=None, request_id=None, success=None,
                 total=None, destinations=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.page = page  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.destinations = destinations  # type: ListDestinationResponseDestinations

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.destinations, 'destinations')
        if self.destinations:
            self.destinations.validate()

    def to_map(self):
        _map = super(ListDestinationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page is not None:
            result['Page'] = self.page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.destinations is not None:
            result['Destinations'] = self.destinations.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Destinations') is not None:
            temp_model = ListDestinationResponseDestinations()
            self.destinations = temp_model.from_map(m['Destinations'])
        return self


class ListDeviceDistributeJobRequest(TeaModel):
    def __init__(self, target_uid=None, current_page=None, page_size=None, status=None, job_id=None, next_token=None,
                 product_key=None):
        self.target_uid = target_uid  # type: str
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.status = status  # type: int
        self.job_id = job_id  # type: str
        self.next_token = next_token  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(ListDeviceDistributeJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.target_uid is not None:
            result['TargetUid'] = self.target_uid
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.status is not None:
            result['Status'] = self.status
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.next_token is not None:
            result['NextToken'] = self.next_token
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TargetUid') is not None:
            self.target_uid = m.get('TargetUid')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('NextToken') is not None:
            self.next_token = m.get('NextToken')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ListDeviceDistributeJobResponseDataJobInfoItemsTargetInstanceConfigsTargetInstanceConfigs(TeaModel):
    def __init__(self, target_instance_id=None, target_instance_name=None, target_region=None):
        self.target_instance_id = target_instance_id  # type: str
        self.target_instance_name = target_instance_name  # type: str
        self.target_region = target_region  # type: str

    def validate(self):
        self.validate_required(self.target_instance_id, 'target_instance_id')
        self.validate_required(self.target_instance_name, 'target_instance_name')
        self.validate_required(self.target_region, 'target_region')

    def to_map(self):
        _map = super(ListDeviceDistributeJobResponseDataJobInfoItemsTargetInstanceConfigsTargetInstanceConfigs, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.target_instance_id is not None:
            result['TargetInstanceId'] = self.target_instance_id
        if self.target_instance_name is not None:
            result['TargetInstanceName'] = self.target_instance_name
        if self.target_region is not None:
            result['TargetRegion'] = self.target_region
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TargetInstanceId') is not None:
            self.target_instance_id = m.get('TargetInstanceId')
        if m.get('TargetInstanceName') is not None:
            self.target_instance_name = m.get('TargetInstanceName')
        if m.get('TargetRegion') is not None:
            self.target_region = m.get('TargetRegion')
        return self


class ListDeviceDistributeJobResponseDataJobInfoItemsTargetInstanceConfigs(TeaModel):
    def __init__(self, target_instance_configs=None):
        self.target_instance_configs = target_instance_configs  # type: list[ListDeviceDistributeJobResponseDataJobInfoItemsTargetInstanceConfigsTargetInstanceConfigs]

    def validate(self):
        self.validate_required(self.target_instance_configs, 'target_instance_configs')
        if self.target_instance_configs:
            for k in self.target_instance_configs:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListDeviceDistributeJobResponseDataJobInfoItemsTargetInstanceConfigs, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['targetInstanceConfigs'] = []
        if self.target_instance_configs is not None:
            for k in self.target_instance_configs:
                result['targetInstanceConfigs'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.target_instance_configs = []
        if m.get('targetInstanceConfigs') is not None:
            for k in m.get('targetInstanceConfigs'):
                temp_model = ListDeviceDistributeJobResponseDataJobInfoItemsTargetInstanceConfigsTargetInstanceConfigs()
                self.target_instance_configs.append(temp_model.from_map(k))
        return self


class ListDeviceDistributeJobResponseDataJobInfoItems(TeaModel):
    def __init__(self, gmt_create=None, job_id=None, product_key=None, source_instance_id=None,
                 source_instance_name=None, source_region=None, source_uid=None, status=None, strategy=None, target_uid=None, total=None,
                 target_instance_configs=None):
        self.gmt_create = gmt_create  # type: long
        self.job_id = job_id  # type: str
        self.product_key = product_key  # type: str
        self.source_instance_id = source_instance_id  # type: str
        self.source_instance_name = source_instance_name  # type: str
        self.source_region = source_region  # type: str
        self.source_uid = source_uid  # type: str
        self.status = status  # type: int
        self.strategy = strategy  # type: int
        self.target_uid = target_uid  # type: str
        self.total = total  # type: int
        self.target_instance_configs = target_instance_configs  # type: ListDeviceDistributeJobResponseDataJobInfoItemsTargetInstanceConfigs

    def validate(self):
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.source_instance_id, 'source_instance_id')
        self.validate_required(self.source_instance_name, 'source_instance_name')
        self.validate_required(self.source_region, 'source_region')
        self.validate_required(self.source_uid, 'source_uid')
        self.validate_required(self.status, 'status')
        self.validate_required(self.strategy, 'strategy')
        self.validate_required(self.target_uid, 'target_uid')
        self.validate_required(self.total, 'total')
        self.validate_required(self.target_instance_configs, 'target_instance_configs')
        if self.target_instance_configs:
            self.target_instance_configs.validate()

    def to_map(self):
        _map = super(ListDeviceDistributeJobResponseDataJobInfoItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.source_instance_id is not None:
            result['SourceInstanceId'] = self.source_instance_id
        if self.source_instance_name is not None:
            result['SourceInstanceName'] = self.source_instance_name
        if self.source_region is not None:
            result['SourceRegion'] = self.source_region
        if self.source_uid is not None:
            result['SourceUid'] = self.source_uid
        if self.status is not None:
            result['Status'] = self.status
        if self.strategy is not None:
            result['Strategy'] = self.strategy
        if self.target_uid is not None:
            result['TargetUid'] = self.target_uid
        if self.total is not None:
            result['Total'] = self.total
        if self.target_instance_configs is not None:
            result['TargetInstanceConfigs'] = self.target_instance_configs.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SourceInstanceId') is not None:
            self.source_instance_id = m.get('SourceInstanceId')
        if m.get('SourceInstanceName') is not None:
            self.source_instance_name = m.get('SourceInstanceName')
        if m.get('SourceRegion') is not None:
            self.source_region = m.get('SourceRegion')
        if m.get('SourceUid') is not None:
            self.source_uid = m.get('SourceUid')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Strategy') is not None:
            self.strategy = m.get('Strategy')
        if m.get('TargetUid') is not None:
            self.target_uid = m.get('TargetUid')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('TargetInstanceConfigs') is not None:
            temp_model = ListDeviceDistributeJobResponseDataJobInfoItemsTargetInstanceConfigs()
            self.target_instance_configs = temp_model.from_map(m['TargetInstanceConfigs'])
        return self


class ListDeviceDistributeJobResponseDataJobInfo(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[ListDeviceDistributeJobResponseDataJobInfoItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListDeviceDistributeJobResponseDataJobInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['items'] = []
        if self.items is not None:
            for k in self.items:
                result['items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('items') is not None:
            for k in m.get('items'):
                temp_model = ListDeviceDistributeJobResponseDataJobInfoItems()
                self.items.append(temp_model.from_map(k))
        return self


class ListDeviceDistributeJobResponseData(TeaModel):
    def __init__(self, next_token=None, total=None, job_info=None):
        self.next_token = next_token  # type: str
        self.total = total  # type: int
        self.job_info = job_info  # type: ListDeviceDistributeJobResponseDataJobInfo

    def validate(self):
        self.validate_required(self.next_token, 'next_token')
        self.validate_required(self.total, 'total')
        self.validate_required(self.job_info, 'job_info')
        if self.job_info:
            self.job_info.validate()

    def to_map(self):
        _map = super(ListDeviceDistributeJobResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.next_token is not None:
            result['NextToken'] = self.next_token
        if self.total is not None:
            result['Total'] = self.total
        if self.job_info is not None:
            result['JobInfo'] = self.job_info.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('NextToken') is not None:
            self.next_token = m.get('NextToken')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('JobInfo') is not None:
            temp_model = ListDeviceDistributeJobResponseDataJobInfo()
            self.job_info = temp_model.from_map(m['JobInfo'])
        return self


class ListDeviceDistributeJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ListDeviceDistributeJobResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListDeviceDistributeJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ListDeviceDistributeJobResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListDistributedDeviceRequest(TeaModel):
    def __init__(self, current_page=None, device_name=None, page_size=None, product_key=None,
                 source_instance_id=None, target_uid=None):
        self.current_page = current_page  # type: int
        self.device_name = device_name  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.source_instance_id = source_instance_id  # type: str
        self.target_uid = target_uid  # type: str

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(ListDistributedDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.source_instance_id is not None:
            result['SourceInstanceId'] = self.source_instance_id
        if self.target_uid is not None:
            result['TargetUid'] = self.target_uid
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SourceInstanceId') is not None:
            self.source_instance_id = m.get('SourceInstanceId')
        if m.get('TargetUid') is not None:
            self.target_uid = m.get('TargetUid')
        return self


class ListDistributedDeviceResponseDataInfoItems(TeaModel):
    def __init__(self, device_name=None, gmt_create=None, gmt_modified=None, product_key=None,
                 source_instance_id=None, source_instance_name=None, source_region=None, source_uid=None, target_aliyun_id=None,
                 target_instance_id=None, target_instance_name=None, target_region=None, target_uid=None):
        self.device_name = device_name  # type: str
        self.gmt_create = gmt_create  # type: long
        self.gmt_modified = gmt_modified  # type: long
        self.product_key = product_key  # type: str
        self.source_instance_id = source_instance_id  # type: str
        self.source_instance_name = source_instance_name  # type: str
        self.source_region = source_region  # type: str
        self.source_uid = source_uid  # type: str
        self.target_aliyun_id = target_aliyun_id  # type: str
        self.target_instance_id = target_instance_id  # type: str
        self.target_instance_name = target_instance_name  # type: str
        self.target_region = target_region  # type: str
        self.target_uid = target_uid  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.source_instance_id, 'source_instance_id')
        self.validate_required(self.source_instance_name, 'source_instance_name')
        self.validate_required(self.source_region, 'source_region')
        self.validate_required(self.source_uid, 'source_uid')
        self.validate_required(self.target_aliyun_id, 'target_aliyun_id')
        self.validate_required(self.target_instance_id, 'target_instance_id')
        self.validate_required(self.target_instance_name, 'target_instance_name')
        self.validate_required(self.target_region, 'target_region')
        self.validate_required(self.target_uid, 'target_uid')

    def to_map(self):
        _map = super(ListDistributedDeviceResponseDataInfoItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.source_instance_id is not None:
            result['SourceInstanceId'] = self.source_instance_id
        if self.source_instance_name is not None:
            result['SourceInstanceName'] = self.source_instance_name
        if self.source_region is not None:
            result['SourceRegion'] = self.source_region
        if self.source_uid is not None:
            result['SourceUid'] = self.source_uid
        if self.target_aliyun_id is not None:
            result['TargetAliyunId'] = self.target_aliyun_id
        if self.target_instance_id is not None:
            result['TargetInstanceId'] = self.target_instance_id
        if self.target_instance_name is not None:
            result['TargetInstanceName'] = self.target_instance_name
        if self.target_region is not None:
            result['TargetRegion'] = self.target_region
        if self.target_uid is not None:
            result['TargetUid'] = self.target_uid
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SourceInstanceId') is not None:
            self.source_instance_id = m.get('SourceInstanceId')
        if m.get('SourceInstanceName') is not None:
            self.source_instance_name = m.get('SourceInstanceName')
        if m.get('SourceRegion') is not None:
            self.source_region = m.get('SourceRegion')
        if m.get('SourceUid') is not None:
            self.source_uid = m.get('SourceUid')
        if m.get('TargetAliyunId') is not None:
            self.target_aliyun_id = m.get('TargetAliyunId')
        if m.get('TargetInstanceId') is not None:
            self.target_instance_id = m.get('TargetInstanceId')
        if m.get('TargetInstanceName') is not None:
            self.target_instance_name = m.get('TargetInstanceName')
        if m.get('TargetRegion') is not None:
            self.target_region = m.get('TargetRegion')
        if m.get('TargetUid') is not None:
            self.target_uid = m.get('TargetUid')
        return self


class ListDistributedDeviceResponseDataInfo(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[ListDistributedDeviceResponseDataInfoItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListDistributedDeviceResponseDataInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['items'] = []
        if self.items is not None:
            for k in self.items:
                result['items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('items') is not None:
            for k in m.get('items'):
                temp_model = ListDistributedDeviceResponseDataInfoItems()
                self.items.append(temp_model.from_map(k))
        return self


class ListDistributedDeviceResponseData(TeaModel):
    def __init__(self, total=None, info=None):
        self.total = total  # type: int
        self.info = info  # type: ListDistributedDeviceResponseDataInfo

    def validate(self):
        self.validate_required(self.total, 'total')
        self.validate_required(self.info, 'info')
        if self.info:
            self.info.validate()

    def to_map(self):
        _map = super(ListDistributedDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.total is not None:
            result['Total'] = self.total
        if self.info is not None:
            result['Info'] = self.info.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Info') is not None:
            temp_model = ListDistributedDeviceResponseDataInfo()
            self.info = temp_model.from_map(m['Info'])
        return self


class ListDistributedDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ListDistributedDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListDistributedDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ListDistributedDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListDistributedProductRequest(TeaModel):
    def __init__(self, page_size=None, source_instance_id=None, product_key=None, target_instance_id=None,
                 target_uid=None, current_page=None):
        self.page_size = page_size  # type: int
        self.source_instance_id = source_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.target_instance_id = target_instance_id  # type: str
        self.target_uid = target_uid  # type: str
        self.current_page = current_page  # type: int

    def validate(self):
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.current_page, 'current_page')

    def to_map(self):
        _map = super(ListDistributedProductRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.source_instance_id is not None:
            result['SourceInstanceId'] = self.source_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.target_instance_id is not None:
            result['TargetInstanceId'] = self.target_instance_id
        if self.target_uid is not None:
            result['TargetUid'] = self.target_uid
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('SourceInstanceId') is not None:
            self.source_instance_id = m.get('SourceInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('TargetInstanceId') is not None:
            self.target_instance_id = m.get('TargetInstanceId')
        if m.get('TargetUid') is not None:
            self.target_uid = m.get('TargetUid')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        return self


class ListDistributedProductResponseDataInfoItems(TeaModel):
    def __init__(self, gmt_create=None, product_key=None, source_instance_id=None, source_instance_name=None,
                 source_region=None, source_uid=None, target_aliyun_id=None, target_instance_id=None, target_instance_name=None,
                 target_region=None, target_uid=None):
        self.gmt_create = gmt_create  # type: long
        self.product_key = product_key  # type: str
        self.source_instance_id = source_instance_id  # type: str
        self.source_instance_name = source_instance_name  # type: str
        self.source_region = source_region  # type: str
        self.source_uid = source_uid  # type: str
        self.target_aliyun_id = target_aliyun_id  # type: str
        self.target_instance_id = target_instance_id  # type: str
        self.target_instance_name = target_instance_name  # type: str
        self.target_region = target_region  # type: str
        self.target_uid = target_uid  # type: str

    def validate(self):
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.source_instance_id, 'source_instance_id')
        self.validate_required(self.source_instance_name, 'source_instance_name')
        self.validate_required(self.source_region, 'source_region')
        self.validate_required(self.source_uid, 'source_uid')
        self.validate_required(self.target_aliyun_id, 'target_aliyun_id')
        self.validate_required(self.target_instance_id, 'target_instance_id')
        self.validate_required(self.target_instance_name, 'target_instance_name')
        self.validate_required(self.target_region, 'target_region')
        self.validate_required(self.target_uid, 'target_uid')

    def to_map(self):
        _map = super(ListDistributedProductResponseDataInfoItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.source_instance_id is not None:
            result['SourceInstanceId'] = self.source_instance_id
        if self.source_instance_name is not None:
            result['SourceInstanceName'] = self.source_instance_name
        if self.source_region is not None:
            result['SourceRegion'] = self.source_region
        if self.source_uid is not None:
            result['SourceUid'] = self.source_uid
        if self.target_aliyun_id is not None:
            result['TargetAliyunId'] = self.target_aliyun_id
        if self.target_instance_id is not None:
            result['TargetInstanceId'] = self.target_instance_id
        if self.target_instance_name is not None:
            result['TargetInstanceName'] = self.target_instance_name
        if self.target_region is not None:
            result['TargetRegion'] = self.target_region
        if self.target_uid is not None:
            result['TargetUid'] = self.target_uid
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SourceInstanceId') is not None:
            self.source_instance_id = m.get('SourceInstanceId')
        if m.get('SourceInstanceName') is not None:
            self.source_instance_name = m.get('SourceInstanceName')
        if m.get('SourceRegion') is not None:
            self.source_region = m.get('SourceRegion')
        if m.get('SourceUid') is not None:
            self.source_uid = m.get('SourceUid')
        if m.get('TargetAliyunId') is not None:
            self.target_aliyun_id = m.get('TargetAliyunId')
        if m.get('TargetInstanceId') is not None:
            self.target_instance_id = m.get('TargetInstanceId')
        if m.get('TargetInstanceName') is not None:
            self.target_instance_name = m.get('TargetInstanceName')
        if m.get('TargetRegion') is not None:
            self.target_region = m.get('TargetRegion')
        if m.get('TargetUid') is not None:
            self.target_uid = m.get('TargetUid')
        return self


class ListDistributedProductResponseDataInfo(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[ListDistributedProductResponseDataInfoItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListDistributedProductResponseDataInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['items'] = []
        if self.items is not None:
            for k in self.items:
                result['items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('items') is not None:
            for k in m.get('items'):
                temp_model = ListDistributedProductResponseDataInfoItems()
                self.items.append(temp_model.from_map(k))
        return self


class ListDistributedProductResponseData(TeaModel):
    def __init__(self, total=None, info=None):
        self.total = total  # type: int
        self.info = info  # type: ListDistributedProductResponseDataInfo

    def validate(self):
        self.validate_required(self.total, 'total')
        self.validate_required(self.info, 'info')
        if self.info:
            self.info.validate()

    def to_map(self):
        _map = super(ListDistributedProductResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.total is not None:
            result['Total'] = self.total
        if self.info is not None:
            result['Info'] = self.info.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Info') is not None:
            temp_model = ListDistributedProductResponseDataInfo()
            self.info = temp_model.from_map(m['Info'])
        return self


class ListDistributedProductResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ListDistributedProductResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListDistributedProductResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ListDistributedProductResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListJobRequest(TeaModel):
    def __init__(self, current_page=None, iot_instance_id=None, page_size=None, status=None):
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(ListJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class ListJobResponseDataData(TeaModel):
    def __init__(self, description=None, job_id=None, job_name=None, scheduled_time=None, status=None, type=None,
                 utc_create=None, utc_modified=None):
        self.description = description  # type: str
        self.job_id = job_id  # type: str
        self.job_name = job_name  # type: str
        self.scheduled_time = scheduled_time  # type: long
        self.status = status  # type: str
        self.type = type  # type: str
        self.utc_create = utc_create  # type: str
        self.utc_modified = utc_modified  # type: str

    def validate(self):
        self.validate_required(self.description, 'description')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.job_name, 'job_name')
        self.validate_required(self.scheduled_time, 'scheduled_time')
        self.validate_required(self.status, 'status')
        self.validate_required(self.type, 'type')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_modified, 'utc_modified')

    def to_map(self):
        _map = super(ListJobResponseDataData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.job_name is not None:
            result['JobName'] = self.job_name
        if self.scheduled_time is not None:
            result['ScheduledTime'] = self.scheduled_time
        if self.status is not None:
            result['Status'] = self.status
        if self.type is not None:
            result['Type'] = self.type
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('JobName') is not None:
            self.job_name = m.get('JobName')
        if m.get('ScheduledTime') is not None:
            self.scheduled_time = m.get('ScheduledTime')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        return self


class ListJobResponseData(TeaModel):
    def __init__(self, data=None):
        self.data = data  # type: list[ListJobResponseDataData]

    def validate(self):
        self.validate_required(self.data, 'data')
        if self.data:
            for k in self.data:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListJobResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['data'] = []
        if self.data is not None:
            for k in self.data:
                result['data'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.data = []
        if m.get('data') is not None:
            for k in m.get('data'):
                temp_model = ListJobResponseDataData()
                self.data.append(temp_model.from_map(k))
        return self


class ListJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, page=None, page_size=None, request_id=None, success=None,
                 total=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.page = page  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: ListJobResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page is not None:
            result['Page'] = self.page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = ListJobResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListOTAFirmwareRequest(TeaModel):
    def __init__(self, current_page=None, dest_version=None, iot_instance_id=None, page_size=None, product_key=None):
        self.current_page = current_page  # type: int
        self.dest_version = dest_version  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(ListOTAFirmwareRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.dest_version is not None:
            result['DestVersion'] = self.dest_version
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('DestVersion') is not None:
            self.dest_version = m.get('DestVersion')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ListOTAFirmwareResponseFirmwareInfoSimpleFirmwareInfo(TeaModel):
    def __init__(self, dest_version=None, firmware_desc=None, firmware_id=None, firmware_name=None,
                 firmware_sign=None, firmware_size=None, module_name=None, product_key=None, product_name=None, sign_method=None,
                 src_version=None, status=None, type=None, utc_create=None, utc_modified=None):
        self.dest_version = dest_version  # type: str
        self.firmware_desc = firmware_desc  # type: str
        self.firmware_id = firmware_id  # type: str
        self.firmware_name = firmware_name  # type: str
        self.firmware_sign = firmware_sign  # type: str
        self.firmware_size = firmware_size  # type: int
        self.module_name = module_name  # type: str
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str
        self.sign_method = sign_method  # type: str
        self.src_version = src_version  # type: str
        self.status = status  # type: int
        self.type = type  # type: int
        self.utc_create = utc_create  # type: str
        self.utc_modified = utc_modified  # type: str

    def validate(self):
        self.validate_required(self.dest_version, 'dest_version')
        self.validate_required(self.firmware_desc, 'firmware_desc')
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.firmware_name, 'firmware_name')
        self.validate_required(self.firmware_sign, 'firmware_sign')
        self.validate_required(self.firmware_size, 'firmware_size')
        self.validate_required(self.module_name, 'module_name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')
        self.validate_required(self.sign_method, 'sign_method')
        self.validate_required(self.src_version, 'src_version')
        self.validate_required(self.status, 'status')
        self.validate_required(self.type, 'type')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_modified, 'utc_modified')

    def to_map(self):
        _map = super(ListOTAFirmwareResponseFirmwareInfoSimpleFirmwareInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dest_version is not None:
            result['DestVersion'] = self.dest_version
        if self.firmware_desc is not None:
            result['FirmwareDesc'] = self.firmware_desc
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.firmware_name is not None:
            result['FirmwareName'] = self.firmware_name
        if self.firmware_sign is not None:
            result['FirmwareSign'] = self.firmware_sign
        if self.firmware_size is not None:
            result['FirmwareSize'] = self.firmware_size
        if self.module_name is not None:
            result['ModuleName'] = self.module_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.sign_method is not None:
            result['SignMethod'] = self.sign_method
        if self.src_version is not None:
            result['SrcVersion'] = self.src_version
        if self.status is not None:
            result['Status'] = self.status
        if self.type is not None:
            result['Type'] = self.type
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DestVersion') is not None:
            self.dest_version = m.get('DestVersion')
        if m.get('FirmwareDesc') is not None:
            self.firmware_desc = m.get('FirmwareDesc')
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('FirmwareName') is not None:
            self.firmware_name = m.get('FirmwareName')
        if m.get('FirmwareSign') is not None:
            self.firmware_sign = m.get('FirmwareSign')
        if m.get('FirmwareSize') is not None:
            self.firmware_size = m.get('FirmwareSize')
        if m.get('ModuleName') is not None:
            self.module_name = m.get('ModuleName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('SignMethod') is not None:
            self.sign_method = m.get('SignMethod')
        if m.get('SrcVersion') is not None:
            self.src_version = m.get('SrcVersion')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        return self


class ListOTAFirmwareResponseFirmwareInfo(TeaModel):
    def __init__(self, simple_firmware_info=None):
        self.simple_firmware_info = simple_firmware_info  # type: list[ListOTAFirmwareResponseFirmwareInfoSimpleFirmwareInfo]

    def validate(self):
        self.validate_required(self.simple_firmware_info, 'simple_firmware_info')
        if self.simple_firmware_info:
            for k in self.simple_firmware_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListOTAFirmwareResponseFirmwareInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['SimpleFirmwareInfo'] = []
        if self.simple_firmware_info is not None:
            for k in self.simple_firmware_info:
                result['SimpleFirmwareInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.simple_firmware_info = []
        if m.get('SimpleFirmwareInfo') is not None:
            for k in m.get('SimpleFirmwareInfo'):
                temp_model = ListOTAFirmwareResponseFirmwareInfoSimpleFirmwareInfo()
                self.simple_firmware_info.append(temp_model.from_map(k))
        return self


class ListOTAFirmwareResponse(TeaModel):
    def __init__(self, code=None, current_page=None, error_message=None, page_count=None, page_size=None,
                 request_id=None, success=None, total=None, firmware_info=None):
        self.code = code  # type: str
        self.current_page = current_page  # type: int
        self.error_message = error_message  # type: str
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.firmware_info = firmware_info  # type: ListOTAFirmwareResponseFirmwareInfo

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.firmware_info, 'firmware_info')
        if self.firmware_info:
            self.firmware_info.validate()

    def to_map(self):
        _map = super(ListOTAFirmwareResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.firmware_info is not None:
            result['FirmwareInfo'] = self.firmware_info.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('FirmwareInfo') is not None:
            temp_model = ListOTAFirmwareResponseFirmwareInfo()
            self.firmware_info = temp_model.from_map(m['FirmwareInfo'])
        return self


class ListOTAJobByDeviceRequest(TeaModel):
    def __init__(self, current_page=None, device_name=None, firmware_id=None, iot_instance_id=None, page_size=None,
                 product_key=None):
        self.current_page = current_page  # type: int
        self.device_name = device_name  # type: str
        self.firmware_id = firmware_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(ListOTAJobByDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ListOTAJobByDeviceResponseDataSimpleOTAJobInfoTagsOtaTagDTO(TeaModel):
    def __init__(self, key=None, value=None):
        self.key = key  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.key, 'key')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(ListOTAJobByDeviceResponseDataSimpleOTAJobInfoTagsOtaTagDTO, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.key is not None:
            result['Key'] = self.key
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Key') is not None:
            self.key = m.get('Key')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class ListOTAJobByDeviceResponseDataSimpleOTAJobInfoTags(TeaModel):
    def __init__(self, ota_tag_dto=None):
        self.ota_tag_dto = ota_tag_dto  # type: list[ListOTAJobByDeviceResponseDataSimpleOTAJobInfoTagsOtaTagDTO]

    def validate(self):
        self.validate_required(self.ota_tag_dto, 'ota_tag_dto')
        if self.ota_tag_dto:
            for k in self.ota_tag_dto:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListOTAJobByDeviceResponseDataSimpleOTAJobInfoTags, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['OtaTagDTO'] = []
        if self.ota_tag_dto is not None:
            for k in self.ota_tag_dto:
                result['OtaTagDTO'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.ota_tag_dto = []
        if m.get('OtaTagDTO') is not None:
            for k in m.get('OtaTagDTO'):
                temp_model = ListOTAJobByDeviceResponseDataSimpleOTAJobInfoTagsOtaTagDTO()
                self.ota_tag_dto.append(temp_model.from_map(k))
        return self


class ListOTAJobByDeviceResponseDataSimpleOTAJobInfo(TeaModel):
    def __init__(self, firmware_id=None, job_id=None, job_status=None, job_type=None, product_key=None,
                 selection_type=None, target_selection=None, utc_create=None, utc_end_time=None, utc_modified=None,
                 utc_start_time=None, tags=None):
        self.firmware_id = firmware_id  # type: str
        self.job_id = job_id  # type: str
        self.job_status = job_status  # type: str
        self.job_type = job_type  # type: str
        self.product_key = product_key  # type: str
        self.selection_type = selection_type  # type: str
        self.target_selection = target_selection  # type: str
        self.utc_create = utc_create  # type: str
        self.utc_end_time = utc_end_time  # type: str
        self.utc_modified = utc_modified  # type: str
        self.utc_start_time = utc_start_time  # type: str
        self.tags = tags  # type: ListOTAJobByDeviceResponseDataSimpleOTAJobInfoTags

    def validate(self):
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.job_status, 'job_status')
        self.validate_required(self.job_type, 'job_type')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.selection_type, 'selection_type')
        self.validate_required(self.target_selection, 'target_selection')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_end_time, 'utc_end_time')
        self.validate_required(self.utc_modified, 'utc_modified')
        self.validate_required(self.utc_start_time, 'utc_start_time')
        self.validate_required(self.tags, 'tags')
        if self.tags:
            self.tags.validate()

    def to_map(self):
        _map = super(ListOTAJobByDeviceResponseDataSimpleOTAJobInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.job_status is not None:
            result['JobStatus'] = self.job_status
        if self.job_type is not None:
            result['JobType'] = self.job_type
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.selection_type is not None:
            result['SelectionType'] = self.selection_type
        if self.target_selection is not None:
            result['TargetSelection'] = self.target_selection
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_end_time is not None:
            result['UtcEndTime'] = self.utc_end_time
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        if self.utc_start_time is not None:
            result['UtcStartTime'] = self.utc_start_time
        if self.tags is not None:
            result['Tags'] = self.tags.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('JobStatus') is not None:
            self.job_status = m.get('JobStatus')
        if m.get('JobType') is not None:
            self.job_type = m.get('JobType')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SelectionType') is not None:
            self.selection_type = m.get('SelectionType')
        if m.get('TargetSelection') is not None:
            self.target_selection = m.get('TargetSelection')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcEndTime') is not None:
            self.utc_end_time = m.get('UtcEndTime')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        if m.get('UtcStartTime') is not None:
            self.utc_start_time = m.get('UtcStartTime')
        if m.get('Tags') is not None:
            temp_model = ListOTAJobByDeviceResponseDataSimpleOTAJobInfoTags()
            self.tags = temp_model.from_map(m['Tags'])
        return self


class ListOTAJobByDeviceResponseData(TeaModel):
    def __init__(self, simple_otajob_info=None):
        self.simple_otajob_info = simple_otajob_info  # type: list[ListOTAJobByDeviceResponseDataSimpleOTAJobInfo]

    def validate(self):
        self.validate_required(self.simple_otajob_info, 'simple_otajob_info')
        if self.simple_otajob_info:
            for k in self.simple_otajob_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListOTAJobByDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['SimpleOTAJobInfo'] = []
        if self.simple_otajob_info is not None:
            for k in self.simple_otajob_info:
                result['SimpleOTAJobInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.simple_otajob_info = []
        if m.get('SimpleOTAJobInfo') is not None:
            for k in m.get('SimpleOTAJobInfo'):
                temp_model = ListOTAJobByDeviceResponseDataSimpleOTAJobInfo()
                self.simple_otajob_info.append(temp_model.from_map(k))
        return self


class ListOTAJobByDeviceResponse(TeaModel):
    def __init__(self, code=None, current_page=None, error_message=None, page_count=None, page_size=None,
                 request_id=None, success=None, total=None, data=None):
        self.code = code  # type: str
        self.current_page = current_page  # type: int
        self.error_message = error_message  # type: str
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: ListOTAJobByDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListOTAJobByDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = ListOTAJobByDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListOTAJobByFirmwareRequest(TeaModel):
    def __init__(self, current_page=None, firmware_id=None, iot_instance_id=None, page_size=None):
        self.current_page = current_page  # type: int
        self.firmware_id = firmware_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(ListOTAJobByFirmwareRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class ListOTAJobByFirmwareResponseDataSimpleOTAJobInfoTagsOtaTagDTO(TeaModel):
    def __init__(self, key=None, value=None):
        self.key = key  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.key, 'key')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(ListOTAJobByFirmwareResponseDataSimpleOTAJobInfoTagsOtaTagDTO, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.key is not None:
            result['Key'] = self.key
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Key') is not None:
            self.key = m.get('Key')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class ListOTAJobByFirmwareResponseDataSimpleOTAJobInfoTags(TeaModel):
    def __init__(self, ota_tag_dto=None):
        self.ota_tag_dto = ota_tag_dto  # type: list[ListOTAJobByFirmwareResponseDataSimpleOTAJobInfoTagsOtaTagDTO]

    def validate(self):
        self.validate_required(self.ota_tag_dto, 'ota_tag_dto')
        if self.ota_tag_dto:
            for k in self.ota_tag_dto:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListOTAJobByFirmwareResponseDataSimpleOTAJobInfoTags, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['OtaTagDTO'] = []
        if self.ota_tag_dto is not None:
            for k in self.ota_tag_dto:
                result['OtaTagDTO'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.ota_tag_dto = []
        if m.get('OtaTagDTO') is not None:
            for k in m.get('OtaTagDTO'):
                temp_model = ListOTAJobByFirmwareResponseDataSimpleOTAJobInfoTagsOtaTagDTO()
                self.ota_tag_dto.append(temp_model.from_map(k))
        return self


class ListOTAJobByFirmwareResponseDataSimpleOTAJobInfo(TeaModel):
    def __init__(self, firmware_id=None, job_id=None, job_status=None, job_type=None, product_key=None,
                 selection_type=None, target_selection=None, utc_create=None, utc_end_time=None, utc_modified=None,
                 utc_start_time=None, tags=None):
        self.firmware_id = firmware_id  # type: str
        self.job_id = job_id  # type: str
        self.job_status = job_status  # type: str
        self.job_type = job_type  # type: str
        self.product_key = product_key  # type: str
        self.selection_type = selection_type  # type: str
        self.target_selection = target_selection  # type: str
        self.utc_create = utc_create  # type: str
        self.utc_end_time = utc_end_time  # type: str
        self.utc_modified = utc_modified  # type: str
        self.utc_start_time = utc_start_time  # type: str
        self.tags = tags  # type: ListOTAJobByFirmwareResponseDataSimpleOTAJobInfoTags

    def validate(self):
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.job_status, 'job_status')
        self.validate_required(self.job_type, 'job_type')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.selection_type, 'selection_type')
        self.validate_required(self.target_selection, 'target_selection')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_end_time, 'utc_end_time')
        self.validate_required(self.utc_modified, 'utc_modified')
        self.validate_required(self.utc_start_time, 'utc_start_time')
        self.validate_required(self.tags, 'tags')
        if self.tags:
            self.tags.validate()

    def to_map(self):
        _map = super(ListOTAJobByFirmwareResponseDataSimpleOTAJobInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.job_status is not None:
            result['JobStatus'] = self.job_status
        if self.job_type is not None:
            result['JobType'] = self.job_type
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.selection_type is not None:
            result['SelectionType'] = self.selection_type
        if self.target_selection is not None:
            result['TargetSelection'] = self.target_selection
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_end_time is not None:
            result['UtcEndTime'] = self.utc_end_time
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        if self.utc_start_time is not None:
            result['UtcStartTime'] = self.utc_start_time
        if self.tags is not None:
            result['Tags'] = self.tags.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('JobStatus') is not None:
            self.job_status = m.get('JobStatus')
        if m.get('JobType') is not None:
            self.job_type = m.get('JobType')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SelectionType') is not None:
            self.selection_type = m.get('SelectionType')
        if m.get('TargetSelection') is not None:
            self.target_selection = m.get('TargetSelection')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcEndTime') is not None:
            self.utc_end_time = m.get('UtcEndTime')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        if m.get('UtcStartTime') is not None:
            self.utc_start_time = m.get('UtcStartTime')
        if m.get('Tags') is not None:
            temp_model = ListOTAJobByFirmwareResponseDataSimpleOTAJobInfoTags()
            self.tags = temp_model.from_map(m['Tags'])
        return self


class ListOTAJobByFirmwareResponseData(TeaModel):
    def __init__(self, simple_otajob_info=None):
        self.simple_otajob_info = simple_otajob_info  # type: list[ListOTAJobByFirmwareResponseDataSimpleOTAJobInfo]

    def validate(self):
        self.validate_required(self.simple_otajob_info, 'simple_otajob_info')
        if self.simple_otajob_info:
            for k in self.simple_otajob_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListOTAJobByFirmwareResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['SimpleOTAJobInfo'] = []
        if self.simple_otajob_info is not None:
            for k in self.simple_otajob_info:
                result['SimpleOTAJobInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.simple_otajob_info = []
        if m.get('SimpleOTAJobInfo') is not None:
            for k in m.get('SimpleOTAJobInfo'):
                temp_model = ListOTAJobByFirmwareResponseDataSimpleOTAJobInfo()
                self.simple_otajob_info.append(temp_model.from_map(k))
        return self


class ListOTAJobByFirmwareResponse(TeaModel):
    def __init__(self, code=None, current_page=None, error_message=None, page_count=None, page_size=None,
                 request_id=None, success=None, total=None, data=None):
        self.code = code  # type: str
        self.current_page = current_page  # type: int
        self.error_message = error_message  # type: str
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: ListOTAJobByFirmwareResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListOTAJobByFirmwareResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = ListOTAJobByFirmwareResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListOTAModuleByProductRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(ListOTAModuleByProductRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ListOTAModuleByProductResponseData(TeaModel):
    def __init__(self, alias_name=None, desc=None, gmt_create=None, gmt_modified=None, module_name=None,
                 product_key=None):
        self.alias_name = alias_name  # type: str
        self.desc = desc  # type: str
        self.gmt_create = gmt_create  # type: str
        self.gmt_modified = gmt_modified  # type: str
        self.module_name = module_name  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.alias_name, 'alias_name')
        self.validate_required(self.desc, 'desc')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.module_name, 'module_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(ListOTAModuleByProductResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.alias_name is not None:
            result['AliasName'] = self.alias_name
        if self.desc is not None:
            result['Desc'] = self.desc
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.module_name is not None:
            result['ModuleName'] = self.module_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AliasName') is not None:
            self.alias_name = m.get('AliasName')
        if m.get('Desc') is not None:
            self.desc = m.get('Desc')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('ModuleName') is not None:
            self.module_name = m.get('ModuleName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ListOTAModuleByProductResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: list[ListOTAModuleByProductResponseData]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            for k in self.data:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListOTAModuleByProductResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        result['Data'] = []
        if self.data is not None:
            for k in self.data:
                result['Data'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        self.data = []
        if m.get('Data') is not None:
            for k in m.get('Data'):
                temp_model = ListOTAModuleByProductResponseData()
                self.data.append(temp_model.from_map(k))
        return self


class ListOTAModuleVersionsByDeviceRequest(TeaModel):
    def __init__(self, current_page=None, device_name=None, iot_id=None, iot_instance_id=None, page_size=None,
                 product_key=None):
        self.current_page = current_page  # type: int
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(ListOTAModuleVersionsByDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ListOTAModuleVersionsByDeviceResponseDataSimpleOTAModuleInfo(TeaModel):
    def __init__(self, device_name=None, iot_id=None, module_name=None, module_version=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.module_name = module_name  # type: str
        self.module_version = module_version  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.module_name, 'module_name')
        self.validate_required(self.module_version, 'module_version')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(ListOTAModuleVersionsByDeviceResponseDataSimpleOTAModuleInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.module_name is not None:
            result['ModuleName'] = self.module_name
        if self.module_version is not None:
            result['ModuleVersion'] = self.module_version
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ModuleName') is not None:
            self.module_name = m.get('ModuleName')
        if m.get('ModuleVersion') is not None:
            self.module_version = m.get('ModuleVersion')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ListOTAModuleVersionsByDeviceResponseData(TeaModel):
    def __init__(self, simple_otamodule_info=None):
        self.simple_otamodule_info = simple_otamodule_info  # type: list[ListOTAModuleVersionsByDeviceResponseDataSimpleOTAModuleInfo]

    def validate(self):
        self.validate_required(self.simple_otamodule_info, 'simple_otamodule_info')
        if self.simple_otamodule_info:
            for k in self.simple_otamodule_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListOTAModuleVersionsByDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['SimpleOTAModuleInfo'] = []
        if self.simple_otamodule_info is not None:
            for k in self.simple_otamodule_info:
                result['SimpleOTAModuleInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.simple_otamodule_info = []
        if m.get('SimpleOTAModuleInfo') is not None:
            for k in m.get('SimpleOTAModuleInfo'):
                temp_model = ListOTAModuleVersionsByDeviceResponseDataSimpleOTAModuleInfo()
                self.simple_otamodule_info.append(temp_model.from_map(k))
        return self


class ListOTAModuleVersionsByDeviceResponse(TeaModel):
    def __init__(self, code=None, current_page=None, error_message=None, page_count=None, page_size=None,
                 request_id=None, success=None, total=None, data=None):
        self.code = code  # type: str
        self.current_page = current_page  # type: int
        self.error_message = error_message  # type: str
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: ListOTAModuleVersionsByDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListOTAModuleVersionsByDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = ListOTAModuleVersionsByDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListOTATaskByJobRequest(TeaModel):
    def __init__(self, current_page=None, device_names=None, iot_instance_id=None, job_id=None, page_size=None,
                 task_status=None):
        self.current_page = current_page  # type: int
        self.device_names = device_names  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str
        self.page_size = page_size  # type: int
        self.task_status = task_status  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(ListOTATaskByJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.device_names is not None:
            result['DeviceNames'] = self.device_names
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.task_status is not None:
            result['TaskStatus'] = self.task_status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('DeviceNames') is not None:
            self.device_names = m.get('DeviceNames')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('TaskStatus') is not None:
            self.task_status = m.get('TaskStatus')
        return self


class ListOTATaskByJobResponseDataSimpleOTATaskInfo(TeaModel):
    def __init__(self, dest_version=None, device_name=None, firmware_id=None, iot_id=None, job_id=None,
                 product_key=None, product_name=None, progress=None, src_version=None, task_desc=None, task_id=None,
                 task_status=None, timeout=None, utc_create=None, utc_modified=None):
        self.dest_version = dest_version  # type: str
        self.device_name = device_name  # type: str
        self.firmware_id = firmware_id  # type: str
        self.iot_id = iot_id  # type: str
        self.job_id = job_id  # type: str
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str
        self.progress = progress  # type: str
        self.src_version = src_version  # type: str
        self.task_desc = task_desc  # type: str
        self.task_id = task_id  # type: str
        self.task_status = task_status  # type: str
        self.timeout = timeout  # type: str
        self.utc_create = utc_create  # type: str
        self.utc_modified = utc_modified  # type: str

    def validate(self):
        self.validate_required(self.dest_version, 'dest_version')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')
        self.validate_required(self.progress, 'progress')
        self.validate_required(self.src_version, 'src_version')
        self.validate_required(self.task_desc, 'task_desc')
        self.validate_required(self.task_id, 'task_id')
        self.validate_required(self.task_status, 'task_status')
        self.validate_required(self.timeout, 'timeout')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_modified, 'utc_modified')

    def to_map(self):
        _map = super(ListOTATaskByJobResponseDataSimpleOTATaskInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dest_version is not None:
            result['DestVersion'] = self.dest_version
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.progress is not None:
            result['Progress'] = self.progress
        if self.src_version is not None:
            result['SrcVersion'] = self.src_version
        if self.task_desc is not None:
            result['TaskDesc'] = self.task_desc
        if self.task_id is not None:
            result['TaskId'] = self.task_id
        if self.task_status is not None:
            result['TaskStatus'] = self.task_status
        if self.timeout is not None:
            result['Timeout'] = self.timeout
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DestVersion') is not None:
            self.dest_version = m.get('DestVersion')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('Progress') is not None:
            self.progress = m.get('Progress')
        if m.get('SrcVersion') is not None:
            self.src_version = m.get('SrcVersion')
        if m.get('TaskDesc') is not None:
            self.task_desc = m.get('TaskDesc')
        if m.get('TaskId') is not None:
            self.task_id = m.get('TaskId')
        if m.get('TaskStatus') is not None:
            self.task_status = m.get('TaskStatus')
        if m.get('Timeout') is not None:
            self.timeout = m.get('Timeout')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        return self


class ListOTATaskByJobResponseData(TeaModel):
    def __init__(self, simple_otatask_info=None):
        self.simple_otatask_info = simple_otatask_info  # type: list[ListOTATaskByJobResponseDataSimpleOTATaskInfo]

    def validate(self):
        self.validate_required(self.simple_otatask_info, 'simple_otatask_info')
        if self.simple_otatask_info:
            for k in self.simple_otatask_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListOTATaskByJobResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['SimpleOTATaskInfo'] = []
        if self.simple_otatask_info is not None:
            for k in self.simple_otatask_info:
                result['SimpleOTATaskInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.simple_otatask_info = []
        if m.get('SimpleOTATaskInfo') is not None:
            for k in m.get('SimpleOTATaskInfo'):
                temp_model = ListOTATaskByJobResponseDataSimpleOTATaskInfo()
                self.simple_otatask_info.append(temp_model.from_map(k))
        return self


class ListOTATaskByJobResponse(TeaModel):
    def __init__(self, code=None, current_page=None, error_message=None, page_count=None, page_size=None,
                 request_id=None, success=None, total=None, data=None):
        self.code = code  # type: str
        self.current_page = current_page  # type: int
        self.error_message = error_message  # type: str
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: ListOTATaskByJobResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListOTATaskByJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = ListOTATaskByJobResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListOTAUnfinishedTaskByDeviceRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, module_name=None, product_key=None,
                 task_status=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.module_name = module_name  # type: str
        self.product_key = product_key  # type: str
        self.task_status = task_status  # type: str

    def validate(self):
        self.validate_required(self.task_status, 'task_status')

    def to_map(self):
        _map = super(ListOTAUnfinishedTaskByDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.module_name is not None:
            result['ModuleName'] = self.module_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.task_status is not None:
            result['TaskStatus'] = self.task_status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModuleName') is not None:
            self.module_name = m.get('ModuleName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('TaskStatus') is not None:
            self.task_status = m.get('TaskStatus')
        return self


class ListOTAUnfinishedTaskByDeviceResponseDataSimpleOTATaskInfo(TeaModel):
    def __init__(self, dest_version=None, device_name=None, firmware_id=None, iot_id=None, job_id=None,
                 module_name=None, product_key=None, product_name=None, src_version=None, task_id=None, task_status=None,
                 utc_create=None, utc_modified=None):
        self.dest_version = dest_version  # type: str
        self.device_name = device_name  # type: str
        self.firmware_id = firmware_id  # type: str
        self.iot_id = iot_id  # type: str
        self.job_id = job_id  # type: str
        self.module_name = module_name  # type: str
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str
        self.src_version = src_version  # type: str
        self.task_id = task_id  # type: str
        self.task_status = task_status  # type: str
        self.utc_create = utc_create  # type: str
        self.utc_modified = utc_modified  # type: str

    def validate(self):
        self.validate_required(self.dest_version, 'dest_version')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.module_name, 'module_name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')
        self.validate_required(self.src_version, 'src_version')
        self.validate_required(self.task_id, 'task_id')
        self.validate_required(self.task_status, 'task_status')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_modified, 'utc_modified')

    def to_map(self):
        _map = super(ListOTAUnfinishedTaskByDeviceResponseDataSimpleOTATaskInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dest_version is not None:
            result['DestVersion'] = self.dest_version
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.module_name is not None:
            result['ModuleName'] = self.module_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.src_version is not None:
            result['SrcVersion'] = self.src_version
        if self.task_id is not None:
            result['TaskId'] = self.task_id
        if self.task_status is not None:
            result['TaskStatus'] = self.task_status
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DestVersion') is not None:
            self.dest_version = m.get('DestVersion')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('ModuleName') is not None:
            self.module_name = m.get('ModuleName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('SrcVersion') is not None:
            self.src_version = m.get('SrcVersion')
        if m.get('TaskId') is not None:
            self.task_id = m.get('TaskId')
        if m.get('TaskStatus') is not None:
            self.task_status = m.get('TaskStatus')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        return self


class ListOTAUnfinishedTaskByDeviceResponseData(TeaModel):
    def __init__(self, simple_otatask_info=None):
        self.simple_otatask_info = simple_otatask_info  # type: list[ListOTAUnfinishedTaskByDeviceResponseDataSimpleOTATaskInfo]

    def validate(self):
        self.validate_required(self.simple_otatask_info, 'simple_otatask_info')
        if self.simple_otatask_info:
            for k in self.simple_otatask_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListOTAUnfinishedTaskByDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['SimpleOTATaskInfo'] = []
        if self.simple_otatask_info is not None:
            for k in self.simple_otatask_info:
                result['SimpleOTATaskInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.simple_otatask_info = []
        if m.get('SimpleOTATaskInfo') is not None:
            for k in m.get('SimpleOTATaskInfo'):
                temp_model = ListOTAUnfinishedTaskByDeviceResponseDataSimpleOTATaskInfo()
                self.simple_otatask_info.append(temp_model.from_map(k))
        return self


class ListOTAUnfinishedTaskByDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ListOTAUnfinishedTaskByDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListOTAUnfinishedTaskByDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ListOTAUnfinishedTaskByDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListParserRequest(TeaModel):
    def __init__(self, current_page=None, iot_instance_id=None, page_size=None, search_name=None):
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.search_name = search_name  # type: str

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(ListParserRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.search_name is not None:
            result['SearchName'] = self.search_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('SearchName') is not None:
            self.search_name = m.get('SearchName')
        return self


class ListParserResponseDataParserList(TeaModel):
    def __init__(self, description=None, name=None, parser_id=None, status=None, utc_created=None, utc_modified=None):
        self.description = description  # type: str
        self.name = name  # type: str
        self.parser_id = parser_id  # type: long
        self.status = status  # type: str
        self.utc_created = utc_created  # type: str
        self.utc_modified = utc_modified  # type: str

    def validate(self):
        self.validate_required(self.description, 'description')
        self.validate_required(self.name, 'name')
        self.validate_required(self.parser_id, 'parser_id')
        self.validate_required(self.status, 'status')
        self.validate_required(self.utc_created, 'utc_created')
        self.validate_required(self.utc_modified, 'utc_modified')

    def to_map(self):
        _map = super(ListParserResponseDataParserList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.name is not None:
            result['Name'] = self.name
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        if self.status is not None:
            result['Status'] = self.status
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        return self


class ListParserResponseData(TeaModel):
    def __init__(self, parser_list=None):
        self.parser_list = parser_list  # type: list[ListParserResponseDataParserList]

    def validate(self):
        self.validate_required(self.parser_list, 'parser_list')
        if self.parser_list:
            for k in self.parser_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListParserResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ParserList'] = []
        if self.parser_list is not None:
            for k in self.parser_list:
                result['ParserList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.parser_list = []
        if m.get('ParserList') is not None:
            for k in m.get('ParserList'):
                temp_model = ListParserResponseDataParserList()
                self.parser_list.append(temp_model.from_map(k))
        return self


class ListParserResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, total=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: ListParserResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListParserResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = ListParserResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListParserDataSourceRequest(TeaModel):
    def __init__(self, iot_instance_id=None, page=None, page_size=None, search_name=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.page = page  # type: int
        self.page_size = page_size  # type: int
        self.search_name = search_name  # type: str

    def validate(self):
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(ListParserDataSourceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page is not None:
            result['Page'] = self.page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.search_name is not None:
            result['SearchName'] = self.search_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('SearchName') is not None:
            self.search_name = m.get('SearchName')
        return self


class ListParserDataSourceResponseDataDataSource(TeaModel):
    def __init__(self, data_source_id=None, description=None, name=None, utc_created=None):
        self.data_source_id = data_source_id  # type: long
        self.description = description  # type: str
        self.name = name  # type: str
        self.utc_created = utc_created  # type: str

    def validate(self):
        self.validate_required(self.data_source_id, 'data_source_id')
        self.validate_required(self.description, 'description')
        self.validate_required(self.name, 'name')
        self.validate_required(self.utc_created, 'utc_created')

    def to_map(self):
        _map = super(ListParserDataSourceResponseDataDataSource, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.description is not None:
            result['Description'] = self.description
        if self.name is not None:
            result['Name'] = self.name
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        return self


class ListParserDataSourceResponseData(TeaModel):
    def __init__(self, data_source=None):
        self.data_source = data_source  # type: list[ListParserDataSourceResponseDataDataSource]

    def validate(self):
        self.validate_required(self.data_source, 'data_source')
        if self.data_source:
            for k in self.data_source:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListParserDataSourceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DataSource'] = []
        if self.data_source is not None:
            for k in self.data_source:
                result['DataSource'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.data_source = []
        if m.get('DataSource') is not None:
            for k in m.get('DataSource'):
                temp_model = ListParserDataSourceResponseDataDataSource()
                self.data_source.append(temp_model.from_map(k))
        return self


class ListParserDataSourceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, page=None, page_size=None, request_id=None, success=None,
                 total=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.page = page  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: ListParserDataSourceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListParserDataSourceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page is not None:
            result['Page'] = self.page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = ListParserDataSourceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListParserDestinationRequest(TeaModel):
    def __init__(self, iot_instance_id=None, is_failover=None, parser_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.is_failover = is_failover  # type: bool
        self.parser_id = parser_id  # type: long

    def validate(self):
        self.validate_required(self.parser_id, 'parser_id')

    def to_map(self):
        _map = super(ListParserDestinationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.is_failover is not None:
            result['IsFailover'] = self.is_failover
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('IsFailover') is not None:
            self.is_failover = m.get('IsFailover')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        return self


class ListParserDestinationResponseDataDestinations(TeaModel):
    def __init__(self, configuration=None, destination_id=None, is_failover=None, name=None, type=None,
                 utc_created=None, utc_modified=None):
        self.configuration = configuration  # type: str
        self.destination_id = destination_id  # type: long
        self.is_failover = is_failover  # type: bool
        self.name = name  # type: str
        self.type = type  # type: str
        self.utc_created = utc_created  # type: str
        self.utc_modified = utc_modified  # type: str

    def validate(self):
        self.validate_required(self.configuration, 'configuration')
        self.validate_required(self.destination_id, 'destination_id')
        self.validate_required(self.is_failover, 'is_failover')
        self.validate_required(self.name, 'name')
        self.validate_required(self.type, 'type')
        self.validate_required(self.utc_created, 'utc_created')
        self.validate_required(self.utc_modified, 'utc_modified')

    def to_map(self):
        _map = super(ListParserDestinationResponseDataDestinations, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        if self.destination_id is not None:
            result['DestinationId'] = self.destination_id
        if self.is_failover is not None:
            result['IsFailover'] = self.is_failover
        if self.name is not None:
            result['Name'] = self.name
        if self.type is not None:
            result['Type'] = self.type
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        if m.get('DestinationId') is not None:
            self.destination_id = m.get('DestinationId')
        if m.get('IsFailover') is not None:
            self.is_failover = m.get('IsFailover')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        return self


class ListParserDestinationResponseData(TeaModel):
    def __init__(self, destinations=None):
        self.destinations = destinations  # type: list[ListParserDestinationResponseDataDestinations]

    def validate(self):
        self.validate_required(self.destinations, 'destinations')
        if self.destinations:
            for k in self.destinations:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListParserDestinationResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['destinations'] = []
        if self.destinations is not None:
            for k in self.destinations:
                result['destinations'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.destinations = []
        if m.get('destinations') is not None:
            for k in m.get('destinations'):
                temp_model = ListParserDestinationResponseDataDestinations()
                self.destinations.append(temp_model.from_map(k))
        return self


class ListParserDestinationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ListParserDestinationResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListParserDestinationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ListParserDestinationResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListProductByTagsRequestProductTag(TeaModel):
    def __init__(self, tag_key=None, tag_value=None):
        self.tag_key = tag_key  # type: str
        self.tag_value = tag_value  # type: str

    def validate(self):
        self.validate_required(self.tag_key, 'tag_key')

    def to_map(self):
        _map = super(ListProductByTagsRequestProductTag, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tag_key is not None:
            result['TagKey'] = self.tag_key
        if self.tag_value is not None:
            result['TagValue'] = self.tag_value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TagKey') is not None:
            self.tag_key = m.get('TagKey')
        if m.get('TagValue') is not None:
            self.tag_value = m.get('TagValue')
        return self


class ListProductByTagsRequest(TeaModel):
    def __init__(self, current_page=None, iot_instance_id=None, page_size=None, product_tag=None):
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.product_tag = product_tag  # type: list[ListProductByTagsRequestProductTag]

    def validate(self):
        self.validate_required(self.product_tag, 'product_tag')
        if self.product_tag:
            for k in self.product_tag:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListProductByTagsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        result['ProductTag'] = []
        if self.product_tag is not None:
            for k in self.product_tag:
                result['ProductTag'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        self.product_tag = []
        if m.get('ProductTag') is not None:
            for k in m.get('ProductTag'):
                temp_model = ListProductByTagsRequestProductTag()
                self.product_tag.append(temp_model.from_map(k))
        return self


class ListProductByTagsResponseProductInfosProductInfo(TeaModel):
    def __init__(self, create_time=None, description=None, node_type=None, product_key=None, product_name=None):
        self.create_time = create_time  # type: long
        self.description = description  # type: str
        self.node_type = node_type  # type: int
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str

    def validate(self):
        self.validate_required(self.create_time, 'create_time')
        self.validate_required(self.description, 'description')
        self.validate_required(self.node_type, 'node_type')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')

    def to_map(self):
        _map = super(ListProductByTagsResponseProductInfosProductInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.create_time is not None:
            result['CreateTime'] = self.create_time
        if self.description is not None:
            result['Description'] = self.description
        if self.node_type is not None:
            result['NodeType'] = self.node_type
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CreateTime') is not None:
            self.create_time = m.get('CreateTime')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('NodeType') is not None:
            self.node_type = m.get('NodeType')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        return self


class ListProductByTagsResponseProductInfos(TeaModel):
    def __init__(self, product_info=None):
        self.product_info = product_info  # type: list[ListProductByTagsResponseProductInfosProductInfo]

    def validate(self):
        self.validate_required(self.product_info, 'product_info')
        if self.product_info:
            for k in self.product_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListProductByTagsResponseProductInfos, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ProductInfo'] = []
        if self.product_info is not None:
            for k in self.product_info:
                result['ProductInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.product_info = []
        if m.get('ProductInfo') is not None:
            for k in m.get('ProductInfo'):
                temp_model = ListProductByTagsResponseProductInfosProductInfo()
                self.product_info.append(temp_model.from_map(k))
        return self


class ListProductByTagsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, product_infos=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.product_infos = product_infos  # type: ListProductByTagsResponseProductInfos

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.product_infos, 'product_infos')
        if self.product_infos:
            self.product_infos.validate()

    def to_map(self):
        _map = super(ListProductByTagsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.product_infos is not None:
            result['ProductInfos'] = self.product_infos.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('ProductInfos') is not None:
            temp_model = ListProductByTagsResponseProductInfos()
            self.product_infos = temp_model.from_map(m['ProductInfos'])
        return self


class ListProductTagsRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(ListProductTagsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ListProductTagsResponseDataProductTag(TeaModel):
    def __init__(self, tag_key=None, tag_value=None):
        self.tag_key = tag_key  # type: str
        self.tag_value = tag_value  # type: str

    def validate(self):
        self.validate_required(self.tag_key, 'tag_key')
        self.validate_required(self.tag_value, 'tag_value')

    def to_map(self):
        _map = super(ListProductTagsResponseDataProductTag, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tag_key is not None:
            result['TagKey'] = self.tag_key
        if self.tag_value is not None:
            result['TagValue'] = self.tag_value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TagKey') is not None:
            self.tag_key = m.get('TagKey')
        if m.get('TagValue') is not None:
            self.tag_value = m.get('TagValue')
        return self


class ListProductTagsResponseData(TeaModel):
    def __init__(self, product_tag=None):
        self.product_tag = product_tag  # type: list[ListProductTagsResponseDataProductTag]

    def validate(self):
        self.validate_required(self.product_tag, 'product_tag')
        if self.product_tag:
            for k in self.product_tag:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListProductTagsResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ProductTag'] = []
        if self.product_tag is not None:
            for k in self.product_tag:
                result['ProductTag'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.product_tag = []
        if m.get('ProductTag') is not None:
            for k in m.get('ProductTag'):
                temp_model = ListProductTagsResponseDataProductTag()
                self.product_tag.append(temp_model.from_map(k))
        return self


class ListProductTagsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ListProductTagsResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListProductTagsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ListProductTagsResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListRuleRequest(TeaModel):
    def __init__(self, current_page=None, iot_instance_id=None, page_size=None, resource_group_id=None):
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.resource_group_id = resource_group_id  # type: str

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(ListRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        return self


class ListRuleResponseDataRuleInfo(TeaModel):
    def __init__(self, create_user_id=None, created=None, data_type=None, id=None, modified=None, name=None,
                 product_key=None, rule_desc=None, select=None, short_topic=None, status=None, topic=None, utc_created=None,
                 utc_modified=None, where=None):
        self.create_user_id = create_user_id  # type: long
        self.created = created  # type: str
        self.data_type = data_type  # type: str
        self.id = id  # type: long
        self.modified = modified  # type: str
        self.name = name  # type: str
        self.product_key = product_key  # type: str
        self.rule_desc = rule_desc  # type: str
        self.select = select  # type: str
        self.short_topic = short_topic  # type: str
        self.status = status  # type: str
        self.topic = topic  # type: str
        self.utc_created = utc_created  # type: str
        self.utc_modified = utc_modified  # type: str
        self.where = where  # type: str

    def validate(self):
        self.validate_required(self.create_user_id, 'create_user_id')
        self.validate_required(self.created, 'created')
        self.validate_required(self.data_type, 'data_type')
        self.validate_required(self.id, 'id')
        self.validate_required(self.modified, 'modified')
        self.validate_required(self.name, 'name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.rule_desc, 'rule_desc')
        self.validate_required(self.select, 'select')
        self.validate_required(self.short_topic, 'short_topic')
        self.validate_required(self.status, 'status')
        self.validate_required(self.topic, 'topic')
        self.validate_required(self.utc_created, 'utc_created')
        self.validate_required(self.utc_modified, 'utc_modified')
        self.validate_required(self.where, 'where')

    def to_map(self):
        _map = super(ListRuleResponseDataRuleInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.create_user_id is not None:
            result['CreateUserId'] = self.create_user_id
        if self.created is not None:
            result['Created'] = self.created
        if self.data_type is not None:
            result['DataType'] = self.data_type
        if self.id is not None:
            result['Id'] = self.id
        if self.modified is not None:
            result['Modified'] = self.modified
        if self.name is not None:
            result['Name'] = self.name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.rule_desc is not None:
            result['RuleDesc'] = self.rule_desc
        if self.select is not None:
            result['Select'] = self.select
        if self.short_topic is not None:
            result['ShortTopic'] = self.short_topic
        if self.status is not None:
            result['Status'] = self.status
        if self.topic is not None:
            result['Topic'] = self.topic
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        if self.where is not None:
            result['Where'] = self.where
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CreateUserId') is not None:
            self.create_user_id = m.get('CreateUserId')
        if m.get('Created') is not None:
            self.created = m.get('Created')
        if m.get('DataType') is not None:
            self.data_type = m.get('DataType')
        if m.get('Id') is not None:
            self.id = m.get('Id')
        if m.get('Modified') is not None:
            self.modified = m.get('Modified')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RuleDesc') is not None:
            self.rule_desc = m.get('RuleDesc')
        if m.get('Select') is not None:
            self.select = m.get('Select')
        if m.get('ShortTopic') is not None:
            self.short_topic = m.get('ShortTopic')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        if m.get('Where') is not None:
            self.where = m.get('Where')
        return self


class ListRuleResponseData(TeaModel):
    def __init__(self, rule_info=None):
        self.rule_info = rule_info  # type: list[ListRuleResponseDataRuleInfo]

    def validate(self):
        self.validate_required(self.rule_info, 'rule_info')
        if self.rule_info:
            for k in self.rule_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListRuleResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['RuleInfo'] = []
        if self.rule_info is not None:
            for k in self.rule_info:
                result['RuleInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.rule_info = []
        if m.get('RuleInfo') is not None:
            for k in m.get('RuleInfo'):
                temp_model = ListRuleResponseDataRuleInfo()
                self.rule_info.append(temp_model.from_map(k))
        return self


class ListRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, page=None, page_size=None, request_id=None, success=None,
                 total=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.page = page  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: ListRuleResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page is not None:
            result['Page'] = self.page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = ListRuleResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListRuleActionsRequest(TeaModel):
    def __init__(self, iot_instance_id=None, rule_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: long

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(ListRuleActionsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class ListRuleActionsResponseRuleActionListRuleActionInfo(TeaModel):
    def __init__(self, configuration=None, error_action_flag=None, id=None, rule_id=None, status=None, type=None):
        self.configuration = configuration  # type: str
        self.error_action_flag = error_action_flag  # type: bool
        self.id = id  # type: long
        self.rule_id = rule_id  # type: long
        self.status = status  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.configuration, 'configuration')
        self.validate_required(self.error_action_flag, 'error_action_flag')
        self.validate_required(self.id, 'id')
        self.validate_required(self.rule_id, 'rule_id')
        self.validate_required(self.status, 'status')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(ListRuleActionsResponseRuleActionListRuleActionInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        if self.error_action_flag is not None:
            result['ErrorActionFlag'] = self.error_action_flag
        if self.id is not None:
            result['Id'] = self.id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        if self.status is not None:
            result['Status'] = self.status
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        if m.get('ErrorActionFlag') is not None:
            self.error_action_flag = m.get('ErrorActionFlag')
        if m.get('Id') is not None:
            self.id = m.get('Id')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class ListRuleActionsResponseRuleActionList(TeaModel):
    def __init__(self, rule_action_info=None):
        self.rule_action_info = rule_action_info  # type: list[ListRuleActionsResponseRuleActionListRuleActionInfo]

    def validate(self):
        self.validate_required(self.rule_action_info, 'rule_action_info')
        if self.rule_action_info:
            for k in self.rule_action_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListRuleActionsResponseRuleActionList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['RuleActionInfo'] = []
        if self.rule_action_info is not None:
            for k in self.rule_action_info:
                result['RuleActionInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.rule_action_info = []
        if m.get('RuleActionInfo') is not None:
            for k in m.get('RuleActionInfo'):
                temp_model = ListRuleActionsResponseRuleActionListRuleActionInfo()
                self.rule_action_info.append(temp_model.from_map(k))
        return self


class ListRuleActionsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, rule_action_list=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.rule_action_list = rule_action_list  # type: ListRuleActionsResponseRuleActionList

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.rule_action_list, 'rule_action_list')
        if self.rule_action_list:
            self.rule_action_list.validate()

    def to_map(self):
        _map = super(ListRuleActionsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.rule_action_list is not None:
            result['RuleActionList'] = self.rule_action_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('RuleActionList') is not None:
            temp_model = ListRuleActionsResponseRuleActionList()
            self.rule_action_list = temp_model.from_map(m['RuleActionList'])
        return self


class ListTaskRequest(TeaModel):
    def __init__(self, device=None, iot_instance_id=None, job_id=None, limit=None, next_token=None, status=None):
        self.device = device  # type: dict[str, any]
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str
        self.limit = limit  # type: int
        self.next_token = next_token  # type: str
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.limit, 'limit')

    def to_map(self):
        _map = super(ListTaskRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device is not None:
            result['Device'] = self.device
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.limit is not None:
            result['Limit'] = self.limit
        if self.next_token is not None:
            result['NextToken'] = self.next_token
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Device') is not None:
            self.device = m.get('Device')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('Limit') is not None:
            self.limit = m.get('Limit')
        if m.get('NextToken') is not None:
            self.next_token = m.get('NextToken')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class ListTaskShrinkRequest(TeaModel):
    def __init__(self, device_shrink=None, iot_instance_id=None, job_id=None, limit=None, next_token=None,
                 status=None):
        self.device_shrink = device_shrink  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str
        self.limit = limit  # type: int
        self.next_token = next_token  # type: str
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.limit, 'limit')

    def to_map(self):
        _map = super(ListTaskShrinkRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_shrink is not None:
            result['Device'] = self.device_shrink
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.limit is not None:
            result['Limit'] = self.limit
        if self.next_token is not None:
            result['NextToken'] = self.next_token
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Device') is not None:
            self.device_shrink = m.get('Device')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('Limit') is not None:
            self.limit = m.get('Limit')
        if m.get('NextToken') is not None:
            self.next_token = m.get('NextToken')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class ListTaskResponseDataData(TeaModel):
    def __init__(self, device_name=None, iot_id=None, job_id=None, job_name=None, product_key=None, progress=None,
                 status=None, task_id=None, utc_modified=None, utc_queue_time=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.job_id = job_id  # type: str
        self.job_name = job_name  # type: str
        self.product_key = product_key  # type: str
        self.progress = progress  # type: str
        self.status = status  # type: str
        self.task_id = task_id  # type: str
        self.utc_modified = utc_modified  # type: str
        self.utc_queue_time = utc_queue_time  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.job_name, 'job_name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.progress, 'progress')
        self.validate_required(self.status, 'status')
        self.validate_required(self.task_id, 'task_id')
        self.validate_required(self.utc_modified, 'utc_modified')
        self.validate_required(self.utc_queue_time, 'utc_queue_time')

    def to_map(self):
        _map = super(ListTaskResponseDataData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.job_name is not None:
            result['JobName'] = self.job_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.progress is not None:
            result['Progress'] = self.progress
        if self.status is not None:
            result['Status'] = self.status
        if self.task_id is not None:
            result['TaskId'] = self.task_id
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        if self.utc_queue_time is not None:
            result['UtcQueueTime'] = self.utc_queue_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('JobName') is not None:
            self.job_name = m.get('JobName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Progress') is not None:
            self.progress = m.get('Progress')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('TaskId') is not None:
            self.task_id = m.get('TaskId')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        if m.get('UtcQueueTime') is not None:
            self.utc_queue_time = m.get('UtcQueueTime')
        return self


class ListTaskResponseData(TeaModel):
    def __init__(self, data=None):
        self.data = data  # type: list[ListTaskResponseDataData]

    def validate(self):
        self.validate_required(self.data, 'data')
        if self.data:
            for k in self.data:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListTaskResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['data'] = []
        if self.data is not None:
            for k in self.data:
                result['data'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.data = []
        if m.get('data') is not None:
            for k in m.get('data'):
                temp_model = ListTaskResponseDataData()
                self.data.append(temp_model.from_map(k))
        return self


class ListTaskResponse(TeaModel):
    def __init__(self, code=None, error_message=None, next_token=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.next_token = next_token  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ListTaskResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.next_token, 'next_token')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListTaskResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.next_token is not None:
            result['NextToken'] = self.next_token
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('NextToken') is not None:
            self.next_token = m.get('NextToken')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ListTaskResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListThingModelVersionRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(ListThingModelVersionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ListThingModelVersionResponseDataModelVersions(TeaModel):
    def __init__(self, description=None, gmt_create=None, model_version=None):
        self.description = description  # type: str
        self.gmt_create = gmt_create  # type: long
        self.model_version = model_version  # type: str

    def validate(self):
        self.validate_required(self.description, 'description')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.model_version, 'model_version')

    def to_map(self):
        _map = super(ListThingModelVersionResponseDataModelVersions, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.model_version is not None:
            result['ModelVersion'] = self.model_version
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('ModelVersion') is not None:
            self.model_version = m.get('ModelVersion')
        return self


class ListThingModelVersionResponseData(TeaModel):
    def __init__(self, model_versions=None):
        self.model_versions = model_versions  # type: list[ListThingModelVersionResponseDataModelVersions]

    def validate(self):
        self.validate_required(self.model_versions, 'model_versions')
        if self.model_versions:
            for k in self.model_versions:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListThingModelVersionResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ModelVersions'] = []
        if self.model_versions is not None:
            for k in self.model_versions:
                result['ModelVersions'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.model_versions = []
        if m.get('ModelVersions') is not None:
            for k in m.get('ModelVersions'):
                temp_model = ListThingModelVersionResponseDataModelVersions()
                self.model_versions.append(temp_model.from_map(k))
        return self


class ListThingModelVersionResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ListThingModelVersionResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ListThingModelVersionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ListThingModelVersionResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ListThingTemplatesRequest(TeaModel):
    def __init__(self, iot_instance_id=None):
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(ListThingTemplatesRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class ListThingTemplatesResponseData(TeaModel):
    def __init__(self, category_key=None, category_name=None):
        self.category_key = category_key  # type: str
        self.category_name = category_name  # type: str

    def validate(self):
        self.validate_required(self.category_key, 'category_key')
        self.validate_required(self.category_name, 'category_name')

    def to_map(self):
        _map = super(ListThingTemplatesResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.category_key is not None:
            result['CategoryKey'] = self.category_key
        if self.category_name is not None:
            result['CategoryName'] = self.category_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CategoryKey') is not None:
            self.category_key = m.get('CategoryKey')
        if m.get('CategoryName') is not None:
            self.category_name = m.get('CategoryName')
        return self


class ListThingTemplatesResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: list[ListThingTemplatesResponseData]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            for k in self.data:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(ListThingTemplatesResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        result['Data'] = []
        if self.data is not None:
            for k in self.data:
                result['Data'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        self.data = []
        if m.get('Data') is not None:
            for k in m.get('Data'):
                temp_model = ListThingTemplatesResponseData()
                self.data.append(temp_model.from_map(k))
        return self


class NotifyAddThingTopoRequest(TeaModel):
    def __init__(self, device_list_str=None, gw_device_name=None, gw_iot_id=None, gw_product_key=None,
                 iot_instance_id=None):
        self.device_list_str = device_list_str  # type: str
        self.gw_device_name = gw_device_name  # type: str
        self.gw_iot_id = gw_iot_id  # type: str
        self.gw_product_key = gw_product_key  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(NotifyAddThingTopoRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_list_str is not None:
            result['DeviceListStr'] = self.device_list_str
        if self.gw_device_name is not None:
            result['GwDeviceName'] = self.gw_device_name
        if self.gw_iot_id is not None:
            result['GwIotId'] = self.gw_iot_id
        if self.gw_product_key is not None:
            result['GwProductKey'] = self.gw_product_key
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceListStr') is not None:
            self.device_list_str = m.get('DeviceListStr')
        if m.get('GwDeviceName') is not None:
            self.gw_device_name = m.get('GwDeviceName')
        if m.get('GwIotId') is not None:
            self.gw_iot_id = m.get('GwIotId')
        if m.get('GwProductKey') is not None:
            self.gw_product_key = m.get('GwProductKey')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class NotifyAddThingTopoResponseData(TeaModel):
    def __init__(self, message_id=None):
        self.message_id = message_id  # type: str

    def validate(self):
        self.validate_required(self.message_id, 'message_id')

    def to_map(self):
        _map = super(NotifyAddThingTopoResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.message_id is not None:
            result['MessageId'] = self.message_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('MessageId') is not None:
            self.message_id = m.get('MessageId')
        return self


class NotifyAddThingTopoResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: NotifyAddThingTopoResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(NotifyAddThingTopoResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = NotifyAddThingTopoResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class OpenIotServiceRequest(TeaModel):
    def __init__(self, owner_id=None):
        self.owner_id = owner_id  # type: long

    def validate(self):
        pass

    def to_map(self):
        _map = super(OpenIotServiceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.owner_id is not None:
            result['OwnerId'] = self.owner_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('OwnerId') is not None:
            self.owner_id = m.get('OwnerId')
        return self


class OpenIotServiceResponse(TeaModel):
    def __init__(self, order_id=None, request_id=None):
        self.order_id = order_id  # type: str
        self.request_id = request_id  # type: str

    def validate(self):
        self.validate_required(self.order_id, 'order_id')
        self.validate_required(self.request_id, 'request_id')

    def to_map(self):
        _map = super(OpenIotServiceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.order_id is not None:
            result['OrderId'] = self.order_id
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('OrderId') is not None:
            self.order_id = m.get('OrderId')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        return self


class PackageSoundCodeLabelBatchAudioRequest(TeaModel):
    def __init__(self, batch_code=None, iot_instance_id=None):
        self.batch_code = batch_code  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.batch_code, 'batch_code')

    def to_map(self):
        _map = super(PackageSoundCodeLabelBatchAudioRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.batch_code is not None:
            result['BatchCode'] = self.batch_code
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BatchCode') is not None:
            self.batch_code = m.get('BatchCode')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class PackageSoundCodeLabelBatchAudioResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(PackageSoundCodeLabelBatchAudioResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class PageQuerySharedSpeechOpenRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, page_id=None, page_size=None,
                 product_key=None, share_task_code=None, status=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.share_task_code = share_task_code  # type: str
        self.status = status  # type: int

    def validate(self):
        pass

    def to_map(self):
        _map = super(PageQuerySharedSpeechOpenRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.share_task_code is not None:
            result['ShareTaskCode'] = self.share_task_code
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ShareTaskCode') is not None:
            self.share_task_code = m.get('ShareTaskCode')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class PageQuerySharedSpeechOpenResponseDataResultDataData(TeaModel):
    def __init__(self, audio_format=None, biz_code=None, code=None, speech_rate=None, status=None, text=None,
                 voice=None, volume=None):
        self.audio_format = audio_format  # type: str
        self.biz_code = biz_code  # type: str
        self.code = code  # type: str
        self.speech_rate = speech_rate  # type: int
        self.status = status  # type: int
        self.text = text  # type: str
        self.voice = voice  # type: str
        self.volume = volume  # type: int

    def validate(self):
        self.validate_required(self.audio_format, 'audio_format')
        self.validate_required(self.biz_code, 'biz_code')
        self.validate_required(self.code, 'code')
        self.validate_required(self.speech_rate, 'speech_rate')
        self.validate_required(self.status, 'status')
        self.validate_required(self.text, 'text')
        self.validate_required(self.voice, 'voice')
        self.validate_required(self.volume, 'volume')

    def to_map(self):
        _map = super(PageQuerySharedSpeechOpenResponseDataResultDataData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.biz_code is not None:
            result['BizCode'] = self.biz_code
        if self.code is not None:
            result['Code'] = self.code
        if self.speech_rate is not None:
            result['SpeechRate'] = self.speech_rate
        if self.status is not None:
            result['Status'] = self.status
        if self.text is not None:
            result['Text'] = self.text
        if self.voice is not None:
            result['Voice'] = self.voice
        if self.volume is not None:
            result['Volume'] = self.volume
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('BizCode') is not None:
            self.biz_code = m.get('BizCode')
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('SpeechRate') is not None:
            self.speech_rate = m.get('SpeechRate')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Text') is not None:
            self.text = m.get('Text')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        if m.get('Volume') is not None:
            self.volume = m.get('Volume')
        return self


class PageQuerySharedSpeechOpenResponseDataResultData(TeaModel):
    def __init__(self, data=None):
        self.data = data  # type: list[PageQuerySharedSpeechOpenResponseDataResultDataData]

    def validate(self):
        self.validate_required(self.data, 'data')
        if self.data:
            for k in self.data:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(PageQuerySharedSpeechOpenResponseDataResultData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Data'] = []
        if self.data is not None:
            for k in self.data:
                result['Data'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.data = []
        if m.get('Data') is not None:
            for k in m.get('Data'):
                temp_model = PageQuerySharedSpeechOpenResponseDataResultDataData()
                self.data.append(temp_model.from_map(k))
        return self


class PageQuerySharedSpeechOpenResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, result_data=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.result_data = result_data  # type: PageQuerySharedSpeechOpenResponseDataResultData

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.result_data, 'result_data')
        if self.result_data:
            self.result_data.validate()

    def to_map(self):
        _map = super(PageQuerySharedSpeechOpenResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.result_data is not None:
            result['ResultData'] = self.result_data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('ResultData') is not None:
            temp_model = PageQuerySharedSpeechOpenResponseDataResultData()
            self.result_data = temp_model.from_map(m['ResultData'])
        return self


class PageQuerySharedSpeechOpenResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: PageQuerySharedSpeechOpenResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(PageQuerySharedSpeechOpenResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = PageQuerySharedSpeechOpenResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class PageQuerySpeechBroadcastHourRequest(TeaModel):
    def __init__(self, iot_instance_id=None, page_size=None, page_token=None, query_date_time_hour=None,
                 share_task_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.page_token = page_token  # type: str
        self.query_date_time_hour = query_date_time_hour  # type: str
        self.share_task_code = share_task_code  # type: str

    def validate(self):
        self.validate_required(self.query_date_time_hour, 'query_date_time_hour')
        self.validate_required(self.share_task_code, 'share_task_code')

    def to_map(self):
        _map = super(PageQuerySpeechBroadcastHourRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.page_token is not None:
            result['PageToken'] = self.page_token
        if self.query_date_time_hour is not None:
            result['QueryDateTimeHour'] = self.query_date_time_hour
        if self.share_task_code is not None:
            result['ShareTaskCode'] = self.share_task_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('PageToken') is not None:
            self.page_token = m.get('PageToken')
        if m.get('QueryDateTimeHour') is not None:
            self.query_date_time_hour = m.get('QueryDateTimeHour')
        if m.get('ShareTaskCode') is not None:
            self.share_task_code = m.get('ShareTaskCode')
        return self


class PageQuerySpeechBroadcastHourResponseDataResultDataData(TeaModel):
    def __init__(self, code=None, device_name=None, msg=None, product_key=None, share_task_code=None, speech_id=None,
                 speechs=None, start_time=None):
        self.code = code  # type: int
        self.device_name = device_name  # type: str
        self.msg = msg  # type: str
        self.product_key = product_key  # type: str
        self.share_task_code = share_task_code  # type: str
        self.speech_id = speech_id  # type: str
        self.speechs = speechs  # type: str
        self.start_time = start_time  # type: long

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.msg, 'msg')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.share_task_code, 'share_task_code')
        self.validate_required(self.speech_id, 'speech_id')
        self.validate_required(self.speechs, 'speechs')
        self.validate_required(self.start_time, 'start_time')

    def to_map(self):
        _map = super(PageQuerySpeechBroadcastHourResponseDataResultDataData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.msg is not None:
            result['Msg'] = self.msg
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.share_task_code is not None:
            result['ShareTaskCode'] = self.share_task_code
        if self.speech_id is not None:
            result['SpeechId'] = self.speech_id
        if self.speechs is not None:
            result['Speechs'] = self.speechs
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('Msg') is not None:
            self.msg = m.get('Msg')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ShareTaskCode') is not None:
            self.share_task_code = m.get('ShareTaskCode')
        if m.get('SpeechId') is not None:
            self.speech_id = m.get('SpeechId')
        if m.get('Speechs') is not None:
            self.speechs = m.get('Speechs')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class PageQuerySpeechBroadcastHourResponseDataResultData(TeaModel):
    def __init__(self, data=None):
        self.data = data  # type: list[PageQuerySpeechBroadcastHourResponseDataResultDataData]

    def validate(self):
        self.validate_required(self.data, 'data')
        if self.data:
            for k in self.data:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(PageQuerySpeechBroadcastHourResponseDataResultData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Data'] = []
        if self.data is not None:
            for k in self.data:
                result['Data'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.data = []
        if m.get('Data') is not None:
            for k in m.get('Data'):
                temp_model = PageQuerySpeechBroadcastHourResponseDataResultDataData()
                self.data.append(temp_model.from_map(k))
        return self


class PageQuerySpeechBroadcastHourResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, page_token=None, total=None, result_data=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.page_token = page_token  # type: str
        self.total = total  # type: int
        self.result_data = result_data  # type: PageQuerySpeechBroadcastHourResponseDataResultData

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.page_token, 'page_token')
        self.validate_required(self.total, 'total')
        self.validate_required(self.result_data, 'result_data')
        if self.result_data:
            self.result_data.validate()

    def to_map(self):
        _map = super(PageQuerySpeechBroadcastHourResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.page_token is not None:
            result['PageToken'] = self.page_token
        if self.total is not None:
            result['Total'] = self.total
        if self.result_data is not None:
            result['ResultData'] = self.result_data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('PageToken') is not None:
            self.page_token = m.get('PageToken')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('ResultData') is not None:
            temp_model = PageQuerySpeechBroadcastHourResponseDataResultData()
            self.result_data = temp_model.from_map(m['ResultData'])
        return self


class PageQuerySpeechBroadcastHourResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: PageQuerySpeechBroadcastHourResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(PageQuerySpeechBroadcastHourResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = PageQuerySpeechBroadcastHourResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class PrintByTemplateRequest(TeaModel):
    def __init__(self, device_name=None, history_print_topic=None, iot_id=None, iot_instance_id=None,
                 params_json_string=None, product_key=None, template_biz_code=None):
        self.device_name = device_name  # type: str
        self.history_print_topic = history_print_topic  # type: bool
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.params_json_string = params_json_string  # type: str
        self.product_key = product_key  # type: str
        self.template_biz_code = template_biz_code  # type: str

    def validate(self):
        self.validate_required(self.template_biz_code, 'template_biz_code')

    def to_map(self):
        _map = super(PrintByTemplateRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.history_print_topic is not None:
            result['HistoryPrintTopic'] = self.history_print_topic
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.params_json_string is not None:
            result['ParamsJsonString'] = self.params_json_string
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.template_biz_code is not None:
            result['TemplateBizCode'] = self.template_biz_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('HistoryPrintTopic') is not None:
            self.history_print_topic = m.get('HistoryPrintTopic')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ParamsJsonString') is not None:
            self.params_json_string = m.get('ParamsJsonString')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('TemplateBizCode') is not None:
            self.template_biz_code = m.get('TemplateBizCode')
        return self


class PrintByTemplateResponseData(TeaModel):
    def __init__(self, device_error_code=None, device_error_message=None, id=None, max_retry_count=None,
                 retry_count=None, success=None):
        self.device_error_code = device_error_code  # type: str
        self.device_error_message = device_error_message  # type: str
        self.id = id  # type: str
        self.max_retry_count = max_retry_count  # type: int
        self.retry_count = retry_count  # type: int
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.device_error_code, 'device_error_code')
        self.validate_required(self.device_error_message, 'device_error_message')
        self.validate_required(self.id, 'id')
        self.validate_required(self.max_retry_count, 'max_retry_count')
        self.validate_required(self.retry_count, 'retry_count')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(PrintByTemplateResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_error_code is not None:
            result['DeviceErrorCode'] = self.device_error_code
        if self.device_error_message is not None:
            result['DeviceErrorMessage'] = self.device_error_message
        if self.id is not None:
            result['Id'] = self.id
        if self.max_retry_count is not None:
            result['MaxRetryCount'] = self.max_retry_count
        if self.retry_count is not None:
            result['RetryCount'] = self.retry_count
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceErrorCode') is not None:
            self.device_error_code = m.get('DeviceErrorCode')
        if m.get('DeviceErrorMessage') is not None:
            self.device_error_message = m.get('DeviceErrorMessage')
        if m.get('Id') is not None:
            self.id = m.get('Id')
        if m.get('MaxRetryCount') is not None:
            self.max_retry_count = m.get('MaxRetryCount')
        if m.get('RetryCount') is not None:
            self.retry_count = m.get('RetryCount')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class PrintByTemplateResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: PrintByTemplateResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(PrintByTemplateResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = PrintByTemplateResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class PubRequestUserProp(TeaModel):
    def __init__(self, key=None, value=None):
        self.key = key  # type: str
        self.value = value  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(PubRequestUserProp, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.key is not None:
            result['Key'] = self.key
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Key') is not None:
            self.key = m.get('Key')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class PubRequest(TeaModel):
    def __init__(self, content_type=None, correlation_data=None, device_name=None, iot_instance_id=None,
                 message_content=None, message_expiry_interval=None, payload_format_indicator=None, product_key=None, qos=None,
                 response_topic=None, retained=None, topic_full_name=None, user_prop=None):
        self.content_type = content_type  # type: str
        self.correlation_data = correlation_data  # type: str
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.message_content = message_content  # type: str
        self.message_expiry_interval = message_expiry_interval  # type: long
        self.payload_format_indicator = payload_format_indicator  # type: int
        self.product_key = product_key  # type: str
        self.qos = qos  # type: int
        self.response_topic = response_topic  # type: str
        self.retained = retained  # type: bool
        self.topic_full_name = topic_full_name  # type: str
        self.user_prop = user_prop  # type: list[PubRequestUserProp]

    def validate(self):
        self.validate_required(self.message_content, 'message_content')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.topic_full_name, 'topic_full_name')
        if self.user_prop:
            for k in self.user_prop:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(PubRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.content_type is not None:
            result['ContentType'] = self.content_type
        if self.correlation_data is not None:
            result['CorrelationData'] = self.correlation_data
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.message_content is not None:
            result['MessageContent'] = self.message_content
        if self.message_expiry_interval is not None:
            result['MessageExpiryInterval'] = self.message_expiry_interval
        if self.payload_format_indicator is not None:
            result['PayloadFormatIndicator'] = self.payload_format_indicator
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.qos is not None:
            result['Qos'] = self.qos
        if self.response_topic is not None:
            result['ResponseTopic'] = self.response_topic
        if self.retained is not None:
            result['Retained'] = self.retained
        if self.topic_full_name is not None:
            result['TopicFullName'] = self.topic_full_name
        result['UserProp'] = []
        if self.user_prop is not None:
            for k in self.user_prop:
                result['UserProp'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ContentType') is not None:
            self.content_type = m.get('ContentType')
        if m.get('CorrelationData') is not None:
            self.correlation_data = m.get('CorrelationData')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('MessageContent') is not None:
            self.message_content = m.get('MessageContent')
        if m.get('MessageExpiryInterval') is not None:
            self.message_expiry_interval = m.get('MessageExpiryInterval')
        if m.get('PayloadFormatIndicator') is not None:
            self.payload_format_indicator = m.get('PayloadFormatIndicator')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Qos') is not None:
            self.qos = m.get('Qos')
        if m.get('ResponseTopic') is not None:
            self.response_topic = m.get('ResponseTopic')
        if m.get('Retained') is not None:
            self.retained = m.get('Retained')
        if m.get('TopicFullName') is not None:
            self.topic_full_name = m.get('TopicFullName')
        self.user_prop = []
        if m.get('UserProp') is not None:
            for k in m.get('UserProp'):
                temp_model = PubRequestUserProp()
                self.user_prop.append(temp_model.from_map(k))
        return self


class PubResponse(TeaModel):
    def __init__(self, code=None, error_message=None, message_id=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.message_id = message_id  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.message_id, 'message_id')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(PubResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.message_id is not None:
            result['MessageId'] = self.message_id
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('MessageId') is not None:
            self.message_id = m.get('MessageId')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class PubBroadcastRequest(TeaModel):
    def __init__(self, iot_instance_id=None, message_content=None, product_key=None, topic_full_name=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.message_content = message_content  # type: str
        self.product_key = product_key  # type: str
        self.topic_full_name = topic_full_name  # type: str

    def validate(self):
        self.validate_required(self.message_content, 'message_content')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(PubBroadcastRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.message_content is not None:
            result['MessageContent'] = self.message_content
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.topic_full_name is not None:
            result['TopicFullName'] = self.topic_full_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('MessageContent') is not None:
            self.message_content = m.get('MessageContent')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('TopicFullName') is not None:
            self.topic_full_name = m.get('TopicFullName')
        return self


class PubBroadcastResponse(TeaModel):
    def __init__(self, code=None, error_message=None, message_id=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.message_id = message_id  # type: long
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.message_id, 'message_id')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(PubBroadcastResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.message_id is not None:
            result['MessageId'] = self.message_id
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('MessageId') is not None:
            self.message_id = m.get('MessageId')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class PublishScriptRequest(TeaModel):
    def __init__(self, iot_instance_id=None, parser_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.parser_id = parser_id  # type: long

    def validate(self):
        self.validate_required(self.parser_id, 'parser_id')

    def to_map(self):
        _map = super(PublishScriptRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        return self


class PublishScriptResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, syntax_error_msg=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.syntax_error_msg = syntax_error_msg  # type: str

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.syntax_error_msg, 'syntax_error_msg')

    def to_map(self):
        _map = super(PublishScriptResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.syntax_error_msg is not None:
            result['SyntaxErrorMsg'] = self.syntax_error_msg
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('SyntaxErrorMsg') is not None:
            self.syntax_error_msg = m.get('SyntaxErrorMsg')
        return self


class PublishStudioAppRequest(TeaModel):
    def __init__(self, app_id=None, description=None, iot_instance_id=None, project_id=None):
        self.app_id = app_id  # type: str
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.app_id, 'app_id')
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(PublishStudioAppRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_id is not None:
            result['AppId'] = self.app_id
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppId') is not None:
            self.app_id = m.get('AppId')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class PublishStudioAppResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: bool
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(PublishStudioAppResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class PublishThingModelRequest(TeaModel):
    def __init__(self, description=None, iot_instance_id=None, model_version=None, product_key=None,
                 resource_group_id=None):
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.model_version = model_version  # type: str
        self.product_key = product_key  # type: str
        self.resource_group_id = resource_group_id  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(PublishThingModelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.model_version is not None:
            result['ModelVersion'] = self.model_version
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModelVersion') is not None:
            self.model_version = m.get('ModelVersion')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        return self


class PublishThingModelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(PublishThingModelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class PushSpeechRequest(TeaModel):
    def __init__(self, device_name=None, group_id=None, iot_id=None, iot_instance_id=None, product_key=None,
                 project_code=None, push_mode=None, speech_code_list=None):
        self.device_name = device_name  # type: str
        self.group_id = group_id  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.project_code = project_code  # type: str
        self.push_mode = push_mode  # type: str
        self.speech_code_list = speech_code_list  # type: list[str]

    def validate(self):
        self.validate_required(self.project_code, 'project_code')
        self.validate_required(self.push_mode, 'push_mode')
        self.validate_required(self.speech_code_list, 'speech_code_list')

    def to_map(self):
        _map = super(PushSpeechRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.project_code is not None:
            result['ProjectCode'] = self.project_code
        if self.push_mode is not None:
            result['PushMode'] = self.push_mode
        if self.speech_code_list is not None:
            result['SpeechCodeList'] = self.speech_code_list
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProjectCode') is not None:
            self.project_code = m.get('ProjectCode')
        if m.get('PushMode') is not None:
            self.push_mode = m.get('PushMode')
        if m.get('SpeechCodeList') is not None:
            self.speech_code_list = m.get('SpeechCodeList')
        return self


class PushSpeechResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(PushSpeechResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class QueryBatchRegisterDeviceStatusRequest(TeaModel):
    def __init__(self, apply_id=None, iot_instance_id=None, product_key=None):
        self.apply_id = apply_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.apply_id, 'apply_id')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryBatchRegisterDeviceStatusRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.apply_id is not None:
            result['ApplyId'] = self.apply_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplyId') is not None:
            self.apply_id = m.get('ApplyId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryBatchRegisterDeviceStatusResponseDataInvalidList(TeaModel):
    def __init__(self, name=None):
        # Name
        self.name = name  # type: list[str]

    def validate(self):
        self.validate_required(self.name, 'name')

    def to_map(self):
        _map = super(QueryBatchRegisterDeviceStatusResponseDataInvalidList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.name is not None:
            result['Name'] = self.name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Name') is not None:
            self.name = m.get('Name')
        return self


class QueryBatchRegisterDeviceStatusResponseDataValidList(TeaModel):
    def __init__(self, name=None):
        # Name
        self.name = name  # type: list[str]

    def validate(self):
        self.validate_required(self.name, 'name')

    def to_map(self):
        _map = super(QueryBatchRegisterDeviceStatusResponseDataValidList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.name is not None:
            result['Name'] = self.name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Name') is not None:
            self.name = m.get('Name')
        return self


class QueryBatchRegisterDeviceStatusResponseData(TeaModel):
    def __init__(self, status=None, invalid_list=None, valid_list=None):
        self.status = status  # type: str
        self.invalid_list = invalid_list  # type: QueryBatchRegisterDeviceStatusResponseDataInvalidList
        self.valid_list = valid_list  # type: QueryBatchRegisterDeviceStatusResponseDataValidList

    def validate(self):
        self.validate_required(self.status, 'status')
        self.validate_required(self.invalid_list, 'invalid_list')
        if self.invalid_list:
            self.invalid_list.validate()
        self.validate_required(self.valid_list, 'valid_list')
        if self.valid_list:
            self.valid_list.validate()

    def to_map(self):
        _map = super(QueryBatchRegisterDeviceStatusResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.status is not None:
            result['Status'] = self.status
        if self.invalid_list is not None:
            result['InvalidList'] = self.invalid_list.to_map()
        if self.valid_list is not None:
            result['ValidList'] = self.valid_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('InvalidList') is not None:
            temp_model = QueryBatchRegisterDeviceStatusResponseDataInvalidList()
            self.invalid_list = temp_model.from_map(m['InvalidList'])
        if m.get('ValidList') is not None:
            temp_model = QueryBatchRegisterDeviceStatusResponseDataValidList()
            self.valid_list = temp_model.from_map(m['ValidList'])
        return self


class QueryBatchRegisterDeviceStatusResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryBatchRegisterDeviceStatusResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryBatchRegisterDeviceStatusResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryBatchRegisterDeviceStatusResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryCertUrlByApplyIdRequest(TeaModel):
    def __init__(self, apply_id=None, iot_instance_id=None):
        self.apply_id = apply_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.apply_id, 'apply_id')

    def to_map(self):
        _map = super(QueryCertUrlByApplyIdRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.apply_id is not None:
            result['ApplyId'] = self.apply_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplyId') is not None:
            self.apply_id = m.get('ApplyId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QueryCertUrlByApplyIdResponse(TeaModel):
    def __init__(self, cert_url=None, code=None, error_message=None, request_id=None, success=None):
        self.cert_url = cert_url  # type: str
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.cert_url, 'cert_url')
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(QueryCertUrlByApplyIdResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.cert_url is not None:
            result['CertUrl'] = self.cert_url
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CertUrl') is not None:
            self.cert_url = m.get('CertUrl')
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class QueryClientIdsRequest(TeaModel):
    def __init__(self, iot_id=None, iot_instance_id=None):
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(QueryClientIdsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QueryClientIdsResponseDataDynamicRegClientIds(TeaModel):
    def __init__(self, client_id=None, create_time=None):
        self.client_id = client_id  # type: str
        self.create_time = create_time  # type: long

    def validate(self):
        self.validate_required(self.client_id, 'client_id')
        self.validate_required(self.create_time, 'create_time')

    def to_map(self):
        _map = super(QueryClientIdsResponseDataDynamicRegClientIds, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.client_id is not None:
            result['ClientId'] = self.client_id
        if self.create_time is not None:
            result['CreateTime'] = self.create_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ClientId') is not None:
            self.client_id = m.get('ClientId')
        if m.get('CreateTime') is not None:
            self.create_time = m.get('CreateTime')
        return self


class QueryClientIdsResponseData(TeaModel):
    def __init__(self, iot_id=None, dynamic_reg_client_ids=None):
        self.iot_id = iot_id  # type: str
        self.dynamic_reg_client_ids = dynamic_reg_client_ids  # type: list[QueryClientIdsResponseDataDynamicRegClientIds]

    def validate(self):
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.dynamic_reg_client_ids, 'dynamic_reg_client_ids')
        if self.dynamic_reg_client_ids:
            for k in self.dynamic_reg_client_ids:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryClientIdsResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        result['DynamicRegClientIds'] = []
        if self.dynamic_reg_client_ids is not None:
            for k in self.dynamic_reg_client_ids:
                result['DynamicRegClientIds'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        self.dynamic_reg_client_ids = []
        if m.get('DynamicRegClientIds') is not None:
            for k in m.get('DynamicRegClientIds'):
                temp_model = QueryClientIdsResponseDataDynamicRegClientIds()
                self.dynamic_reg_client_ids.append(temp_model.from_map(k))
        return self


class QueryClientIdsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryClientIdsResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryClientIdsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryClientIdsResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryConsumerGroupByGroupIdRequest(TeaModel):
    def __init__(self, group_id=None, iot_instance_id=None):
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(QueryConsumerGroupByGroupIdRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QueryConsumerGroupByGroupIdResponseData(TeaModel):
    def __init__(self, create_time=None, group_id=None, group_name=None):
        self.create_time = create_time  # type: str
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str

    def validate(self):
        self.validate_required(self.create_time, 'create_time')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')

    def to_map(self):
        _map = super(QueryConsumerGroupByGroupIdResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.create_time is not None:
            result['CreateTime'] = self.create_time
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CreateTime') is not None:
            self.create_time = m.get('CreateTime')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        return self


class QueryConsumerGroupByGroupIdResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryConsumerGroupByGroupIdResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryConsumerGroupByGroupIdResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryConsumerGroupByGroupIdResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryConsumerGroupListRequest(TeaModel):
    def __init__(self, current_page=None, fuzzy=None, group_name=None, iot_instance_id=None, page_size=None):
        self.current_page = current_page  # type: int
        self.fuzzy = fuzzy  # type: bool
        self.group_name = group_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryConsumerGroupListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.fuzzy is not None:
            result['Fuzzy'] = self.fuzzy
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('Fuzzy') is not None:
            self.fuzzy = m.get('Fuzzy')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryConsumerGroupListResponseDataConsumerGroupDTO(TeaModel):
    def __init__(self, create_time=None, group_id=None, group_name=None):
        self.create_time = create_time  # type: str
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str

    def validate(self):
        self.validate_required(self.create_time, 'create_time')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')

    def to_map(self):
        _map = super(QueryConsumerGroupListResponseDataConsumerGroupDTO, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.create_time is not None:
            result['CreateTime'] = self.create_time
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CreateTime') is not None:
            self.create_time = m.get('CreateTime')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        return self


class QueryConsumerGroupListResponseData(TeaModel):
    def __init__(self, consumer_group_dto=None):
        self.consumer_group_dto = consumer_group_dto  # type: list[QueryConsumerGroupListResponseDataConsumerGroupDTO]

    def validate(self):
        self.validate_required(self.consumer_group_dto, 'consumer_group_dto')
        if self.consumer_group_dto:
            for k in self.consumer_group_dto:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryConsumerGroupListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ConsumerGroupDTO'] = []
        if self.consumer_group_dto is not None:
            for k in self.consumer_group_dto:
                result['ConsumerGroupDTO'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.consumer_group_dto = []
        if m.get('ConsumerGroupDTO') is not None:
            for k in m.get('ConsumerGroupDTO'):
                temp_model = QueryConsumerGroupListResponseDataConsumerGroupDTO()
                self.consumer_group_dto.append(temp_model.from_map(k))
        return self


class QueryConsumerGroupListResponse(TeaModel):
    def __init__(self, code=None, current_page=None, error_message=None, page_count=None, page_size=None,
                 request_id=None, success=None, total=None, data=None):
        self.code = code  # type: str
        self.current_page = current_page  # type: int
        self.error_message = error_message  # type: str
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: QueryConsumerGroupListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryConsumerGroupListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = QueryConsumerGroupListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryConsumerGroupStatusRequest(TeaModel):
    def __init__(self, group_id=None, iot_instance_id=None):
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(QueryConsumerGroupStatusRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QueryConsumerGroupStatusResponseClientConnectionStatusListConsumerGroupClientConnectionInfo(TeaModel):
    def __init__(self, accumulated_consume_count_per_minute=None, client_id=None, client_ip_port=None,
                 online_time=None, real_time_consume_count_per_minute=None):
        self.accumulated_consume_count_per_minute = accumulated_consume_count_per_minute  # type: int
        self.client_id = client_id  # type: str
        self.client_ip_port = client_ip_port  # type: str
        self.online_time = online_time  # type: long
        self.real_time_consume_count_per_minute = real_time_consume_count_per_minute  # type: int

    def validate(self):
        self.validate_required(self.accumulated_consume_count_per_minute, 'accumulated_consume_count_per_minute')
        self.validate_required(self.client_id, 'client_id')
        self.validate_required(self.client_ip_port, 'client_ip_port')
        self.validate_required(self.online_time, 'online_time')
        self.validate_required(self.real_time_consume_count_per_minute, 'real_time_consume_count_per_minute')

    def to_map(self):
        _map = super(QueryConsumerGroupStatusResponseClientConnectionStatusListConsumerGroupClientConnectionInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.accumulated_consume_count_per_minute is not None:
            result['AccumulatedConsumeCountPerMinute'] = self.accumulated_consume_count_per_minute
        if self.client_id is not None:
            result['ClientId'] = self.client_id
        if self.client_ip_port is not None:
            result['ClientIpPort'] = self.client_ip_port
        if self.online_time is not None:
            result['OnlineTime'] = self.online_time
        if self.real_time_consume_count_per_minute is not None:
            result['RealTimeConsumeCountPerMinute'] = self.real_time_consume_count_per_minute
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AccumulatedConsumeCountPerMinute') is not None:
            self.accumulated_consume_count_per_minute = m.get('AccumulatedConsumeCountPerMinute')
        if m.get('ClientId') is not None:
            self.client_id = m.get('ClientId')
        if m.get('ClientIpPort') is not None:
            self.client_ip_port = m.get('ClientIpPort')
        if m.get('OnlineTime') is not None:
            self.online_time = m.get('OnlineTime')
        if m.get('RealTimeConsumeCountPerMinute') is not None:
            self.real_time_consume_count_per_minute = m.get('RealTimeConsumeCountPerMinute')
        return self


class QueryConsumerGroupStatusResponseClientConnectionStatusList(TeaModel):
    def __init__(self, consumer_group_client_connection_info=None):
        self.consumer_group_client_connection_info = consumer_group_client_connection_info  # type: list[QueryConsumerGroupStatusResponseClientConnectionStatusListConsumerGroupClientConnectionInfo]

    def validate(self):
        self.validate_required(self.consumer_group_client_connection_info, 'consumer_group_client_connection_info')
        if self.consumer_group_client_connection_info:
            for k in self.consumer_group_client_connection_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryConsumerGroupStatusResponseClientConnectionStatusList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ConsumerGroupClientConnectionInfo'] = []
        if self.consumer_group_client_connection_info is not None:
            for k in self.consumer_group_client_connection_info:
                result['ConsumerGroupClientConnectionInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.consumer_group_client_connection_info = []
        if m.get('ConsumerGroupClientConnectionInfo') is not None:
            for k in m.get('ConsumerGroupClientConnectionInfo'):
                temp_model = QueryConsumerGroupStatusResponseClientConnectionStatusListConsumerGroupClientConnectionInfo()
                self.consumer_group_client_connection_info.append(temp_model.from_map(k))
        return self


class QueryConsumerGroupStatusResponse(TeaModel):
    def __init__(self, accumulated_consume_count_per_minute=None, accumulation_count=None, code=None,
                 consumer_speed=None, error_message=None, last_consumer_time=None, real_time_consume_count_per_minute=None,
                 request_id=None, success=None, client_connection_status_list=None):
        self.accumulated_consume_count_per_minute = accumulated_consume_count_per_minute  # type: int
        self.accumulation_count = accumulation_count  # type: int
        self.code = code  # type: str
        self.consumer_speed = consumer_speed  # type: int
        self.error_message = error_message  # type: str
        self.last_consumer_time = last_consumer_time  # type: str
        self.real_time_consume_count_per_minute = real_time_consume_count_per_minute  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.client_connection_status_list = client_connection_status_list  # type: QueryConsumerGroupStatusResponseClientConnectionStatusList

    def validate(self):
        self.validate_required(self.accumulated_consume_count_per_minute, 'accumulated_consume_count_per_minute')
        self.validate_required(self.accumulation_count, 'accumulation_count')
        self.validate_required(self.code, 'code')
        self.validate_required(self.consumer_speed, 'consumer_speed')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.last_consumer_time, 'last_consumer_time')
        self.validate_required(self.real_time_consume_count_per_minute, 'real_time_consume_count_per_minute')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.client_connection_status_list, 'client_connection_status_list')
        if self.client_connection_status_list:
            self.client_connection_status_list.validate()

    def to_map(self):
        _map = super(QueryConsumerGroupStatusResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.accumulated_consume_count_per_minute is not None:
            result['AccumulatedConsumeCountPerMinute'] = self.accumulated_consume_count_per_minute
        if self.accumulation_count is not None:
            result['AccumulationCount'] = self.accumulation_count
        if self.code is not None:
            result['Code'] = self.code
        if self.consumer_speed is not None:
            result['ConsumerSpeed'] = self.consumer_speed
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.last_consumer_time is not None:
            result['LastConsumerTime'] = self.last_consumer_time
        if self.real_time_consume_count_per_minute is not None:
            result['RealTimeConsumeCountPerMinute'] = self.real_time_consume_count_per_minute
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.client_connection_status_list is not None:
            result['ClientConnectionStatusList'] = self.client_connection_status_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AccumulatedConsumeCountPerMinute') is not None:
            self.accumulated_consume_count_per_minute = m.get('AccumulatedConsumeCountPerMinute')
        if m.get('AccumulationCount') is not None:
            self.accumulation_count = m.get('AccumulationCount')
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ConsumerSpeed') is not None:
            self.consumer_speed = m.get('ConsumerSpeed')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('LastConsumerTime') is not None:
            self.last_consumer_time = m.get('LastConsumerTime')
        if m.get('RealTimeConsumeCountPerMinute') is not None:
            self.real_time_consume_count_per_minute = m.get('RealTimeConsumeCountPerMinute')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('ClientConnectionStatusList') is not None:
            temp_model = QueryConsumerGroupStatusResponseClientConnectionStatusList()
            self.client_connection_status_list = temp_model.from_map(m['ClientConnectionStatusList'])
        return self


class QueryDetailSceneRuleLogRequest(TeaModel):
    def __init__(self, current_page=None, end_time=None, iot_instance_id=None, page_size=None, rule_id=None,
                 start_time=None, trace_id=None):
        self.current_page = current_page  # type: int
        self.end_time = end_time  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.rule_id = rule_id  # type: str
        self.start_time = start_time  # type: int
        self.trace_id = trace_id  # type: str

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.rule_id, 'rule_id')
        self.validate_required(self.start_time, 'start_time')
        self.validate_required(self.trace_id, 'trace_id')

    def to_map(self):
        _map = super(QueryDetailSceneRuleLogRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        if self.trace_id is not None:
            result['TraceId'] = self.trace_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        if m.get('TraceId') is not None:
            self.trace_id = m.get('TraceId')
        return self


class QueryDetailSceneRuleLogResponseDataLogList(TeaModel):
    def __init__(self, code=None, message=None, pk_dn=None):
        self.code = code  # type: str
        self.message = message  # type: str
        self.pk_dn = pk_dn  # type: str

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.message, 'message')
        self.validate_required(self.pk_dn, 'pk_dn')

    def to_map(self):
        _map = super(QueryDetailSceneRuleLogResponseDataLogList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.message is not None:
            result['Message'] = self.message
        if self.pk_dn is not None:
            result['PkDn'] = self.pk_dn
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Message') is not None:
            self.message = m.get('Message')
        if m.get('PkDn') is not None:
            self.pk_dn = m.get('PkDn')
        return self


class QueryDetailSceneRuleLogResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, log_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.log_list = log_list  # type: list[QueryDetailSceneRuleLogResponseDataLogList]

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.log_list, 'log_list')
        if self.log_list:
            for k in self.log_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDetailSceneRuleLogResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        result['LogList'] = []
        if self.log_list is not None:
            for k in self.log_list:
                result['LogList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        self.log_list = []
        if m.get('LogList') is not None:
            for k in m.get('LogList'):
                temp_model = QueryDetailSceneRuleLogResponseDataLogList()
                self.log_list.append(temp_model.from_map(k))
        return self


class QueryDetailSceneRuleLogResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDetailSceneRuleLogResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDetailSceneRuleLogResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDetailSceneRuleLogResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceRequest(TeaModel):
    def __init__(self, current_page=None, iot_instance_id=None, next_token=None, page_size=None, product_key=None):
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.next_token = next_token  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.next_token is not None:
            result['NextToken'] = self.next_token
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('NextToken') is not None:
            self.next_token = m.get('NextToken')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceResponseDataDeviceInfo(TeaModel):
    def __init__(self, device_id=None, device_name=None, device_secret=None, device_status=None, device_type=None,
                 gmt_create=None, gmt_modified=None, iot_id=None, nickname=None, product_key=None, utc_create=None,
                 utc_modified=None):
        self.device_id = device_id  # type: str
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.device_status = device_status  # type: str
        self.device_type = device_type  # type: str
        self.gmt_create = gmt_create  # type: str
        self.gmt_modified = gmt_modified  # type: str
        self.iot_id = iot_id  # type: str
        self.nickname = nickname  # type: str
        self.product_key = product_key  # type: str
        self.utc_create = utc_create  # type: str
        self.utc_modified = utc_modified  # type: str

    def validate(self):
        self.validate_required(self.device_id, 'device_id')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')
        self.validate_required(self.device_status, 'device_status')
        self.validate_required(self.device_type, 'device_type')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.nickname, 'nickname')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_modified, 'utc_modified')

    def to_map(self):
        _map = super(QueryDeviceResponseDataDeviceInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_id is not None:
            result['DeviceId'] = self.device_id
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.device_status is not None:
            result['DeviceStatus'] = self.device_status
        if self.device_type is not None:
            result['DeviceType'] = self.device_type
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceId') is not None:
            self.device_id = m.get('DeviceId')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('DeviceStatus') is not None:
            self.device_status = m.get('DeviceStatus')
        if m.get('DeviceType') is not None:
            self.device_type = m.get('DeviceType')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        return self


class QueryDeviceResponseData(TeaModel):
    def __init__(self, device_info=None):
        self.device_info = device_info  # type: list[QueryDeviceResponseDataDeviceInfo]

    def validate(self):
        self.validate_required(self.device_info, 'device_info')
        if self.device_info:
            for k in self.device_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DeviceInfo'] = []
        if self.device_info is not None:
            for k in self.device_info:
                result['DeviceInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_info = []
        if m.get('DeviceInfo') is not None:
            for k in m.get('DeviceInfo'):
                temp_model = QueryDeviceResponseDataDeviceInfo()
                self.device_info.append(temp_model.from_map(k))
        return self


class QueryDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, next_token=None, page=None, page_count=None, page_size=None,
                 request_id=None, success=None, total=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.next_token = next_token  # type: str
        self.page = page  # type: int
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: QueryDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.next_token, 'next_token')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.next_token is not None:
            result['NextToken'] = self.next_token
        if self.page is not None:
            result['Page'] = self.page
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('NextToken') is not None:
            self.next_token = m.get('NextToken')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = QueryDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceBySQLRequest(TeaModel):
    def __init__(self, iot_instance_id=None, sql=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.sql = sql  # type: str

    def validate(self):
        self.validate_required(self.sql, 'sql')

    def to_map(self):
        _map = super(QueryDeviceBySQLRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.sql is not None:
            result['SQL'] = self.sql
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('SQL') is not None:
            self.sql = m.get('SQL')
        return self


class QueryDeviceBySQLResponseDataGroups(TeaModel):
    def __init__(self, group_id=None):
        self.group_id = group_id  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(QueryDeviceBySQLResponseDataGroups, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        return self


class QueryDeviceBySQLResponseDataOTAModules(TeaModel):
    def __init__(self, firmware_version=None, module_name=None):
        self.firmware_version = firmware_version  # type: str
        self.module_name = module_name  # type: str

    def validate(self):
        self.validate_required(self.firmware_version, 'firmware_version')
        self.validate_required(self.module_name, 'module_name')

    def to_map(self):
        _map = super(QueryDeviceBySQLResponseDataOTAModules, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.firmware_version is not None:
            result['FirmwareVersion'] = self.firmware_version
        if self.module_name is not None:
            result['ModuleName'] = self.module_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FirmwareVersion') is not None:
            self.firmware_version = m.get('FirmwareVersion')
        if m.get('ModuleName') is not None:
            self.module_name = m.get('ModuleName')
        return self


class QueryDeviceBySQLResponseDataTags(TeaModel):
    def __init__(self, tag_name=None, tag_value=None):
        self.tag_name = tag_name  # type: str
        self.tag_value = tag_value  # type: str

    def validate(self):
        self.validate_required(self.tag_name, 'tag_name')
        self.validate_required(self.tag_value, 'tag_value')

    def to_map(self):
        _map = super(QueryDeviceBySQLResponseDataTags, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tag_name is not None:
            result['TagName'] = self.tag_name
        if self.tag_value is not None:
            result['TagValue'] = self.tag_value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TagName') is not None:
            self.tag_name = m.get('TagName')
        if m.get('TagValue') is not None:
            self.tag_value = m.get('TagValue')
        return self


class QueryDeviceBySQLResponseData(TeaModel):
    def __init__(self, active_time=None, device_name=None, gmt_create=None, gmt_modified=None, iot_id=None,
                 nickname=None, product_key=None, status=None, groups=None, otamodules=None, tags=None):
        self.active_time = active_time  # type: str
        self.device_name = device_name  # type: str
        self.gmt_create = gmt_create  # type: str
        self.gmt_modified = gmt_modified  # type: str
        self.iot_id = iot_id  # type: str
        self.nickname = nickname  # type: str
        self.product_key = product_key  # type: str
        self.status = status  # type: str
        self.groups = groups  # type: list[QueryDeviceBySQLResponseDataGroups]
        self.otamodules = otamodules  # type: list[QueryDeviceBySQLResponseDataOTAModules]
        self.tags = tags  # type: list[QueryDeviceBySQLResponseDataTags]

    def validate(self):
        self.validate_required(self.active_time, 'active_time')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.nickname, 'nickname')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.status, 'status')
        self.validate_required(self.groups, 'groups')
        if self.groups:
            for k in self.groups:
                if k:
                    k.validate()
        self.validate_required(self.otamodules, 'otamodules')
        if self.otamodules:
            for k in self.otamodules:
                if k:
                    k.validate()
        self.validate_required(self.tags, 'tags')
        if self.tags:
            for k in self.tags:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceBySQLResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.active_time is not None:
            result['ActiveTime'] = self.active_time
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.status is not None:
            result['Status'] = self.status
        result['Groups'] = []
        if self.groups is not None:
            for k in self.groups:
                result['Groups'].append(k.to_map() if k else None)
        result['OTAModules'] = []
        if self.otamodules is not None:
            for k in self.otamodules:
                result['OTAModules'].append(k.to_map() if k else None)
        result['Tags'] = []
        if self.tags is not None:
            for k in self.tags:
                result['Tags'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ActiveTime') is not None:
            self.active_time = m.get('ActiveTime')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        self.groups = []
        if m.get('Groups') is not None:
            for k in m.get('Groups'):
                temp_model = QueryDeviceBySQLResponseDataGroups()
                self.groups.append(temp_model.from_map(k))
        self.otamodules = []
        if m.get('OTAModules') is not None:
            for k in m.get('OTAModules'):
                temp_model = QueryDeviceBySQLResponseDataOTAModules()
                self.otamodules.append(temp_model.from_map(k))
        self.tags = []
        if m.get('Tags') is not None:
            for k in m.get('Tags'):
                temp_model = QueryDeviceBySQLResponseDataTags()
                self.tags.append(temp_model.from_map(k))
        return self


class QueryDeviceBySQLResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, total_count=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total_count = total_count  # type: long
        self.data = data  # type: list[QueryDeviceBySQLResponseData]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total_count, 'total_count')
        self.validate_required(self.data, 'data')
        if self.data:
            for k in self.data:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceBySQLResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total_count is not None:
            result['TotalCount'] = self.total_count
        result['Data'] = []
        if self.data is not None:
            for k in self.data:
                result['Data'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('TotalCount') is not None:
            self.total_count = m.get('TotalCount')
        self.data = []
        if m.get('Data') is not None:
            for k in m.get('Data'):
                temp_model = QueryDeviceBySQLResponseData()
                self.data.append(temp_model.from_map(k))
        return self


class QueryDeviceByStatusRequest(TeaModel):
    def __init__(self, current_page=None, iot_instance_id=None, page_size=None, product_key=None,
                 resource_group_id=None, status=None):
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.resource_group_id = resource_group_id  # type: str
        self.status = status  # type: int

    def validate(self):
        self.validate_required(self.status, 'status')

    def to_map(self):
        _map = super(QueryDeviceByStatusRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class QueryDeviceByStatusResponseDataSimpleDeviceInfo(TeaModel):
    def __init__(self, device_name=None, device_secret=None, gmt_create=None, gmt_modified=None, iot_id=None,
                 nickname=None, product_key=None, status=None, utc_create=None, utc_modified=None):
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.gmt_create = gmt_create  # type: str
        self.gmt_modified = gmt_modified  # type: str
        self.iot_id = iot_id  # type: str
        self.nickname = nickname  # type: str
        self.product_key = product_key  # type: str
        self.status = status  # type: str
        self.utc_create = utc_create  # type: str
        self.utc_modified = utc_modified  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.nickname, 'nickname')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.status, 'status')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_modified, 'utc_modified')

    def to_map(self):
        _map = super(QueryDeviceByStatusResponseDataSimpleDeviceInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.status is not None:
            result['Status'] = self.status
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        return self


class QueryDeviceByStatusResponseData(TeaModel):
    def __init__(self, simple_device_info=None):
        self.simple_device_info = simple_device_info  # type: list[QueryDeviceByStatusResponseDataSimpleDeviceInfo]

    def validate(self):
        self.validate_required(self.simple_device_info, 'simple_device_info')
        if self.simple_device_info:
            for k in self.simple_device_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceByStatusResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['SimpleDeviceInfo'] = []
        if self.simple_device_info is not None:
            for k in self.simple_device_info:
                result['SimpleDeviceInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.simple_device_info = []
        if m.get('SimpleDeviceInfo') is not None:
            for k in m.get('SimpleDeviceInfo'):
                temp_model = QueryDeviceByStatusResponseDataSimpleDeviceInfo()
                self.simple_device_info.append(temp_model.from_map(k))
        return self


class QueryDeviceByStatusResponse(TeaModel):
    def __init__(self, code=None, error_message=None, page=None, page_count=None, page_size=None, request_id=None,
                 success=None, total=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.page = page  # type: int
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: QueryDeviceByStatusResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceByStatusResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page is not None:
            result['Page'] = self.page
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = QueryDeviceByStatusResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceByTagsRequestTag(TeaModel):
    def __init__(self, tag_key=None, tag_value=None):
        self.tag_key = tag_key  # type: str
        self.tag_value = tag_value  # type: str

    def validate(self):
        self.validate_required(self.tag_key, 'tag_key')
        self.validate_required(self.tag_value, 'tag_value')

    def to_map(self):
        _map = super(QueryDeviceByTagsRequestTag, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tag_key is not None:
            result['TagKey'] = self.tag_key
        if self.tag_value is not None:
            result['TagValue'] = self.tag_value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TagKey') is not None:
            self.tag_key = m.get('TagKey')
        if m.get('TagValue') is not None:
            self.tag_value = m.get('TagValue')
        return self


class QueryDeviceByTagsRequest(TeaModel):
    def __init__(self, current_page=None, iot_instance_id=None, page_size=None, tag=None):
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.tag = tag  # type: list[QueryDeviceByTagsRequestTag]

    def validate(self):
        if self.tag:
            for k in self.tag:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceByTagsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        result['Tag'] = []
        if self.tag is not None:
            for k in self.tag:
                result['Tag'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        self.tag = []
        if m.get('Tag') is not None:
            for k in m.get('Tag'):
                temp_model = QueryDeviceByTagsRequestTag()
                self.tag.append(temp_model.from_map(k))
        return self


class QueryDeviceByTagsResponseDataSimpleDeviceInfo(TeaModel):
    def __init__(self, device_name=None, iot_id=None, product_key=None, product_name=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')

    def to_map(self):
        _map = super(QueryDeviceByTagsResponseDataSimpleDeviceInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        return self


class QueryDeviceByTagsResponseData(TeaModel):
    def __init__(self, simple_device_info=None):
        self.simple_device_info = simple_device_info  # type: list[QueryDeviceByTagsResponseDataSimpleDeviceInfo]

    def validate(self):
        self.validate_required(self.simple_device_info, 'simple_device_info')
        if self.simple_device_info:
            for k in self.simple_device_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceByTagsResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['SimpleDeviceInfo'] = []
        if self.simple_device_info is not None:
            for k in self.simple_device_info:
                result['SimpleDeviceInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.simple_device_info = []
        if m.get('SimpleDeviceInfo') is not None:
            for k in m.get('SimpleDeviceInfo'):
                temp_model = QueryDeviceByTagsResponseDataSimpleDeviceInfo()
                self.simple_device_info.append(temp_model.from_map(k))
        return self


class QueryDeviceByTagsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, page=None, page_count=None, page_size=None, request_id=None,
                 success=None, total=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.page = page  # type: int
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: QueryDeviceByTagsResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceByTagsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page is not None:
            result['Page'] = self.page
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = QueryDeviceByTagsResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceCertRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryDeviceCertRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceCertResponseDeviceCertInfo(TeaModel):
    def __init__(self, cert_sn=None, certificate=None, private_key=None, status=None):
        self.cert_sn = cert_sn  # type: str
        self.certificate = certificate  # type: str
        self.private_key = private_key  # type: str
        self.status = status  # type: int

    def validate(self):
        self.validate_required(self.cert_sn, 'cert_sn')
        self.validate_required(self.certificate, 'certificate')
        self.validate_required(self.private_key, 'private_key')
        self.validate_required(self.status, 'status')

    def to_map(self):
        _map = super(QueryDeviceCertResponseDeviceCertInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.cert_sn is not None:
            result['CertSN'] = self.cert_sn
        if self.certificate is not None:
            result['Certificate'] = self.certificate
        if self.private_key is not None:
            result['PrivateKey'] = self.private_key
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CertSN') is not None:
            self.cert_sn = m.get('CertSN')
        if m.get('Certificate') is not None:
            self.certificate = m.get('Certificate')
        if m.get('PrivateKey') is not None:
            self.private_key = m.get('PrivateKey')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class QueryDeviceCertResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, device_cert_info=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.device_cert_info = device_cert_info  # type: QueryDeviceCertResponseDeviceCertInfo

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.device_cert_info, 'device_cert_info')
        if self.device_cert_info:
            self.device_cert_info.validate()

    def to_map(self):
        _map = super(QueryDeviceCertResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.device_cert_info is not None:
            result['DeviceCertInfo'] = self.device_cert_info.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('DeviceCertInfo') is not None:
            temp_model = QueryDeviceCertResponseDeviceCertInfo()
            self.device_cert_info = temp_model.from_map(m['DeviceCertInfo'])
        return self


class QueryDeviceDesiredPropertyRequest(TeaModel):
    def __init__(self, device_name=None, function_block_id=None, identifier=None, iot_id=None, iot_instance_id=None,
                 product_key=None):
        self.device_name = device_name  # type: str
        self.function_block_id = function_block_id  # type: str
        self.identifier = identifier  # type: list[str]
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryDeviceDesiredPropertyRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceDesiredPropertyResponseDataListDesiredPropertyInfo(TeaModel):
    def __init__(self, data_type=None, identifier=None, name=None, time=None, unit=None, value=None, version=None):
        self.data_type = data_type  # type: str
        self.identifier = identifier  # type: str
        self.name = name  # type: str
        self.time = time  # type: str
        self.unit = unit  # type: str
        self.value = value  # type: str
        self.version = version  # type: long

    def validate(self):
        self.validate_required(self.data_type, 'data_type')
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.name, 'name')
        self.validate_required(self.time, 'time')
        self.validate_required(self.unit, 'unit')
        self.validate_required(self.value, 'value')
        self.validate_required(self.version, 'version')

    def to_map(self):
        _map = super(QueryDeviceDesiredPropertyResponseDataListDesiredPropertyInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_type is not None:
            result['DataType'] = self.data_type
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.name is not None:
            result['Name'] = self.name
        if self.time is not None:
            result['Time'] = self.time
        if self.unit is not None:
            result['Unit'] = self.unit
        if self.value is not None:
            result['Value'] = self.value
        if self.version is not None:
            result['Version'] = self.version
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataType') is not None:
            self.data_type = m.get('DataType')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Time') is not None:
            self.time = m.get('Time')
        if m.get('Unit') is not None:
            self.unit = m.get('Unit')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        if m.get('Version') is not None:
            self.version = m.get('Version')
        return self


class QueryDeviceDesiredPropertyResponseDataList(TeaModel):
    def __init__(self, desired_property_info=None):
        self.desired_property_info = desired_property_info  # type: list[QueryDeviceDesiredPropertyResponseDataListDesiredPropertyInfo]

    def validate(self):
        self.validate_required(self.desired_property_info, 'desired_property_info')
        if self.desired_property_info:
            for k in self.desired_property_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceDesiredPropertyResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DesiredPropertyInfo'] = []
        if self.desired_property_info is not None:
            for k in self.desired_property_info:
                result['DesiredPropertyInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.desired_property_info = []
        if m.get('DesiredPropertyInfo') is not None:
            for k in m.get('DesiredPropertyInfo'):
                temp_model = QueryDeviceDesiredPropertyResponseDataListDesiredPropertyInfo()
                self.desired_property_info.append(temp_model.from_map(k))
        return self


class QueryDeviceDesiredPropertyResponseData(TeaModel):
    def __init__(self, list=None):
        self.list = list  # type: QueryDeviceDesiredPropertyResponseDataList

    def validate(self):
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDeviceDesiredPropertyResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('List') is not None:
            temp_model = QueryDeviceDesiredPropertyResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDeviceDesiredPropertyResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceDesiredPropertyResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceDesiredPropertyResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceDesiredPropertyResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceDetailRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryDeviceDetailRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceDetailResponseData(TeaModel):
    def __init__(self, device_name=None, device_secret=None, firmware_version=None, gmt_active=None,
                 gmt_create=None, gmt_online=None, iot_id=None, ip_address=None, nickname=None, node_type=None, owner=None,
                 product_key=None, product_name=None, region=None, status=None, utc_active=None, utc_create=None,
                 utc_online=None):
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.firmware_version = firmware_version  # type: str
        self.gmt_active = gmt_active  # type: str
        self.gmt_create = gmt_create  # type: str
        self.gmt_online = gmt_online  # type: str
        self.iot_id = iot_id  # type: str
        self.ip_address = ip_address  # type: str
        self.nickname = nickname  # type: str
        self.node_type = node_type  # type: int
        self.owner = owner  # type: bool
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str
        self.region = region  # type: str
        self.status = status  # type: str
        self.utc_active = utc_active  # type: str
        self.utc_create = utc_create  # type: str
        self.utc_online = utc_online  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')
        self.validate_required(self.firmware_version, 'firmware_version')
        self.validate_required(self.gmt_active, 'gmt_active')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_online, 'gmt_online')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.ip_address, 'ip_address')
        self.validate_required(self.nickname, 'nickname')
        self.validate_required(self.node_type, 'node_type')
        self.validate_required(self.owner, 'owner')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')
        self.validate_required(self.region, 'region')
        self.validate_required(self.status, 'status')
        self.validate_required(self.utc_active, 'utc_active')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_online, 'utc_online')

    def to_map(self):
        _map = super(QueryDeviceDetailResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.firmware_version is not None:
            result['FirmwareVersion'] = self.firmware_version
        if self.gmt_active is not None:
            result['GmtActive'] = self.gmt_active
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_online is not None:
            result['GmtOnline'] = self.gmt_online
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.ip_address is not None:
            result['IpAddress'] = self.ip_address
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.node_type is not None:
            result['NodeType'] = self.node_type
        if self.owner is not None:
            result['Owner'] = self.owner
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.region is not None:
            result['Region'] = self.region
        if self.status is not None:
            result['Status'] = self.status
        if self.utc_active is not None:
            result['UtcActive'] = self.utc_active
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_online is not None:
            result['UtcOnline'] = self.utc_online
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('FirmwareVersion') is not None:
            self.firmware_version = m.get('FirmwareVersion')
        if m.get('GmtActive') is not None:
            self.gmt_active = m.get('GmtActive')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtOnline') is not None:
            self.gmt_online = m.get('GmtOnline')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IpAddress') is not None:
            self.ip_address = m.get('IpAddress')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('NodeType') is not None:
            self.node_type = m.get('NodeType')
        if m.get('Owner') is not None:
            self.owner = m.get('Owner')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('Region') is not None:
            self.region = m.get('Region')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('UtcActive') is not None:
            self.utc_active = m.get('UtcActive')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcOnline') is not None:
            self.utc_online = m.get('UtcOnline')
        return self


class QueryDeviceDetailResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceDetailResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceDetailResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceDetailResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceDistributeDetailRequest(TeaModel):
    def __init__(self, job_id=None):
        self.job_id = job_id  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(QueryDeviceDistributeDetailRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.job_id is not None:
            result['JobId'] = self.job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        return self


class QueryDeviceDistributeDetailResponse(TeaModel):
    def __init__(self, code=None, error_message=None, file=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.file = file  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.file, 'file')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(QueryDeviceDistributeDetailResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.file is not None:
            result['File'] = self.file
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('File') is not None:
            self.file = m.get('File')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class QueryDeviceDistributeJobRequest(TeaModel):
    def __init__(self, job_id=None):
        self.job_id = job_id  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(QueryDeviceDistributeJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.job_id is not None:
            result['JobId'] = self.job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        return self


class QueryDeviceDistributeJobResponseDataTargetInstanceConfigsTargetInstanceConfigs(TeaModel):
    def __init__(self, target_instance_id=None):
        self.target_instance_id = target_instance_id  # type: str

    def validate(self):
        self.validate_required(self.target_instance_id, 'target_instance_id')

    def to_map(self):
        _map = super(QueryDeviceDistributeJobResponseDataTargetInstanceConfigsTargetInstanceConfigs, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.target_instance_id is not None:
            result['TargetInstanceId'] = self.target_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TargetInstanceId') is not None:
            self.target_instance_id = m.get('TargetInstanceId')
        return self


class QueryDeviceDistributeJobResponseDataTargetInstanceConfigs(TeaModel):
    def __init__(self, target_instance_configs=None):
        self.target_instance_configs = target_instance_configs  # type: list[QueryDeviceDistributeJobResponseDataTargetInstanceConfigsTargetInstanceConfigs]

    def validate(self):
        self.validate_required(self.target_instance_configs, 'target_instance_configs')
        if self.target_instance_configs:
            for k in self.target_instance_configs:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceDistributeJobResponseDataTargetInstanceConfigs, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['targetInstanceConfigs'] = []
        if self.target_instance_configs is not None:
            for k in self.target_instance_configs:
                result['targetInstanceConfigs'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.target_instance_configs = []
        if m.get('targetInstanceConfigs') is not None:
            for k in m.get('targetInstanceConfigs'):
                temp_model = QueryDeviceDistributeJobResponseDataTargetInstanceConfigsTargetInstanceConfigs()
                self.target_instance_configs.append(temp_model.from_map(k))
        return self


class QueryDeviceDistributeJobResponseData(TeaModel):
    def __init__(self, gmt_create=None, job_id=None, product_key=None, source_instance_id=None, source_uid=None,
                 status=None, strategy=None, target_uid=None, total=None, target_instance_configs=None):
        self.gmt_create = gmt_create  # type: long
        self.job_id = job_id  # type: str
        self.product_key = product_key  # type: str
        self.source_instance_id = source_instance_id  # type: str
        self.source_uid = source_uid  # type: str
        self.status = status  # type: int
        self.strategy = strategy  # type: int
        self.target_uid = target_uid  # type: str
        self.total = total  # type: int
        self.target_instance_configs = target_instance_configs  # type: QueryDeviceDistributeJobResponseDataTargetInstanceConfigs

    def validate(self):
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.source_instance_id, 'source_instance_id')
        self.validate_required(self.source_uid, 'source_uid')
        self.validate_required(self.status, 'status')
        self.validate_required(self.strategy, 'strategy')
        self.validate_required(self.target_uid, 'target_uid')
        self.validate_required(self.total, 'total')
        self.validate_required(self.target_instance_configs, 'target_instance_configs')
        if self.target_instance_configs:
            self.target_instance_configs.validate()

    def to_map(self):
        _map = super(QueryDeviceDistributeJobResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.source_instance_id is not None:
            result['SourceInstanceId'] = self.source_instance_id
        if self.source_uid is not None:
            result['SourceUid'] = self.source_uid
        if self.status is not None:
            result['Status'] = self.status
        if self.strategy is not None:
            result['Strategy'] = self.strategy
        if self.target_uid is not None:
            result['TargetUid'] = self.target_uid
        if self.total is not None:
            result['Total'] = self.total
        if self.target_instance_configs is not None:
            result['TargetInstanceConfigs'] = self.target_instance_configs.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SourceInstanceId') is not None:
            self.source_instance_id = m.get('SourceInstanceId')
        if m.get('SourceUid') is not None:
            self.source_uid = m.get('SourceUid')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Strategy') is not None:
            self.strategy = m.get('Strategy')
        if m.get('TargetUid') is not None:
            self.target_uid = m.get('TargetUid')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('TargetInstanceConfigs') is not None:
            temp_model = QueryDeviceDistributeJobResponseDataTargetInstanceConfigs()
            self.target_instance_configs = temp_model.from_map(m['TargetInstanceConfigs'])
        return self


class QueryDeviceDistributeJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceDistributeJobResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceDistributeJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceDistributeJobResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceEventDataRequest(TeaModel):
    def __init__(self, asc=None, device_name=None, end_time=None, event_type=None, identifier=None, iot_id=None,
                 iot_instance_id=None, page_size=None, product_key=None, start_time=None):
        self.asc = asc  # type: int
        self.device_name = device_name  # type: str
        self.end_time = end_time  # type: long
        self.event_type = event_type  # type: str
        self.identifier = identifier  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.start_time = start_time  # type: long

    def validate(self):
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.start_time, 'start_time')

    def to_map(self):
        _map = super(QueryDeviceEventDataRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.asc is not None:
            result['Asc'] = self.asc
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.event_type is not None:
            result['EventType'] = self.event_type
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Asc') is not None:
            self.asc = m.get('Asc')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('EventType') is not None:
            self.event_type = m.get('EventType')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class QueryDeviceEventDataResponseDataListEventInfo(TeaModel):
    def __init__(self, event_type=None, identifier=None, name=None, output_data=None, time=None):
        self.event_type = event_type  # type: str
        self.identifier = identifier  # type: str
        self.name = name  # type: str
        self.output_data = output_data  # type: str
        self.time = time  # type: str

    def validate(self):
        self.validate_required(self.event_type, 'event_type')
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.name, 'name')
        self.validate_required(self.output_data, 'output_data')
        self.validate_required(self.time, 'time')

    def to_map(self):
        _map = super(QueryDeviceEventDataResponseDataListEventInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.event_type is not None:
            result['EventType'] = self.event_type
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.name is not None:
            result['Name'] = self.name
        if self.output_data is not None:
            result['OutputData'] = self.output_data
        if self.time is not None:
            result['Time'] = self.time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('EventType') is not None:
            self.event_type = m.get('EventType')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('OutputData') is not None:
            self.output_data = m.get('OutputData')
        if m.get('Time') is not None:
            self.time = m.get('Time')
        return self


class QueryDeviceEventDataResponseDataList(TeaModel):
    def __init__(self, event_info=None):
        self.event_info = event_info  # type: list[QueryDeviceEventDataResponseDataListEventInfo]

    def validate(self):
        self.validate_required(self.event_info, 'event_info')
        if self.event_info:
            for k in self.event_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceEventDataResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['EventInfo'] = []
        if self.event_info is not None:
            for k in self.event_info:
                result['EventInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.event_info = []
        if m.get('EventInfo') is not None:
            for k in m.get('EventInfo'):
                temp_model = QueryDeviceEventDataResponseDataListEventInfo()
                self.event_info.append(temp_model.from_map(k))
        return self


class QueryDeviceEventDataResponseData(TeaModel):
    def __init__(self, next_time=None, next_valid=None, list=None):
        self.next_time = next_time  # type: long
        self.next_valid = next_valid  # type: bool
        self.list = list  # type: QueryDeviceEventDataResponseDataList

    def validate(self):
        self.validate_required(self.next_time, 'next_time')
        self.validate_required(self.next_valid, 'next_valid')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDeviceEventDataResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.next_time is not None:
            result['NextTime'] = self.next_time
        if self.next_valid is not None:
            result['NextValid'] = self.next_valid
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('NextTime') is not None:
            self.next_time = m.get('NextTime')
        if m.get('NextValid') is not None:
            self.next_valid = m.get('NextValid')
        if m.get('List') is not None:
            temp_model = QueryDeviceEventDataResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDeviceEventDataResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceEventDataResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceEventDataResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceEventDataResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceFileRequest(TeaModel):
    def __init__(self, device_name=None, file_id=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.file_id = file_id  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.file_id, 'file_id')

    def to_map(self):
        _map = super(QueryDeviceFileRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.file_id is not None:
            result['FileId'] = self.file_id
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('FileId') is not None:
            self.file_id = m.get('FileId')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceFileResponseData(TeaModel):
    def __init__(self, download_url=None, file_id=None, name=None, size=None, utc_created_on=None):
        self.download_url = download_url  # type: str
        self.file_id = file_id  # type: str
        self.name = name  # type: str
        self.size = size  # type: str
        self.utc_created_on = utc_created_on  # type: str

    def validate(self):
        self.validate_required(self.download_url, 'download_url')
        self.validate_required(self.file_id, 'file_id')
        self.validate_required(self.name, 'name')
        self.validate_required(self.size, 'size')
        self.validate_required(self.utc_created_on, 'utc_created_on')

    def to_map(self):
        _map = super(QueryDeviceFileResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.download_url is not None:
            result['DownloadUrl'] = self.download_url
        if self.file_id is not None:
            result['FileId'] = self.file_id
        if self.name is not None:
            result['Name'] = self.name
        if self.size is not None:
            result['Size'] = self.size
        if self.utc_created_on is not None:
            result['UtcCreatedOn'] = self.utc_created_on
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DownloadUrl') is not None:
            self.download_url = m.get('DownloadUrl')
        if m.get('FileId') is not None:
            self.file_id = m.get('FileId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Size') is not None:
            self.size = m.get('Size')
        if m.get('UtcCreatedOn') is not None:
            self.utc_created_on = m.get('UtcCreatedOn')
        return self


class QueryDeviceFileResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceFileResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceFileResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceFileResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceFileListRequest(TeaModel):
    def __init__(self, current_page=None, device_name=None, iot_id=None, iot_instance_id=None, page_size=None,
                 product_key=None):
        self.current_page = current_page  # type: int
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryDeviceFileListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceFileListResponseDataFileSummary(TeaModel):
    def __init__(self, file_id=None, name=None, size=None, utc_created_on=None):
        self.file_id = file_id  # type: str
        self.name = name  # type: str
        self.size = size  # type: str
        self.utc_created_on = utc_created_on  # type: str

    def validate(self):
        self.validate_required(self.file_id, 'file_id')
        self.validate_required(self.name, 'name')
        self.validate_required(self.size, 'size')
        self.validate_required(self.utc_created_on, 'utc_created_on')

    def to_map(self):
        _map = super(QueryDeviceFileListResponseDataFileSummary, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.file_id is not None:
            result['FileId'] = self.file_id
        if self.name is not None:
            result['Name'] = self.name
        if self.size is not None:
            result['Size'] = self.size
        if self.utc_created_on is not None:
            result['UtcCreatedOn'] = self.utc_created_on
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FileId') is not None:
            self.file_id = m.get('FileId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Size') is not None:
            self.size = m.get('Size')
        if m.get('UtcCreatedOn') is not None:
            self.utc_created_on = m.get('UtcCreatedOn')
        return self


class QueryDeviceFileListResponseData(TeaModel):
    def __init__(self, file_summary=None):
        self.file_summary = file_summary  # type: list[QueryDeviceFileListResponseDataFileSummary]

    def validate(self):
        self.validate_required(self.file_summary, 'file_summary')
        if self.file_summary:
            for k in self.file_summary:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceFileListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['FileSummary'] = []
        if self.file_summary is not None:
            for k in self.file_summary:
                result['FileSummary'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.file_summary = []
        if m.get('FileSummary') is not None:
            for k in m.get('FileSummary'):
                temp_model = QueryDeviceFileListResponseDataFileSummary()
                self.file_summary.append(temp_model.from_map(k))
        return self


class QueryDeviceFileListResponse(TeaModel):
    def __init__(self, code=None, current_page=None, error_message=None, page_count=None, page_size=None,
                 request_id=None, success=None, total=None, data=None):
        self.code = code  # type: str
        self.current_page = current_page  # type: int
        self.error_message = error_message  # type: str
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: QueryDeviceFileListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceFileListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = QueryDeviceFileListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceGroupByDeviceRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryDeviceGroupByDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceGroupByDeviceResponseGroupInfosGroupInfo(TeaModel):
    def __init__(self, group_desc=None, group_id=None, group_name=None, group_type=None, utc_create=None):
        self.group_desc = group_desc  # type: str
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str
        self.group_type = group_type  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.group_desc, 'group_desc')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')
        self.validate_required(self.group_type, 'group_type')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(QueryDeviceGroupByDeviceResponseGroupInfosGroupInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_desc is not None:
            result['GroupDesc'] = self.group_desc
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.group_type is not None:
            result['GroupType'] = self.group_type
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupDesc') is not None:
            self.group_desc = m.get('GroupDesc')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('GroupType') is not None:
            self.group_type = m.get('GroupType')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class QueryDeviceGroupByDeviceResponseGroupInfos(TeaModel):
    def __init__(self, group_info=None):
        self.group_info = group_info  # type: list[QueryDeviceGroupByDeviceResponseGroupInfosGroupInfo]

    def validate(self):
        self.validate_required(self.group_info, 'group_info')
        if self.group_info:
            for k in self.group_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceGroupByDeviceResponseGroupInfos, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['GroupInfo'] = []
        if self.group_info is not None:
            for k in self.group_info:
                result['GroupInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.group_info = []
        if m.get('GroupInfo') is not None:
            for k in m.get('GroupInfo'):
                temp_model = QueryDeviceGroupByDeviceResponseGroupInfosGroupInfo()
                self.group_info.append(temp_model.from_map(k))
        return self


class QueryDeviceGroupByDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, group_infos=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.group_infos = group_infos  # type: QueryDeviceGroupByDeviceResponseGroupInfos

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.group_infos, 'group_infos')
        if self.group_infos:
            self.group_infos.validate()

    def to_map(self):
        _map = super(QueryDeviceGroupByDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.group_infos is not None:
            result['GroupInfos'] = self.group_infos.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('GroupInfos') is not None:
            temp_model = QueryDeviceGroupByDeviceResponseGroupInfos()
            self.group_infos = temp_model.from_map(m['GroupInfos'])
        return self


class QueryDeviceGroupByTagsRequestTag(TeaModel):
    def __init__(self, tag_key=None, tag_value=None):
        self.tag_key = tag_key  # type: str
        self.tag_value = tag_value  # type: str

    def validate(self):
        self.validate_required(self.tag_key, 'tag_key')
        self.validate_required(self.tag_value, 'tag_value')

    def to_map(self):
        _map = super(QueryDeviceGroupByTagsRequestTag, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tag_key is not None:
            result['TagKey'] = self.tag_key
        if self.tag_value is not None:
            result['TagValue'] = self.tag_value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TagKey') is not None:
            self.tag_key = m.get('TagKey')
        if m.get('TagValue') is not None:
            self.tag_value = m.get('TagValue')
        return self


class QueryDeviceGroupByTagsRequest(TeaModel):
    def __init__(self, current_page=None, iot_instance_id=None, page_size=None, tag=None):
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.tag = tag  # type: list[QueryDeviceGroupByTagsRequestTag]

    def validate(self):
        if self.tag:
            for k in self.tag:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceGroupByTagsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        result['Tag'] = []
        if self.tag is not None:
            for k in self.tag:
                result['Tag'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        self.tag = []
        if m.get('Tag') is not None:
            for k in m.get('Tag'):
                temp_model = QueryDeviceGroupByTagsRequestTag()
                self.tag.append(temp_model.from_map(k))
        return self


class QueryDeviceGroupByTagsResponseDataDeviceGroup(TeaModel):
    def __init__(self, group_id=None, group_name=None):
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')

    def to_map(self):
        _map = super(QueryDeviceGroupByTagsResponseDataDeviceGroup, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        return self


class QueryDeviceGroupByTagsResponseData(TeaModel):
    def __init__(self, device_group=None):
        self.device_group = device_group  # type: list[QueryDeviceGroupByTagsResponseDataDeviceGroup]

    def validate(self):
        self.validate_required(self.device_group, 'device_group')
        if self.device_group:
            for k in self.device_group:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceGroupByTagsResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DeviceGroup'] = []
        if self.device_group is not None:
            for k in self.device_group:
                result['DeviceGroup'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device_group = []
        if m.get('DeviceGroup') is not None:
            for k in m.get('DeviceGroup'):
                temp_model = QueryDeviceGroupByTagsResponseDataDeviceGroup()
                self.device_group.append(temp_model.from_map(k))
        return self


class QueryDeviceGroupByTagsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, page=None, page_count=None, page_size=None, request_id=None,
                 success=None, total=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.page = page  # type: int
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: QueryDeviceGroupByTagsResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceGroupByTagsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page is not None:
            result['Page'] = self.page
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = QueryDeviceGroupByTagsResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceGroupInfoRequest(TeaModel):
    def __init__(self, group_id=None, group_type=None, iot_instance_id=None):
        self.group_id = group_id  # type: str
        self.group_type = group_type  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(QueryDeviceGroupInfoRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_type is not None:
            result['GroupType'] = self.group_type
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupType') is not None:
            self.group_type = m.get('GroupType')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QueryDeviceGroupInfoResponseData(TeaModel):
    def __init__(self, device_active=None, device_count=None, device_online=None, dynamic_group_expression=None,
                 group_desc=None, group_id=None, group_name=None, utc_create=None):
        self.device_active = device_active  # type: int
        self.device_count = device_count  # type: int
        self.device_online = device_online  # type: int
        self.dynamic_group_expression = dynamic_group_expression  # type: str
        self.group_desc = group_desc  # type: str
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.device_active, 'device_active')
        self.validate_required(self.device_count, 'device_count')
        self.validate_required(self.device_online, 'device_online')
        self.validate_required(self.dynamic_group_expression, 'dynamic_group_expression')
        self.validate_required(self.group_desc, 'group_desc')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(QueryDeviceGroupInfoResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_active is not None:
            result['DeviceActive'] = self.device_active
        if self.device_count is not None:
            result['DeviceCount'] = self.device_count
        if self.device_online is not None:
            result['DeviceOnline'] = self.device_online
        if self.dynamic_group_expression is not None:
            result['DynamicGroupExpression'] = self.dynamic_group_expression
        if self.group_desc is not None:
            result['GroupDesc'] = self.group_desc
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceActive') is not None:
            self.device_active = m.get('DeviceActive')
        if m.get('DeviceCount') is not None:
            self.device_count = m.get('DeviceCount')
        if m.get('DeviceOnline') is not None:
            self.device_online = m.get('DeviceOnline')
        if m.get('DynamicGroupExpression') is not None:
            self.dynamic_group_expression = m.get('DynamicGroupExpression')
        if m.get('GroupDesc') is not None:
            self.group_desc = m.get('GroupDesc')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class QueryDeviceGroupInfoResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceGroupInfoResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceGroupInfoResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceGroupInfoResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceGroupListRequest(TeaModel):
    def __init__(self, current_page=None, group_name=None, group_types=None, iot_instance_id=None, page_size=None,
                 super_group_id=None):
        self.current_page = current_page  # type: int
        self.group_name = group_name  # type: str
        self.group_types = group_types  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.super_group_id = super_group_id  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryDeviceGroupListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.group_types is not None:
            result['GroupTypes'] = self.group_types
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.super_group_id is not None:
            result['SuperGroupId'] = self.super_group_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('GroupTypes') is not None:
            self.group_types = m.get('GroupTypes')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('SuperGroupId') is not None:
            self.super_group_id = m.get('SuperGroupId')
        return self


class QueryDeviceGroupListResponseDataGroupInfo(TeaModel):
    def __init__(self, group_desc=None, group_id=None, group_name=None, group_type=None, utc_create=None):
        self.group_desc = group_desc  # type: str
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str
        self.group_type = group_type  # type: str
        self.utc_create = utc_create  # type: str

    def validate(self):
        self.validate_required(self.group_desc, 'group_desc')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')
        self.validate_required(self.group_type, 'group_type')
        self.validate_required(self.utc_create, 'utc_create')

    def to_map(self):
        _map = super(QueryDeviceGroupListResponseDataGroupInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_desc is not None:
            result['GroupDesc'] = self.group_desc
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.group_type is not None:
            result['GroupType'] = self.group_type
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupDesc') is not None:
            self.group_desc = m.get('GroupDesc')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('GroupType') is not None:
            self.group_type = m.get('GroupType')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        return self


class QueryDeviceGroupListResponseData(TeaModel):
    def __init__(self, group_info=None):
        self.group_info = group_info  # type: list[QueryDeviceGroupListResponseDataGroupInfo]

    def validate(self):
        self.validate_required(self.group_info, 'group_info')
        if self.group_info:
            for k in self.group_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceGroupListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['GroupInfo'] = []
        if self.group_info is not None:
            for k in self.group_info:
                result['GroupInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.group_info = []
        if m.get('GroupInfo') is not None:
            for k in m.get('GroupInfo'):
                temp_model = QueryDeviceGroupListResponseDataGroupInfo()
                self.group_info.append(temp_model.from_map(k))
        return self


class QueryDeviceGroupListResponse(TeaModel):
    def __init__(self, code=None, current_page=None, error_message=None, page_count=None, page_size=None,
                 request_id=None, success=None, total=None, data=None):
        self.code = code  # type: str
        self.current_page = current_page  # type: int
        self.error_message = error_message  # type: str
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: QueryDeviceGroupListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceGroupListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = QueryDeviceGroupListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceGroupTagListRequest(TeaModel):
    def __init__(self, group_id=None, group_type=None, iot_instance_id=None):
        self.group_id = group_id  # type: str
        self.group_type = group_type  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(QueryDeviceGroupTagListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_type is not None:
            result['GroupType'] = self.group_type
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupType') is not None:
            self.group_type = m.get('GroupType')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QueryDeviceGroupTagListResponseDataGroupTagInfo(TeaModel):
    def __init__(self, tag_key=None, tag_value=None):
        self.tag_key = tag_key  # type: str
        self.tag_value = tag_value  # type: str

    def validate(self):
        self.validate_required(self.tag_key, 'tag_key')
        self.validate_required(self.tag_value, 'tag_value')

    def to_map(self):
        _map = super(QueryDeviceGroupTagListResponseDataGroupTagInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tag_key is not None:
            result['TagKey'] = self.tag_key
        if self.tag_value is not None:
            result['TagValue'] = self.tag_value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TagKey') is not None:
            self.tag_key = m.get('TagKey')
        if m.get('TagValue') is not None:
            self.tag_value = m.get('TagValue')
        return self


class QueryDeviceGroupTagListResponseData(TeaModel):
    def __init__(self, group_tag_info=None):
        self.group_tag_info = group_tag_info  # type: list[QueryDeviceGroupTagListResponseDataGroupTagInfo]

    def validate(self):
        self.validate_required(self.group_tag_info, 'group_tag_info')
        if self.group_tag_info:
            for k in self.group_tag_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceGroupTagListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['GroupTagInfo'] = []
        if self.group_tag_info is not None:
            for k in self.group_tag_info:
                result['GroupTagInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.group_tag_info = []
        if m.get('GroupTagInfo') is not None:
            for k in m.get('GroupTagInfo'):
                temp_model = QueryDeviceGroupTagListResponseDataGroupTagInfo()
                self.group_tag_info.append(temp_model.from_map(k))
        return self


class QueryDeviceGroupTagListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceGroupTagListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceGroupTagListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceGroupTagListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceInfoRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryDeviceInfoRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceInfoResponseData(TeaModel):
    def __init__(self, device_name=None, device_secret=None, iot_id=None, nickname=None, product_key=None):
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.iot_id = iot_id  # type: str
        self.nickname = nickname  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.nickname, 'nickname')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryDeviceInfoResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceInfoResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceInfoResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceInfoResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceInfoResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceListByDeviceGroupRequest(TeaModel):
    def __init__(self, current_page=None, group_id=None, iot_instance_id=None, page_size=None):
        self.current_page = current_page  # type: int
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(QueryDeviceListByDeviceGroupRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryDeviceListByDeviceGroupResponseDataSimpleDeviceInfo(TeaModel):
    def __init__(self, device_name=None, iot_id=None, product_key=None, product_name=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')

    def to_map(self):
        _map = super(QueryDeviceListByDeviceGroupResponseDataSimpleDeviceInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        return self


class QueryDeviceListByDeviceGroupResponseData(TeaModel):
    def __init__(self, simple_device_info=None):
        self.simple_device_info = simple_device_info  # type: list[QueryDeviceListByDeviceGroupResponseDataSimpleDeviceInfo]

    def validate(self):
        self.validate_required(self.simple_device_info, 'simple_device_info')
        if self.simple_device_info:
            for k in self.simple_device_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceListByDeviceGroupResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['SimpleDeviceInfo'] = []
        if self.simple_device_info is not None:
            for k in self.simple_device_info:
                result['SimpleDeviceInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.simple_device_info = []
        if m.get('SimpleDeviceInfo') is not None:
            for k in m.get('SimpleDeviceInfo'):
                temp_model = QueryDeviceListByDeviceGroupResponseDataSimpleDeviceInfo()
                self.simple_device_info.append(temp_model.from_map(k))
        return self


class QueryDeviceListByDeviceGroupResponse(TeaModel):
    def __init__(self, code=None, error_message=None, page=None, page_count=None, page_size=None, request_id=None,
                 success=None, total=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.page = page  # type: int
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: QueryDeviceListByDeviceGroupResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceListByDeviceGroupResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page is not None:
            result['Page'] = self.page
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = QueryDeviceListByDeviceGroupResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceOriginalEventDataRequest(TeaModel):
    def __init__(self, asc=None, device_name=None, end_time=None, identifier=None, iot_id=None, iot_instance_id=None,
                 next_page_token=None, page_size=None, product_key=None, start_time=None):
        self.asc = asc  # type: int
        self.device_name = device_name  # type: str
        self.end_time = end_time  # type: long
        self.identifier = identifier  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.next_page_token = next_page_token  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.start_time = start_time  # type: long

    def validate(self):
        self.validate_required(self.asc, 'asc')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.start_time, 'start_time')

    def to_map(self):
        _map = super(QueryDeviceOriginalEventDataRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.asc is not None:
            result['Asc'] = self.asc
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.next_page_token is not None:
            result['NextPageToken'] = self.next_page_token
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Asc') is not None:
            self.asc = m.get('Asc')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('NextPageToken') is not None:
            self.next_page_token = m.get('NextPageToken')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class QueryDeviceOriginalEventDataResponseDataListEventInfo(TeaModel):
    def __init__(self, event_type=None, identifier=None, name=None, output_data=None, time=None):
        self.event_type = event_type  # type: str
        self.identifier = identifier  # type: str
        self.name = name  # type: str
        self.output_data = output_data  # type: str
        self.time = time  # type: str

    def validate(self):
        self.validate_required(self.event_type, 'event_type')
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.name, 'name')
        self.validate_required(self.output_data, 'output_data')
        self.validate_required(self.time, 'time')

    def to_map(self):
        _map = super(QueryDeviceOriginalEventDataResponseDataListEventInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.event_type is not None:
            result['EventType'] = self.event_type
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.name is not None:
            result['Name'] = self.name
        if self.output_data is not None:
            result['OutputData'] = self.output_data
        if self.time is not None:
            result['Time'] = self.time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('EventType') is not None:
            self.event_type = m.get('EventType')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('OutputData') is not None:
            self.output_data = m.get('OutputData')
        if m.get('Time') is not None:
            self.time = m.get('Time')
        return self


class QueryDeviceOriginalEventDataResponseDataList(TeaModel):
    def __init__(self, event_info=None):
        self.event_info = event_info  # type: list[QueryDeviceOriginalEventDataResponseDataListEventInfo]

    def validate(self):
        self.validate_required(self.event_info, 'event_info')
        if self.event_info:
            for k in self.event_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalEventDataResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['EventInfo'] = []
        if self.event_info is not None:
            for k in self.event_info:
                result['EventInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.event_info = []
        if m.get('EventInfo') is not None:
            for k in m.get('EventInfo'):
                temp_model = QueryDeviceOriginalEventDataResponseDataListEventInfo()
                self.event_info.append(temp_model.from_map(k))
        return self


class QueryDeviceOriginalEventDataResponseData(TeaModel):
    def __init__(self, next_page_token=None, next_valid=None, list=None):
        self.next_page_token = next_page_token  # type: str
        self.next_valid = next_valid  # type: bool
        self.list = list  # type: QueryDeviceOriginalEventDataResponseDataList

    def validate(self):
        self.validate_required(self.next_page_token, 'next_page_token')
        self.validate_required(self.next_valid, 'next_valid')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalEventDataResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.next_page_token is not None:
            result['NextPageToken'] = self.next_page_token
        if self.next_valid is not None:
            result['NextValid'] = self.next_valid
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('NextPageToken') is not None:
            self.next_page_token = m.get('NextPageToken')
        if m.get('NextValid') is not None:
            self.next_valid = m.get('NextValid')
        if m.get('List') is not None:
            temp_model = QueryDeviceOriginalEventDataResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDeviceOriginalEventDataResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceOriginalEventDataResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalEventDataResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceOriginalEventDataResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceOriginalPropertyDataRequest(TeaModel):
    def __init__(self, asc=None, device_name=None, end_time=None, identifier=None, iot_id=None, iot_instance_id=None,
                 next_page_token=None, page_size=None, product_key=None, start_time=None):
        self.asc = asc  # type: int
        self.device_name = device_name  # type: str
        self.end_time = end_time  # type: long
        self.identifier = identifier  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.next_page_token = next_page_token  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.start_time = start_time  # type: long

    def validate(self):
        self.validate_required(self.asc, 'asc')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.start_time, 'start_time')

    def to_map(self):
        _map = super(QueryDeviceOriginalPropertyDataRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.asc is not None:
            result['Asc'] = self.asc
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.next_page_token is not None:
            result['NextPageToken'] = self.next_page_token
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Asc') is not None:
            self.asc = m.get('Asc')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('NextPageToken') is not None:
            self.next_page_token = m.get('NextPageToken')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class QueryDeviceOriginalPropertyDataResponseDataListPropertyInfo(TeaModel):
    def __init__(self, time=None, value=None):
        self.time = time  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.time, 'time')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(QueryDeviceOriginalPropertyDataResponseDataListPropertyInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.time is not None:
            result['Time'] = self.time
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Time') is not None:
            self.time = m.get('Time')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class QueryDeviceOriginalPropertyDataResponseDataList(TeaModel):
    def __init__(self, property_info=None):
        self.property_info = property_info  # type: list[QueryDeviceOriginalPropertyDataResponseDataListPropertyInfo]

    def validate(self):
        self.validate_required(self.property_info, 'property_info')
        if self.property_info:
            for k in self.property_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalPropertyDataResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['PropertyInfo'] = []
        if self.property_info is not None:
            for k in self.property_info:
                result['PropertyInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.property_info = []
        if m.get('PropertyInfo') is not None:
            for k in m.get('PropertyInfo'):
                temp_model = QueryDeviceOriginalPropertyDataResponseDataListPropertyInfo()
                self.property_info.append(temp_model.from_map(k))
        return self


class QueryDeviceOriginalPropertyDataResponseData(TeaModel):
    def __init__(self, next_valid=None, next_page_token=None, list=None):
        self.next_valid = next_valid  # type: bool
        self.next_page_token = next_page_token  # type: str
        self.list = list  # type: QueryDeviceOriginalPropertyDataResponseDataList

    def validate(self):
        self.validate_required(self.next_valid, 'next_valid')
        self.validate_required(self.next_page_token, 'next_page_token')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalPropertyDataResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.next_valid is not None:
            result['NextValid'] = self.next_valid
        if self.next_page_token is not None:
            result['nextPageToken'] = self.next_page_token
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('NextValid') is not None:
            self.next_valid = m.get('NextValid')
        if m.get('nextPageToken') is not None:
            self.next_page_token = m.get('nextPageToken')
        if m.get('List') is not None:
            temp_model = QueryDeviceOriginalPropertyDataResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDeviceOriginalPropertyDataResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceOriginalPropertyDataResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalPropertyDataResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceOriginalPropertyDataResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceOriginalPropertyStatusRequest(TeaModel):
    def __init__(self, asc=None, device_name=None, iot_id=None, iot_instance_id=None, next_page_token=None,
                 page_size=None, product_key=None):
        self.asc = asc  # type: int
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.next_page_token = next_page_token  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.asc, 'asc')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryDeviceOriginalPropertyStatusRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.asc is not None:
            result['Asc'] = self.asc
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.next_page_token is not None:
            result['NextPageToken'] = self.next_page_token
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Asc') is not None:
            self.asc = m.get('Asc')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('NextPageToken') is not None:
            self.next_page_token = m.get('NextPageToken')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceOriginalPropertyStatusResponseDataListPropertyStatusDataInfo(TeaModel):
    def __init__(self, identifier=None, time=None, value=None):
        self.identifier = identifier  # type: str
        self.time = time  # type: long
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.time, 'time')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(QueryDeviceOriginalPropertyStatusResponseDataListPropertyStatusDataInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.time is not None:
            result['Time'] = self.time
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('Time') is not None:
            self.time = m.get('Time')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class QueryDeviceOriginalPropertyStatusResponseDataList(TeaModel):
    def __init__(self, property_status_data_info=None):
        self.property_status_data_info = property_status_data_info  # type: list[QueryDeviceOriginalPropertyStatusResponseDataListPropertyStatusDataInfo]

    def validate(self):
        self.validate_required(self.property_status_data_info, 'property_status_data_info')
        if self.property_status_data_info:
            for k in self.property_status_data_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalPropertyStatusResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['PropertyStatusDataInfo'] = []
        if self.property_status_data_info is not None:
            for k in self.property_status_data_info:
                result['PropertyStatusDataInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.property_status_data_info = []
        if m.get('PropertyStatusDataInfo') is not None:
            for k in m.get('PropertyStatusDataInfo'):
                temp_model = QueryDeviceOriginalPropertyStatusResponseDataListPropertyStatusDataInfo()
                self.property_status_data_info.append(temp_model.from_map(k))
        return self


class QueryDeviceOriginalPropertyStatusResponseData(TeaModel):
    def __init__(self, next_page_token=None, next_valid=None, list=None):
        self.next_page_token = next_page_token  # type: str
        self.next_valid = next_valid  # type: bool
        self.list = list  # type: QueryDeviceOriginalPropertyStatusResponseDataList

    def validate(self):
        self.validate_required(self.next_page_token, 'next_page_token')
        self.validate_required(self.next_valid, 'next_valid')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalPropertyStatusResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.next_page_token is not None:
            result['NextPageToken'] = self.next_page_token
        if self.next_valid is not None:
            result['NextValid'] = self.next_valid
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('NextPageToken') is not None:
            self.next_page_token = m.get('NextPageToken')
        if m.get('NextValid') is not None:
            self.next_valid = m.get('NextValid')
        if m.get('List') is not None:
            temp_model = QueryDeviceOriginalPropertyStatusResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDeviceOriginalPropertyStatusResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceOriginalPropertyStatusResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalPropertyStatusResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceOriginalPropertyStatusResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceOriginalServiceDataRequest(TeaModel):
    def __init__(self, asc=None, device_name=None, end_time=None, identifier=None, iot_id=None, iot_instance_id=None,
                 next_page_token=None, page_size=None, product_key=None, start_time=None):
        self.asc = asc  # type: int
        self.device_name = device_name  # type: str
        self.end_time = end_time  # type: long
        self.identifier = identifier  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.next_page_token = next_page_token  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.start_time = start_time  # type: long

    def validate(self):
        self.validate_required(self.asc, 'asc')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.start_time, 'start_time')

    def to_map(self):
        _map = super(QueryDeviceOriginalServiceDataRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.asc is not None:
            result['Asc'] = self.asc
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.next_page_token is not None:
            result['NextPageToken'] = self.next_page_token
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Asc') is not None:
            self.asc = m.get('Asc')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('NextPageToken') is not None:
            self.next_page_token = m.get('NextPageToken')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class QueryDeviceOriginalServiceDataResponseDataListServiceInfo(TeaModel):
    def __init__(self, identifier=None, input_data=None, name=None, output_data=None, time=None):
        self.identifier = identifier  # type: str
        self.input_data = input_data  # type: str
        self.name = name  # type: str
        self.output_data = output_data  # type: str
        self.time = time  # type: str

    def validate(self):
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.input_data, 'input_data')
        self.validate_required(self.name, 'name')
        self.validate_required(self.output_data, 'output_data')
        self.validate_required(self.time, 'time')

    def to_map(self):
        _map = super(QueryDeviceOriginalServiceDataResponseDataListServiceInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.input_data is not None:
            result['InputData'] = self.input_data
        if self.name is not None:
            result['Name'] = self.name
        if self.output_data is not None:
            result['OutputData'] = self.output_data
        if self.time is not None:
            result['Time'] = self.time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('InputData') is not None:
            self.input_data = m.get('InputData')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('OutputData') is not None:
            self.output_data = m.get('OutputData')
        if m.get('Time') is not None:
            self.time = m.get('Time')
        return self


class QueryDeviceOriginalServiceDataResponseDataList(TeaModel):
    def __init__(self, service_info=None):
        self.service_info = service_info  # type: list[QueryDeviceOriginalServiceDataResponseDataListServiceInfo]

    def validate(self):
        self.validate_required(self.service_info, 'service_info')
        if self.service_info:
            for k in self.service_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalServiceDataResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ServiceInfo'] = []
        if self.service_info is not None:
            for k in self.service_info:
                result['ServiceInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.service_info = []
        if m.get('ServiceInfo') is not None:
            for k in m.get('ServiceInfo'):
                temp_model = QueryDeviceOriginalServiceDataResponseDataListServiceInfo()
                self.service_info.append(temp_model.from_map(k))
        return self


class QueryDeviceOriginalServiceDataResponseData(TeaModel):
    def __init__(self, next_page_token=None, next_valid=None, list=None):
        self.next_page_token = next_page_token  # type: str
        self.next_valid = next_valid  # type: bool
        self.list = list  # type: QueryDeviceOriginalServiceDataResponseDataList

    def validate(self):
        self.validate_required(self.next_page_token, 'next_page_token')
        self.validate_required(self.next_valid, 'next_valid')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalServiceDataResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.next_page_token is not None:
            result['NextPageToken'] = self.next_page_token
        if self.next_valid is not None:
            result['NextValid'] = self.next_valid
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('NextPageToken') is not None:
            self.next_page_token = m.get('NextPageToken')
        if m.get('NextValid') is not None:
            self.next_valid = m.get('NextValid')
        if m.get('List') is not None:
            temp_model = QueryDeviceOriginalServiceDataResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDeviceOriginalServiceDataResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceOriginalServiceDataResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceOriginalServiceDataResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceOriginalServiceDataResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDevicePropRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryDevicePropRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDevicePropResponse(TeaModel):
    def __init__(self, code=None, error_message=None, props=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.props = props  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.props, 'props')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(QueryDevicePropResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.props is not None:
            result['Props'] = self.props
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Props') is not None:
            self.props = m.get('Props')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class QueryDevicePropertiesDataRequest(TeaModel):
    def __init__(self, asc=None, device_name=None, end_time=None, identifier=None, iot_id=None, iot_instance_id=None,
                 page_size=None, product_key=None, start_time=None):
        self.asc = asc  # type: int
        self.device_name = device_name  # type: str
        self.end_time = end_time  # type: long
        self.identifier = identifier  # type: list[str]
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.start_time = start_time  # type: long

    def validate(self):
        self.validate_required(self.asc, 'asc')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.start_time, 'start_time')

    def to_map(self):
        _map = super(QueryDevicePropertiesDataRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.asc is not None:
            result['Asc'] = self.asc
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Asc') is not None:
            self.asc = m.get('Asc')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfoListPropertyInfo(TeaModel):
    def __init__(self, time=None, value=None):
        self.time = time  # type: long
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.time, 'time')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfoListPropertyInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.time is not None:
            result['Time'] = self.time
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Time') is not None:
            self.time = m.get('Time')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfoList(TeaModel):
    def __init__(self, property_info=None):
        self.property_info = property_info  # type: list[QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfoListPropertyInfo]

    def validate(self):
        self.validate_required(self.property_info, 'property_info')
        if self.property_info:
            for k in self.property_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfoList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['PropertyInfo'] = []
        if self.property_info is not None:
            for k in self.property_info:
                result['PropertyInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.property_info = []
        if m.get('PropertyInfo') is not None:
            for k in m.get('PropertyInfo'):
                temp_model = QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfoListPropertyInfo()
                self.property_info.append(temp_model.from_map(k))
        return self


class QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfo(TeaModel):
    def __init__(self, identifier=None, list=None):
        self.identifier = identifier  # type: str
        self.list = list  # type: QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfoList

    def validate(self):
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('List') is not None:
            temp_model = QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfoList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDevicePropertiesDataResponsePropertyDataInfos(TeaModel):
    def __init__(self, property_data_info=None):
        self.property_data_info = property_data_info  # type: list[QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfo]

    def validate(self):
        self.validate_required(self.property_data_info, 'property_data_info')
        if self.property_data_info:
            for k in self.property_data_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDevicePropertiesDataResponsePropertyDataInfos, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['PropertyDataInfo'] = []
        if self.property_data_info is not None:
            for k in self.property_data_info:
                result['PropertyDataInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.property_data_info = []
        if m.get('PropertyDataInfo') is not None:
            for k in m.get('PropertyDataInfo'):
                temp_model = QueryDevicePropertiesDataResponsePropertyDataInfosPropertyDataInfo()
                self.property_data_info.append(temp_model.from_map(k))
        return self


class QueryDevicePropertiesDataResponse(TeaModel):
    def __init__(self, code=None, error_message=None, next_time=None, next_valid=None, request_id=None, success=None,
                 property_data_infos=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.next_time = next_time  # type: long
        self.next_valid = next_valid  # type: bool
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.property_data_infos = property_data_infos  # type: QueryDevicePropertiesDataResponsePropertyDataInfos

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.next_time, 'next_time')
        self.validate_required(self.next_valid, 'next_valid')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.property_data_infos, 'property_data_infos')
        if self.property_data_infos:
            self.property_data_infos.validate()

    def to_map(self):
        _map = super(QueryDevicePropertiesDataResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.next_time is not None:
            result['NextTime'] = self.next_time
        if self.next_valid is not None:
            result['NextValid'] = self.next_valid
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.property_data_infos is not None:
            result['PropertyDataInfos'] = self.property_data_infos.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('NextTime') is not None:
            self.next_time = m.get('NextTime')
        if m.get('NextValid') is not None:
            self.next_valid = m.get('NextValid')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('PropertyDataInfos') is not None:
            temp_model = QueryDevicePropertiesDataResponsePropertyDataInfos()
            self.property_data_infos = temp_model.from_map(m['PropertyDataInfos'])
        return self


class QueryDevicePropertyDataRequest(TeaModel):
    def __init__(self, asc=None, device_name=None, end_time=None, identifier=None, iot_id=None, iot_instance_id=None,
                 page_size=None, product_key=None, start_time=None):
        self.asc = asc  # type: int
        self.device_name = device_name  # type: str
        self.end_time = end_time  # type: long
        self.identifier = identifier  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.start_time = start_time  # type: long

    def validate(self):
        self.validate_required(self.asc, 'asc')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.start_time, 'start_time')

    def to_map(self):
        _map = super(QueryDevicePropertyDataRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.asc is not None:
            result['Asc'] = self.asc
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Asc') is not None:
            self.asc = m.get('Asc')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class QueryDevicePropertyDataResponseDataListPropertyInfo(TeaModel):
    def __init__(self, time=None, value=None):
        self.time = time  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.time, 'time')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(QueryDevicePropertyDataResponseDataListPropertyInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.time is not None:
            result['Time'] = self.time
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Time') is not None:
            self.time = m.get('Time')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class QueryDevicePropertyDataResponseDataList(TeaModel):
    def __init__(self, property_info=None):
        self.property_info = property_info  # type: list[QueryDevicePropertyDataResponseDataListPropertyInfo]

    def validate(self):
        self.validate_required(self.property_info, 'property_info')
        if self.property_info:
            for k in self.property_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDevicePropertyDataResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['PropertyInfo'] = []
        if self.property_info is not None:
            for k in self.property_info:
                result['PropertyInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.property_info = []
        if m.get('PropertyInfo') is not None:
            for k in m.get('PropertyInfo'):
                temp_model = QueryDevicePropertyDataResponseDataListPropertyInfo()
                self.property_info.append(temp_model.from_map(k))
        return self


class QueryDevicePropertyDataResponseData(TeaModel):
    def __init__(self, next_time=None, next_valid=None, list=None):
        self.next_time = next_time  # type: long
        self.next_valid = next_valid  # type: bool
        self.list = list  # type: QueryDevicePropertyDataResponseDataList

    def validate(self):
        self.validate_required(self.next_time, 'next_time')
        self.validate_required(self.next_valid, 'next_valid')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDevicePropertyDataResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.next_time is not None:
            result['NextTime'] = self.next_time
        if self.next_valid is not None:
            result['NextValid'] = self.next_valid
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('NextTime') is not None:
            self.next_time = m.get('NextTime')
        if m.get('NextValid') is not None:
            self.next_valid = m.get('NextValid')
        if m.get('List') is not None:
            temp_model = QueryDevicePropertyDataResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDevicePropertyDataResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDevicePropertyDataResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDevicePropertyDataResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDevicePropertyDataResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDevicePropertyStatusRequest(TeaModel):
    def __init__(self, device_name=None, function_block_id=None, iot_id=None, iot_instance_id=None,
                 product_key=None):
        self.device_name = device_name  # type: str
        self.function_block_id = function_block_id  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryDevicePropertyStatusRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDevicePropertyStatusResponseDataListPropertyStatusInfo(TeaModel):
    def __init__(self, data_type=None, identifier=None, name=None, time=None, unit=None, value=None):
        self.data_type = data_type  # type: str
        self.identifier = identifier  # type: str
        self.name = name  # type: str
        self.time = time  # type: str
        self.unit = unit  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.data_type, 'data_type')
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.name, 'name')
        self.validate_required(self.time, 'time')
        self.validate_required(self.unit, 'unit')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(QueryDevicePropertyStatusResponseDataListPropertyStatusInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_type is not None:
            result['DataType'] = self.data_type
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.name is not None:
            result['Name'] = self.name
        if self.time is not None:
            result['Time'] = self.time
        if self.unit is not None:
            result['Unit'] = self.unit
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataType') is not None:
            self.data_type = m.get('DataType')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Time') is not None:
            self.time = m.get('Time')
        if m.get('Unit') is not None:
            self.unit = m.get('Unit')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class QueryDevicePropertyStatusResponseDataList(TeaModel):
    def __init__(self, property_status_info=None):
        self.property_status_info = property_status_info  # type: list[QueryDevicePropertyStatusResponseDataListPropertyStatusInfo]

    def validate(self):
        self.validate_required(self.property_status_info, 'property_status_info')
        if self.property_status_info:
            for k in self.property_status_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDevicePropertyStatusResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['PropertyStatusInfo'] = []
        if self.property_status_info is not None:
            for k in self.property_status_info:
                result['PropertyStatusInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.property_status_info = []
        if m.get('PropertyStatusInfo') is not None:
            for k in m.get('PropertyStatusInfo'):
                temp_model = QueryDevicePropertyStatusResponseDataListPropertyStatusInfo()
                self.property_status_info.append(temp_model.from_map(k))
        return self


class QueryDevicePropertyStatusResponseData(TeaModel):
    def __init__(self, list=None):
        self.list = list  # type: QueryDevicePropertyStatusResponseDataList

    def validate(self):
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDevicePropertyStatusResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('List') is not None:
            temp_model = QueryDevicePropertyStatusResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDevicePropertyStatusResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDevicePropertyStatusResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDevicePropertyStatusResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDevicePropertyStatusResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceServiceDataRequest(TeaModel):
    def __init__(self, asc=None, device_name=None, end_time=None, identifier=None, iot_id=None, iot_instance_id=None,
                 page_size=None, product_key=None, start_time=None):
        self.asc = asc  # type: int
        self.device_name = device_name  # type: str
        self.end_time = end_time  # type: long
        self.identifier = identifier  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.start_time = start_time  # type: long

    def validate(self):
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.start_time, 'start_time')

    def to_map(self):
        _map = super(QueryDeviceServiceDataRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.asc is not None:
            result['Asc'] = self.asc
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Asc') is not None:
            self.asc = m.get('Asc')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class QueryDeviceServiceDataResponseDataListServiceInfo(TeaModel):
    def __init__(self, identifier=None, input_data=None, name=None, output_data=None, time=None):
        self.identifier = identifier  # type: str
        self.input_data = input_data  # type: str
        self.name = name  # type: str
        self.output_data = output_data  # type: str
        self.time = time  # type: str

    def validate(self):
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.input_data, 'input_data')
        self.validate_required(self.name, 'name')
        self.validate_required(self.output_data, 'output_data')
        self.validate_required(self.time, 'time')

    def to_map(self):
        _map = super(QueryDeviceServiceDataResponseDataListServiceInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.input_data is not None:
            result['InputData'] = self.input_data
        if self.name is not None:
            result['Name'] = self.name
        if self.output_data is not None:
            result['OutputData'] = self.output_data
        if self.time is not None:
            result['Time'] = self.time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('InputData') is not None:
            self.input_data = m.get('InputData')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('OutputData') is not None:
            self.output_data = m.get('OutputData')
        if m.get('Time') is not None:
            self.time = m.get('Time')
        return self


class QueryDeviceServiceDataResponseDataList(TeaModel):
    def __init__(self, service_info=None):
        self.service_info = service_info  # type: list[QueryDeviceServiceDataResponseDataListServiceInfo]

    def validate(self):
        self.validate_required(self.service_info, 'service_info')
        if self.service_info:
            for k in self.service_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceServiceDataResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ServiceInfo'] = []
        if self.service_info is not None:
            for k in self.service_info:
                result['ServiceInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.service_info = []
        if m.get('ServiceInfo') is not None:
            for k in m.get('ServiceInfo'):
                temp_model = QueryDeviceServiceDataResponseDataListServiceInfo()
                self.service_info.append(temp_model.from_map(k))
        return self


class QueryDeviceServiceDataResponseData(TeaModel):
    def __init__(self, next_time=None, next_valid=None, list=None):
        self.next_time = next_time  # type: long
        self.next_valid = next_valid  # type: bool
        self.list = list  # type: QueryDeviceServiceDataResponseDataList

    def validate(self):
        self.validate_required(self.next_time, 'next_time')
        self.validate_required(self.next_valid, 'next_valid')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDeviceServiceDataResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.next_time is not None:
            result['NextTime'] = self.next_time
        if self.next_valid is not None:
            result['NextValid'] = self.next_valid
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('NextTime') is not None:
            self.next_time = m.get('NextTime')
        if m.get('NextValid') is not None:
            self.next_valid = m.get('NextValid')
        if m.get('List') is not None:
            temp_model = QueryDeviceServiceDataResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDeviceServiceDataResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceServiceDataResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceServiceDataResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceServiceDataResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceSpeechRequest(TeaModel):
    def __init__(self, iot_id=None, iot_instance_id=None, page_id=None, page_size=None):
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(QueryDeviceSpeechRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryDeviceSpeechResponseDataListItems(TeaModel):
    def __init__(self, audio_format=None, biz_code=None, size=None):
        self.audio_format = audio_format  # type: str
        self.biz_code = biz_code  # type: str
        self.size = size  # type: float

    def validate(self):
        self.validate_required(self.audio_format, 'audio_format')
        self.validate_required(self.biz_code, 'biz_code')
        self.validate_required(self.size, 'size')

    def to_map(self):
        _map = super(QueryDeviceSpeechResponseDataListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.biz_code is not None:
            result['BizCode'] = self.biz_code
        if self.size is not None:
            result['Size'] = self.size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('BizCode') is not None:
            self.biz_code = m.get('BizCode')
        if m.get('Size') is not None:
            self.size = m.get('Size')
        return self


class QueryDeviceSpeechResponseDataList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QueryDeviceSpeechResponseDataListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceSpeechResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QueryDeviceSpeechResponseDataListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QueryDeviceSpeechResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QueryDeviceSpeechResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDeviceSpeechResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QueryDeviceSpeechResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDeviceSpeechResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceSpeechResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceSpeechResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceSpeechResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceStatisticsRequest(TeaModel):
    def __init__(self, group_id=None, iot_instance_id=None, product_key=None):
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryDeviceStatisticsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceStatisticsResponseData(TeaModel):
    def __init__(self, active_count=None, device_count=None, online_count=None):
        self.active_count = active_count  # type: long
        self.device_count = device_count  # type: long
        self.online_count = online_count  # type: long

    def validate(self):
        self.validate_required(self.active_count, 'active_count')
        self.validate_required(self.device_count, 'device_count')
        self.validate_required(self.online_count, 'online_count')

    def to_map(self):
        _map = super(QueryDeviceStatisticsResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.active_count is not None:
            result['activeCount'] = self.active_count
        if self.device_count is not None:
            result['deviceCount'] = self.device_count
        if self.online_count is not None:
            result['onlineCount'] = self.online_count
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('activeCount') is not None:
            self.active_count = m.get('activeCount')
        if m.get('deviceCount') is not None:
            self.device_count = m.get('deviceCount')
        if m.get('onlineCount') is not None:
            self.online_count = m.get('onlineCount')
        return self


class QueryDeviceStatisticsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceStatisticsResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceStatisticsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceStatisticsResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDeviceSubTopicRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryDeviceSubTopicRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryDeviceSubTopicResponseTopicList(TeaModel):
    def __init__(self, timestamp=None, topic_name=None):
        self.timestamp = timestamp  # type: long
        self.topic_name = topic_name  # type: str

    def validate(self):
        self.validate_required(self.timestamp, 'timestamp')
        self.validate_required(self.topic_name, 'topic_name')

    def to_map(self):
        _map = super(QueryDeviceSubTopicResponseTopicList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.timestamp is not None:
            result['Timestamp'] = self.timestamp
        if self.topic_name is not None:
            result['TopicName'] = self.topic_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Timestamp') is not None:
            self.timestamp = m.get('Timestamp')
        if m.get('TopicName') is not None:
            self.topic_name = m.get('TopicName')
        return self


class QueryDeviceSubTopicResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, topic_list=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.topic_list = topic_list  # type: list[QueryDeviceSubTopicResponseTopicList]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.topic_list, 'topic_list')
        if self.topic_list:
            for k in self.topic_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDeviceSubTopicResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        result['TopicList'] = []
        if self.topic_list is not None:
            for k in self.topic_list:
                result['TopicList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        self.topic_list = []
        if m.get('TopicList') is not None:
            for k in m.get('TopicList'):
                temp_model = QueryDeviceSubTopicResponseTopicList()
                self.topic_list.append(temp_model.from_map(k))
        return self


class QueryDeviceTunnelRequest(TeaModel):
    def __init__(self, tunnel_id=None, iot_instance_id=None):
        self.tunnel_id = tunnel_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.tunnel_id, 'tunnel_id')

    def to_map(self):
        _map = super(QueryDeviceTunnelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tunnel_id is not None:
            result['TunnelId'] = self.tunnel_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TunnelId') is not None:
            self.tunnel_id = m.get('TunnelId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QueryDeviceTunnelResponseData(TeaModel):
    def __init__(self, description=None, device_conn_state=None, device_name=None, iot_id=None, product_key=None,
                 product_name=None, source_conn_state=None, tunnel_id=None, tunnel_state=None, udi=None, utc_closed=None,
                 utc_created=None):
        self.description = description  # type: str
        self.device_conn_state = device_conn_state  # type: str
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str
        self.source_conn_state = source_conn_state  # type: str
        self.tunnel_id = tunnel_id  # type: str
        self.tunnel_state = tunnel_state  # type: str
        self.udi = udi  # type: str
        self.utc_closed = utc_closed  # type: str
        self.utc_created = utc_created  # type: str

    def validate(self):
        self.validate_required(self.description, 'description')
        self.validate_required(self.device_conn_state, 'device_conn_state')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')
        self.validate_required(self.source_conn_state, 'source_conn_state')
        self.validate_required(self.tunnel_id, 'tunnel_id')
        self.validate_required(self.tunnel_state, 'tunnel_state')
        self.validate_required(self.udi, 'udi')
        self.validate_required(self.utc_closed, 'utc_closed')
        self.validate_required(self.utc_created, 'utc_created')

    def to_map(self):
        _map = super(QueryDeviceTunnelResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.device_conn_state is not None:
            result['DeviceConnState'] = self.device_conn_state
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.source_conn_state is not None:
            result['SourceConnState'] = self.source_conn_state
        if self.tunnel_id is not None:
            result['TunnelId'] = self.tunnel_id
        if self.tunnel_state is not None:
            result['TunnelState'] = self.tunnel_state
        if self.udi is not None:
            result['Udi'] = self.udi
        if self.utc_closed is not None:
            result['UtcClosed'] = self.utc_closed
        if self.utc_created is not None:
            result['UtcCreated'] = self.utc_created
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('DeviceConnState') is not None:
            self.device_conn_state = m.get('DeviceConnState')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('SourceConnState') is not None:
            self.source_conn_state = m.get('SourceConnState')
        if m.get('TunnelId') is not None:
            self.tunnel_id = m.get('TunnelId')
        if m.get('TunnelState') is not None:
            self.tunnel_state = m.get('TunnelState')
        if m.get('Udi') is not None:
            self.udi = m.get('Udi')
        if m.get('UtcClosed') is not None:
            self.utc_closed = m.get('UtcClosed')
        if m.get('UtcCreated') is not None:
            self.utc_created = m.get('UtcCreated')
        return self


class QueryDeviceTunnelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDeviceTunnelResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDeviceTunnelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDeviceTunnelResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDevicesHotStorageDataRequest(TeaModel):
    def __init__(self, asc=None, device_name=None, end_time=None, identifier=None, iot_id=None, iot_instance_id=None,
                 next_page_token=None, page_size=None, product_key=None, start_time=None, user_topic=None):
        self.asc = asc  # type: int
        self.device_name = device_name  # type: str
        self.end_time = end_time  # type: long
        self.identifier = identifier  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.next_page_token = next_page_token  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.start_time = start_time  # type: long
        self.user_topic = user_topic  # type: str

    def validate(self):
        self.validate_required(self.asc, 'asc')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.iot_instance_id, 'iot_instance_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.start_time, 'start_time')
        self.validate_required(self.user_topic, 'user_topic')

    def to_map(self):
        _map = super(QueryDevicesHotStorageDataRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.asc is not None:
            result['Asc'] = self.asc
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.next_page_token is not None:
            result['NextPageToken'] = self.next_page_token
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        if self.user_topic is not None:
            result['UserTopic'] = self.user_topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Asc') is not None:
            self.asc = m.get('Asc')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('NextPageToken') is not None:
            self.next_page_token = m.get('NextPageToken')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        if m.get('UserTopic') is not None:
            self.user_topic = m.get('UserTopic')
        return self


class QueryDevicesHotStorageDataResponseDataListPropertyInfo(TeaModel):
    def __init__(self, time=None, value=None):
        self.time = time  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.time, 'time')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(QueryDevicesHotStorageDataResponseDataListPropertyInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.time is not None:
            result['Time'] = self.time
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Time') is not None:
            self.time = m.get('Time')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class QueryDevicesHotStorageDataResponseDataList(TeaModel):
    def __init__(self, property_info=None):
        self.property_info = property_info  # type: list[QueryDevicesHotStorageDataResponseDataListPropertyInfo]

    def validate(self):
        self.validate_required(self.property_info, 'property_info')
        if self.property_info:
            for k in self.property_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDevicesHotStorageDataResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['PropertyInfo'] = []
        if self.property_info is not None:
            for k in self.property_info:
                result['PropertyInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.property_info = []
        if m.get('PropertyInfo') is not None:
            for k in m.get('PropertyInfo'):
                temp_model = QueryDevicesHotStorageDataResponseDataListPropertyInfo()
                self.property_info.append(temp_model.from_map(k))
        return self


class QueryDevicesHotStorageDataResponseData(TeaModel):
    def __init__(self, next_valid=None, next_page_token=None, list=None):
        self.next_valid = next_valid  # type: bool
        self.next_page_token = next_page_token  # type: str
        self.list = list  # type: QueryDevicesHotStorageDataResponseDataList

    def validate(self):
        self.validate_required(self.next_valid, 'next_valid')
        self.validate_required(self.next_page_token, 'next_page_token')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDevicesHotStorageDataResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.next_valid is not None:
            result['NextValid'] = self.next_valid
        if self.next_page_token is not None:
            result['nextPageToken'] = self.next_page_token
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('NextValid') is not None:
            self.next_valid = m.get('NextValid')
        if m.get('nextPageToken') is not None:
            self.next_page_token = m.get('nextPageToken')
        if m.get('List') is not None:
            temp_model = QueryDevicesHotStorageDataResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDevicesHotStorageDataResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDevicesHotStorageDataResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDevicesHotStorageDataResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDevicesHotStorageDataResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDevicesHotStorageDataStatusRequest(TeaModel):
    def __init__(self, asc=None, device_name=None, iot_id=None, iot_instance_id=None, next_page_token=None,
                 page_size=None, product_key=None, user_topic=None):
        self.asc = asc  # type: int
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.next_page_token = next_page_token  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.user_topic = user_topic  # type: str

    def validate(self):
        self.validate_required(self.asc, 'asc')
        self.validate_required(self.iot_instance_id, 'iot_instance_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.user_topic, 'user_topic')

    def to_map(self):
        _map = super(QueryDevicesHotStorageDataStatusRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.asc is not None:
            result['Asc'] = self.asc
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.next_page_token is not None:
            result['NextPageToken'] = self.next_page_token
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.user_topic is not None:
            result['UserTopic'] = self.user_topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Asc') is not None:
            self.asc = m.get('Asc')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('NextPageToken') is not None:
            self.next_page_token = m.get('NextPageToken')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('UserTopic') is not None:
            self.user_topic = m.get('UserTopic')
        return self


class QueryDevicesHotStorageDataStatusResponseDataListPropertyStatusDataInfo(TeaModel):
    def __init__(self, identifier=None, time=None, value=None):
        self.identifier = identifier  # type: str
        self.time = time  # type: long
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.identifier, 'identifier')
        self.validate_required(self.time, 'time')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(QueryDevicesHotStorageDataStatusResponseDataListPropertyStatusDataInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.time is not None:
            result['Time'] = self.time
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('Time') is not None:
            self.time = m.get('Time')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class QueryDevicesHotStorageDataStatusResponseDataList(TeaModel):
    def __init__(self, property_status_data_info=None):
        self.property_status_data_info = property_status_data_info  # type: list[QueryDevicesHotStorageDataStatusResponseDataListPropertyStatusDataInfo]

    def validate(self):
        self.validate_required(self.property_status_data_info, 'property_status_data_info')
        if self.property_status_data_info:
            for k in self.property_status_data_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDevicesHotStorageDataStatusResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['PropertyStatusDataInfo'] = []
        if self.property_status_data_info is not None:
            for k in self.property_status_data_info:
                result['PropertyStatusDataInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.property_status_data_info = []
        if m.get('PropertyStatusDataInfo') is not None:
            for k in m.get('PropertyStatusDataInfo'):
                temp_model = QueryDevicesHotStorageDataStatusResponseDataListPropertyStatusDataInfo()
                self.property_status_data_info.append(temp_model.from_map(k))
        return self


class QueryDevicesHotStorageDataStatusResponseData(TeaModel):
    def __init__(self, next_page_token=None, next_valid=None, list=None):
        self.next_page_token = next_page_token  # type: str
        self.next_valid = next_valid  # type: bool
        self.list = list  # type: QueryDevicesHotStorageDataStatusResponseDataList

    def validate(self):
        self.validate_required(self.next_page_token, 'next_page_token')
        self.validate_required(self.next_valid, 'next_valid')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryDevicesHotStorageDataStatusResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.next_page_token is not None:
            result['NextPageToken'] = self.next_page_token
        if self.next_valid is not None:
            result['NextValid'] = self.next_valid
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('NextPageToken') is not None:
            self.next_page_token = m.get('NextPageToken')
        if m.get('NextValid') is not None:
            self.next_valid = m.get('NextValid')
        if m.get('List') is not None:
            temp_model = QueryDevicesHotStorageDataStatusResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryDevicesHotStorageDataStatusResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryDevicesHotStorageDataStatusResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDevicesHotStorageDataStatusResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryDevicesHotStorageDataStatusResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryDynamicGroupDevicesRequest(TeaModel):
    def __init__(self, current_page=None, device_name=None, fuzzy_name=None, group_id=None, iot_instance_id=None,
                 next_token=None, page_size=None, product_key=None, status=None):
        self.current_page = current_page  # type: int
        self.device_name = device_name  # type: str
        self.fuzzy_name = fuzzy_name  # type: bool
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.next_token = next_token  # type: str
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.iot_instance_id, 'iot_instance_id')

    def to_map(self):
        _map = super(QueryDynamicGroupDevicesRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.fuzzy_name is not None:
            result['FuzzyName'] = self.fuzzy_name
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.next_token is not None:
            result['NextToken'] = self.next_token
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('FuzzyName') is not None:
            self.fuzzy_name = m.get('FuzzyName')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('NextToken') is not None:
            self.next_token = m.get('NextToken')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class QueryDynamicGroupDevicesResponseDataSimpleDeviceInfo(TeaModel):
    def __init__(self, active_time=None, category_key=None, device_name=None, iot_id=None, last_online_time=None,
                 nickname=None, node_type=None, product_key=None, product_name=None, status=None, utc_active_time=None,
                 utc_last_online_time=None):
        self.active_time = active_time  # type: str
        self.category_key = category_key  # type: str
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.last_online_time = last_online_time  # type: str
        self.nickname = nickname  # type: str
        self.node_type = node_type  # type: int
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str
        self.status = status  # type: str
        self.utc_active_time = utc_active_time  # type: str
        self.utc_last_online_time = utc_last_online_time  # type: str

    def validate(self):
        self.validate_required(self.active_time, 'active_time')
        self.validate_required(self.category_key, 'category_key')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.last_online_time, 'last_online_time')
        self.validate_required(self.nickname, 'nickname')
        self.validate_required(self.node_type, 'node_type')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')
        self.validate_required(self.status, 'status')
        self.validate_required(self.utc_active_time, 'utc_active_time')
        self.validate_required(self.utc_last_online_time, 'utc_last_online_time')

    def to_map(self):
        _map = super(QueryDynamicGroupDevicesResponseDataSimpleDeviceInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.active_time is not None:
            result['ActiveTime'] = self.active_time
        if self.category_key is not None:
            result['CategoryKey'] = self.category_key
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.last_online_time is not None:
            result['LastOnlineTime'] = self.last_online_time
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.node_type is not None:
            result['NodeType'] = self.node_type
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.status is not None:
            result['Status'] = self.status
        if self.utc_active_time is not None:
            result['UtcActiveTime'] = self.utc_active_time
        if self.utc_last_online_time is not None:
            result['UtcLastOnlineTime'] = self.utc_last_online_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ActiveTime') is not None:
            self.active_time = m.get('ActiveTime')
        if m.get('CategoryKey') is not None:
            self.category_key = m.get('CategoryKey')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('LastOnlineTime') is not None:
            self.last_online_time = m.get('LastOnlineTime')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('NodeType') is not None:
            self.node_type = m.get('NodeType')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('UtcActiveTime') is not None:
            self.utc_active_time = m.get('UtcActiveTime')
        if m.get('UtcLastOnlineTime') is not None:
            self.utc_last_online_time = m.get('UtcLastOnlineTime')
        return self


class QueryDynamicGroupDevicesResponseData(TeaModel):
    def __init__(self, simple_device_info=None):
        self.simple_device_info = simple_device_info  # type: list[QueryDynamicGroupDevicesResponseDataSimpleDeviceInfo]

    def validate(self):
        self.validate_required(self.simple_device_info, 'simple_device_info')
        if self.simple_device_info:
            for k in self.simple_device_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryDynamicGroupDevicesResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['SimpleDeviceInfo'] = []
        if self.simple_device_info is not None:
            for k in self.simple_device_info:
                result['SimpleDeviceInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.simple_device_info = []
        if m.get('SimpleDeviceInfo') is not None:
            for k in m.get('SimpleDeviceInfo'):
                temp_model = QueryDynamicGroupDevicesResponseDataSimpleDeviceInfo()
                self.simple_device_info.append(temp_model.from_map(k))
        return self


class QueryDynamicGroupDevicesResponse(TeaModel):
    def __init__(self, code=None, error_message=None, next_token=None, page=None, page_count=None, page_size=None,
                 request_id=None, success=None, total=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.next_token = next_token  # type: str
        self.page = page  # type: int
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.data = data  # type: QueryDynamicGroupDevicesResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.next_token, 'next_token')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryDynamicGroupDevicesResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.next_token is not None:
            result['NextToken'] = self.next_token
        if self.page is not None:
            result['Page'] = self.page
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('NextToken') is not None:
            self.next_token = m.get('NextToken')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('Data') is not None:
            temp_model = QueryDynamicGroupDevicesResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryEdgeDriverRequest(TeaModel):
    def __init__(self, current_page=None, driver_name=None, iot_instance_id=None, page_size=None, type=None):
        self.current_page = current_page  # type: int
        self.driver_name = driver_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.type = type  # type: int

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(QueryEdgeDriverRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.driver_name is not None:
            result['DriverName'] = self.driver_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('DriverName') is not None:
            self.driver_name = m.get('DriverName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class QueryEdgeDriverResponseDataDriverList(TeaModel):
    def __init__(self, cpu_arch=None, driver_id=None, driver_name=None, driver_protocol=None,
                 gmt_create_timestamp=None, gmt_modified_timestamp=None, is_apply=None, is_built_in=None, runtime=None, type=None):
        self.cpu_arch = cpu_arch  # type: str
        self.driver_id = driver_id  # type: str
        self.driver_name = driver_name  # type: str
        self.driver_protocol = driver_protocol  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.is_apply = is_apply  # type: bool
        self.is_built_in = is_built_in  # type: bool
        self.runtime = runtime  # type: str
        self.type = type  # type: int

    def validate(self):
        self.validate_required(self.cpu_arch, 'cpu_arch')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.driver_name, 'driver_name')
        self.validate_required(self.driver_protocol, 'driver_protocol')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.is_apply, 'is_apply')
        self.validate_required(self.is_built_in, 'is_built_in')
        self.validate_required(self.runtime, 'runtime')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(QueryEdgeDriverResponseDataDriverList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.cpu_arch is not None:
            result['CpuArch'] = self.cpu_arch
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_name is not None:
            result['DriverName'] = self.driver_name
        if self.driver_protocol is not None:
            result['DriverProtocol'] = self.driver_protocol
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.is_apply is not None:
            result['IsApply'] = self.is_apply
        if self.is_built_in is not None:
            result['IsBuiltIn'] = self.is_built_in
        if self.runtime is not None:
            result['Runtime'] = self.runtime
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CpuArch') is not None:
            self.cpu_arch = m.get('CpuArch')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverName') is not None:
            self.driver_name = m.get('DriverName')
        if m.get('DriverProtocol') is not None:
            self.driver_protocol = m.get('DriverProtocol')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('IsApply') is not None:
            self.is_apply = m.get('IsApply')
        if m.get('IsBuiltIn') is not None:
            self.is_built_in = m.get('IsBuiltIn')
        if m.get('Runtime') is not None:
            self.runtime = m.get('Runtime')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class QueryEdgeDriverResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, driver_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.driver_list = driver_list  # type: list[QueryEdgeDriverResponseDataDriverList]

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.driver_list, 'driver_list')
        if self.driver_list:
            for k in self.driver_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeDriverResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        result['DriverList'] = []
        if self.driver_list is not None:
            for k in self.driver_list:
                result['DriverList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        self.driver_list = []
        if m.get('DriverList') is not None:
            for k in m.get('DriverList'):
                temp_model = QueryEdgeDriverResponseDataDriverList()
                self.driver_list.append(temp_model.from_map(k))
        return self


class QueryEdgeDriverResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryEdgeDriverResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryEdgeDriverResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryEdgeDriverResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryEdgeDriverVersionRequest(TeaModel):
    def __init__(self, current_page=None, driver_id=None, driver_version=None, iot_instance_id=None, page_size=None,
                 version_state=None):
        self.current_page = current_page  # type: int
        self.driver_id = driver_id  # type: str
        self.driver_version = driver_version  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.version_state = version_state  # type: int

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryEdgeDriverVersionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_version is not None:
            result['DriverVersion'] = self.driver_version
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.version_state is not None:
            result['VersionState'] = self.version_state
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverVersion') is not None:
            self.driver_version = m.get('DriverVersion')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('VersionState') is not None:
            self.version_state = m.get('VersionState')
        return self


class QueryEdgeDriverVersionResponseDataDriverVersionList(TeaModel):
    def __init__(self, argument=None, config_check_rule=None, container_config=None, description=None,
                 driver_config=None, driver_id=None, driver_version=None, edge_version=None, gmt_create_timestamp=None,
                 gmt_modified_timestamp=None, source_config=None, version_state=None):
        self.argument = argument  # type: str
        self.config_check_rule = config_check_rule  # type: str
        self.container_config = container_config  # type: str
        self.description = description  # type: str
        self.driver_config = driver_config  # type: str
        self.driver_id = driver_id  # type: str
        self.driver_version = driver_version  # type: str
        self.edge_version = edge_version  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.source_config = source_config  # type: str
        self.version_state = version_state  # type: str

    def validate(self):
        self.validate_required(self.argument, 'argument')
        self.validate_required(self.config_check_rule, 'config_check_rule')
        self.validate_required(self.container_config, 'container_config')
        self.validate_required(self.description, 'description')
        self.validate_required(self.driver_config, 'driver_config')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.driver_version, 'driver_version')
        self.validate_required(self.edge_version, 'edge_version')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.source_config, 'source_config')
        self.validate_required(self.version_state, 'version_state')

    def to_map(self):
        _map = super(QueryEdgeDriverVersionResponseDataDriverVersionList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.argument is not None:
            result['Argument'] = self.argument
        if self.config_check_rule is not None:
            result['ConfigCheckRule'] = self.config_check_rule
        if self.container_config is not None:
            result['ContainerConfig'] = self.container_config
        if self.description is not None:
            result['Description'] = self.description
        if self.driver_config is not None:
            result['DriverConfig'] = self.driver_config
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_version is not None:
            result['DriverVersion'] = self.driver_version
        if self.edge_version is not None:
            result['EdgeVersion'] = self.edge_version
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.source_config is not None:
            result['SourceConfig'] = self.source_config
        if self.version_state is not None:
            result['VersionState'] = self.version_state
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Argument') is not None:
            self.argument = m.get('Argument')
        if m.get('ConfigCheckRule') is not None:
            self.config_check_rule = m.get('ConfigCheckRule')
        if m.get('ContainerConfig') is not None:
            self.container_config = m.get('ContainerConfig')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('DriverConfig') is not None:
            self.driver_config = m.get('DriverConfig')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverVersion') is not None:
            self.driver_version = m.get('DriverVersion')
        if m.get('EdgeVersion') is not None:
            self.edge_version = m.get('EdgeVersion')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('SourceConfig') is not None:
            self.source_config = m.get('SourceConfig')
        if m.get('VersionState') is not None:
            self.version_state = m.get('VersionState')
        return self


class QueryEdgeDriverVersionResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, driver_version_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.driver_version_list = driver_version_list  # type: list[QueryEdgeDriverVersionResponseDataDriverVersionList]

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.driver_version_list, 'driver_version_list')
        if self.driver_version_list:
            for k in self.driver_version_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeDriverVersionResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        result['DriverVersionList'] = []
        if self.driver_version_list is not None:
            for k in self.driver_version_list:
                result['DriverVersionList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        self.driver_version_list = []
        if m.get('DriverVersionList') is not None:
            for k in m.get('DriverVersionList'):
                temp_model = QueryEdgeDriverVersionResponseDataDriverVersionList()
                self.driver_version_list.append(temp_model.from_map(k))
        return self


class QueryEdgeDriverVersionResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryEdgeDriverVersionResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryEdgeDriverVersionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryEdgeDriverVersionResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryEdgeInstanceRequest(TeaModel):
    def __init__(self, current_page=None, iot_instance_id=None, name=None, page_size=None):
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryEdgeInstanceResponseDataInstanceList(TeaModel):
    def __init__(self, biz_enable=None, gmt_create=None, gmt_create_timestamp=None, gmt_modified=None,
                 gmt_modified_timestamp=None, instance_id=None, latest_deployment_status=None, latest_deployment_type=None, name=None,
                 role_arn=None, role_attach_time=None, role_attach_timestamp=None, role_name=None, spec=None, tags=None,
                 type=None):
        self.biz_enable = biz_enable  # type: bool
        self.gmt_create = gmt_create  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified = gmt_modified  # type: str
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.instance_id = instance_id  # type: str
        self.latest_deployment_status = latest_deployment_status  # type: int
        self.latest_deployment_type = latest_deployment_type  # type: str
        self.name = name  # type: str
        self.role_arn = role_arn  # type: str
        self.role_attach_time = role_attach_time  # type: str
        self.role_attach_timestamp = role_attach_timestamp  # type: long
        self.role_name = role_name  # type: str
        self.spec = spec  # type: int
        self.tags = tags  # type: str
        self.type = type  # type: int

    def validate(self):
        self.validate_required(self.biz_enable, 'biz_enable')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.latest_deployment_status, 'latest_deployment_status')
        self.validate_required(self.latest_deployment_type, 'latest_deployment_type')
        self.validate_required(self.name, 'name')
        self.validate_required(self.role_arn, 'role_arn')
        self.validate_required(self.role_attach_time, 'role_attach_time')
        self.validate_required(self.role_attach_timestamp, 'role_attach_timestamp')
        self.validate_required(self.role_name, 'role_name')
        self.validate_required(self.spec, 'spec')
        self.validate_required(self.tags, 'tags')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(QueryEdgeInstanceResponseDataInstanceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.biz_enable is not None:
            result['BizEnable'] = self.biz_enable
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.latest_deployment_status is not None:
            result['LatestDeploymentStatus'] = self.latest_deployment_status
        if self.latest_deployment_type is not None:
            result['LatestDeploymentType'] = self.latest_deployment_type
        if self.name is not None:
            result['Name'] = self.name
        if self.role_arn is not None:
            result['RoleArn'] = self.role_arn
        if self.role_attach_time is not None:
            result['RoleAttachTime'] = self.role_attach_time
        if self.role_attach_timestamp is not None:
            result['RoleAttachTimestamp'] = self.role_attach_timestamp
        if self.role_name is not None:
            result['RoleName'] = self.role_name
        if self.spec is not None:
            result['Spec'] = self.spec
        if self.tags is not None:
            result['Tags'] = self.tags
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BizEnable') is not None:
            self.biz_enable = m.get('BizEnable')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('LatestDeploymentStatus') is not None:
            self.latest_deployment_status = m.get('LatestDeploymentStatus')
        if m.get('LatestDeploymentType') is not None:
            self.latest_deployment_type = m.get('LatestDeploymentType')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('RoleArn') is not None:
            self.role_arn = m.get('RoleArn')
        if m.get('RoleAttachTime') is not None:
            self.role_attach_time = m.get('RoleAttachTime')
        if m.get('RoleAttachTimestamp') is not None:
            self.role_attach_timestamp = m.get('RoleAttachTimestamp')
        if m.get('RoleName') is not None:
            self.role_name = m.get('RoleName')
        if m.get('Spec') is not None:
            self.spec = m.get('Spec')
        if m.get('Tags') is not None:
            self.tags = m.get('Tags')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class QueryEdgeInstanceResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, instance_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.instance_list = instance_list  # type: list[QueryEdgeInstanceResponseDataInstanceList]

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.instance_list, 'instance_list')
        if self.instance_list:
            for k in self.instance_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        result['InstanceList'] = []
        if self.instance_list is not None:
            for k in self.instance_list:
                result['InstanceList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        self.instance_list = []
        if m.get('InstanceList') is not None:
            for k in m.get('InstanceList'):
                temp_model = QueryEdgeInstanceResponseDataInstanceList()
                self.instance_list.append(temp_model.from_map(k))
        return self


class QueryEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryEdgeInstanceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryEdgeInstanceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryEdgeInstanceChannelRequest(TeaModel):
    def __init__(self, channel_name=None, current_page=None, driver_id=None, instance_id=None, iot_instance_id=None,
                 page_size=None):
        self.channel_name = channel_name  # type: str
        self.current_page = current_page  # type: int
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryEdgeInstanceChannelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.channel_name is not None:
            result['ChannelName'] = self.channel_name
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ChannelName') is not None:
            self.channel_name = m.get('ChannelName')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryEdgeInstanceChannelResponseDataChannelListChannelConfigListConfig(TeaModel):
    def __init__(self, config_id=None, content=None, format=None, key=None):
        self.config_id = config_id  # type: str
        self.content = content  # type: str
        self.format = format  # type: str
        self.key = key  # type: str

    def validate(self):
        self.validate_required(self.config_id, 'config_id')
        self.validate_required(self.content, 'content')
        self.validate_required(self.format, 'format')
        self.validate_required(self.key, 'key')

    def to_map(self):
        _map = super(QueryEdgeInstanceChannelResponseDataChannelListChannelConfigListConfig, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.config_id is not None:
            result['ConfigId'] = self.config_id
        if self.content is not None:
            result['Content'] = self.content
        if self.format is not None:
            result['Format'] = self.format
        if self.key is not None:
            result['Key'] = self.key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ConfigId') is not None:
            self.config_id = m.get('ConfigId')
        if m.get('Content') is not None:
            self.content = m.get('Content')
        if m.get('Format') is not None:
            self.format = m.get('Format')
        if m.get('Key') is not None:
            self.key = m.get('Key')
        return self


class QueryEdgeInstanceChannelResponseDataChannelListChannelConfigList(TeaModel):
    def __init__(self, config=None):
        self.config = config  # type: list[QueryEdgeInstanceChannelResponseDataChannelListChannelConfigListConfig]

    def validate(self):
        self.validate_required(self.config, 'config')
        if self.config:
            for k in self.config:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceChannelResponseDataChannelListChannelConfigList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Config'] = []
        if self.config is not None:
            for k in self.config:
                result['Config'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.config = []
        if m.get('Config') is not None:
            for k in m.get('Config'):
                temp_model = QueryEdgeInstanceChannelResponseDataChannelListChannelConfigListConfig()
                self.config.append(temp_model.from_map(k))
        return self


class QueryEdgeInstanceChannelResponseDataChannelListChannel(TeaModel):
    def __init__(self, channel_id=None, channel_name=None, gmt_create=None, gmt_create_timestamp=None,
                 gmt_modified=None, gmt_modified_timestamp=None, config_list=None):
        self.channel_id = channel_id  # type: str
        self.channel_name = channel_name  # type: str
        self.gmt_create = gmt_create  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified = gmt_modified  # type: str
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.config_list = config_list  # type: QueryEdgeInstanceChannelResponseDataChannelListChannelConfigList

    def validate(self):
        self.validate_required(self.channel_id, 'channel_id')
        self.validate_required(self.channel_name, 'channel_name')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.config_list, 'config_list')
        if self.config_list:
            self.config_list.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceChannelResponseDataChannelListChannel, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.channel_id is not None:
            result['ChannelId'] = self.channel_id
        if self.channel_name is not None:
            result['ChannelName'] = self.channel_name
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.config_list is not None:
            result['ConfigList'] = self.config_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ChannelId') is not None:
            self.channel_id = m.get('ChannelId')
        if m.get('ChannelName') is not None:
            self.channel_name = m.get('ChannelName')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('ConfigList') is not None:
            temp_model = QueryEdgeInstanceChannelResponseDataChannelListChannelConfigList()
            self.config_list = temp_model.from_map(m['ConfigList'])
        return self


class QueryEdgeInstanceChannelResponseDataChannelList(TeaModel):
    def __init__(self, channel=None):
        self.channel = channel  # type: list[QueryEdgeInstanceChannelResponseDataChannelListChannel]

    def validate(self):
        self.validate_required(self.channel, 'channel')
        if self.channel:
            for k in self.channel:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceChannelResponseDataChannelList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Channel'] = []
        if self.channel is not None:
            for k in self.channel:
                result['Channel'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.channel = []
        if m.get('Channel') is not None:
            for k in m.get('Channel'):
                temp_model = QueryEdgeInstanceChannelResponseDataChannelListChannel()
                self.channel.append(temp_model.from_map(k))
        return self


class QueryEdgeInstanceChannelResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, channel_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.channel_list = channel_list  # type: QueryEdgeInstanceChannelResponseDataChannelList

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.channel_list, 'channel_list')
        if self.channel_list:
            self.channel_list.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceChannelResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.channel_list is not None:
            result['ChannelList'] = self.channel_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('ChannelList') is not None:
            temp_model = QueryEdgeInstanceChannelResponseDataChannelList()
            self.channel_list = temp_model.from_map(m['ChannelList'])
        return self


class QueryEdgeInstanceChannelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryEdgeInstanceChannelResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceChannelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryEdgeInstanceChannelResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryEdgeInstanceDeviceRequest(TeaModel):
    def __init__(self, current_page=None, instance_id=None, iot_instance_id=None, page_size=None):
        self.current_page = current_page  # type: int
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryEdgeInstanceDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryEdgeInstanceDeviceResponseDataDeviceList(TeaModel):
    def __init__(self, device_name=None, driver_id=None, iot_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.driver_id = driver_id  # type: str
        self.iot_id = iot_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryEdgeInstanceDeviceResponseDataDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryEdgeInstanceDeviceResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, device_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.device_list = device_list  # type: list[QueryEdgeInstanceDeviceResponseDataDeviceList]

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.device_list, 'device_list')
        if self.device_list:
            for k in self.device_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        result['DeviceList'] = []
        if self.device_list is not None:
            for k in self.device_list:
                result['DeviceList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        self.device_list = []
        if m.get('DeviceList') is not None:
            for k in m.get('DeviceList'):
                temp_model = QueryEdgeInstanceDeviceResponseDataDeviceList()
                self.device_list.append(temp_model.from_map(k))
        return self


class QueryEdgeInstanceDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryEdgeInstanceDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryEdgeInstanceDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryEdgeInstanceDeviceByDriverRequest(TeaModel):
    def __init__(self, channel_id=None, current_page=None, driver_id=None, instance_id=None, iot_instance_id=None,
                 page_size=None):
        self.channel_id = channel_id  # type: str
        self.current_page = current_page  # type: int
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryEdgeInstanceDeviceByDriverRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.channel_id is not None:
            result['ChannelId'] = self.channel_id
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ChannelId') is not None:
            self.channel_id = m.get('ChannelId')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryEdgeInstanceDeviceByDriverResponseDataDeviceList(TeaModel):
    def __init__(self, iot_id=None):
        self.iot_id = iot_id  # type: str

    def validate(self):
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(QueryEdgeInstanceDeviceByDriverResponseDataDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        return self


class QueryEdgeInstanceDeviceByDriverResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, device_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.device_list = device_list  # type: list[QueryEdgeInstanceDeviceByDriverResponseDataDeviceList]

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.device_list, 'device_list')
        if self.device_list:
            for k in self.device_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceDeviceByDriverResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        result['DeviceList'] = []
        if self.device_list is not None:
            for k in self.device_list:
                result['DeviceList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        self.device_list = []
        if m.get('DeviceList') is not None:
            for k in m.get('DeviceList'):
                temp_model = QueryEdgeInstanceDeviceByDriverResponseDataDeviceList()
                self.device_list.append(temp_model.from_map(k))
        return self


class QueryEdgeInstanceDeviceByDriverResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryEdgeInstanceDeviceByDriverResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceDeviceByDriverResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryEdgeInstanceDeviceByDriverResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryEdgeInstanceDriverRequest(TeaModel):
    def __init__(self, current_page=None, instance_id=None, iot_instance_id=None, page_size=None):
        self.current_page = current_page  # type: int
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryEdgeInstanceDriverRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryEdgeInstanceDriverResponseDataDriverList(TeaModel):
    def __init__(self, driver_id=None, driver_version=None, gmt_create=None, gmt_modified=None, order_id=None):
        self.driver_id = driver_id  # type: str
        self.driver_version = driver_version  # type: str
        self.gmt_create = gmt_create  # type: str
        self.gmt_modified = gmt_modified  # type: str
        self.order_id = order_id  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.driver_version, 'driver_version')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.order_id, 'order_id')

    def to_map(self):
        _map = super(QueryEdgeInstanceDriverResponseDataDriverList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_version is not None:
            result['DriverVersion'] = self.driver_version
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.order_id is not None:
            result['OrderId'] = self.order_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverVersion') is not None:
            self.driver_version = m.get('DriverVersion')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('OrderId') is not None:
            self.order_id = m.get('OrderId')
        return self


class QueryEdgeInstanceDriverResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, driver_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.driver_list = driver_list  # type: list[QueryEdgeInstanceDriverResponseDataDriverList]

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.driver_list, 'driver_list')
        if self.driver_list:
            for k in self.driver_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceDriverResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        result['DriverList'] = []
        if self.driver_list is not None:
            for k in self.driver_list:
                result['DriverList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        self.driver_list = []
        if m.get('DriverList') is not None:
            for k in m.get('DriverList'):
                temp_model = QueryEdgeInstanceDriverResponseDataDriverList()
                self.driver_list.append(temp_model.from_map(k))
        return self


class QueryEdgeInstanceDriverResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryEdgeInstanceDriverResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceDriverResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryEdgeInstanceDriverResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryEdgeInstanceGatewayRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(QueryEdgeInstanceGatewayRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QueryEdgeInstanceGatewayResponseGatewayList(TeaModel):
    def __init__(self, device_name=None, edge_version=None, iot_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.edge_version = edge_version  # type: str
        self.iot_id = iot_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.edge_version, 'edge_version')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryEdgeInstanceGatewayResponseGatewayList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.edge_version is not None:
            result['EdgeVersion'] = self.edge_version
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('EdgeVersion') is not None:
            self.edge_version = m.get('EdgeVersion')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryEdgeInstanceGatewayResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, gateway_list=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.gateway_list = gateway_list  # type: list[QueryEdgeInstanceGatewayResponseGatewayList]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.gateway_list, 'gateway_list')
        if self.gateway_list:
            for k in self.gateway_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceGatewayResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        result['GatewayList'] = []
        if self.gateway_list is not None:
            for k in self.gateway_list:
                result['GatewayList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        self.gateway_list = []
        if m.get('GatewayList') is not None:
            for k in m.get('GatewayList'):
                temp_model = QueryEdgeInstanceGatewayResponseGatewayList()
                self.gateway_list.append(temp_model.from_map(k))
        return self


class QueryEdgeInstanceHistoricDeploymentRequest(TeaModel):
    def __init__(self, current_page=None, end_time=None, instance_id=None, iot_instance_id=None, page_size=None,
                 start_time=None):
        self.current_page = current_page  # type: int
        self.end_time = end_time  # type: long
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.start_time = start_time  # type: long

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryEdgeInstanceHistoricDeploymentRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class QueryEdgeInstanceHistoricDeploymentResponseDataDeploymentList(TeaModel):
    def __init__(self, deployment_id=None, description=None, gmt_completed=None, gmt_completed_timestamp=None,
                 gmt_create=None, gmt_create_timestamp=None, gmt_modified=None, gmt_modified_timestamp=None, status=None,
                 type=None):
        self.deployment_id = deployment_id  # type: str
        self.description = description  # type: str
        self.gmt_completed = gmt_completed  # type: str
        self.gmt_completed_timestamp = gmt_completed_timestamp  # type: long
        self.gmt_create = gmt_create  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified = gmt_modified  # type: str
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.status = status  # type: int
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.deployment_id, 'deployment_id')
        self.validate_required(self.description, 'description')
        self.validate_required(self.gmt_completed, 'gmt_completed')
        self.validate_required(self.gmt_completed_timestamp, 'gmt_completed_timestamp')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.status, 'status')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(QueryEdgeInstanceHistoricDeploymentResponseDataDeploymentList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.deployment_id is not None:
            result['DeploymentId'] = self.deployment_id
        if self.description is not None:
            result['Description'] = self.description
        if self.gmt_completed is not None:
            result['GmtCompleted'] = self.gmt_completed
        if self.gmt_completed_timestamp is not None:
            result['GmtCompletedTimestamp'] = self.gmt_completed_timestamp
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.status is not None:
            result['Status'] = self.status
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeploymentId') is not None:
            self.deployment_id = m.get('DeploymentId')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('GmtCompleted') is not None:
            self.gmt_completed = m.get('GmtCompleted')
        if m.get('GmtCompletedTimestamp') is not None:
            self.gmt_completed_timestamp = m.get('GmtCompletedTimestamp')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class QueryEdgeInstanceHistoricDeploymentResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, deployment_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.deployment_list = deployment_list  # type: list[QueryEdgeInstanceHistoricDeploymentResponseDataDeploymentList]

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.deployment_list, 'deployment_list')
        if self.deployment_list:
            for k in self.deployment_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceHistoricDeploymentResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        result['DeploymentList'] = []
        if self.deployment_list is not None:
            for k in self.deployment_list:
                result['DeploymentList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        self.deployment_list = []
        if m.get('DeploymentList') is not None:
            for k in m.get('DeploymentList'):
                temp_model = QueryEdgeInstanceHistoricDeploymentResponseDataDeploymentList()
                self.deployment_list.append(temp_model.from_map(k))
        return self


class QueryEdgeInstanceHistoricDeploymentResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryEdgeInstanceHistoricDeploymentResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceHistoricDeploymentResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryEdgeInstanceHistoricDeploymentResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryEdgeInstanceMessageRoutingRequest(TeaModel):
    def __init__(self, current_page=None, instance_id=None, iot_instance_id=None, page_size=None):
        self.current_page = current_page  # type: int
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryEdgeInstanceMessageRoutingRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryEdgeInstanceMessageRoutingResponseDataMessageRouteListMessageRouteRouteContext(TeaModel):
    def __init__(self, qos=None, source_application_name=None, source_fc_function_name=None,
                 source_fc_service_name=None, target_application_name=None, target_fc_function_name=None, target_fc_service_name=None):
        self.qos = qos  # type: str
        self.source_application_name = source_application_name  # type: str
        self.source_fc_function_name = source_fc_function_name  # type: str
        self.source_fc_service_name = source_fc_service_name  # type: str
        self.target_application_name = target_application_name  # type: str
        self.target_fc_function_name = target_fc_function_name  # type: str
        self.target_fc_service_name = target_fc_service_name  # type: str

    def validate(self):
        self.validate_required(self.qos, 'qos')
        self.validate_required(self.source_application_name, 'source_application_name')
        self.validate_required(self.source_fc_function_name, 'source_fc_function_name')
        self.validate_required(self.source_fc_service_name, 'source_fc_service_name')
        self.validate_required(self.target_application_name, 'target_application_name')
        self.validate_required(self.target_fc_function_name, 'target_fc_function_name')
        self.validate_required(self.target_fc_service_name, 'target_fc_service_name')

    def to_map(self):
        _map = super(QueryEdgeInstanceMessageRoutingResponseDataMessageRouteListMessageRouteRouteContext, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.qos is not None:
            result['Qos'] = self.qos
        if self.source_application_name is not None:
            result['SourceApplicationName'] = self.source_application_name
        if self.source_fc_function_name is not None:
            result['SourceFcFunctionName'] = self.source_fc_function_name
        if self.source_fc_service_name is not None:
            result['SourceFcServiceName'] = self.source_fc_service_name
        if self.target_application_name is not None:
            result['TargetApplicationName'] = self.target_application_name
        if self.target_fc_function_name is not None:
            result['TargetFcFunctionName'] = self.target_fc_function_name
        if self.target_fc_service_name is not None:
            result['TargetFcServiceName'] = self.target_fc_service_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Qos') is not None:
            self.qos = m.get('Qos')
        if m.get('SourceApplicationName') is not None:
            self.source_application_name = m.get('SourceApplicationName')
        if m.get('SourceFcFunctionName') is not None:
            self.source_fc_function_name = m.get('SourceFcFunctionName')
        if m.get('SourceFcServiceName') is not None:
            self.source_fc_service_name = m.get('SourceFcServiceName')
        if m.get('TargetApplicationName') is not None:
            self.target_application_name = m.get('TargetApplicationName')
        if m.get('TargetFcFunctionName') is not None:
            self.target_fc_function_name = m.get('TargetFcFunctionName')
        if m.get('TargetFcServiceName') is not None:
            self.target_fc_service_name = m.get('TargetFcServiceName')
        return self


class QueryEdgeInstanceMessageRoutingResponseDataMessageRouteListMessageRoute(TeaModel):
    def __init__(self, gmt_create=None, gmt_create_timestamp=None, gmt_modified=None, gmt_modified_timestamp=None,
                 name=None, route_id=None, source_data=None, source_type=None, target_data=None, target_type=None,
                 topic_filter=None, route_context=None):
        self.gmt_create = gmt_create  # type: str
        self.gmt_create_timestamp = gmt_create_timestamp  # type: long
        self.gmt_modified = gmt_modified  # type: str
        self.gmt_modified_timestamp = gmt_modified_timestamp  # type: long
        self.name = name  # type: str
        self.route_id = route_id  # type: int
        self.source_data = source_data  # type: str
        self.source_type = source_type  # type: str
        self.target_data = target_data  # type: str
        self.target_type = target_type  # type: str
        self.topic_filter = topic_filter  # type: str
        self.route_context = route_context  # type: QueryEdgeInstanceMessageRoutingResponseDataMessageRouteListMessageRouteRouteContext

    def validate(self):
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_create_timestamp, 'gmt_create_timestamp')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.gmt_modified_timestamp, 'gmt_modified_timestamp')
        self.validate_required(self.name, 'name')
        self.validate_required(self.route_id, 'route_id')
        self.validate_required(self.source_data, 'source_data')
        self.validate_required(self.source_type, 'source_type')
        self.validate_required(self.target_data, 'target_data')
        self.validate_required(self.target_type, 'target_type')
        self.validate_required(self.topic_filter, 'topic_filter')
        self.validate_required(self.route_context, 'route_context')
        if self.route_context:
            self.route_context.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceMessageRoutingResponseDataMessageRouteListMessageRoute, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_create_timestamp is not None:
            result['GmtCreateTimestamp'] = self.gmt_create_timestamp
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.gmt_modified_timestamp is not None:
            result['GmtModifiedTimestamp'] = self.gmt_modified_timestamp
        if self.name is not None:
            result['Name'] = self.name
        if self.route_id is not None:
            result['RouteId'] = self.route_id
        if self.source_data is not None:
            result['SourceData'] = self.source_data
        if self.source_type is not None:
            result['SourceType'] = self.source_type
        if self.target_data is not None:
            result['TargetData'] = self.target_data
        if self.target_type is not None:
            result['TargetType'] = self.target_type
        if self.topic_filter is not None:
            result['TopicFilter'] = self.topic_filter
        if self.route_context is not None:
            result['RouteContext'] = self.route_context.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtCreateTimestamp') is not None:
            self.gmt_create_timestamp = m.get('GmtCreateTimestamp')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('GmtModifiedTimestamp') is not None:
            self.gmt_modified_timestamp = m.get('GmtModifiedTimestamp')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('RouteId') is not None:
            self.route_id = m.get('RouteId')
        if m.get('SourceData') is not None:
            self.source_data = m.get('SourceData')
        if m.get('SourceType') is not None:
            self.source_type = m.get('SourceType')
        if m.get('TargetData') is not None:
            self.target_data = m.get('TargetData')
        if m.get('TargetType') is not None:
            self.target_type = m.get('TargetType')
        if m.get('TopicFilter') is not None:
            self.topic_filter = m.get('TopicFilter')
        if m.get('RouteContext') is not None:
            temp_model = QueryEdgeInstanceMessageRoutingResponseDataMessageRouteListMessageRouteRouteContext()
            self.route_context = temp_model.from_map(m['RouteContext'])
        return self


class QueryEdgeInstanceMessageRoutingResponseDataMessageRouteList(TeaModel):
    def __init__(self, message_route=None):
        self.message_route = message_route  # type: list[QueryEdgeInstanceMessageRoutingResponseDataMessageRouteListMessageRoute]

    def validate(self):
        self.validate_required(self.message_route, 'message_route')
        if self.message_route:
            for k in self.message_route:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceMessageRoutingResponseDataMessageRouteList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['MessageRoute'] = []
        if self.message_route is not None:
            for k in self.message_route:
                result['MessageRoute'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.message_route = []
        if m.get('MessageRoute') is not None:
            for k in m.get('MessageRoute'):
                temp_model = QueryEdgeInstanceMessageRoutingResponseDataMessageRouteListMessageRoute()
                self.message_route.append(temp_model.from_map(k))
        return self


class QueryEdgeInstanceMessageRoutingResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, message_route_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.message_route_list = message_route_list  # type: QueryEdgeInstanceMessageRoutingResponseDataMessageRouteList

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.message_route_list, 'message_route_list')
        if self.message_route_list:
            self.message_route_list.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceMessageRoutingResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.message_route_list is not None:
            result['MessageRouteList'] = self.message_route_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('MessageRouteList') is not None:
            temp_model = QueryEdgeInstanceMessageRoutingResponseDataMessageRouteList()
            self.message_route_list = temp_model.from_map(m['MessageRouteList'])
        return self


class QueryEdgeInstanceMessageRoutingResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryEdgeInstanceMessageRoutingResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceMessageRoutingResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryEdgeInstanceMessageRoutingResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryEdgeInstanceSceneRuleRequest(TeaModel):
    def __init__(self, current_page=None, instance_id=None, iot_instance_id=None, page_size=None):
        self.current_page = current_page  # type: int
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryEdgeInstanceSceneRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryEdgeInstanceSceneRuleResponseDataRuleList(TeaModel):
    def __init__(self, gmt_create=None, is_existed=None, rule_id=None, rule_name=None, status=None):
        self.gmt_create = gmt_create  # type: long
        self.is_existed = is_existed  # type: int
        self.rule_id = rule_id  # type: str
        self.rule_name = rule_name  # type: str
        self.status = status  # type: int

    def validate(self):
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.is_existed, 'is_existed')
        self.validate_required(self.rule_id, 'rule_id')
        self.validate_required(self.rule_name, 'rule_name')
        self.validate_required(self.status, 'status')

    def to_map(self):
        _map = super(QueryEdgeInstanceSceneRuleResponseDataRuleList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.is_existed is not None:
            result['IsExisted'] = self.is_existed
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        if self.rule_name is not None:
            result['RuleName'] = self.rule_name
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('IsExisted') is not None:
            self.is_existed = m.get('IsExisted')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        if m.get('RuleName') is not None:
            self.rule_name = m.get('RuleName')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class QueryEdgeInstanceSceneRuleResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, rule_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.rule_list = rule_list  # type: list[QueryEdgeInstanceSceneRuleResponseDataRuleList]

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.rule_list, 'rule_list')
        if self.rule_list:
            for k in self.rule_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceSceneRuleResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        result['RuleList'] = []
        if self.rule_list is not None:
            for k in self.rule_list:
                result['RuleList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        self.rule_list = []
        if m.get('RuleList') is not None:
            for k in m.get('RuleList'):
                temp_model = QueryEdgeInstanceSceneRuleResponseDataRuleList()
                self.rule_list.append(temp_model.from_map(k))
        return self


class QueryEdgeInstanceSceneRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryEdgeInstanceSceneRuleResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryEdgeInstanceSceneRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryEdgeInstanceSceneRuleResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryImportedDeviceByApplyIdRequest(TeaModel):
    def __init__(self, apply_id=None, iot_instance_id=None, page_no=None, page_size=None):
        self.apply_id = apply_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.apply_id, 'apply_id')
        self.validate_required(self.page_no, 'page_no')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryImportedDeviceByApplyIdRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.apply_id is not None:
            result['ApplyId'] = self.apply_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplyId') is not None:
            self.apply_id = m.get('ApplyId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryImportedDeviceByApplyIdResponseDeviceListDevice(TeaModel):
    def __init__(self, device_name=None, device_secret=None, product_key=None, sn=None):
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.product_key = product_key  # type: str
        self.sn = sn  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.sn, 'sn')

    def to_map(self):
        _map = super(QueryImportedDeviceByApplyIdResponseDeviceListDevice, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.sn is not None:
            result['Sn'] = self.sn
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Sn') is not None:
            self.sn = m.get('Sn')
        return self


class QueryImportedDeviceByApplyIdResponseDeviceList(TeaModel):
    def __init__(self, device=None):
        self.device = device  # type: list[QueryImportedDeviceByApplyIdResponseDeviceListDevice]

    def validate(self):
        self.validate_required(self.device, 'device')
        if self.device:
            for k in self.device:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryImportedDeviceByApplyIdResponseDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['device'] = []
        if self.device is not None:
            for k in self.device:
                result['device'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.device = []
        if m.get('device') is not None:
            for k in m.get('device'):
                temp_model = QueryImportedDeviceByApplyIdResponseDeviceListDevice()
                self.device.append(temp_model.from_map(k))
        return self


class QueryImportedDeviceByApplyIdResponse(TeaModel):
    def __init__(self, code=None, error_message=None, page_no=None, page_size=None, product_key=None,
                 request_id=None, success=None, total_page=None, device_list=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total_page = total_page  # type: int
        self.device_list = device_list  # type: QueryImportedDeviceByApplyIdResponseDeviceList

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page_no, 'page_no')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total_page, 'total_page')
        self.validate_required(self.device_list, 'device_list')
        if self.device_list:
            self.device_list.validate()

    def to_map(self):
        _map = super(QueryImportedDeviceByApplyIdResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total_page is not None:
            result['TotalPage'] = self.total_page
        if self.device_list is not None:
            result['DeviceList'] = self.device_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('TotalPage') is not None:
            self.total_page = m.get('TotalPage')
        if m.get('DeviceList') is not None:
            temp_model = QueryImportedDeviceByApplyIdResponseDeviceList()
            self.device_list = temp_model.from_map(m['DeviceList'])
        return self


class QueryJobRequest(TeaModel):
    def __init__(self, iot_instance_id=None, job_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(QueryJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        return self


class QueryJobResponseDataJobFile(TeaModel):
    def __init__(self, file_url=None, sign=None, sign_method=None):
        self.file_url = file_url  # type: str
        self.sign = sign  # type: str
        self.sign_method = sign_method  # type: str

    def validate(self):
        self.validate_required(self.file_url, 'file_url')
        self.validate_required(self.sign, 'sign')
        self.validate_required(self.sign_method, 'sign_method')

    def to_map(self):
        _map = super(QueryJobResponseDataJobFile, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.file_url is not None:
            result['FileUrl'] = self.file_url
        if self.sign is not None:
            result['Sign'] = self.sign
        if self.sign_method is not None:
            result['SignMethod'] = self.sign_method
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FileUrl') is not None:
            self.file_url = m.get('FileUrl')
        if m.get('Sign') is not None:
            self.sign = m.get('Sign')
        if m.get('SignMethod') is not None:
            self.sign_method = m.get('SignMethod')
        return self


class QueryJobResponseDataRolloutConfig(TeaModel):
    def __init__(self, maximum_per_minute=None, message_qo_s=None):
        self.maximum_per_minute = maximum_per_minute  # type: int
        self.message_qo_s = message_qo_s  # type: str

    def validate(self):
        self.validate_required(self.maximum_per_minute, 'maximum_per_minute')
        self.validate_required(self.message_qo_s, 'message_qo_s')

    def to_map(self):
        _map = super(QueryJobResponseDataRolloutConfig, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.maximum_per_minute is not None:
            result['MaximumPerMinute'] = self.maximum_per_minute
        if self.message_qo_s is not None:
            result['MessageQoS'] = self.message_qo_s
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('MaximumPerMinute') is not None:
            self.maximum_per_minute = m.get('MaximumPerMinute')
        if m.get('MessageQoS') is not None:
            self.message_qo_s = m.get('MessageQoS')
        return self


class QueryJobResponseDataTargetConfigTargetDevicesTargetDevices(TeaModel):
    def __init__(self, device_name=None, product_key=None):
        self.device_name = device_name  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryJobResponseDataTargetConfigTargetDevicesTargetDevices, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryJobResponseDataTargetConfigTargetDevices(TeaModel):
    def __init__(self, target_devices=None):
        self.target_devices = target_devices  # type: list[QueryJobResponseDataTargetConfigTargetDevicesTargetDevices]

    def validate(self):
        self.validate_required(self.target_devices, 'target_devices')
        if self.target_devices:
            for k in self.target_devices:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryJobResponseDataTargetConfigTargetDevices, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['targetDevices'] = []
        if self.target_devices is not None:
            for k in self.target_devices:
                result['targetDevices'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.target_devices = []
        if m.get('targetDevices') is not None:
            for k in m.get('targetDevices'):
                temp_model = QueryJobResponseDataTargetConfigTargetDevicesTargetDevices()
                self.target_devices.append(temp_model.from_map(k))
        return self


class QueryJobResponseDataTargetConfig(TeaModel):
    def __init__(self, target_group=None, target_product=None, target_type=None, target_devices=None):
        self.target_group = target_group  # type: str
        self.target_product = target_product  # type: str
        self.target_type = target_type  # type: str
        self.target_devices = target_devices  # type: QueryJobResponseDataTargetConfigTargetDevices

    def validate(self):
        self.validate_required(self.target_group, 'target_group')
        self.validate_required(self.target_product, 'target_product')
        self.validate_required(self.target_type, 'target_type')
        self.validate_required(self.target_devices, 'target_devices')
        if self.target_devices:
            self.target_devices.validate()

    def to_map(self):
        _map = super(QueryJobResponseDataTargetConfig, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.target_group is not None:
            result['TargetGroup'] = self.target_group
        if self.target_product is not None:
            result['TargetProduct'] = self.target_product
        if self.target_type is not None:
            result['TargetType'] = self.target_type
        if self.target_devices is not None:
            result['TargetDevices'] = self.target_devices.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TargetGroup') is not None:
            self.target_group = m.get('TargetGroup')
        if m.get('TargetProduct') is not None:
            self.target_product = m.get('TargetProduct')
        if m.get('TargetType') is not None:
            self.target_type = m.get('TargetType')
        if m.get('TargetDevices') is not None:
            temp_model = QueryJobResponseDataTargetConfigTargetDevices()
            self.target_devices = temp_model.from_map(m['TargetDevices'])
        return self


class QueryJobResponseDataTimeoutConfig(TeaModel):
    def __init__(self, in_progress_timeout_in_minutes=None):
        self.in_progress_timeout_in_minutes = in_progress_timeout_in_minutes  # type: int

    def validate(self):
        self.validate_required(self.in_progress_timeout_in_minutes, 'in_progress_timeout_in_minutes')

    def to_map(self):
        _map = super(QueryJobResponseDataTimeoutConfig, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.in_progress_timeout_in_minutes is not None:
            result['InProgressTimeoutInMinutes'] = self.in_progress_timeout_in_minutes
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InProgressTimeoutInMinutes') is not None:
            self.in_progress_timeout_in_minutes = m.get('InProgressTimeoutInMinutes')
        return self


class QueryJobResponseData(TeaModel):
    def __init__(self, description=None, job_document=None, job_id=None, job_name=None, scheduled_time=None,
                 status=None, type=None, utc_create=None, utc_modified=None, job_file=None, rollout_config=None,
                 target_config=None, timeout_config=None):
        self.description = description  # type: str
        self.job_document = job_document  # type: str
        self.job_id = job_id  # type: str
        self.job_name = job_name  # type: str
        self.scheduled_time = scheduled_time  # type: long
        self.status = status  # type: str
        self.type = type  # type: str
        self.utc_create = utc_create  # type: str
        self.utc_modified = utc_modified  # type: str
        self.job_file = job_file  # type: QueryJobResponseDataJobFile
        self.rollout_config = rollout_config  # type: QueryJobResponseDataRolloutConfig
        self.target_config = target_config  # type: QueryJobResponseDataTargetConfig
        self.timeout_config = timeout_config  # type: QueryJobResponseDataTimeoutConfig

    def validate(self):
        self.validate_required(self.description, 'description')
        self.validate_required(self.job_document, 'job_document')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.job_name, 'job_name')
        self.validate_required(self.scheduled_time, 'scheduled_time')
        self.validate_required(self.status, 'status')
        self.validate_required(self.type, 'type')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_modified, 'utc_modified')
        self.validate_required(self.job_file, 'job_file')
        if self.job_file:
            self.job_file.validate()
        self.validate_required(self.rollout_config, 'rollout_config')
        if self.rollout_config:
            self.rollout_config.validate()
        self.validate_required(self.target_config, 'target_config')
        if self.target_config:
            self.target_config.validate()
        self.validate_required(self.timeout_config, 'timeout_config')
        if self.timeout_config:
            self.timeout_config.validate()

    def to_map(self):
        _map = super(QueryJobResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.job_document is not None:
            result['JobDocument'] = self.job_document
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.job_name is not None:
            result['JobName'] = self.job_name
        if self.scheduled_time is not None:
            result['ScheduledTime'] = self.scheduled_time
        if self.status is not None:
            result['Status'] = self.status
        if self.type is not None:
            result['Type'] = self.type
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        if self.job_file is not None:
            result['JobFile'] = self.job_file.to_map()
        if self.rollout_config is not None:
            result['RolloutConfig'] = self.rollout_config.to_map()
        if self.target_config is not None:
            result['TargetConfig'] = self.target_config.to_map()
        if self.timeout_config is not None:
            result['TimeoutConfig'] = self.timeout_config.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('JobDocument') is not None:
            self.job_document = m.get('JobDocument')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('JobName') is not None:
            self.job_name = m.get('JobName')
        if m.get('ScheduledTime') is not None:
            self.scheduled_time = m.get('ScheduledTime')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        if m.get('JobFile') is not None:
            temp_model = QueryJobResponseDataJobFile()
            self.job_file = temp_model.from_map(m['JobFile'])
        if m.get('RolloutConfig') is not None:
            temp_model = QueryJobResponseDataRolloutConfig()
            self.rollout_config = temp_model.from_map(m['RolloutConfig'])
        if m.get('TargetConfig') is not None:
            temp_model = QueryJobResponseDataTargetConfig()
            self.target_config = temp_model.from_map(m['TargetConfig'])
        if m.get('TimeoutConfig') is not None:
            temp_model = QueryJobResponseDataTimeoutConfig()
            self.timeout_config = temp_model.from_map(m['TimeoutConfig'])
        return self


class QueryJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryJobResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryJobResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryJobStatisticsRequest(TeaModel):
    def __init__(self, iot_instance_id=None, job_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(QueryJobStatisticsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        return self


class QueryJobStatisticsResponseData(TeaModel):
    def __init__(self, cancelled=None, failed=None, in_progress=None, queued=None, rejected=None, sent=None,
                 succeeded=None, time_out=None, total=None):
        self.cancelled = cancelled  # type: int
        self.failed = failed  # type: int
        self.in_progress = in_progress  # type: int
        self.queued = queued  # type: int
        self.rejected = rejected  # type: int
        self.sent = sent  # type: int
        self.succeeded = succeeded  # type: int
        self.time_out = time_out  # type: int
        self.total = total  # type: int

    def validate(self):
        self.validate_required(self.cancelled, 'cancelled')
        self.validate_required(self.failed, 'failed')
        self.validate_required(self.in_progress, 'in_progress')
        self.validate_required(self.queued, 'queued')
        self.validate_required(self.rejected, 'rejected')
        self.validate_required(self.sent, 'sent')
        self.validate_required(self.succeeded, 'succeeded')
        self.validate_required(self.time_out, 'time_out')
        self.validate_required(self.total, 'total')

    def to_map(self):
        _map = super(QueryJobStatisticsResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.cancelled is not None:
            result['Cancelled'] = self.cancelled
        if self.failed is not None:
            result['Failed'] = self.failed
        if self.in_progress is not None:
            result['InProgress'] = self.in_progress
        if self.queued is not None:
            result['Queued'] = self.queued
        if self.rejected is not None:
            result['Rejected'] = self.rejected
        if self.sent is not None:
            result['Sent'] = self.sent
        if self.succeeded is not None:
            result['Succeeded'] = self.succeeded
        if self.time_out is not None:
            result['TimeOut'] = self.time_out
        if self.total is not None:
            result['Total'] = self.total
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Cancelled') is not None:
            self.cancelled = m.get('Cancelled')
        if m.get('Failed') is not None:
            self.failed = m.get('Failed')
        if m.get('InProgress') is not None:
            self.in_progress = m.get('InProgress')
        if m.get('Queued') is not None:
            self.queued = m.get('Queued')
        if m.get('Rejected') is not None:
            self.rejected = m.get('Rejected')
        if m.get('Sent') is not None:
            self.sent = m.get('Sent')
        if m.get('Succeeded') is not None:
            self.succeeded = m.get('Succeeded')
        if m.get('TimeOut') is not None:
            self.time_out = m.get('TimeOut')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        return self


class QueryJobStatisticsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryJobStatisticsResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryJobStatisticsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryJobStatisticsResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryLicenseDeviceListRequest(TeaModel):
    def __init__(self, end_time=None, iot_id=None, iot_instance_id=None, license_code=None, page_id=None,
                 page_size=None, product_key=None, start_time=None):
        self.end_time = end_time  # type: long
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.license_code = license_code  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str
        self.start_time = start_time  # type: long

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryLicenseDeviceListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.license_code is not None:
            result['LicenseCode'] = self.license_code
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('LicenseCode') is not None:
            self.license_code = m.get('LicenseCode')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class QueryLicenseDeviceListResponseDataDeviceListItem(TeaModel):
    def __init__(self, device_name=None, expiry_time=None, gmt_create=None, iot_id=None, license_code=None,
                 product_key=None, product_name=None):
        self.device_name = device_name  # type: str
        self.expiry_time = expiry_time  # type: long
        self.gmt_create = gmt_create  # type: long
        self.iot_id = iot_id  # type: str
        self.license_code = license_code  # type: str
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.expiry_time, 'expiry_time')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.license_code, 'license_code')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')

    def to_map(self):
        _map = super(QueryLicenseDeviceListResponseDataDeviceListItem, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.expiry_time is not None:
            result['ExpiryTime'] = self.expiry_time
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.license_code is not None:
            result['LicenseCode'] = self.license_code
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('ExpiryTime') is not None:
            self.expiry_time = m.get('ExpiryTime')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('LicenseCode') is not None:
            self.license_code = m.get('LicenseCode')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        return self


class QueryLicenseDeviceListResponseDataDeviceList(TeaModel):
    def __init__(self, item=None):
        self.item = item  # type: list[QueryLicenseDeviceListResponseDataDeviceListItem]

    def validate(self):
        self.validate_required(self.item, 'item')
        if self.item:
            for k in self.item:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryLicenseDeviceListResponseDataDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['item'] = []
        if self.item is not None:
            for k in self.item:
                result['item'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.item = []
        if m.get('item') is not None:
            for k in m.get('item'):
                temp_model = QueryLicenseDeviceListResponseDataDeviceListItem()
                self.item.append(temp_model.from_map(k))
        return self


class QueryLicenseDeviceListResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, device_list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.device_list = device_list  # type: QueryLicenseDeviceListResponseDataDeviceList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.device_list, 'device_list')
        if self.device_list:
            self.device_list.validate()

    def to_map(self):
        _map = super(QueryLicenseDeviceListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.device_list is not None:
            result['DeviceList'] = self.device_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('DeviceList') is not None:
            temp_model = QueryLicenseDeviceListResponseDataDeviceList()
            self.device_list = temp_model.from_map(m['DeviceList'])
        return self


class QueryLicenseDeviceListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryLicenseDeviceListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryLicenseDeviceListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryLicenseDeviceListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryLoRaJoinPermissionsRequest(TeaModel):
    def __init__(self, iot_instance_id=None):
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryLoRaJoinPermissionsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QueryLoRaJoinPermissionsResponseJoinPermissionsJoinPermission(TeaModel):
    def __init__(self, class_mode=None, enabled=None, join_permission_id=None, join_permission_name=None,
                 join_permission_type=None, owner_aliyun_pk=None):
        self.class_mode = class_mode  # type: str
        self.enabled = enabled  # type: bool
        self.join_permission_id = join_permission_id  # type: str
        self.join_permission_name = join_permission_name  # type: str
        self.join_permission_type = join_permission_type  # type: str
        self.owner_aliyun_pk = owner_aliyun_pk  # type: str

    def validate(self):
        self.validate_required(self.class_mode, 'class_mode')
        self.validate_required(self.enabled, 'enabled')
        self.validate_required(self.join_permission_id, 'join_permission_id')
        self.validate_required(self.join_permission_name, 'join_permission_name')
        self.validate_required(self.join_permission_type, 'join_permission_type')
        self.validate_required(self.owner_aliyun_pk, 'owner_aliyun_pk')

    def to_map(self):
        _map = super(QueryLoRaJoinPermissionsResponseJoinPermissionsJoinPermission, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.class_mode is not None:
            result['ClassMode'] = self.class_mode
        if self.enabled is not None:
            result['Enabled'] = self.enabled
        if self.join_permission_id is not None:
            result['JoinPermissionId'] = self.join_permission_id
        if self.join_permission_name is not None:
            result['JoinPermissionName'] = self.join_permission_name
        if self.join_permission_type is not None:
            result['JoinPermissionType'] = self.join_permission_type
        if self.owner_aliyun_pk is not None:
            result['OwnerAliyunPk'] = self.owner_aliyun_pk
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ClassMode') is not None:
            self.class_mode = m.get('ClassMode')
        if m.get('Enabled') is not None:
            self.enabled = m.get('Enabled')
        if m.get('JoinPermissionId') is not None:
            self.join_permission_id = m.get('JoinPermissionId')
        if m.get('JoinPermissionName') is not None:
            self.join_permission_name = m.get('JoinPermissionName')
        if m.get('JoinPermissionType') is not None:
            self.join_permission_type = m.get('JoinPermissionType')
        if m.get('OwnerAliyunPk') is not None:
            self.owner_aliyun_pk = m.get('OwnerAliyunPk')
        return self


class QueryLoRaJoinPermissionsResponseJoinPermissions(TeaModel):
    def __init__(self, join_permission=None):
        self.join_permission = join_permission  # type: list[QueryLoRaJoinPermissionsResponseJoinPermissionsJoinPermission]

    def validate(self):
        self.validate_required(self.join_permission, 'join_permission')
        if self.join_permission:
            for k in self.join_permission:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryLoRaJoinPermissionsResponseJoinPermissions, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['JoinPermission'] = []
        if self.join_permission is not None:
            for k in self.join_permission:
                result['JoinPermission'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.join_permission = []
        if m.get('JoinPermission') is not None:
            for k in m.get('JoinPermission'):
                temp_model = QueryLoRaJoinPermissionsResponseJoinPermissionsJoinPermission()
                self.join_permission.append(temp_model.from_map(k))
        return self


class QueryLoRaJoinPermissionsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, product_key=None, request_id=None, success=None,
                 join_permissions=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.product_key = product_key  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.join_permissions = join_permissions  # type: QueryLoRaJoinPermissionsResponseJoinPermissions

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.join_permissions, 'join_permissions')
        if self.join_permissions:
            self.join_permissions.validate()

    def to_map(self):
        _map = super(QueryLoRaJoinPermissionsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.join_permissions is not None:
            result['JoinPermissions'] = self.join_permissions.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('JoinPermissions') is not None:
            temp_model = QueryLoRaJoinPermissionsResponseJoinPermissions()
            self.join_permissions = temp_model.from_map(m['JoinPermissions'])
        return self


class QueryMessageInfoRequest(TeaModel):
    def __init__(self, iot_instance_id=None, uni_msg_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.uni_msg_id = uni_msg_id  # type: str

    def validate(self):
        self.validate_required(self.uni_msg_id, 'uni_msg_id')

    def to_map(self):
        _map = super(QueryMessageInfoRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.uni_msg_id is not None:
            result['UniMsgId'] = self.uni_msg_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('UniMsgId') is not None:
            self.uni_msg_id = m.get('UniMsgId')
        return self


class QueryMessageInfoResponseMessageUserProperties(TeaModel):
    def __init__(self, key=None, value=None):
        self.key = key  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.key, 'key')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(QueryMessageInfoResponseMessageUserProperties, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.key is not None:
            result['Key'] = self.key
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Key') is not None:
            self.key = m.get('Key')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class QueryMessageInfoResponseMessage(TeaModel):
    def __init__(self, generate_time=None, message_content=None, topic_full_name=None, uni_msg_id=None,
                 user_properties=None):
        self.generate_time = generate_time  # type: long
        self.message_content = message_content  # type: str
        self.topic_full_name = topic_full_name  # type: str
        self.uni_msg_id = uni_msg_id  # type: str
        self.user_properties = user_properties  # type: list[QueryMessageInfoResponseMessageUserProperties]

    def validate(self):
        self.validate_required(self.generate_time, 'generate_time')
        self.validate_required(self.message_content, 'message_content')
        self.validate_required(self.topic_full_name, 'topic_full_name')
        self.validate_required(self.uni_msg_id, 'uni_msg_id')
        self.validate_required(self.user_properties, 'user_properties')
        if self.user_properties:
            for k in self.user_properties:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryMessageInfoResponseMessage, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.generate_time is not None:
            result['GenerateTime'] = self.generate_time
        if self.message_content is not None:
            result['MessageContent'] = self.message_content
        if self.topic_full_name is not None:
            result['TopicFullName'] = self.topic_full_name
        if self.uni_msg_id is not None:
            result['UniMsgId'] = self.uni_msg_id
        result['UserProperties'] = []
        if self.user_properties is not None:
            for k in self.user_properties:
                result['UserProperties'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GenerateTime') is not None:
            self.generate_time = m.get('GenerateTime')
        if m.get('MessageContent') is not None:
            self.message_content = m.get('MessageContent')
        if m.get('TopicFullName') is not None:
            self.topic_full_name = m.get('TopicFullName')
        if m.get('UniMsgId') is not None:
            self.uni_msg_id = m.get('UniMsgId')
        self.user_properties = []
        if m.get('UserProperties') is not None:
            for k in m.get('UserProperties'):
                temp_model = QueryMessageInfoResponseMessageUserProperties()
                self.user_properties.append(temp_model.from_map(k))
        return self


class QueryMessageInfoResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, message=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.message = message  # type: QueryMessageInfoResponseMessage

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.message, 'message')
        if self.message:
            self.message.validate()

    def to_map(self):
        _map = super(QueryMessageInfoResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.message is not None:
            result['Message'] = self.message.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Message') is not None:
            temp_model = QueryMessageInfoResponseMessage()
            self.message = temp_model.from_map(m['Message'])
        return self


class QueryOTAFirmwareRequest(TeaModel):
    def __init__(self, firmware_id=None, iot_instance_id=None):
        self.firmware_id = firmware_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.firmware_id, 'firmware_id')

    def to_map(self):
        _map = super(QueryOTAFirmwareRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QueryOTAFirmwareResponseFirmwareInfoMultiFiles(TeaModel):
    def __init__(self, file_md_5=None, name=None, sign_value=None, size=None, url=None):
        self.file_md_5 = file_md_5  # type: str
        self.name = name  # type: str
        self.sign_value = sign_value  # type: str
        self.size = size  # type: int
        self.url = url  # type: str

    def validate(self):
        self.validate_required(self.file_md_5, 'file_md_5')
        self.validate_required(self.name, 'name')
        self.validate_required(self.sign_value, 'sign_value')
        self.validate_required(self.size, 'size')
        self.validate_required(self.url, 'url')

    def to_map(self):
        _map = super(QueryOTAFirmwareResponseFirmwareInfoMultiFiles, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.file_md_5 is not None:
            result['FileMd5'] = self.file_md_5
        if self.name is not None:
            result['Name'] = self.name
        if self.sign_value is not None:
            result['SignValue'] = self.sign_value
        if self.size is not None:
            result['Size'] = self.size
        if self.url is not None:
            result['Url'] = self.url
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FileMd5') is not None:
            self.file_md_5 = m.get('FileMd5')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('SignValue') is not None:
            self.sign_value = m.get('SignValue')
        if m.get('Size') is not None:
            self.size = m.get('Size')
        if m.get('Url') is not None:
            self.url = m.get('Url')
        return self


class QueryOTAFirmwareResponseFirmwareInfo(TeaModel):
    def __init__(self, dest_version=None, firmware_desc=None, firmware_id=None, firmware_name=None,
                 firmware_sign=None, firmware_size=None, firmware_url=None, module_name=None, product_key=None, product_name=None,
                 sign_method=None, src_version=None, status=None, type=None, udi=None, utc_create=None, utc_modified=None,
                 verify_progress=None, multi_files=None):
        self.dest_version = dest_version  # type: str
        self.firmware_desc = firmware_desc  # type: str
        self.firmware_id = firmware_id  # type: str
        self.firmware_name = firmware_name  # type: str
        self.firmware_sign = firmware_sign  # type: str
        self.firmware_size = firmware_size  # type: int
        self.firmware_url = firmware_url  # type: str
        self.module_name = module_name  # type: str
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str
        self.sign_method = sign_method  # type: str
        self.src_version = src_version  # type: str
        self.status = status  # type: int
        self.type = type  # type: int
        self.udi = udi  # type: str
        self.utc_create = utc_create  # type: str
        self.utc_modified = utc_modified  # type: str
        self.verify_progress = verify_progress  # type: int
        self.multi_files = multi_files  # type: list[QueryOTAFirmwareResponseFirmwareInfoMultiFiles]

    def validate(self):
        self.validate_required(self.dest_version, 'dest_version')
        self.validate_required(self.firmware_desc, 'firmware_desc')
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.firmware_name, 'firmware_name')
        self.validate_required(self.firmware_sign, 'firmware_sign')
        self.validate_required(self.firmware_size, 'firmware_size')
        self.validate_required(self.firmware_url, 'firmware_url')
        self.validate_required(self.module_name, 'module_name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')
        self.validate_required(self.sign_method, 'sign_method')
        self.validate_required(self.src_version, 'src_version')
        self.validate_required(self.status, 'status')
        self.validate_required(self.type, 'type')
        self.validate_required(self.udi, 'udi')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_modified, 'utc_modified')
        self.validate_required(self.verify_progress, 'verify_progress')
        self.validate_required(self.multi_files, 'multi_files')
        if self.multi_files:
            for k in self.multi_files:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryOTAFirmwareResponseFirmwareInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dest_version is not None:
            result['DestVersion'] = self.dest_version
        if self.firmware_desc is not None:
            result['FirmwareDesc'] = self.firmware_desc
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.firmware_name is not None:
            result['FirmwareName'] = self.firmware_name
        if self.firmware_sign is not None:
            result['FirmwareSign'] = self.firmware_sign
        if self.firmware_size is not None:
            result['FirmwareSize'] = self.firmware_size
        if self.firmware_url is not None:
            result['FirmwareUrl'] = self.firmware_url
        if self.module_name is not None:
            result['ModuleName'] = self.module_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.sign_method is not None:
            result['SignMethod'] = self.sign_method
        if self.src_version is not None:
            result['SrcVersion'] = self.src_version
        if self.status is not None:
            result['Status'] = self.status
        if self.type is not None:
            result['Type'] = self.type
        if self.udi is not None:
            result['Udi'] = self.udi
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        if self.verify_progress is not None:
            result['VerifyProgress'] = self.verify_progress
        result['MultiFiles'] = []
        if self.multi_files is not None:
            for k in self.multi_files:
                result['MultiFiles'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DestVersion') is not None:
            self.dest_version = m.get('DestVersion')
        if m.get('FirmwareDesc') is not None:
            self.firmware_desc = m.get('FirmwareDesc')
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('FirmwareName') is not None:
            self.firmware_name = m.get('FirmwareName')
        if m.get('FirmwareSign') is not None:
            self.firmware_sign = m.get('FirmwareSign')
        if m.get('FirmwareSize') is not None:
            self.firmware_size = m.get('FirmwareSize')
        if m.get('FirmwareUrl') is not None:
            self.firmware_url = m.get('FirmwareUrl')
        if m.get('ModuleName') is not None:
            self.module_name = m.get('ModuleName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('SignMethod') is not None:
            self.sign_method = m.get('SignMethod')
        if m.get('SrcVersion') is not None:
            self.src_version = m.get('SrcVersion')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('Udi') is not None:
            self.udi = m.get('Udi')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        if m.get('VerifyProgress') is not None:
            self.verify_progress = m.get('VerifyProgress')
        self.multi_files = []
        if m.get('MultiFiles') is not None:
            for k in m.get('MultiFiles'):
                temp_model = QueryOTAFirmwareResponseFirmwareInfoMultiFiles()
                self.multi_files.append(temp_model.from_map(k))
        return self


class QueryOTAFirmwareResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, firmware_info=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.firmware_info = firmware_info  # type: QueryOTAFirmwareResponseFirmwareInfo

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.firmware_info, 'firmware_info')
        if self.firmware_info:
            self.firmware_info.validate()

    def to_map(self):
        _map = super(QueryOTAFirmwareResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.firmware_info is not None:
            result['FirmwareInfo'] = self.firmware_info.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('FirmwareInfo') is not None:
            temp_model = QueryOTAFirmwareResponseFirmwareInfo()
            self.firmware_info = temp_model.from_map(m['FirmwareInfo'])
        return self


class QueryOTAJobRequest(TeaModel):
    def __init__(self, iot_instance_id=None, job_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(QueryOTAJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        return self


class QueryOTAJobResponseDataTagsOtaTagDTO(TeaModel):
    def __init__(self, key=None, value=None):
        self.key = key  # type: str
        self.value = value  # type: str

    def validate(self):
        self.validate_required(self.key, 'key')
        self.validate_required(self.value, 'value')

    def to_map(self):
        _map = super(QueryOTAJobResponseDataTagsOtaTagDTO, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.key is not None:
            result['Key'] = self.key
        if self.value is not None:
            result['Value'] = self.value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Key') is not None:
            self.key = m.get('Key')
        if m.get('Value') is not None:
            self.value = m.get('Value')
        return self


class QueryOTAJobResponseDataTags(TeaModel):
    def __init__(self, ota_tag_dto=None):
        self.ota_tag_dto = ota_tag_dto  # type: list[QueryOTAJobResponseDataTagsOtaTagDTO]

    def validate(self):
        self.validate_required(self.ota_tag_dto, 'ota_tag_dto')
        if self.ota_tag_dto:
            for k in self.ota_tag_dto:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryOTAJobResponseDataTags, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['OtaTagDTO'] = []
        if self.ota_tag_dto is not None:
            for k in self.ota_tag_dto:
                result['OtaTagDTO'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.ota_tag_dto = []
        if m.get('OtaTagDTO') is not None:
            for k in m.get('OtaTagDTO'):
                temp_model = QueryOTAJobResponseDataTagsOtaTagDTO()
                self.ota_tag_dto.append(temp_model.from_map(k))
        return self


class QueryOTAJobResponseDataSrcVersions(TeaModel):
    def __init__(self, src_version=None):
        # SrcVersion
        self.src_version = src_version  # type: list[str]

    def validate(self):
        self.validate_required(self.src_version, 'src_version')

    def to_map(self):
        _map = super(QueryOTAJobResponseDataSrcVersions, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.src_version is not None:
            result['SrcVersion'] = self.src_version
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('SrcVersion') is not None:
            self.src_version = m.get('SrcVersion')
        return self


class QueryOTAJobResponseData(TeaModel):
    def __init__(self, dest_version=None, download_protocol=None, dynamic_mode=None, firmware_id=None,
                 gray_percent=None, group_id=None, group_name=None, job_desc=None, job_id=None, job_status=None, job_type=None,
                 maximum_per_minute=None, multi_module_mode=None, name=None, need_confirm=None, need_push=None, overwrite_mode=None,
                 product_key=None, retry_count=None, retry_interval=None, selection_type=None, target_selection=None,
                 timeout_in_minutes=None, utc_create=None, utc_end_time=None, utc_modified=None, utc_schedule_finish_time=None,
                 utc_schedule_time=None, utc_start_time=None, tags=None, src_versions=None):
        self.dest_version = dest_version  # type: str
        self.download_protocol = download_protocol  # type: str
        self.dynamic_mode = dynamic_mode  # type: int
        self.firmware_id = firmware_id  # type: str
        self.gray_percent = gray_percent  # type: str
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str
        self.job_desc = job_desc  # type: str
        self.job_id = job_id  # type: str
        self.job_status = job_status  # type: str
        self.job_type = job_type  # type: str
        self.maximum_per_minute = maximum_per_minute  # type: int
        self.multi_module_mode = multi_module_mode  # type: bool
        self.name = name  # type: str
        self.need_confirm = need_confirm  # type: bool
        self.need_push = need_push  # type: bool
        self.overwrite_mode = overwrite_mode  # type: int
        self.product_key = product_key  # type: str
        self.retry_count = retry_count  # type: int
        self.retry_interval = retry_interval  # type: int
        self.selection_type = selection_type  # type: str
        self.target_selection = target_selection  # type: str
        self.timeout_in_minutes = timeout_in_minutes  # type: int
        self.utc_create = utc_create  # type: str
        self.utc_end_time = utc_end_time  # type: str
        self.utc_modified = utc_modified  # type: str
        self.utc_schedule_finish_time = utc_schedule_finish_time  # type: str
        self.utc_schedule_time = utc_schedule_time  # type: str
        self.utc_start_time = utc_start_time  # type: str
        self.tags = tags  # type: QueryOTAJobResponseDataTags
        self.src_versions = src_versions  # type: QueryOTAJobResponseDataSrcVersions

    def validate(self):
        self.validate_required(self.dest_version, 'dest_version')
        self.validate_required(self.download_protocol, 'download_protocol')
        self.validate_required(self.dynamic_mode, 'dynamic_mode')
        self.validate_required(self.firmware_id, 'firmware_id')
        self.validate_required(self.gray_percent, 'gray_percent')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')
        self.validate_required(self.job_desc, 'job_desc')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.job_status, 'job_status')
        self.validate_required(self.job_type, 'job_type')
        self.validate_required(self.maximum_per_minute, 'maximum_per_minute')
        self.validate_required(self.multi_module_mode, 'multi_module_mode')
        self.validate_required(self.name, 'name')
        self.validate_required(self.need_confirm, 'need_confirm')
        self.validate_required(self.need_push, 'need_push')
        self.validate_required(self.overwrite_mode, 'overwrite_mode')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.retry_count, 'retry_count')
        self.validate_required(self.retry_interval, 'retry_interval')
        self.validate_required(self.selection_type, 'selection_type')
        self.validate_required(self.target_selection, 'target_selection')
        self.validate_required(self.timeout_in_minutes, 'timeout_in_minutes')
        self.validate_required(self.utc_create, 'utc_create')
        self.validate_required(self.utc_end_time, 'utc_end_time')
        self.validate_required(self.utc_modified, 'utc_modified')
        self.validate_required(self.utc_schedule_finish_time, 'utc_schedule_finish_time')
        self.validate_required(self.utc_schedule_time, 'utc_schedule_time')
        self.validate_required(self.utc_start_time, 'utc_start_time')
        self.validate_required(self.tags, 'tags')
        if self.tags:
            self.tags.validate()
        self.validate_required(self.src_versions, 'src_versions')
        if self.src_versions:
            self.src_versions.validate()

    def to_map(self):
        _map = super(QueryOTAJobResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dest_version is not None:
            result['DestVersion'] = self.dest_version
        if self.download_protocol is not None:
            result['DownloadProtocol'] = self.download_protocol
        if self.dynamic_mode is not None:
            result['DynamicMode'] = self.dynamic_mode
        if self.firmware_id is not None:
            result['FirmwareId'] = self.firmware_id
        if self.gray_percent is not None:
            result['GrayPercent'] = self.gray_percent
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.job_desc is not None:
            result['JobDesc'] = self.job_desc
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.job_status is not None:
            result['JobStatus'] = self.job_status
        if self.job_type is not None:
            result['JobType'] = self.job_type
        if self.maximum_per_minute is not None:
            result['MaximumPerMinute'] = self.maximum_per_minute
        if self.multi_module_mode is not None:
            result['MultiModuleMode'] = self.multi_module_mode
        if self.name is not None:
            result['Name'] = self.name
        if self.need_confirm is not None:
            result['NeedConfirm'] = self.need_confirm
        if self.need_push is not None:
            result['NeedPush'] = self.need_push
        if self.overwrite_mode is not None:
            result['OverwriteMode'] = self.overwrite_mode
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.retry_count is not None:
            result['RetryCount'] = self.retry_count
        if self.retry_interval is not None:
            result['RetryInterval'] = self.retry_interval
        if self.selection_type is not None:
            result['SelectionType'] = self.selection_type
        if self.target_selection is not None:
            result['TargetSelection'] = self.target_selection
        if self.timeout_in_minutes is not None:
            result['TimeoutInMinutes'] = self.timeout_in_minutes
        if self.utc_create is not None:
            result['UtcCreate'] = self.utc_create
        if self.utc_end_time is not None:
            result['UtcEndTime'] = self.utc_end_time
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        if self.utc_schedule_finish_time is not None:
            result['UtcScheduleFinishTime'] = self.utc_schedule_finish_time
        if self.utc_schedule_time is not None:
            result['UtcScheduleTime'] = self.utc_schedule_time
        if self.utc_start_time is not None:
            result['UtcStartTime'] = self.utc_start_time
        if self.tags is not None:
            result['Tags'] = self.tags.to_map()
        if self.src_versions is not None:
            result['SrcVersions'] = self.src_versions.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DestVersion') is not None:
            self.dest_version = m.get('DestVersion')
        if m.get('DownloadProtocol') is not None:
            self.download_protocol = m.get('DownloadProtocol')
        if m.get('DynamicMode') is not None:
            self.dynamic_mode = m.get('DynamicMode')
        if m.get('FirmwareId') is not None:
            self.firmware_id = m.get('FirmwareId')
        if m.get('GrayPercent') is not None:
            self.gray_percent = m.get('GrayPercent')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('JobDesc') is not None:
            self.job_desc = m.get('JobDesc')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('JobStatus') is not None:
            self.job_status = m.get('JobStatus')
        if m.get('JobType') is not None:
            self.job_type = m.get('JobType')
        if m.get('MaximumPerMinute') is not None:
            self.maximum_per_minute = m.get('MaximumPerMinute')
        if m.get('MultiModuleMode') is not None:
            self.multi_module_mode = m.get('MultiModuleMode')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('NeedConfirm') is not None:
            self.need_confirm = m.get('NeedConfirm')
        if m.get('NeedPush') is not None:
            self.need_push = m.get('NeedPush')
        if m.get('OverwriteMode') is not None:
            self.overwrite_mode = m.get('OverwriteMode')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RetryCount') is not None:
            self.retry_count = m.get('RetryCount')
        if m.get('RetryInterval') is not None:
            self.retry_interval = m.get('RetryInterval')
        if m.get('SelectionType') is not None:
            self.selection_type = m.get('SelectionType')
        if m.get('TargetSelection') is not None:
            self.target_selection = m.get('TargetSelection')
        if m.get('TimeoutInMinutes') is not None:
            self.timeout_in_minutes = m.get('TimeoutInMinutes')
        if m.get('UtcCreate') is not None:
            self.utc_create = m.get('UtcCreate')
        if m.get('UtcEndTime') is not None:
            self.utc_end_time = m.get('UtcEndTime')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        if m.get('UtcScheduleFinishTime') is not None:
            self.utc_schedule_finish_time = m.get('UtcScheduleFinishTime')
        if m.get('UtcScheduleTime') is not None:
            self.utc_schedule_time = m.get('UtcScheduleTime')
        if m.get('UtcStartTime') is not None:
            self.utc_start_time = m.get('UtcStartTime')
        if m.get('Tags') is not None:
            temp_model = QueryOTAJobResponseDataTags()
            self.tags = temp_model.from_map(m['Tags'])
        if m.get('SrcVersions') is not None:
            temp_model = QueryOTAJobResponseDataSrcVersions()
            self.src_versions = temp_model.from_map(m['SrcVersions'])
        return self


class QueryOTAJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryOTAJobResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryOTAJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryOTAJobResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryPageByApplyIdRequest(TeaModel):
    def __init__(self, apply_id=None, current_page=None, iot_instance_id=None, page_size=None):
        self.apply_id = apply_id  # type: long
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.apply_id, 'apply_id')

    def to_map(self):
        _map = super(QueryPageByApplyIdRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.apply_id is not None:
            result['ApplyId'] = self.apply_id
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplyId') is not None:
            self.apply_id = m.get('ApplyId')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryPageByApplyIdResponseApplyDeviceListApplyDeviceInfo(TeaModel):
    def __init__(self, device_id=None, device_name=None, device_secret=None, iot_id=None):
        self.device_id = device_id  # type: str
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.iot_id = iot_id  # type: str

    def validate(self):
        self.validate_required(self.device_id, 'device_id')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(QueryPageByApplyIdResponseApplyDeviceListApplyDeviceInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_id is not None:
            result['DeviceId'] = self.device_id
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceId') is not None:
            self.device_id = m.get('DeviceId')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        return self


class QueryPageByApplyIdResponseApplyDeviceList(TeaModel):
    def __init__(self, apply_device_info=None):
        self.apply_device_info = apply_device_info  # type: list[QueryPageByApplyIdResponseApplyDeviceListApplyDeviceInfo]

    def validate(self):
        self.validate_required(self.apply_device_info, 'apply_device_info')
        if self.apply_device_info:
            for k in self.apply_device_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryPageByApplyIdResponseApplyDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ApplyDeviceInfo'] = []
        if self.apply_device_info is not None:
            for k in self.apply_device_info:
                result['ApplyDeviceInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.apply_device_info = []
        if m.get('ApplyDeviceInfo') is not None:
            for k in m.get('ApplyDeviceInfo'):
                temp_model = QueryPageByApplyIdResponseApplyDeviceListApplyDeviceInfo()
                self.apply_device_info.append(temp_model.from_map(k))
        return self


class QueryPageByApplyIdResponse(TeaModel):
    def __init__(self, code=None, error_message=None, page=None, page_count=None, page_size=None, request_id=None,
                 success=None, total=None, apply_device_list=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.page = page  # type: int
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.total = total  # type: int
        self.apply_device_list = apply_device_list  # type: QueryPageByApplyIdResponseApplyDeviceList

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.page, 'page')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.total, 'total')
        self.validate_required(self.apply_device_list, 'apply_device_list')
        if self.apply_device_list:
            self.apply_device_list.validate()

    def to_map(self):
        _map = super(QueryPageByApplyIdResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.page is not None:
            result['Page'] = self.page
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.total is not None:
            result['Total'] = self.total
        if self.apply_device_list is not None:
            result['ApplyDeviceList'] = self.apply_device_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Page') is not None:
            self.page = m.get('Page')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('ApplyDeviceList') is not None:
            temp_model = QueryPageByApplyIdResponseApplyDeviceList()
            self.apply_device_list = temp_model.from_map(m['ApplyDeviceList'])
        return self


class QueryProductRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryProductRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryProductResponseData(TeaModel):
    def __init__(self, aliyun_commodity_code=None, auth_type=None, category_key=None, category_name=None,
                 data_format=None, description=None, device_count=None, gmt_create=None, id_2=None, net_type=None,
                 node_type=None, owner=None, product_key=None, product_name=None, product_secret=None, product_status=None,
                 protocol_type=None, validate_type=None):
        self.aliyun_commodity_code = aliyun_commodity_code  # type: str
        self.auth_type = auth_type  # type: str
        self.category_key = category_key  # type: str
        self.category_name = category_name  # type: str
        self.data_format = data_format  # type: int
        self.description = description  # type: str
        self.device_count = device_count  # type: int
        self.gmt_create = gmt_create  # type: long
        self.id_2 = id_2  # type: bool
        self.net_type = net_type  # type: int
        self.node_type = node_type  # type: int
        self.owner = owner  # type: bool
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str
        self.product_secret = product_secret  # type: str
        self.product_status = product_status  # type: str
        self.protocol_type = protocol_type  # type: str
        self.validate_type = validate_type  # type: int

    def validate(self):
        self.validate_required(self.aliyun_commodity_code, 'aliyun_commodity_code')
        self.validate_required(self.auth_type, 'auth_type')
        self.validate_required(self.category_key, 'category_key')
        self.validate_required(self.category_name, 'category_name')
        self.validate_required(self.data_format, 'data_format')
        self.validate_required(self.description, 'description')
        self.validate_required(self.device_count, 'device_count')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.id_2, 'id_2')
        self.validate_required(self.net_type, 'net_type')
        self.validate_required(self.node_type, 'node_type')
        self.validate_required(self.owner, 'owner')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')
        self.validate_required(self.product_secret, 'product_secret')
        self.validate_required(self.product_status, 'product_status')
        self.validate_required(self.protocol_type, 'protocol_type')
        self.validate_required(self.validate_type, 'validate_type')

    def to_map(self):
        _map = super(QueryProductResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.aliyun_commodity_code is not None:
            result['AliyunCommodityCode'] = self.aliyun_commodity_code
        if self.auth_type is not None:
            result['AuthType'] = self.auth_type
        if self.category_key is not None:
            result['CategoryKey'] = self.category_key
        if self.category_name is not None:
            result['CategoryName'] = self.category_name
        if self.data_format is not None:
            result['DataFormat'] = self.data_format
        if self.description is not None:
            result['Description'] = self.description
        if self.device_count is not None:
            result['DeviceCount'] = self.device_count
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.id_2 is not None:
            result['Id2'] = self.id_2
        if self.net_type is not None:
            result['NetType'] = self.net_type
        if self.node_type is not None:
            result['NodeType'] = self.node_type
        if self.owner is not None:
            result['Owner'] = self.owner
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        if self.product_secret is not None:
            result['ProductSecret'] = self.product_secret
        if self.product_status is not None:
            result['ProductStatus'] = self.product_status
        if self.protocol_type is not None:
            result['ProtocolType'] = self.protocol_type
        if self.validate_type is not None:
            result['ValidateType'] = self.validate_type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AliyunCommodityCode') is not None:
            self.aliyun_commodity_code = m.get('AliyunCommodityCode')
        if m.get('AuthType') is not None:
            self.auth_type = m.get('AuthType')
        if m.get('CategoryKey') is not None:
            self.category_key = m.get('CategoryKey')
        if m.get('CategoryName') is not None:
            self.category_name = m.get('CategoryName')
        if m.get('DataFormat') is not None:
            self.data_format = m.get('DataFormat')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('DeviceCount') is not None:
            self.device_count = m.get('DeviceCount')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('Id2') is not None:
            self.id_2 = m.get('Id2')
        if m.get('NetType') is not None:
            self.net_type = m.get('NetType')
        if m.get('NodeType') is not None:
            self.node_type = m.get('NodeType')
        if m.get('Owner') is not None:
            self.owner = m.get('Owner')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        if m.get('ProductSecret') is not None:
            self.product_secret = m.get('ProductSecret')
        if m.get('ProductStatus') is not None:
            self.product_status = m.get('ProductStatus')
        if m.get('ProtocolType') is not None:
            self.protocol_type = m.get('ProtocolType')
        if m.get('ValidateType') is not None:
            self.validate_type = m.get('ValidateType')
        return self


class QueryProductResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryProductResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryProductResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryProductResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryProductCertInfoRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryProductCertInfoRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryProductCertInfoResponseProductCertInfo(TeaModel):
    def __init__(self, issue_model=None):
        self.issue_model = issue_model  # type: int

    def validate(self):
        self.validate_required(self.issue_model, 'issue_model')

    def to_map(self):
        _map = super(QueryProductCertInfoResponseProductCertInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.issue_model is not None:
            result['IssueModel'] = self.issue_model
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IssueModel') is not None:
            self.issue_model = m.get('IssueModel')
        return self


class QueryProductCertInfoResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, product_cert_info=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.product_cert_info = product_cert_info  # type: QueryProductCertInfoResponseProductCertInfo

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.product_cert_info, 'product_cert_info')
        if self.product_cert_info:
            self.product_cert_info.validate()

    def to_map(self):
        _map = super(QueryProductCertInfoResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.product_cert_info is not None:
            result['ProductCertInfo'] = self.product_cert_info.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('ProductCertInfo') is not None:
            temp_model = QueryProductCertInfoResponseProductCertInfo()
            self.product_cert_info = temp_model.from_map(m['ProductCertInfo'])
        return self


class QueryProductListRequest(TeaModel):
    def __init__(self, aliyun_commodity_code=None, current_page=None, iot_instance_id=None, page_size=None,
                 resource_group_id=None):
        self.aliyun_commodity_code = aliyun_commodity_code  # type: str
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.resource_group_id = resource_group_id  # type: str

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QueryProductListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.aliyun_commodity_code is not None:
            result['AliyunCommodityCode'] = self.aliyun_commodity_code
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AliyunCommodityCode') is not None:
            self.aliyun_commodity_code = m.get('AliyunCommodityCode')
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        return self


class QueryProductListResponseDataListProductInfo(TeaModel):
    def __init__(self, auth_type=None, data_format=None, description=None, device_count=None, gmt_create=None,
                 node_type=None, product_key=None, product_name=None):
        self.auth_type = auth_type  # type: str
        self.data_format = data_format  # type: int
        self.description = description  # type: str
        self.device_count = device_count  # type: int
        self.gmt_create = gmt_create  # type: long
        self.node_type = node_type  # type: int
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str

    def validate(self):
        self.validate_required(self.auth_type, 'auth_type')
        self.validate_required(self.data_format, 'data_format')
        self.validate_required(self.description, 'description')
        self.validate_required(self.device_count, 'device_count')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.node_type, 'node_type')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')

    def to_map(self):
        _map = super(QueryProductListResponseDataListProductInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.auth_type is not None:
            result['AuthType'] = self.auth_type
        if self.data_format is not None:
            result['DataFormat'] = self.data_format
        if self.description is not None:
            result['Description'] = self.description
        if self.device_count is not None:
            result['DeviceCount'] = self.device_count
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.node_type is not None:
            result['NodeType'] = self.node_type
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AuthType') is not None:
            self.auth_type = m.get('AuthType')
        if m.get('DataFormat') is not None:
            self.data_format = m.get('DataFormat')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('DeviceCount') is not None:
            self.device_count = m.get('DeviceCount')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('NodeType') is not None:
            self.node_type = m.get('NodeType')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        return self


class QueryProductListResponseDataList(TeaModel):
    def __init__(self, product_info=None):
        self.product_info = product_info  # type: list[QueryProductListResponseDataListProductInfo]

    def validate(self):
        self.validate_required(self.product_info, 'product_info')
        if self.product_info:
            for k in self.product_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryProductListResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ProductInfo'] = []
        if self.product_info is not None:
            for k in self.product_info:
                result['ProductInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.product_info = []
        if m.get('ProductInfo') is not None:
            for k in m.get('ProductInfo'):
                temp_model = QueryProductListResponseDataListProductInfo()
                self.product_info.append(temp_model.from_map(k))
        return self


class QueryProductListResponseData(TeaModel):
    def __init__(self, current_page=None, page_count=None, page_size=None, total=None, list=None):
        self.current_page = current_page  # type: int
        self.page_count = page_count  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QueryProductListResponseDataList

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_count, 'page_count')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryProductListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_count is not None:
            result['PageCount'] = self.page_count
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageCount') is not None:
            self.page_count = m.get('PageCount')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QueryProductListResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryProductListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryProductListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryProductListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryProductListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryProductTopicRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryProductTopicRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryProductTopicResponseDataProductTopicInfo(TeaModel):
    def __init__(self, desc=None, id=None, operation=None, product_key=None, topic_short_name=None):
        self.desc = desc  # type: str
        self.id = id  # type: str
        self.operation = operation  # type: str
        self.product_key = product_key  # type: str
        self.topic_short_name = topic_short_name  # type: str

    def validate(self):
        self.validate_required(self.desc, 'desc')
        self.validate_required(self.id, 'id')
        self.validate_required(self.operation, 'operation')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.topic_short_name, 'topic_short_name')

    def to_map(self):
        _map = super(QueryProductTopicResponseDataProductTopicInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.desc is not None:
            result['Desc'] = self.desc
        if self.id is not None:
            result['Id'] = self.id
        if self.operation is not None:
            result['Operation'] = self.operation
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.topic_short_name is not None:
            result['TopicShortName'] = self.topic_short_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Desc') is not None:
            self.desc = m.get('Desc')
        if m.get('Id') is not None:
            self.id = m.get('Id')
        if m.get('Operation') is not None:
            self.operation = m.get('Operation')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('TopicShortName') is not None:
            self.topic_short_name = m.get('TopicShortName')
        return self


class QueryProductTopicResponseData(TeaModel):
    def __init__(self, product_topic_info=None):
        self.product_topic_info = product_topic_info  # type: list[QueryProductTopicResponseDataProductTopicInfo]

    def validate(self):
        self.validate_required(self.product_topic_info, 'product_topic_info')
        if self.product_topic_info:
            for k in self.product_topic_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryProductTopicResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ProductTopicInfo'] = []
        if self.product_topic_info is not None:
            for k in self.product_topic_info:
                result['ProductTopicInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.product_topic_info = []
        if m.get('ProductTopicInfo') is not None:
            for k in m.get('ProductTopicInfo'):
                temp_model = QueryProductTopicResponseDataProductTopicInfo()
                self.product_topic_info.append(temp_model.from_map(k))
        return self


class QueryProductTopicResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryProductTopicResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryProductTopicResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryProductTopicResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryProjectShareDeviceListRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, page_id=None, page_size=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryProjectShareDeviceListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryProjectShareDeviceListResponseDataDeviceListItems(TeaModel):
    def __init__(self, device_name=None, iot_id=None, product_key=None, sharable=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.product_key = product_key  # type: str
        self.sharable = sharable  # type: long

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.sharable, 'sharable')

    def to_map(self):
        _map = super(QueryProjectShareDeviceListResponseDataDeviceListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.sharable is not None:
            result['Sharable'] = self.sharable
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Sharable') is not None:
            self.sharable = m.get('Sharable')
        return self


class QueryProjectShareDeviceListResponseDataDeviceList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QueryProjectShareDeviceListResponseDataDeviceListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryProjectShareDeviceListResponseDataDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['items'] = []
        if self.items is not None:
            for k in self.items:
                result['items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('items') is not None:
            for k in m.get('items'):
                temp_model = QueryProjectShareDeviceListResponseDataDeviceListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QueryProjectShareDeviceListResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, device_list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.device_list = device_list  # type: QueryProjectShareDeviceListResponseDataDeviceList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.device_list, 'device_list')
        if self.device_list:
            self.device_list.validate()

    def to_map(self):
        _map = super(QueryProjectShareDeviceListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.device_list is not None:
            result['DeviceList'] = self.device_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('DeviceList') is not None:
            temp_model = QueryProjectShareDeviceListResponseDataDeviceList()
            self.device_list = temp_model.from_map(m['DeviceList'])
        return self


class QueryProjectShareDeviceListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryProjectShareDeviceListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryProjectShareDeviceListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryProjectShareDeviceListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySceneRuleRequest(TeaModel):
    def __init__(self, current_page=None, iot_instance_id=None, page_size=None, rule_name=None):
        self.current_page = current_page  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.rule_name = rule_name  # type: str

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')

    def to_map(self):
        _map = super(QuerySceneRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.rule_name is not None:
            result['RuleName'] = self.rule_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RuleName') is not None:
            self.rule_name = m.get('RuleName')
        return self


class QuerySceneRuleResponseDataRuleList(TeaModel):
    def __init__(self, gmt_create=None, gmt_modified=None, rule_description=None, rule_id=None, rule_name=None,
                 rule_status=None):
        self.gmt_create = gmt_create  # type: long
        self.gmt_modified = gmt_modified  # type: long
        self.rule_description = rule_description  # type: str
        self.rule_id = rule_id  # type: str
        self.rule_name = rule_name  # type: str
        self.rule_status = rule_status  # type: int

    def validate(self):
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.rule_description, 'rule_description')
        self.validate_required(self.rule_id, 'rule_id')
        self.validate_required(self.rule_name, 'rule_name')
        self.validate_required(self.rule_status, 'rule_status')

    def to_map(self):
        _map = super(QuerySceneRuleResponseDataRuleList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.rule_description is not None:
            result['RuleDescription'] = self.rule_description
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        if self.rule_name is not None:
            result['RuleName'] = self.rule_name
        if self.rule_status is not None:
            result['RuleStatus'] = self.rule_status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('RuleDescription') is not None:
            self.rule_description = m.get('RuleDescription')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        if m.get('RuleName') is not None:
            self.rule_name = m.get('RuleName')
        if m.get('RuleStatus') is not None:
            self.rule_status = m.get('RuleStatus')
        return self


class QuerySceneRuleResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, rule_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.rule_list = rule_list  # type: list[QuerySceneRuleResponseDataRuleList]

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.rule_list, 'rule_list')
        if self.rule_list:
            for k in self.rule_list:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySceneRuleResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        result['RuleList'] = []
        if self.rule_list is not None:
            for k in self.rule_list:
                result['RuleList'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        self.rule_list = []
        if m.get('RuleList') is not None:
            for k in m.get('RuleList'):
                temp_model = QuerySceneRuleResponseDataRuleList()
                self.rule_list.append(temp_model.from_map(k))
        return self


class QuerySceneRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySceneRuleResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySceneRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySceneRuleResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySchedulePeriodListRequest(TeaModel):
    def __init__(self, iot_instance_id=None, page_id=None, page_size=None, schedule_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.schedule_code = schedule_code  # type: str

    def validate(self):
        self.validate_required(self.schedule_code, 'schedule_code')

    def to_map(self):
        _map = super(QuerySchedulePeriodListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        return self


class QuerySchedulePeriodListResponseDataListItems(TeaModel):
    def __init__(self, description=None, end_time=None, period_code=None, sound_code_content=None, start_time=None):
        self.description = description  # type: str
        self.end_time = end_time  # type: str
        self.period_code = period_code  # type: str
        self.sound_code_content = sound_code_content  # type: str
        self.start_time = start_time  # type: str

    def validate(self):
        self.validate_required(self.description, 'description')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.period_code, 'period_code')
        self.validate_required(self.sound_code_content, 'sound_code_content')
        self.validate_required(self.start_time, 'start_time')

    def to_map(self):
        _map = super(QuerySchedulePeriodListResponseDataListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.period_code is not None:
            result['PeriodCode'] = self.period_code
        if self.sound_code_content is not None:
            result['SoundCodeContent'] = self.sound_code_content
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('PeriodCode') is not None:
            self.period_code = m.get('PeriodCode')
        if m.get('SoundCodeContent') is not None:
            self.sound_code_content = m.get('SoundCodeContent')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class QuerySchedulePeriodListResponseDataList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySchedulePeriodListResponseDataListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySchedulePeriodListResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySchedulePeriodListResponseDataListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySchedulePeriodListResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QuerySchedulePeriodListResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QuerySchedulePeriodListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QuerySchedulePeriodListResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QuerySchedulePeriodListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySchedulePeriodListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySchedulePeriodListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySchedulePeriodListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryShareTaskDeviceListRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, page_id=None, page_size=None, share_task_id=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.share_task_id = share_task_id  # type: str

    def validate(self):
        self.validate_required(self.share_task_id, 'share_task_id')

    def to_map(self):
        _map = super(QueryShareTaskDeviceListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.share_task_id is not None:
            result['ShareTaskId'] = self.share_task_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ShareTaskId') is not None:
            self.share_task_id = m.get('ShareTaskId')
        return self


class QueryShareTaskDeviceListResponseDataDeviceListItems(TeaModel):
    def __init__(self, device_name=None, gmt_added=None, iot_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.gmt_added = gmt_added  # type: long
        self.iot_id = iot_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.gmt_added, 'gmt_added')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryShareTaskDeviceListResponseDataDeviceListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.gmt_added is not None:
            result['GmtAdded'] = self.gmt_added
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('GmtAdded') is not None:
            self.gmt_added = m.get('GmtAdded')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryShareTaskDeviceListResponseDataDeviceList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QueryShareTaskDeviceListResponseDataDeviceListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryShareTaskDeviceListResponseDataDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['items'] = []
        if self.items is not None:
            for k in self.items:
                result['items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('items') is not None:
            for k in m.get('items'):
                temp_model = QueryShareTaskDeviceListResponseDataDeviceListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QueryShareTaskDeviceListResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, device_list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.device_list = device_list  # type: QueryShareTaskDeviceListResponseDataDeviceList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.device_list, 'device_list')
        if self.device_list:
            self.device_list.validate()

    def to_map(self):
        _map = super(QueryShareTaskDeviceListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.device_list is not None:
            result['DeviceList'] = self.device_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('DeviceList') is not None:
            temp_model = QueryShareTaskDeviceListResponseDataDeviceList()
            self.device_list = temp_model.from_map(m['DeviceList'])
        return self


class QueryShareTaskDeviceListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryShareTaskDeviceListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryShareTaskDeviceListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryShareTaskDeviceListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySolutionDeviceGroupPageRequest(TeaModel):
    def __init__(self, fuzzy_group_name=None, iot_instance_id=None, page_id=None, page_size=None, project_code=None):
        self.fuzzy_group_name = fuzzy_group_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.project_code = project_code  # type: str

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.project_code, 'project_code')

    def to_map(self):
        _map = super(QuerySolutionDeviceGroupPageRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.fuzzy_group_name is not None:
            result['FuzzyGroupName'] = self.fuzzy_group_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.project_code is not None:
            result['ProjectCode'] = self.project_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FuzzyGroupName') is not None:
            self.fuzzy_group_name = m.get('FuzzyGroupName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProjectCode') is not None:
            self.project_code = m.get('ProjectCode')
        return self


class QuerySolutionDeviceGroupPageResponseDataListItemName(TeaModel):
    def __init__(self, device_count=None, gmt_create=None, gmt_modified=None, group_desc=None, group_id=None,
                 group_name=None):
        self.device_count = device_count  # type: long
        self.gmt_create = gmt_create  # type: long
        self.gmt_modified = gmt_modified  # type: long
        self.group_desc = group_desc  # type: str
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str

    def validate(self):
        self.validate_required(self.device_count, 'device_count')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.group_desc, 'group_desc')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')

    def to_map(self):
        _map = super(QuerySolutionDeviceGroupPageResponseDataListItemName, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_count is not None:
            result['DeviceCount'] = self.device_count
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.group_desc is not None:
            result['GroupDesc'] = self.group_desc
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceCount') is not None:
            self.device_count = m.get('DeviceCount')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('GroupDesc') is not None:
            self.group_desc = m.get('GroupDesc')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        return self


class QuerySolutionDeviceGroupPageResponseDataList(TeaModel):
    def __init__(self, item_name=None):
        self.item_name = item_name  # type: list[QuerySolutionDeviceGroupPageResponseDataListItemName]

    def validate(self):
        self.validate_required(self.item_name, 'item_name')
        if self.item_name:
            for k in self.item_name:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySolutionDeviceGroupPageResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['itemName'] = []
        if self.item_name is not None:
            for k in self.item_name:
                result['itemName'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.item_name = []
        if m.get('itemName') is not None:
            for k in m.get('itemName'):
                temp_model = QuerySolutionDeviceGroupPageResponseDataListItemName()
                self.item_name.append(temp_model.from_map(k))
        return self


class QuerySolutionDeviceGroupPageResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QuerySolutionDeviceGroupPageResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QuerySolutionDeviceGroupPageResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QuerySolutionDeviceGroupPageResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QuerySolutionDeviceGroupPageResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySolutionDeviceGroupPageResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySolutionDeviceGroupPageResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySolutionDeviceGroupPageResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySoundCodeLabelBatchFailedResultRequest(TeaModel):
    def __init__(self, batch_code=None, iot_instance_id=None):
        self.batch_code = batch_code  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.batch_code, 'batch_code')

    def to_map(self):
        _map = super(QuerySoundCodeLabelBatchFailedResultRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.batch_code is not None:
            result['BatchCode'] = self.batch_code
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BatchCode') is not None:
            self.batch_code = m.get('BatchCode')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QuerySoundCodeLabelBatchFailedResultResponseDataItems(TeaModel):
    def __init__(self, error_message=None, label=None, result_code=None):
        self.error_message = error_message  # type: str
        self.label = label  # type: str
        self.result_code = result_code  # type: str

    def validate(self):
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.label, 'label')
        self.validate_required(self.result_code, 'result_code')

    def to_map(self):
        _map = super(QuerySoundCodeLabelBatchFailedResultResponseDataItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.label is not None:
            result['Label'] = self.label
        if self.result_code is not None:
            result['ResultCode'] = self.result_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Label') is not None:
            self.label = m.get('Label')
        if m.get('ResultCode') is not None:
            self.result_code = m.get('ResultCode')
        return self


class QuerySoundCodeLabelBatchFailedResultResponseData(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySoundCodeLabelBatchFailedResultResponseDataItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySoundCodeLabelBatchFailedResultResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySoundCodeLabelBatchFailedResultResponseDataItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySoundCodeLabelBatchFailedResultResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySoundCodeLabelBatchFailedResultResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySoundCodeLabelBatchFailedResultResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySoundCodeLabelBatchFailedResultResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySoundCodeLabelBatchListRequest(TeaModel):
    def __init__(self, iot_instance_id=None, page_id=None, page_size=None, schedule_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.schedule_code = schedule_code  # type: str

    def validate(self):
        self.validate_required(self.schedule_code, 'schedule_code')

    def to_map(self):
        _map = super(QuerySoundCodeLabelBatchListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        return self


class QuerySoundCodeLabelBatchListResponseDataListItems(TeaModel):
    def __init__(self, batch_code=None, description=None, gmt_create=None, status=None, success_num=None, total=None):
        self.batch_code = batch_code  # type: str
        self.description = description  # type: str
        self.gmt_create = gmt_create  # type: long
        self.status = status  # type: str
        self.success_num = success_num  # type: int
        self.total = total  # type: int

    def validate(self):
        self.validate_required(self.batch_code, 'batch_code')
        self.validate_required(self.description, 'description')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.status, 'status')
        self.validate_required(self.success_num, 'success_num')
        self.validate_required(self.total, 'total')

    def to_map(self):
        _map = super(QuerySoundCodeLabelBatchListResponseDataListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.batch_code is not None:
            result['BatchCode'] = self.batch_code
        if self.description is not None:
            result['Description'] = self.description
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.status is not None:
            result['Status'] = self.status
        if self.success_num is not None:
            result['SuccessNum'] = self.success_num
        if self.total is not None:
            result['Total'] = self.total
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BatchCode') is not None:
            self.batch_code = m.get('BatchCode')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('SuccessNum') is not None:
            self.success_num = m.get('SuccessNum')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        return self


class QuerySoundCodeLabelBatchListResponseDataList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySoundCodeLabelBatchListResponseDataListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySoundCodeLabelBatchListResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySoundCodeLabelBatchListResponseDataListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySoundCodeLabelBatchListResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QuerySoundCodeLabelBatchListResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QuerySoundCodeLabelBatchListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QuerySoundCodeLabelBatchListResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QuerySoundCodeLabelBatchListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySoundCodeLabelBatchListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySoundCodeLabelBatchListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySoundCodeLabelBatchListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySoundCodeLabelListRequest(TeaModel):
    def __init__(self, iot_instance_id=None, page_id=None, page_size=None, schedule_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.schedule_code = schedule_code  # type: str

    def validate(self):
        self.validate_required(self.schedule_code, 'schedule_code')

    def to_map(self):
        _map = super(QuerySoundCodeLabelListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        return self


class QuerySoundCodeLabelListResponseDataListItems(TeaModel):
    def __init__(self, label=None, sound_code=None):
        self.label = label  # type: str
        self.sound_code = sound_code  # type: str

    def validate(self):
        self.validate_required(self.label, 'label')
        self.validate_required(self.sound_code, 'sound_code')

    def to_map(self):
        _map = super(QuerySoundCodeLabelListResponseDataListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.label is not None:
            result['Label'] = self.label
        if self.sound_code is not None:
            result['SoundCode'] = self.sound_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Label') is not None:
            self.label = m.get('Label')
        if m.get('SoundCode') is not None:
            self.sound_code = m.get('SoundCode')
        return self


class QuerySoundCodeLabelListResponseDataList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySoundCodeLabelListResponseDataListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySoundCodeLabelListResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySoundCodeLabelListResponseDataListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySoundCodeLabelListResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QuerySoundCodeLabelListResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QuerySoundCodeLabelListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QuerySoundCodeLabelListResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QuerySoundCodeLabelListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySoundCodeLabelListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySoundCodeLabelListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySoundCodeLabelListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySoundCodeListRequest(TeaModel):
    def __init__(self, iot_instance_id=None, page_id=None, page_size=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int

    def validate(self):
        pass

    def to_map(self):
        _map = super(QuerySoundCodeListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QuerySoundCodeListResponseDataListItems(TeaModel):
    def __init__(self, duration=None, gmt_create=None, name=None, open_type=None, sound_code=None,
                 sound_code_content=None):
        self.duration = duration  # type: int
        self.gmt_create = gmt_create  # type: long
        self.name = name  # type: str
        self.open_type = open_type  # type: str
        self.sound_code = sound_code  # type: str
        self.sound_code_content = sound_code_content  # type: str

    def validate(self):
        self.validate_required(self.duration, 'duration')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.name, 'name')
        self.validate_required(self.open_type, 'open_type')
        self.validate_required(self.sound_code, 'sound_code')
        self.validate_required(self.sound_code_content, 'sound_code_content')

    def to_map(self):
        _map = super(QuerySoundCodeListResponseDataListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.duration is not None:
            result['Duration'] = self.duration
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.name is not None:
            result['Name'] = self.name
        if self.open_type is not None:
            result['OpenType'] = self.open_type
        if self.sound_code is not None:
            result['SoundCode'] = self.sound_code
        if self.sound_code_content is not None:
            result['SoundCodeContent'] = self.sound_code_content
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Duration') is not None:
            self.duration = m.get('Duration')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('OpenType') is not None:
            self.open_type = m.get('OpenType')
        if m.get('SoundCode') is not None:
            self.sound_code = m.get('SoundCode')
        if m.get('SoundCodeContent') is not None:
            self.sound_code_content = m.get('SoundCodeContent')
        return self


class QuerySoundCodeListResponseDataList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySoundCodeListResponseDataListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySoundCodeListResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySoundCodeListResponseDataListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySoundCodeListResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QuerySoundCodeListResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QuerySoundCodeListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QuerySoundCodeListResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QuerySoundCodeListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySoundCodeListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySoundCodeListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySoundCodeListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySoundCodeScheduleListRequest(TeaModel):
    def __init__(self, iot_instance_id=None, page_id=None, page_size=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int

    def validate(self):
        pass

    def to_map(self):
        _map = super(QuerySoundCodeScheduleListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QuerySoundCodeScheduleListResponseDataListItems(TeaModel):
    def __init__(self, description=None, end_date=None, end_time=None, gmt_create=None, name=None, open_type=None,
                 schedule_code=None, start_date=None, start_time=None, status=None):
        self.description = description  # type: str
        self.end_date = end_date  # type: str
        self.end_time = end_time  # type: str
        self.gmt_create = gmt_create  # type: long
        self.name = name  # type: str
        self.open_type = open_type  # type: str
        self.schedule_code = schedule_code  # type: str
        self.start_date = start_date  # type: str
        self.start_time = start_time  # type: str
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.description, 'description')
        self.validate_required(self.end_date, 'end_date')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.name, 'name')
        self.validate_required(self.open_type, 'open_type')
        self.validate_required(self.schedule_code, 'schedule_code')
        self.validate_required(self.start_date, 'start_date')
        self.validate_required(self.start_time, 'start_time')
        self.validate_required(self.status, 'status')

    def to_map(self):
        _map = super(QuerySoundCodeScheduleListResponseDataListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.end_date is not None:
            result['EndDate'] = self.end_date
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.name is not None:
            result['Name'] = self.name
        if self.open_type is not None:
            result['OpenType'] = self.open_type
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        if self.start_date is not None:
            result['StartDate'] = self.start_date
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('EndDate') is not None:
            self.end_date = m.get('EndDate')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('OpenType') is not None:
            self.open_type = m.get('OpenType')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        if m.get('StartDate') is not None:
            self.start_date = m.get('StartDate')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class QuerySoundCodeScheduleListResponseDataList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySoundCodeScheduleListResponseDataListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySoundCodeScheduleListResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySoundCodeScheduleListResponseDataListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySoundCodeScheduleListResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QuerySoundCodeScheduleListResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QuerySoundCodeScheduleListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QuerySoundCodeScheduleListResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QuerySoundCodeScheduleListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySoundCodeScheduleListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySoundCodeScheduleListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySoundCodeScheduleListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySpeechRequest(TeaModel):
    def __init__(self, iot_instance_id=None, speech_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.speech_code = speech_code  # type: str

    def validate(self):
        self.validate_required(self.speech_code, 'speech_code')

    def to_map(self):
        _map = super(QuerySpeechRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.speech_code is not None:
            result['SpeechCode'] = self.speech_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('SpeechCode') is not None:
            self.speech_code = m.get('SpeechCode')
        return self


class QuerySpeechResponseDataSoundCodeConfig(TeaModel):
    def __init__(self, additional_duration=None, sound_code_content=None):
        self.additional_duration = additional_duration  # type: int
        self.sound_code_content = sound_code_content  # type: str

    def validate(self):
        self.validate_required(self.additional_duration, 'additional_duration')
        self.validate_required(self.sound_code_content, 'sound_code_content')

    def to_map(self):
        _map = super(QuerySpeechResponseDataSoundCodeConfig, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.additional_duration is not None:
            result['AdditionalDuration'] = self.additional_duration
        if self.sound_code_content is not None:
            result['SoundCodeContent'] = self.sound_code_content
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AdditionalDuration') is not None:
            self.additional_duration = m.get('AdditionalDuration')
        if m.get('SoundCodeContent') is not None:
            self.sound_code_content = m.get('SoundCodeContent')
        return self


class QuerySpeechResponseData(TeaModel):
    def __init__(self, audio_format=None, biz_code=None, enable_sound_code=None, speech_code=None, speech_rate=None,
                 speech_type=None, text=None, voice=None, volume=None, sound_code_config=None):
        self.audio_format = audio_format  # type: str
        self.biz_code = biz_code  # type: str
        self.enable_sound_code = enable_sound_code  # type: bool
        self.speech_code = speech_code  # type: str
        self.speech_rate = speech_rate  # type: int
        self.speech_type = speech_type  # type: str
        self.text = text  # type: str
        self.voice = voice  # type: str
        self.volume = volume  # type: int
        self.sound_code_config = sound_code_config  # type: QuerySpeechResponseDataSoundCodeConfig

    def validate(self):
        self.validate_required(self.audio_format, 'audio_format')
        self.validate_required(self.biz_code, 'biz_code')
        self.validate_required(self.enable_sound_code, 'enable_sound_code')
        self.validate_required(self.speech_code, 'speech_code')
        self.validate_required(self.speech_rate, 'speech_rate')
        self.validate_required(self.speech_type, 'speech_type')
        self.validate_required(self.text, 'text')
        self.validate_required(self.voice, 'voice')
        self.validate_required(self.volume, 'volume')
        self.validate_required(self.sound_code_config, 'sound_code_config')
        if self.sound_code_config:
            self.sound_code_config.validate()

    def to_map(self):
        _map = super(QuerySpeechResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.biz_code is not None:
            result['BizCode'] = self.biz_code
        if self.enable_sound_code is not None:
            result['EnableSoundCode'] = self.enable_sound_code
        if self.speech_code is not None:
            result['SpeechCode'] = self.speech_code
        if self.speech_rate is not None:
            result['SpeechRate'] = self.speech_rate
        if self.speech_type is not None:
            result['SpeechType'] = self.speech_type
        if self.text is not None:
            result['Text'] = self.text
        if self.voice is not None:
            result['Voice'] = self.voice
        if self.volume is not None:
            result['Volume'] = self.volume
        if self.sound_code_config is not None:
            result['SoundCodeConfig'] = self.sound_code_config.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('BizCode') is not None:
            self.biz_code = m.get('BizCode')
        if m.get('EnableSoundCode') is not None:
            self.enable_sound_code = m.get('EnableSoundCode')
        if m.get('SpeechCode') is not None:
            self.speech_code = m.get('SpeechCode')
        if m.get('SpeechRate') is not None:
            self.speech_rate = m.get('SpeechRate')
        if m.get('SpeechType') is not None:
            self.speech_type = m.get('SpeechType')
        if m.get('Text') is not None:
            self.text = m.get('Text')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        if m.get('Volume') is not None:
            self.volume = m.get('Volume')
        if m.get('SoundCodeConfig') is not None:
            temp_model = QuerySpeechResponseDataSoundCodeConfig()
            self.sound_code_config = temp_model.from_map(m['SoundCodeConfig'])
        return self


class QuerySpeechResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySpeechResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySpeechResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySpeechResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySpeechDeviceRequest(TeaModel):
    def __init__(self, available_space=None, available_space_scope=None, device_name=None, iot_instance_id=None,
                 page_id=None, page_size=None, project_code=None):
        self.available_space = available_space  # type: str
        self.available_space_scope = available_space_scope  # type: str
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.project_code = project_code  # type: str

    def validate(self):
        self.validate_required(self.project_code, 'project_code')

    def to_map(self):
        _map = super(QuerySpeechDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.available_space is not None:
            result['AvailableSpace'] = self.available_space
        if self.available_space_scope is not None:
            result['AvailableSpaceScope'] = self.available_space_scope
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.project_code is not None:
            result['ProjectCode'] = self.project_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AvailableSpace') is not None:
            self.available_space = m.get('AvailableSpace')
        if m.get('AvailableSpaceScope') is not None:
            self.available_space_scope = m.get('AvailableSpaceScope')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProjectCode') is not None:
            self.project_code = m.get('ProjectCode')
        return self


class QuerySpeechDeviceResponseDataListItems(TeaModel):
    def __init__(self, available_space=None, device_name=None, iot_id=None, product_key=None):
        self.available_space = available_space  # type: float
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.available_space, 'available_space')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QuerySpeechDeviceResponseDataListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.available_space is not None:
            result['AvailableSpace'] = self.available_space
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AvailableSpace') is not None:
            self.available_space = m.get('AvailableSpace')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QuerySpeechDeviceResponseDataList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySpeechDeviceResponseDataListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySpeechDeviceResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySpeechDeviceResponseDataListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySpeechDeviceResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QuerySpeechDeviceResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QuerySpeechDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QuerySpeechDeviceResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QuerySpeechDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySpeechDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySpeechDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySpeechDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySpeechLicenseDeviceListRequest(TeaModel):
    def __init__(self, check_group_id=None, device_name=None, iot_instance_id=None, license_status_list=None,
                 page_id=None, page_size=None, product_key=None):
        self.check_group_id = check_group_id  # type: str
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.license_status_list = license_status_list  # type: list[str]
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QuerySpeechLicenseDeviceListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.check_group_id is not None:
            result['CheckGroupId'] = self.check_group_id
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.license_status_list is not None:
            result['LicenseStatusList'] = self.license_status_list
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CheckGroupId') is not None:
            self.check_group_id = m.get('CheckGroupId')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('LicenseStatusList') is not None:
            self.license_status_list = m.get('LicenseStatusList')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QuerySpeechLicenseDeviceListResponseDataDeviceListItem(TeaModel):
    def __init__(self, device_name=None, device_status=None, expiry_time=None, in_specified_group=None, iot_id=None,
                 license_status=None, product_key=None, product_name=None):
        self.device_name = device_name  # type: str
        self.device_status = device_status  # type: str
        self.expiry_time = expiry_time  # type: long
        self.in_specified_group = in_specified_group  # type: bool
        self.iot_id = iot_id  # type: str
        self.license_status = license_status  # type: str
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_status, 'device_status')
        self.validate_required(self.expiry_time, 'expiry_time')
        self.validate_required(self.in_specified_group, 'in_specified_group')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.license_status, 'license_status')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')

    def to_map(self):
        _map = super(QuerySpeechLicenseDeviceListResponseDataDeviceListItem, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_status is not None:
            result['DeviceStatus'] = self.device_status
        if self.expiry_time is not None:
            result['ExpiryTime'] = self.expiry_time
        if self.in_specified_group is not None:
            result['InSpecifiedGroup'] = self.in_specified_group
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.license_status is not None:
            result['LicenseStatus'] = self.license_status
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceStatus') is not None:
            self.device_status = m.get('DeviceStatus')
        if m.get('ExpiryTime') is not None:
            self.expiry_time = m.get('ExpiryTime')
        if m.get('InSpecifiedGroup') is not None:
            self.in_specified_group = m.get('InSpecifiedGroup')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('LicenseStatus') is not None:
            self.license_status = m.get('LicenseStatus')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        return self


class QuerySpeechLicenseDeviceListResponseDataDeviceList(TeaModel):
    def __init__(self, item=None):
        self.item = item  # type: list[QuerySpeechLicenseDeviceListResponseDataDeviceListItem]

    def validate(self):
        self.validate_required(self.item, 'item')
        if self.item:
            for k in self.item:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySpeechLicenseDeviceListResponseDataDeviceList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['item'] = []
        if self.item is not None:
            for k in self.item:
                result['item'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.item = []
        if m.get('item') is not None:
            for k in m.get('item'):
                temp_model = QuerySpeechLicenseDeviceListResponseDataDeviceListItem()
                self.item.append(temp_model.from_map(k))
        return self


class QuerySpeechLicenseDeviceListResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, device_list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.device_list = device_list  # type: QuerySpeechLicenseDeviceListResponseDataDeviceList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.device_list, 'device_list')
        if self.device_list:
            self.device_list.validate()

    def to_map(self):
        _map = super(QuerySpeechLicenseDeviceListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.device_list is not None:
            result['DeviceList'] = self.device_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('DeviceList') is not None:
            temp_model = QuerySpeechLicenseDeviceListResponseDataDeviceList()
            self.device_list = temp_model.from_map(m['DeviceList'])
        return self


class QuerySpeechLicenseDeviceListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySpeechLicenseDeviceListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySpeechLicenseDeviceListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySpeechLicenseDeviceListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySpeechListRequest(TeaModel):
    def __init__(self, audio_format=None, iot_instance_id=None, page_id=None, page_size=None, project_code=None):
        self.audio_format = audio_format  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.project_code = project_code  # type: str

    def validate(self):
        self.validate_required(self.project_code, 'project_code')

    def to_map(self):
        _map = super(QuerySpeechListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.project_code is not None:
            result['ProjectCode'] = self.project_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProjectCode') is not None:
            self.project_code = m.get('ProjectCode')
        return self


class QuerySpeechListResponseDataListItemsSpeechListItems(TeaModel):
    def __init__(self, biz_code=None, speech_code=None, text=None, voice=None):
        self.biz_code = biz_code  # type: str
        self.speech_code = speech_code  # type: str
        self.text = text  # type: str
        self.voice = voice  # type: str

    def validate(self):
        self.validate_required(self.biz_code, 'biz_code')
        self.validate_required(self.speech_code, 'speech_code')
        self.validate_required(self.text, 'text')
        self.validate_required(self.voice, 'voice')

    def to_map(self):
        _map = super(QuerySpeechListResponseDataListItemsSpeechListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.biz_code is not None:
            result['BizCode'] = self.biz_code
        if self.speech_code is not None:
            result['SpeechCode'] = self.speech_code
        if self.text is not None:
            result['Text'] = self.text
        if self.voice is not None:
            result['Voice'] = self.voice
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BizCode') is not None:
            self.biz_code = m.get('BizCode')
        if m.get('SpeechCode') is not None:
            self.speech_code = m.get('SpeechCode')
        if m.get('Text') is not None:
            self.text = m.get('Text')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        return self


class QuerySpeechListResponseDataListItemsSpeechList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySpeechListResponseDataListItemsSpeechListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySpeechListResponseDataListItemsSpeechList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySpeechListResponseDataListItemsSpeechListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySpeechListResponseDataListItems(TeaModel):
    def __init__(self, audio_format=None, biz_code=None, speech_code=None, speech_type=None, text=None, voice=None,
                 speech_list=None):
        self.audio_format = audio_format  # type: str
        self.biz_code = biz_code  # type: str
        self.speech_code = speech_code  # type: str
        self.speech_type = speech_type  # type: str
        self.text = text  # type: str
        self.voice = voice  # type: str
        self.speech_list = speech_list  # type: QuerySpeechListResponseDataListItemsSpeechList

    def validate(self):
        self.validate_required(self.audio_format, 'audio_format')
        self.validate_required(self.biz_code, 'biz_code')
        self.validate_required(self.speech_code, 'speech_code')
        self.validate_required(self.speech_type, 'speech_type')
        self.validate_required(self.text, 'text')
        self.validate_required(self.voice, 'voice')
        self.validate_required(self.speech_list, 'speech_list')
        if self.speech_list:
            self.speech_list.validate()

    def to_map(self):
        _map = super(QuerySpeechListResponseDataListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.biz_code is not None:
            result['BizCode'] = self.biz_code
        if self.speech_code is not None:
            result['SpeechCode'] = self.speech_code
        if self.speech_type is not None:
            result['SpeechType'] = self.speech_type
        if self.text is not None:
            result['Text'] = self.text
        if self.voice is not None:
            result['Voice'] = self.voice
        if self.speech_list is not None:
            result['SpeechList'] = self.speech_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('BizCode') is not None:
            self.biz_code = m.get('BizCode')
        if m.get('SpeechCode') is not None:
            self.speech_code = m.get('SpeechCode')
        if m.get('SpeechType') is not None:
            self.speech_type = m.get('SpeechType')
        if m.get('Text') is not None:
            self.text = m.get('Text')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        if m.get('SpeechList') is not None:
            temp_model = QuerySpeechListResponseDataListItemsSpeechList()
            self.speech_list = temp_model.from_map(m['SpeechList'])
        return self


class QuerySpeechListResponseDataList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySpeechListResponseDataListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySpeechListResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySpeechListResponseDataListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySpeechListResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QuerySpeechListResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QuerySpeechListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QuerySpeechListResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QuerySpeechListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySpeechListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySpeechListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySpeechListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySpeechPushJobRequest(TeaModel):
    def __init__(self, iot_instance_id=None, job_code=None, page_id=None, page_size=None, project_code=None,
                 push_mode=None, status_list=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_code = job_code  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.project_code = project_code  # type: str
        self.push_mode = push_mode  # type: str
        self.status_list = status_list  # type: list[str]

    def validate(self):
        self.validate_required(self.project_code, 'project_code')

    def to_map(self):
        _map = super(QuerySpeechPushJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_code is not None:
            result['JobCode'] = self.job_code
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.project_code is not None:
            result['ProjectCode'] = self.project_code
        if self.push_mode is not None:
            result['PushMode'] = self.push_mode
        if self.status_list is not None:
            result['StatusList'] = self.status_list
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobCode') is not None:
            self.job_code = m.get('JobCode')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProjectCode') is not None:
            self.project_code = m.get('ProjectCode')
        if m.get('PushMode') is not None:
            self.push_mode = m.get('PushMode')
        if m.get('StatusList') is not None:
            self.status_list = m.get('StatusList')
        return self


class QuerySpeechPushJobResponseDataListItems(TeaModel):
    def __init__(self, code=None, created_time=None, device_name=None, expired_time=None, fail_device_num=None,
                 group_id=None, group_name=None, iot_id=None, product_key=None, push_mode=None, running_device_num=None,
                 speech_num=None, speech_status=None, status=None, success_device_num=None, total_device_num=None):
        self.code = code  # type: str
        self.created_time = created_time  # type: long
        self.device_name = device_name  # type: str
        self.expired_time = expired_time  # type: long
        self.fail_device_num = fail_device_num  # type: int
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str
        self.iot_id = iot_id  # type: str
        self.product_key = product_key  # type: str
        self.push_mode = push_mode  # type: str
        self.running_device_num = running_device_num  # type: int
        self.speech_num = speech_num  # type: int
        self.speech_status = speech_status  # type: bool
        self.status = status  # type: str
        self.success_device_num = success_device_num  # type: int
        self.total_device_num = total_device_num  # type: int

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.created_time, 'created_time')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.expired_time, 'expired_time')
        self.validate_required(self.fail_device_num, 'fail_device_num')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.push_mode, 'push_mode')
        self.validate_required(self.running_device_num, 'running_device_num')
        self.validate_required(self.speech_num, 'speech_num')
        self.validate_required(self.speech_status, 'speech_status')
        self.validate_required(self.status, 'status')
        self.validate_required(self.success_device_num, 'success_device_num')
        self.validate_required(self.total_device_num, 'total_device_num')

    def to_map(self):
        _map = super(QuerySpeechPushJobResponseDataListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.created_time is not None:
            result['CreatedTime'] = self.created_time
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.expired_time is not None:
            result['ExpiredTime'] = self.expired_time
        if self.fail_device_num is not None:
            result['FailDeviceNum'] = self.fail_device_num
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.push_mode is not None:
            result['PushMode'] = self.push_mode
        if self.running_device_num is not None:
            result['RunningDeviceNum'] = self.running_device_num
        if self.speech_num is not None:
            result['SpeechNum'] = self.speech_num
        if self.speech_status is not None:
            result['SpeechStatus'] = self.speech_status
        if self.status is not None:
            result['Status'] = self.status
        if self.success_device_num is not None:
            result['SuccessDeviceNum'] = self.success_device_num
        if self.total_device_num is not None:
            result['TotalDeviceNum'] = self.total_device_num
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('CreatedTime') is not None:
            self.created_time = m.get('CreatedTime')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('ExpiredTime') is not None:
            self.expired_time = m.get('ExpiredTime')
        if m.get('FailDeviceNum') is not None:
            self.fail_device_num = m.get('FailDeviceNum')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('PushMode') is not None:
            self.push_mode = m.get('PushMode')
        if m.get('RunningDeviceNum') is not None:
            self.running_device_num = m.get('RunningDeviceNum')
        if m.get('SpeechNum') is not None:
            self.speech_num = m.get('SpeechNum')
        if m.get('SpeechStatus') is not None:
            self.speech_status = m.get('SpeechStatus')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('SuccessDeviceNum') is not None:
            self.success_device_num = m.get('SuccessDeviceNum')
        if m.get('TotalDeviceNum') is not None:
            self.total_device_num = m.get('TotalDeviceNum')
        return self


class QuerySpeechPushJobResponseDataList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySpeechPushJobResponseDataListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySpeechPushJobResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySpeechPushJobResponseDataListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySpeechPushJobResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QuerySpeechPushJobResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QuerySpeechPushJobResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QuerySpeechPushJobResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QuerySpeechPushJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySpeechPushJobResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySpeechPushJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySpeechPushJobResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySpeechPushJobDeviceRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, job_code=None, page_id=None, page_size=None,
                 status=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_code = job_code  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.job_code, 'job_code')

    def to_map(self):
        _map = super(QuerySpeechPushJobDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_code is not None:
            result['JobCode'] = self.job_code
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobCode') is not None:
            self.job_code = m.get('JobCode')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class QuerySpeechPushJobDeviceResponseDataListItems(TeaModel):
    def __init__(self, device_name=None, error_code=None, error_message=None, gmt_modified=None, status=None):
        self.device_name = device_name  # type: str
        self.error_code = error_code  # type: str
        self.error_message = error_message  # type: str
        self.gmt_modified = gmt_modified  # type: long
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.error_code, 'error_code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.status, 'status')

    def to_map(self):
        _map = super(QuerySpeechPushJobDeviceResponseDataListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.error_code is not None:
            result['ErrorCode'] = self.error_code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('ErrorCode') is not None:
            self.error_code = m.get('ErrorCode')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class QuerySpeechPushJobDeviceResponseDataList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySpeechPushJobDeviceResponseDataListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySpeechPushJobDeviceResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySpeechPushJobDeviceResponseDataListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySpeechPushJobDeviceResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QuerySpeechPushJobDeviceResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QuerySpeechPushJobDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QuerySpeechPushJobDeviceResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QuerySpeechPushJobDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySpeechPushJobDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySpeechPushJobDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySpeechPushJobDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySpeechPushJobSpeechRequest(TeaModel):
    def __init__(self, iot_instance_id=None, job_code=None, page_id=None, page_size=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_code = job_code  # type: str
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int

    def validate(self):
        self.validate_required(self.job_code, 'job_code')

    def to_map(self):
        _map = super(QuerySpeechPushJobSpeechRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_code is not None:
            result['JobCode'] = self.job_code
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobCode') is not None:
            self.job_code = m.get('JobCode')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QuerySpeechPushJobSpeechResponseDataListItemsSpeechListItems(TeaModel):
    def __init__(self, biz_code=None, text=None, voice=None):
        self.biz_code = biz_code  # type: str
        self.text = text  # type: str
        self.voice = voice  # type: str

    def validate(self):
        self.validate_required(self.biz_code, 'biz_code')
        self.validate_required(self.text, 'text')
        self.validate_required(self.voice, 'voice')

    def to_map(self):
        _map = super(QuerySpeechPushJobSpeechResponseDataListItemsSpeechListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.biz_code is not None:
            result['BizCode'] = self.biz_code
        if self.text is not None:
            result['Text'] = self.text
        if self.voice is not None:
            result['Voice'] = self.voice
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BizCode') is not None:
            self.biz_code = m.get('BizCode')
        if m.get('Text') is not None:
            self.text = m.get('Text')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        return self


class QuerySpeechPushJobSpeechResponseDataListItemsSpeechList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySpeechPushJobSpeechResponseDataListItemsSpeechListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySpeechPushJobSpeechResponseDataListItemsSpeechList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySpeechPushJobSpeechResponseDataListItemsSpeechListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySpeechPushJobSpeechResponseDataListItems(TeaModel):
    def __init__(self, biz_code=None, speech_type=None, text=None, voice=None, speech_list=None):
        self.biz_code = biz_code  # type: str
        self.speech_type = speech_type  # type: str
        self.text = text  # type: str
        self.voice = voice  # type: str
        self.speech_list = speech_list  # type: QuerySpeechPushJobSpeechResponseDataListItemsSpeechList

    def validate(self):
        self.validate_required(self.biz_code, 'biz_code')
        self.validate_required(self.speech_type, 'speech_type')
        self.validate_required(self.text, 'text')
        self.validate_required(self.voice, 'voice')
        self.validate_required(self.speech_list, 'speech_list')
        if self.speech_list:
            self.speech_list.validate()

    def to_map(self):
        _map = super(QuerySpeechPushJobSpeechResponseDataListItems, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.biz_code is not None:
            result['BizCode'] = self.biz_code
        if self.speech_type is not None:
            result['SpeechType'] = self.speech_type
        if self.text is not None:
            result['Text'] = self.text
        if self.voice is not None:
            result['Voice'] = self.voice
        if self.speech_list is not None:
            result['SpeechList'] = self.speech_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BizCode') is not None:
            self.biz_code = m.get('BizCode')
        if m.get('SpeechType') is not None:
            self.speech_type = m.get('SpeechType')
        if m.get('Text') is not None:
            self.text = m.get('Text')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        if m.get('SpeechList') is not None:
            temp_model = QuerySpeechPushJobSpeechResponseDataListItemsSpeechList()
            self.speech_list = temp_model.from_map(m['SpeechList'])
        return self


class QuerySpeechPushJobSpeechResponseDataList(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[QuerySpeechPushJobSpeechResponseDataListItems]

    def validate(self):
        self.validate_required(self.items, 'items')
        if self.items:
            for k in self.items:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySpeechPushJobSpeechResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Items'] = []
        if self.items is not None:
            for k in self.items:
                result['Items'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.items = []
        if m.get('Items') is not None:
            for k in m.get('Items'):
                temp_model = QuerySpeechPushJobSpeechResponseDataListItems()
                self.items.append(temp_model.from_map(k))
        return self


class QuerySpeechPushJobSpeechResponseData(TeaModel):
    def __init__(self, page_id=None, page_size=None, total=None, list=None):
        self.page_id = page_id  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.list = list  # type: QuerySpeechPushJobSpeechResponseDataList

    def validate(self):
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QuerySpeechPushJobSpeechResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('List') is not None:
            temp_model = QuerySpeechPushJobSpeechResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QuerySpeechPushJobSpeechResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySpeechPushJobSpeechResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySpeechPushJobSpeechResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySpeechPushJobSpeechResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryStudioAppDomainListOpenRequest(TeaModel):
    def __init__(self, app_id=None, iot_instance_id=None, project_id=None):
        self.app_id = app_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.app_id, 'app_id')
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(QueryStudioAppDomainListOpenRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_id is not None:
            result['AppId'] = self.app_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppId') is not None:
            self.app_id = m.get('AppId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class QueryStudioAppDomainListOpenResponseDataListDomainInfo(TeaModel):
    def __init__(self, app_id=None, gmt_create=None, gmt_modified=None, host=None, id=None, is_beian=None,
                 project_id=None, protocol=None, tenant_id=None):
        self.app_id = app_id  # type: str
        self.gmt_create = gmt_create  # type: str
        self.gmt_modified = gmt_modified  # type: str
        self.host = host  # type: str
        self.id = id  # type: int
        self.is_beian = is_beian  # type: str
        self.project_id = project_id  # type: str
        self.protocol = protocol  # type: str
        self.tenant_id = tenant_id  # type: str

    def validate(self):
        self.validate_required(self.app_id, 'app_id')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.host, 'host')
        self.validate_required(self.id, 'id')
        self.validate_required(self.is_beian, 'is_beian')
        self.validate_required(self.project_id, 'project_id')
        self.validate_required(self.protocol, 'protocol')
        self.validate_required(self.tenant_id, 'tenant_id')

    def to_map(self):
        _map = super(QueryStudioAppDomainListOpenResponseDataListDomainInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_id is not None:
            result['AppId'] = self.app_id
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.host is not None:
            result['Host'] = self.host
        if self.id is not None:
            result['Id'] = self.id
        if self.is_beian is not None:
            result['IsBeian'] = self.is_beian
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        if self.protocol is not None:
            result['Protocol'] = self.protocol
        if self.tenant_id is not None:
            result['TenantId'] = self.tenant_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppId') is not None:
            self.app_id = m.get('AppId')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('Host') is not None:
            self.host = m.get('Host')
        if m.get('Id') is not None:
            self.id = m.get('Id')
        if m.get('IsBeian') is not None:
            self.is_beian = m.get('IsBeian')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        if m.get('Protocol') is not None:
            self.protocol = m.get('Protocol')
        if m.get('TenantId') is not None:
            self.tenant_id = m.get('TenantId')
        return self


class QueryStudioAppDomainListOpenResponseDataList(TeaModel):
    def __init__(self, domain_info=None):
        self.domain_info = domain_info  # type: list[QueryStudioAppDomainListOpenResponseDataListDomainInfo]

    def validate(self):
        self.validate_required(self.domain_info, 'domain_info')
        if self.domain_info:
            for k in self.domain_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryStudioAppDomainListOpenResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['DomainInfo'] = []
        if self.domain_info is not None:
            for k in self.domain_info:
                result['DomainInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.domain_info = []
        if m.get('DomainInfo') is not None:
            for k in m.get('DomainInfo'):
                temp_model = QueryStudioAppDomainListOpenResponseDataListDomainInfo()
                self.domain_info.append(temp_model.from_map(k))
        return self


class QueryStudioAppDomainListOpenResponseData(TeaModel):
    def __init__(self, page_no=None, page_size=None, total=None, total_page=None, list=None):
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.total_page = total_page  # type: int
        self.list = list  # type: QueryStudioAppDomainListOpenResponseDataList

    def validate(self):
        self.validate_required(self.page_no, 'page_no')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.total_page, 'total_page')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryStudioAppDomainListOpenResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.total_page is not None:
            result['TotalPage'] = self.total_page
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('TotalPage') is not None:
            self.total_page = m.get('TotalPage')
        if m.get('List') is not None:
            temp_model = QueryStudioAppDomainListOpenResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryStudioAppDomainListOpenResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryStudioAppDomainListOpenResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryStudioAppDomainListOpenResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryStudioAppDomainListOpenResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryStudioAppListRequest(TeaModel):
    def __init__(self, fuzzy_name=None, iot_instance_id=None, page_no=None, page_size=None, project_id=None,
                 types=None):
        self.fuzzy_name = fuzzy_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int
        self.project_id = project_id  # type: str
        self.types = types  # type: list[str]

    def validate(self):
        self.validate_required(self.project_id, 'project_id')
        self.validate_required(self.types, 'types')

    def to_map(self):
        _map = super(QueryStudioAppListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.fuzzy_name is not None:
            result['FuzzyName'] = self.fuzzy_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        if self.types is not None:
            result['Types'] = self.types
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FuzzyName') is not None:
            self.fuzzy_name = m.get('FuzzyName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        if m.get('Types') is not None:
            self.types = m.get('Types')
        return self


class QueryStudioAppListResponseDataListAppInfo(TeaModel):
    def __init__(self, app_id=None, app_key=None, app_secret=None, description=None, gmt_create=None,
                 gmt_modified=None, gmt_release=None, name=None, project_id=None, type=None):
        self.app_id = app_id  # type: str
        self.app_key = app_key  # type: str
        self.app_secret = app_secret  # type: str
        self.description = description  # type: str
        self.gmt_create = gmt_create  # type: str
        self.gmt_modified = gmt_modified  # type: str
        self.gmt_release = gmt_release  # type: str
        self.name = name  # type: str
        self.project_id = project_id  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.app_id, 'app_id')
        self.validate_required(self.app_key, 'app_key')
        self.validate_required(self.app_secret, 'app_secret')
        self.validate_required(self.description, 'description')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.gmt_release, 'gmt_release')
        self.validate_required(self.name, 'name')
        self.validate_required(self.project_id, 'project_id')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(QueryStudioAppListResponseDataListAppInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_id is not None:
            result['AppId'] = self.app_id
        if self.app_key is not None:
            result['AppKey'] = self.app_key
        if self.app_secret is not None:
            result['AppSecret'] = self.app_secret
        if self.description is not None:
            result['Description'] = self.description
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.gmt_release is not None:
            result['GmtRelease'] = self.gmt_release
        if self.name is not None:
            result['Name'] = self.name
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppId') is not None:
            self.app_id = m.get('AppId')
        if m.get('AppKey') is not None:
            self.app_key = m.get('AppKey')
        if m.get('AppSecret') is not None:
            self.app_secret = m.get('AppSecret')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('GmtRelease') is not None:
            self.gmt_release = m.get('GmtRelease')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class QueryStudioAppListResponseDataList(TeaModel):
    def __init__(self, app_info=None):
        self.app_info = app_info  # type: list[QueryStudioAppListResponseDataListAppInfo]

    def validate(self):
        self.validate_required(self.app_info, 'app_info')
        if self.app_info:
            for k in self.app_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryStudioAppListResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['AppInfo'] = []
        if self.app_info is not None:
            for k in self.app_info:
                result['AppInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.app_info = []
        if m.get('AppInfo') is not None:
            for k in m.get('AppInfo'):
                temp_model = QueryStudioAppListResponseDataListAppInfo()
                self.app_info.append(temp_model.from_map(k))
        return self


class QueryStudioAppListResponseData(TeaModel):
    def __init__(self, page_no=None, page_size=None, total=None, total_page=None, list=None):
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.total_page = total_page  # type: int
        self.list = list  # type: QueryStudioAppListResponseDataList

    def validate(self):
        self.validate_required(self.page_no, 'page_no')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.total_page, 'total_page')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryStudioAppListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.total_page is not None:
            result['TotalPage'] = self.total_page
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('TotalPage') is not None:
            self.total_page = m.get('TotalPage')
        if m.get('List') is not None:
            temp_model = QueryStudioAppListResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryStudioAppListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryStudioAppListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryStudioAppListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryStudioAppListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryStudioAppPageListOpenRequest(TeaModel):
    def __init__(self, app_id=None, iot_instance_id=None, is_release=None, page_no=None, page_size=None,
                 project_id=None):
        self.app_id = app_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.is_release = is_release  # type: bool
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.app_id, 'app_id')
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(QueryStudioAppPageListOpenRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_id is not None:
            result['AppId'] = self.app_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.is_release is not None:
            result['IsRelease'] = self.is_release
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppId') is not None:
            self.app_id = m.get('AppId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('IsRelease') is not None:
            self.is_release = m.get('IsRelease')
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class QueryStudioAppPageListOpenResponseDataListPageInfo(TeaModel):
    def __init__(self, gmt_create=None, gmt_modified=None, id=None, is_hidden=None, is_home=None, is_login_page=None,
                 name=None, page_id=None, path=None):
        self.gmt_create = gmt_create  # type: str
        self.gmt_modified = gmt_modified  # type: str
        self.id = id  # type: int
        self.is_hidden = is_hidden  # type: int
        self.is_home = is_home  # type: int
        self.is_login_page = is_login_page  # type: int
        self.name = name  # type: str
        self.page_id = page_id  # type: str
        self.path = path  # type: str

    def validate(self):
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.id, 'id')
        self.validate_required(self.is_hidden, 'is_hidden')
        self.validate_required(self.is_home, 'is_home')
        self.validate_required(self.is_login_page, 'is_login_page')
        self.validate_required(self.name, 'name')
        self.validate_required(self.page_id, 'page_id')
        self.validate_required(self.path, 'path')

    def to_map(self):
        _map = super(QueryStudioAppPageListOpenResponseDataListPageInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.id is not None:
            result['Id'] = self.id
        if self.is_hidden is not None:
            result['IsHidden'] = self.is_hidden
        if self.is_home is not None:
            result['IsHome'] = self.is_home
        if self.is_login_page is not None:
            result['IsLoginPage'] = self.is_login_page
        if self.name is not None:
            result['Name'] = self.name
        if self.page_id is not None:
            result['PageId'] = self.page_id
        if self.path is not None:
            result['Path'] = self.path
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('Id') is not None:
            self.id = m.get('Id')
        if m.get('IsHidden') is not None:
            self.is_hidden = m.get('IsHidden')
        if m.get('IsHome') is not None:
            self.is_home = m.get('IsHome')
        if m.get('IsLoginPage') is not None:
            self.is_login_page = m.get('IsLoginPage')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('PageId') is not None:
            self.page_id = m.get('PageId')
        if m.get('Path') is not None:
            self.path = m.get('Path')
        return self


class QueryStudioAppPageListOpenResponseDataList(TeaModel):
    def __init__(self, page_info=None):
        self.page_info = page_info  # type: list[QueryStudioAppPageListOpenResponseDataListPageInfo]

    def validate(self):
        self.validate_required(self.page_info, 'page_info')
        if self.page_info:
            for k in self.page_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryStudioAppPageListOpenResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['PageInfo'] = []
        if self.page_info is not None:
            for k in self.page_info:
                result['PageInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.page_info = []
        if m.get('PageInfo') is not None:
            for k in m.get('PageInfo'):
                temp_model = QueryStudioAppPageListOpenResponseDataListPageInfo()
                self.page_info.append(temp_model.from_map(k))
        return self


class QueryStudioAppPageListOpenResponseData(TeaModel):
    def __init__(self, page_no=None, page_size=None, total=None, total_page=None, list=None):
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.total_page = total_page  # type: int
        self.list = list  # type: QueryStudioAppPageListOpenResponseDataList

    def validate(self):
        self.validate_required(self.page_no, 'page_no')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.total_page, 'total_page')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryStudioAppPageListOpenResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.total_page is not None:
            result['TotalPage'] = self.total_page
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('TotalPage') is not None:
            self.total_page = m.get('TotalPage')
        if m.get('List') is not None:
            temp_model = QueryStudioAppPageListOpenResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryStudioAppPageListOpenResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryStudioAppPageListOpenResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryStudioAppPageListOpenResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryStudioAppPageListOpenResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryStudioProjectListRequest(TeaModel):
    def __init__(self, iot_instance_id=None, name=None, page_no=None, page_size=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryStudioProjectListRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        return self


class QueryStudioProjectListResponseDataListProjectInfo(TeaModel):
    def __init__(self, description=None, gmt_create=None, gmt_modified=None, name=None, project_id=None):
        self.description = description  # type: str
        self.gmt_create = gmt_create  # type: long
        self.gmt_modified = gmt_modified  # type: long
        self.name = name  # type: str
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.description, 'description')
        self.validate_required(self.gmt_create, 'gmt_create')
        self.validate_required(self.gmt_modified, 'gmt_modified')
        self.validate_required(self.name, 'name')
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(QueryStudioProjectListResponseDataListProjectInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.gmt_create is not None:
            result['GmtCreate'] = self.gmt_create
        if self.gmt_modified is not None:
            result['GmtModified'] = self.gmt_modified
        if self.name is not None:
            result['Name'] = self.name
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('GmtCreate') is not None:
            self.gmt_create = m.get('GmtCreate')
        if m.get('GmtModified') is not None:
            self.gmt_modified = m.get('GmtModified')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class QueryStudioProjectListResponseDataList(TeaModel):
    def __init__(self, project_info=None):
        self.project_info = project_info  # type: list[QueryStudioProjectListResponseDataListProjectInfo]

    def validate(self):
        self.validate_required(self.project_info, 'project_info')
        if self.project_info:
            for k in self.project_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QueryStudioProjectListResponseDataList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ProjectInfo'] = []
        if self.project_info is not None:
            for k in self.project_info:
                result['ProjectInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.project_info = []
        if m.get('ProjectInfo') is not None:
            for k in m.get('ProjectInfo'):
                temp_model = QueryStudioProjectListResponseDataListProjectInfo()
                self.project_info.append(temp_model.from_map(k))
        return self


class QueryStudioProjectListResponseData(TeaModel):
    def __init__(self, page_no=None, page_size=None, total=None, total_page=None, list=None):
        self.page_no = page_no  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.total_page = total_page  # type: int
        self.list = list  # type: QueryStudioProjectListResponseDataList

    def validate(self):
        self.validate_required(self.page_no, 'page_no')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.total_page, 'total_page')
        self.validate_required(self.list, 'list')
        if self.list:
            self.list.validate()

    def to_map(self):
        _map = super(QueryStudioProjectListResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.page_no is not None:
            result['PageNo'] = self.page_no
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.total_page is not None:
            result['TotalPage'] = self.total_page
        if self.list is not None:
            result['List'] = self.list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('PageNo') is not None:
            self.page_no = m.get('PageNo')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('TotalPage') is not None:
            self.total_page = m.get('TotalPage')
        if m.get('List') is not None:
            temp_model = QueryStudioProjectListResponseDataList()
            self.list = temp_model.from_map(m['List'])
        return self


class QueryStudioProjectListResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryStudioProjectListResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryStudioProjectListResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryStudioProjectListResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySubscribeRelationRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None, type=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(QuerySubscribeRelationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class QuerySubscribeRelationResponse(TeaModel):
    def __init__(self, code=None, device_data_flag=None, device_life_cycle_flag=None,
                 device_status_change_flag=None, device_tag_flag=None, device_topo_life_cycle_flag=None, error_message=None,
                 found_device_list_flag=None, mns_configuration=None, ota_event_flag=None, ota_job_flag=None, ota_version_flag=None,
                 product_key=None, request_id=None, subscribe_flags=None, success=None, thing_history_flag=None, type=None,
                 consumer_group_ids=None):
        self.code = code  # type: str
        self.device_data_flag = device_data_flag  # type: bool
        self.device_life_cycle_flag = device_life_cycle_flag  # type: bool
        self.device_status_change_flag = device_status_change_flag  # type: bool
        self.device_tag_flag = device_tag_flag  # type: bool
        self.device_topo_life_cycle_flag = device_topo_life_cycle_flag  # type: bool
        self.error_message = error_message  # type: str
        self.found_device_list_flag = found_device_list_flag  # type: bool
        self.mns_configuration = mns_configuration  # type: str
        self.ota_event_flag = ota_event_flag  # type: bool
        self.ota_job_flag = ota_job_flag  # type: bool
        self.ota_version_flag = ota_version_flag  # type: bool
        self.product_key = product_key  # type: str
        self.request_id = request_id  # type: str
        self.subscribe_flags = subscribe_flags  # type: str
        self.success = success  # type: bool
        self.thing_history_flag = thing_history_flag  # type: bool
        self.type = type  # type: str
        self.consumer_group_ids = consumer_group_ids  # type: list[str]

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.device_data_flag, 'device_data_flag')
        self.validate_required(self.device_life_cycle_flag, 'device_life_cycle_flag')
        self.validate_required(self.device_status_change_flag, 'device_status_change_flag')
        self.validate_required(self.device_tag_flag, 'device_tag_flag')
        self.validate_required(self.device_topo_life_cycle_flag, 'device_topo_life_cycle_flag')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.found_device_list_flag, 'found_device_list_flag')
        self.validate_required(self.mns_configuration, 'mns_configuration')
        self.validate_required(self.ota_event_flag, 'ota_event_flag')
        self.validate_required(self.ota_job_flag, 'ota_job_flag')
        self.validate_required(self.ota_version_flag, 'ota_version_flag')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.subscribe_flags, 'subscribe_flags')
        self.validate_required(self.success, 'success')
        self.validate_required(self.thing_history_flag, 'thing_history_flag')
        self.validate_required(self.type, 'type')
        self.validate_required(self.consumer_group_ids, 'consumer_group_ids')

    def to_map(self):
        _map = super(QuerySubscribeRelationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.device_data_flag is not None:
            result['DeviceDataFlag'] = self.device_data_flag
        if self.device_life_cycle_flag is not None:
            result['DeviceLifeCycleFlag'] = self.device_life_cycle_flag
        if self.device_status_change_flag is not None:
            result['DeviceStatusChangeFlag'] = self.device_status_change_flag
        if self.device_tag_flag is not None:
            result['DeviceTagFlag'] = self.device_tag_flag
        if self.device_topo_life_cycle_flag is not None:
            result['DeviceTopoLifeCycleFlag'] = self.device_topo_life_cycle_flag
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.found_device_list_flag is not None:
            result['FoundDeviceListFlag'] = self.found_device_list_flag
        if self.mns_configuration is not None:
            result['MnsConfiguration'] = self.mns_configuration
        if self.ota_event_flag is not None:
            result['OtaEventFlag'] = self.ota_event_flag
        if self.ota_job_flag is not None:
            result['OtaJobFlag'] = self.ota_job_flag
        if self.ota_version_flag is not None:
            result['OtaVersionFlag'] = self.ota_version_flag
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.subscribe_flags is not None:
            result['SubscribeFlags'] = self.subscribe_flags
        if self.success is not None:
            result['Success'] = self.success
        if self.thing_history_flag is not None:
            result['ThingHistoryFlag'] = self.thing_history_flag
        if self.type is not None:
            result['Type'] = self.type
        if self.consumer_group_ids is not None:
            result['ConsumerGroupIds'] = self.consumer_group_ids
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('DeviceDataFlag') is not None:
            self.device_data_flag = m.get('DeviceDataFlag')
        if m.get('DeviceLifeCycleFlag') is not None:
            self.device_life_cycle_flag = m.get('DeviceLifeCycleFlag')
        if m.get('DeviceStatusChangeFlag') is not None:
            self.device_status_change_flag = m.get('DeviceStatusChangeFlag')
        if m.get('DeviceTagFlag') is not None:
            self.device_tag_flag = m.get('DeviceTagFlag')
        if m.get('DeviceTopoLifeCycleFlag') is not None:
            self.device_topo_life_cycle_flag = m.get('DeviceTopoLifeCycleFlag')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('FoundDeviceListFlag') is not None:
            self.found_device_list_flag = m.get('FoundDeviceListFlag')
        if m.get('MnsConfiguration') is not None:
            self.mns_configuration = m.get('MnsConfiguration')
        if m.get('OtaEventFlag') is not None:
            self.ota_event_flag = m.get('OtaEventFlag')
        if m.get('OtaJobFlag') is not None:
            self.ota_job_flag = m.get('OtaJobFlag')
        if m.get('OtaVersionFlag') is not None:
            self.ota_version_flag = m.get('OtaVersionFlag')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('SubscribeFlags') is not None:
            self.subscribe_flags = m.get('SubscribeFlags')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('ThingHistoryFlag') is not None:
            self.thing_history_flag = m.get('ThingHistoryFlag')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        if m.get('ConsumerGroupIds') is not None:
            self.consumer_group_ids = m.get('ConsumerGroupIds')
        return self


class QuerySummarySceneRuleLogRequest(TeaModel):
    def __init__(self, current_page=None, end_time=None, iot_instance_id=None, page_size=None, rule_id=None,
                 start_time=None, status=None):
        self.current_page = current_page  # type: int
        self.end_time = end_time  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.page_size = page_size  # type: int
        self.rule_id = rule_id  # type: str
        self.start_time = start_time  # type: int
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.end_time, 'end_time')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.rule_id, 'rule_id')
        self.validate_required(self.start_time, 'start_time')
        self.validate_required(self.status, 'status')

    def to_map(self):
        _map = super(QuerySummarySceneRuleLogRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class QuerySummarySceneRuleLogResponseDataLogListLogInfo(TeaModel):
    def __init__(self, log_time=None, result=None, trace_id=None):
        self.log_time = log_time  # type: int
        self.result = result  # type: str
        self.trace_id = trace_id  # type: str

    def validate(self):
        self.validate_required(self.log_time, 'log_time')
        self.validate_required(self.result, 'result')
        self.validate_required(self.trace_id, 'trace_id')

    def to_map(self):
        _map = super(QuerySummarySceneRuleLogResponseDataLogListLogInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.log_time is not None:
            result['LogTime'] = self.log_time
        if self.result is not None:
            result['Result'] = self.result
        if self.trace_id is not None:
            result['TraceId'] = self.trace_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('LogTime') is not None:
            self.log_time = m.get('LogTime')
        if m.get('Result') is not None:
            self.result = m.get('Result')
        if m.get('TraceId') is not None:
            self.trace_id = m.get('TraceId')
        return self


class QuerySummarySceneRuleLogResponseDataLogList(TeaModel):
    def __init__(self, log_info=None):
        self.log_info = log_info  # type: list[QuerySummarySceneRuleLogResponseDataLogListLogInfo]

    def validate(self):
        self.validate_required(self.log_info, 'log_info')
        if self.log_info:
            for k in self.log_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySummarySceneRuleLogResponseDataLogList, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['LogInfo'] = []
        if self.log_info is not None:
            for k in self.log_info:
                result['LogInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.log_info = []
        if m.get('LogInfo') is not None:
            for k in m.get('LogInfo'):
                temp_model = QuerySummarySceneRuleLogResponseDataLogListLogInfo()
                self.log_info.append(temp_model.from_map(k))
        return self


class QuerySummarySceneRuleLogResponseData(TeaModel):
    def __init__(self, current_page=None, page_size=None, total=None, log_list=None):
        self.current_page = current_page  # type: int
        self.page_size = page_size  # type: int
        self.total = total  # type: int
        self.log_list = log_list  # type: QuerySummarySceneRuleLogResponseDataLogList

    def validate(self):
        self.validate_required(self.current_page, 'current_page')
        self.validate_required(self.page_size, 'page_size')
        self.validate_required(self.total, 'total')
        self.validate_required(self.log_list, 'log_list')
        if self.log_list:
            self.log_list.validate()

    def to_map(self):
        _map = super(QuerySummarySceneRuleLogResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_page is not None:
            result['CurrentPage'] = self.current_page
        if self.page_size is not None:
            result['PageSize'] = self.page_size
        if self.total is not None:
            result['Total'] = self.total
        if self.log_list is not None:
            result['LogList'] = self.log_list.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentPage') is not None:
            self.current_page = m.get('CurrentPage')
        if m.get('PageSize') is not None:
            self.page_size = m.get('PageSize')
        if m.get('Total') is not None:
            self.total = m.get('Total')
        if m.get('LogList') is not None:
            temp_model = QuerySummarySceneRuleLogResponseDataLogList()
            self.log_list = temp_model.from_map(m['LogList'])
        return self


class QuerySummarySceneRuleLogResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySummarySceneRuleLogResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySummarySceneRuleLogResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySummarySceneRuleLogResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QuerySuperDeviceGroupRequest(TeaModel):
    def __init__(self, group_id=None, iot_instance_id=None):
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(QuerySuperDeviceGroupRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class QuerySuperDeviceGroupResponseDataGroupInfo(TeaModel):
    def __init__(self, group_desc=None, group_id=None, group_name=None):
        self.group_desc = group_desc  # type: str
        self.group_id = group_id  # type: str
        self.group_name = group_name  # type: str

    def validate(self):
        self.validate_required(self.group_desc, 'group_desc')
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.group_name, 'group_name')

    def to_map(self):
        _map = super(QuerySuperDeviceGroupResponseDataGroupInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_desc is not None:
            result['GroupDesc'] = self.group_desc
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_name is not None:
            result['GroupName'] = self.group_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupDesc') is not None:
            self.group_desc = m.get('GroupDesc')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupName') is not None:
            self.group_name = m.get('GroupName')
        return self


class QuerySuperDeviceGroupResponseData(TeaModel):
    def __init__(self, group_info=None):
        self.group_info = group_info  # type: list[QuerySuperDeviceGroupResponseDataGroupInfo]

    def validate(self):
        self.validate_required(self.group_info, 'group_info')
        if self.group_info:
            for k in self.group_info:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(QuerySuperDeviceGroupResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['GroupInfo'] = []
        if self.group_info is not None:
            for k in self.group_info:
                result['GroupInfo'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.group_info = []
        if m.get('GroupInfo') is not None:
            for k in m.get('GroupInfo'):
                temp_model = QuerySuperDeviceGroupResponseDataGroupInfo()
                self.group_info.append(temp_model.from_map(k))
        return self


class QuerySuperDeviceGroupResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QuerySuperDeviceGroupResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QuerySuperDeviceGroupResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QuerySuperDeviceGroupResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryTaskRequest(TeaModel):
    def __init__(self, iot_instance_id=None, task_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.task_id = task_id  # type: str

    def validate(self):
        self.validate_required(self.task_id, 'task_id')

    def to_map(self):
        _map = super(QueryTaskRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.task_id is not None:
            result['TaskId'] = self.task_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('TaskId') is not None:
            self.task_id = m.get('TaskId')
        return self


class QueryTaskResponseData(TeaModel):
    def __init__(self, device_name=None, iot_id=None, job_id=None, job_name=None, message=None, product_key=None,
                 progress=None, status=None, status_detail=None, task_id=None, utc_modified=None, utc_queue_time=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.job_id = job_id  # type: str
        self.job_name = job_name  # type: str
        self.message = message  # type: str
        self.product_key = product_key  # type: str
        self.progress = progress  # type: str
        self.status = status  # type: str
        self.status_detail = status_detail  # type: str
        self.task_id = task_id  # type: str
        self.utc_modified = utc_modified  # type: str
        self.utc_queue_time = utc_queue_time  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.job_name, 'job_name')
        self.validate_required(self.message, 'message')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.progress, 'progress')
        self.validate_required(self.status, 'status')
        self.validate_required(self.status_detail, 'status_detail')
        self.validate_required(self.task_id, 'task_id')
        self.validate_required(self.utc_modified, 'utc_modified')
        self.validate_required(self.utc_queue_time, 'utc_queue_time')

    def to_map(self):
        _map = super(QueryTaskResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.job_name is not None:
            result['JobName'] = self.job_name
        if self.message is not None:
            result['Message'] = self.message
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.progress is not None:
            result['Progress'] = self.progress
        if self.status is not None:
            result['Status'] = self.status
        if self.status_detail is not None:
            result['StatusDetail'] = self.status_detail
        if self.task_id is not None:
            result['TaskId'] = self.task_id
        if self.utc_modified is not None:
            result['UtcModified'] = self.utc_modified
        if self.utc_queue_time is not None:
            result['UtcQueueTime'] = self.utc_queue_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('JobName') is not None:
            self.job_name = m.get('JobName')
        if m.get('Message') is not None:
            self.message = m.get('Message')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Progress') is not None:
            self.progress = m.get('Progress')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('StatusDetail') is not None:
            self.status_detail = m.get('StatusDetail')
        if m.get('TaskId') is not None:
            self.task_id = m.get('TaskId')
        if m.get('UtcModified') is not None:
            self.utc_modified = m.get('UtcModified')
        if m.get('UtcQueueTime') is not None:
            self.utc_queue_time = m.get('UtcQueueTime')
        return self


class QueryTaskResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryTaskResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryTaskResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryTaskResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryThingModelRequest(TeaModel):
    def __init__(self, function_block_id=None, iot_instance_id=None, model_version=None, product_key=None,
                 resource_group_id=None):
        self.function_block_id = function_block_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.model_version = model_version  # type: str
        self.product_key = product_key  # type: str
        self.resource_group_id = resource_group_id  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryThingModelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.model_version is not None:
            result['ModelVersion'] = self.model_version
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModelVersion') is not None:
            self.model_version = m.get('ModelVersion')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        return self


class QueryThingModelResponseData(TeaModel):
    def __init__(self, thing_model_json=None):
        self.thing_model_json = thing_model_json  # type: str

    def validate(self):
        self.validate_required(self.thing_model_json, 'thing_model_json')

    def to_map(self):
        _map = super(QueryThingModelResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.thing_model_json is not None:
            result['ThingModelJson'] = self.thing_model_json
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ThingModelJson') is not None:
            self.thing_model_json = m.get('ThingModelJson')
        return self


class QueryThingModelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, product_key=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.product_key = product_key  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryThingModelResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryThingModelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryThingModelResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryThingModelExtendConfigRequest(TeaModel):
    def __init__(self, function_block_id=None, iot_instance_id=None, model_version=None, product_key=None,
                 resource_group_id=None):
        self.function_block_id = function_block_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.model_version = model_version  # type: str
        self.product_key = product_key  # type: str
        self.resource_group_id = resource_group_id  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryThingModelExtendConfigRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.model_version is not None:
            result['ModelVersion'] = self.model_version
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModelVersion') is not None:
            self.model_version = m.get('ModelVersion')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        return self


class QueryThingModelExtendConfigResponseData(TeaModel):
    def __init__(self, configuration=None):
        self.configuration = configuration  # type: str

    def validate(self):
        self.validate_required(self.configuration, 'configuration')

    def to_map(self):
        _map = super(QueryThingModelExtendConfigResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        return self


class QueryThingModelExtendConfigResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryThingModelExtendConfigResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryThingModelExtendConfigResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryThingModelExtendConfigResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryThingModelExtendConfigPublishedRequest(TeaModel):
    def __init__(self, function_block_id=None, iot_instance_id=None, model_version=None, product_key=None):
        self.function_block_id = function_block_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.model_version = model_version  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryThingModelExtendConfigPublishedRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.model_version is not None:
            result['ModelVersion'] = self.model_version
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModelVersion') is not None:
            self.model_version = m.get('ModelVersion')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryThingModelExtendConfigPublishedResponseData(TeaModel):
    def __init__(self, configuration=None):
        self.configuration = configuration  # type: str

    def validate(self):
        self.validate_required(self.configuration, 'configuration')

    def to_map(self):
        _map = super(QueryThingModelExtendConfigPublishedResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        return self


class QueryThingModelExtendConfigPublishedResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryThingModelExtendConfigPublishedResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryThingModelExtendConfigPublishedResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryThingModelExtendConfigPublishedResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryThingModelPublishedRequest(TeaModel):
    def __init__(self, function_block_id=None, iot_instance_id=None, model_version=None, product_key=None,
                 resource_group_id=None):
        self.function_block_id = function_block_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.model_version = model_version  # type: str
        self.product_key = product_key  # type: str
        self.resource_group_id = resource_group_id  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(QueryThingModelPublishedRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.model_version is not None:
            result['ModelVersion'] = self.model_version
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.resource_group_id is not None:
            result['ResourceGroupId'] = self.resource_group_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModelVersion') is not None:
            self.model_version = m.get('ModelVersion')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ResourceGroupId') is not None:
            self.resource_group_id = m.get('ResourceGroupId')
        return self


class QueryThingModelPublishedResponseData(TeaModel):
    def __init__(self, thing_model_json=None):
        self.thing_model_json = thing_model_json  # type: str

    def validate(self):
        self.validate_required(self.thing_model_json, 'thing_model_json')

    def to_map(self):
        _map = super(QueryThingModelPublishedResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.thing_model_json is not None:
            result['ThingModelJson'] = self.thing_model_json
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ThingModelJson') is not None:
            self.thing_model_json = m.get('ThingModelJson')
        return self


class QueryThingModelPublishedResponse(TeaModel):
    def __init__(self, code=None, error_message=None, product_key=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.product_key = product_key  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryThingModelPublishedResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryThingModelPublishedResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryThingModelPublishedResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class QueryTopicReverseRouteTableRequest(TeaModel):
    def __init__(self, iot_instance_id=None, region_id=None, topic=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.region_id = region_id  # type: str
        self.topic = topic  # type: str

    def validate(self):
        self.validate_required(self.topic, 'topic')

    def to_map(self):
        _map = super(QueryTopicReverseRouteTableRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.region_id is not None:
            result['RegionId'] = self.region_id
        if self.topic is not None:
            result['Topic'] = self.topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RegionId') is not None:
            self.region_id = m.get('RegionId')
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        return self


class QueryTopicReverseRouteTableResponseSrcTopics(TeaModel):
    def __init__(self, topic=None):
        self.topic = topic  # type: list[dict[str, any]]

    def validate(self):
        self.validate_required(self.topic, 'topic')

    def to_map(self):
        _map = super(QueryTopicReverseRouteTableResponseSrcTopics, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.topic is not None:
            result['Topic'] = self.topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        return self


class QueryTopicReverseRouteTableResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, src_topics=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.src_topics = src_topics  # type: QueryTopicReverseRouteTableResponseSrcTopics

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.src_topics, 'src_topics')
        if self.src_topics:
            self.src_topics.validate()

    def to_map(self):
        _map = super(QueryTopicReverseRouteTableResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.src_topics is not None:
            result['SrcTopics'] = self.src_topics.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('SrcTopics') is not None:
            temp_model = QueryTopicReverseRouteTableResponseSrcTopics()
            self.src_topics = temp_model.from_map(m['SrcTopics'])
        return self


class QueryTopicRouteTableRequest(TeaModel):
    def __init__(self, iot_instance_id=None, topic=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.topic = topic  # type: str

    def validate(self):
        self.validate_required(self.topic, 'topic')

    def to_map(self):
        _map = super(QueryTopicRouteTableRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.topic is not None:
            result['Topic'] = self.topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        return self


class QueryTopicRouteTableResponseDstTopics(TeaModel):
    def __init__(self, topic=None):
        self.topic = topic  # type: list[dict[str, any]]

    def validate(self):
        self.validate_required(self.topic, 'topic')

    def to_map(self):
        _map = super(QueryTopicRouteTableResponseDstTopics, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.topic is not None:
            result['Topic'] = self.topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        return self


class QueryTopicRouteTableResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, dst_topics=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.dst_topics = dst_topics  # type: QueryTopicRouteTableResponseDstTopics

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.dst_topics, 'dst_topics')
        if self.dst_topics:
            self.dst_topics.validate()

    def to_map(self):
        _map = super(QueryTopicRouteTableResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.dst_topics is not None:
            result['DstTopics'] = self.dst_topics.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('DstTopics') is not None:
            temp_model = QueryTopicRouteTableResponseDstTopics()
            self.dst_topics = temp_model.from_map(m['DstTopics'])
        return self


class QueryVehicleDeviceRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(QueryVehicleDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class QueryVehicleDeviceResponseData(TeaModel):
    def __init__(self, auth_code=None, city=None, create_time=None, device_id=None, device_model=None,
                 device_name=None, iot_id=None, manufacturer=None, modified_time=None, product_key=None, province=None,
                 register_time=None, status=None, vehicle_colour=None, vehicle_number=None):
        self.auth_code = auth_code  # type: str
        self.city = city  # type: str
        self.create_time = create_time  # type: long
        self.device_id = device_id  # type: str
        self.device_model = device_model  # type: str
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.manufacturer = manufacturer  # type: str
        self.modified_time = modified_time  # type: long
        self.product_key = product_key  # type: str
        self.province = province  # type: str
        self.register_time = register_time  # type: long
        self.status = status  # type: str
        self.vehicle_colour = vehicle_colour  # type: str
        self.vehicle_number = vehicle_number  # type: str

    def validate(self):
        self.validate_required(self.auth_code, 'auth_code')
        self.validate_required(self.city, 'city')
        self.validate_required(self.create_time, 'create_time')
        self.validate_required(self.device_id, 'device_id')
        self.validate_required(self.device_model, 'device_model')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.manufacturer, 'manufacturer')
        self.validate_required(self.modified_time, 'modified_time')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.province, 'province')
        self.validate_required(self.register_time, 'register_time')
        self.validate_required(self.status, 'status')
        self.validate_required(self.vehicle_colour, 'vehicle_colour')
        self.validate_required(self.vehicle_number, 'vehicle_number')

    def to_map(self):
        _map = super(QueryVehicleDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.auth_code is not None:
            result['AuthCode'] = self.auth_code
        if self.city is not None:
            result['City'] = self.city
        if self.create_time is not None:
            result['CreateTime'] = self.create_time
        if self.device_id is not None:
            result['DeviceId'] = self.device_id
        if self.device_model is not None:
            result['DeviceModel'] = self.device_model
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.manufacturer is not None:
            result['Manufacturer'] = self.manufacturer
        if self.modified_time is not None:
            result['ModifiedTime'] = self.modified_time
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.province is not None:
            result['Province'] = self.province
        if self.register_time is not None:
            result['RegisterTime'] = self.register_time
        if self.status is not None:
            result['Status'] = self.status
        if self.vehicle_colour is not None:
            result['VehicleColour'] = self.vehicle_colour
        if self.vehicle_number is not None:
            result['VehicleNumber'] = self.vehicle_number
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AuthCode') is not None:
            self.auth_code = m.get('AuthCode')
        if m.get('City') is not None:
            self.city = m.get('City')
        if m.get('CreateTime') is not None:
            self.create_time = m.get('CreateTime')
        if m.get('DeviceId') is not None:
            self.device_id = m.get('DeviceId')
        if m.get('DeviceModel') is not None:
            self.device_model = m.get('DeviceModel')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('Manufacturer') is not None:
            self.manufacturer = m.get('Manufacturer')
        if m.get('ModifiedTime') is not None:
            self.modified_time = m.get('ModifiedTime')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Province') is not None:
            self.province = m.get('Province')
        if m.get('RegisterTime') is not None:
            self.register_time = m.get('RegisterTime')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        if m.get('VehicleColour') is not None:
            self.vehicle_colour = m.get('VehicleColour')
        if m.get('VehicleNumber') is not None:
            self.vehicle_number = m.get('VehicleNumber')
        return self


class QueryVehicleDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: QueryVehicleDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(QueryVehicleDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = QueryVehicleDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class RRpcRequest(TeaModel):
    def __init__(self, content_type=None, device_name=None, iot_instance_id=None, product_key=None,
                 request_base_64byte=None, timeout=None, topic=None):
        self.content_type = content_type  # type: str
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.request_base_64byte = request_base_64byte  # type: str
        self.timeout = timeout  # type: int
        self.topic = topic  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.request_base_64byte, 'request_base_64byte')
        self.validate_required(self.timeout, 'timeout')

    def to_map(self):
        _map = super(RRpcRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.content_type is not None:
            result['ContentType'] = self.content_type
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.request_base_64byte is not None:
            result['RequestBase64Byte'] = self.request_base_64byte
        if self.timeout is not None:
            result['Timeout'] = self.timeout
        if self.topic is not None:
            result['Topic'] = self.topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ContentType') is not None:
            self.content_type = m.get('ContentType')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RequestBase64Byte') is not None:
            self.request_base_64byte = m.get('RequestBase64Byte')
        if m.get('Timeout') is not None:
            self.timeout = m.get('Timeout')
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        return self


class RRpcResponse(TeaModel):
    def __init__(self, code=None, error_message=None, message_id=None, payload_base_64byte=None, request_id=None,
                 rrpc_code=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.message_id = message_id  # type: long
        self.payload_base_64byte = payload_base_64byte  # type: str
        self.request_id = request_id  # type: str
        self.rrpc_code = rrpc_code  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.message_id, 'message_id')
        self.validate_required(self.payload_base_64byte, 'payload_base_64byte')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.rrpc_code, 'rrpc_code')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(RRpcResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.message_id is not None:
            result['MessageId'] = self.message_id
        if self.payload_base_64byte is not None:
            result['PayloadBase64Byte'] = self.payload_base_64byte
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.rrpc_code is not None:
            result['RrpcCode'] = self.rrpc_code
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('MessageId') is not None:
            self.message_id = m.get('MessageId')
        if m.get('PayloadBase64Byte') is not None:
            self.payload_base_64byte = m.get('PayloadBase64Byte')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('RrpcCode') is not None:
            self.rrpc_code = m.get('RrpcCode')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class ReBindLicenseDeviceRequest(TeaModel):
    def __init__(self, device_name_list=None, iot_instance_id=None, license_code=None, product_key=None):
        self.device_name_list = device_name_list  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.license_code = license_code  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name_list, 'device_name_list')
        self.validate_required(self.license_code, 'license_code')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(ReBindLicenseDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name_list is not None:
            result['DeviceNameList'] = self.device_name_list
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.license_code is not None:
            result['LicenseCode'] = self.license_code
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceNameList') is not None:
            self.device_name_list = m.get('DeviceNameList')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('LicenseCode') is not None:
            self.license_code = m.get('LicenseCode')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ReBindLicenseDeviceResponseData(TeaModel):
    def __init__(self, check_progress_id=None, fail_sum=None, progress=None, result_csv_file=None, success_sum=None):
        self.check_progress_id = check_progress_id  # type: str
        self.fail_sum = fail_sum  # type: long
        self.progress = progress  # type: int
        self.result_csv_file = result_csv_file  # type: str
        self.success_sum = success_sum  # type: long

    def validate(self):
        self.validate_required(self.check_progress_id, 'check_progress_id')
        self.validate_required(self.fail_sum, 'fail_sum')
        self.validate_required(self.progress, 'progress')
        self.validate_required(self.result_csv_file, 'result_csv_file')
        self.validate_required(self.success_sum, 'success_sum')

    def to_map(self):
        _map = super(ReBindLicenseDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.check_progress_id is not None:
            result['CheckProgressId'] = self.check_progress_id
        if self.fail_sum is not None:
            result['FailSum'] = self.fail_sum
        if self.progress is not None:
            result['Progress'] = self.progress
        if self.result_csv_file is not None:
            result['ResultCsvFile'] = self.result_csv_file
        if self.success_sum is not None:
            result['SuccessSum'] = self.success_sum
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CheckProgressId') is not None:
            self.check_progress_id = m.get('CheckProgressId')
        if m.get('FailSum') is not None:
            self.fail_sum = m.get('FailSum')
        if m.get('Progress') is not None:
            self.progress = m.get('Progress')
        if m.get('ResultCsvFile') is not None:
            self.result_csv_file = m.get('ResultCsvFile')
        if m.get('SuccessSum') is not None:
            self.success_sum = m.get('SuccessSum')
        return self


class ReBindLicenseDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: ReBindLicenseDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(ReBindLicenseDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = ReBindLicenseDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class RecognizeCarNumRequest(TeaModel):
    def __init__(self, url=None):
        self.url = url  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(RecognizeCarNumRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.url is not None:
            result['Url'] = self.url
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Url') is not None:
            self.url = m.get('Url')
        return self


class RecognizeCarNumResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(RecognizeCarNumResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class RecognizePictureGeneralRequest(TeaModel):
    def __init__(self, url=None):
        self.url = url  # type: str

    def validate(self):
        self.validate_required(self.url, 'url')

    def to_map(self):
        _map = super(RecognizePictureGeneralRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.url is not None:
            result['Url'] = self.url
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Url') is not None:
            self.url = m.get('Url')
        return self


class RecognizePictureGeneralResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(RecognizePictureGeneralResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class RefreshDeviceTunnelSharePasswordRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(RefreshDeviceTunnelSharePasswordRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class RefreshDeviceTunnelSharePasswordResponse(TeaModel):
    def __init__(self, code=None, error_message=None, password=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.password = password  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.password, 'password')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(RefreshDeviceTunnelSharePasswordResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.password is not None:
            result['Password'] = self.password
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('Password') is not None:
            self.password = m.get('Password')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class RefreshStudioAppTokenOpenRequest(TeaModel):
    def __init__(self, app_id=None, iot_instance_id=None, project_id=None):
        self.app_id = app_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.app_id, 'app_id')
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(RefreshStudioAppTokenOpenRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_id is not None:
            result['AppId'] = self.app_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppId') is not None:
            self.app_id = m.get('AppId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class RefreshStudioAppTokenOpenResponseData(TeaModel):
    def __init__(self, biz_id=None, biz_type=None, is_enable=None, token=None, type=None):
        self.biz_id = biz_id  # type: str
        self.biz_type = biz_type  # type: str
        self.is_enable = is_enable  # type: str
        self.token = token  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.biz_id, 'biz_id')
        self.validate_required(self.biz_type, 'biz_type')
        self.validate_required(self.is_enable, 'is_enable')
        self.validate_required(self.token, 'token')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(RefreshStudioAppTokenOpenResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.biz_id is not None:
            result['BizId'] = self.biz_id
        if self.biz_type is not None:
            result['BizType'] = self.biz_type
        if self.is_enable is not None:
            result['IsEnable'] = self.is_enable
        if self.token is not None:
            result['Token'] = self.token
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BizId') is not None:
            self.biz_id = m.get('BizId')
        if m.get('BizType') is not None:
            self.biz_type = m.get('BizType')
        if m.get('IsEnable') is not None:
            self.is_enable = m.get('IsEnable')
        if m.get('Token') is not None:
            self.token = m.get('Token')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class RefreshStudioAppTokenOpenResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: RefreshStudioAppTokenOpenResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(RefreshStudioAppTokenOpenResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = RefreshStudioAppTokenOpenResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class RegisterDeviceRequest(TeaModel):
    def __init__(self, app_key=None, dev_eui=None, device_name=None, iot_instance_id=None, join_eui=None,
                 lora_node_type=None, nickname=None, pin_code=None, product_key=None):
        self.app_key = app_key  # type: str
        self.dev_eui = dev_eui  # type: str
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.join_eui = join_eui  # type: str
        self.lora_node_type = lora_node_type  # type: str
        self.nickname = nickname  # type: str
        self.pin_code = pin_code  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(RegisterDeviceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_key is not None:
            result['AppKey'] = self.app_key
        if self.dev_eui is not None:
            result['DevEui'] = self.dev_eui
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.join_eui is not None:
            result['JoinEui'] = self.join_eui
        if self.lora_node_type is not None:
            result['LoraNodeType'] = self.lora_node_type
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.pin_code is not None:
            result['PinCode'] = self.pin_code
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppKey') is not None:
            self.app_key = m.get('AppKey')
        if m.get('DevEui') is not None:
            self.dev_eui = m.get('DevEui')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JoinEui') is not None:
            self.join_eui = m.get('JoinEui')
        if m.get('LoraNodeType') is not None:
            self.lora_node_type = m.get('LoraNodeType')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('PinCode') is not None:
            self.pin_code = m.get('PinCode')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class RegisterDeviceResponseData(TeaModel):
    def __init__(self, dev_eui=None, device_name=None, device_secret=None, iot_id=None, join_eui=None, nickname=None,
                 product_key=None):
        self.dev_eui = dev_eui  # type: str
        self.device_name = device_name  # type: str
        self.device_secret = device_secret  # type: str
        self.iot_id = iot_id  # type: str
        self.join_eui = join_eui  # type: str
        self.nickname = nickname  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.dev_eui, 'dev_eui')
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.device_secret, 'device_secret')
        self.validate_required(self.iot_id, 'iot_id')
        self.validate_required(self.join_eui, 'join_eui')
        self.validate_required(self.nickname, 'nickname')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(RegisterDeviceResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.dev_eui is not None:
            result['DevEui'] = self.dev_eui
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.device_secret is not None:
            result['DeviceSecret'] = self.device_secret
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.join_eui is not None:
            result['JoinEui'] = self.join_eui
        if self.nickname is not None:
            result['Nickname'] = self.nickname
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DevEui') is not None:
            self.dev_eui = m.get('DevEui')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('DeviceSecret') is not None:
            self.device_secret = m.get('DeviceSecret')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('JoinEui') is not None:
            self.join_eui = m.get('JoinEui')
        if m.get('Nickname') is not None:
            self.nickname = m.get('Nickname')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class RegisterDeviceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: RegisterDeviceResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(RegisterDeviceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = RegisterDeviceResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ReleaseEdgeDriverVersionRequest(TeaModel):
    def __init__(self, driver_id=None, driver_version=None, iot_instance_id=None):
        self.driver_id = driver_id  # type: str
        self.driver_version = driver_version  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.driver_version, 'driver_version')

    def to_map(self):
        _map = super(ReleaseEdgeDriverVersionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_version is not None:
            result['DriverVersion'] = self.driver_version
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverVersion') is not None:
            self.driver_version = m.get('DriverVersion')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class ReleaseEdgeDriverVersionResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(ReleaseEdgeDriverVersionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class ReleaseProductRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(ReleaseProductRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ReleaseProductResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(ReleaseProductResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class RemoveThingTopoRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(RemoveThingTopoRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class RemoveThingTopoResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: bool
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(RemoveThingTopoResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class ReplaceEdgeInstanceGatewayRequest(TeaModel):
    def __init__(self, current_gateway_id=None, instance_id=None, iot_instance_id=None, new_gateway_id=None):
        self.current_gateway_id = current_gateway_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.new_gateway_id = new_gateway_id  # type: str

    def validate(self):
        self.validate_required(self.current_gateway_id, 'current_gateway_id')
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.new_gateway_id, 'new_gateway_id')

    def to_map(self):
        _map = super(ReplaceEdgeInstanceGatewayRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.current_gateway_id is not None:
            result['CurrentGatewayId'] = self.current_gateway_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.new_gateway_id is not None:
            result['NewGatewayId'] = self.new_gateway_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('CurrentGatewayId') is not None:
            self.current_gateway_id = m.get('CurrentGatewayId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('NewGatewayId') is not None:
            self.new_gateway_id = m.get('NewGatewayId')
        return self


class ReplaceEdgeInstanceGatewayResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(ReplaceEdgeInstanceGatewayResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class RerunJobRequest(TeaModel):
    def __init__(self, iot_instance_id=None, job_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(RerunJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        return self


class RerunJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(RerunJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class ResetConsumerGroupPositionRequest(TeaModel):
    def __init__(self, group_id=None, iot_instance_id=None):
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(ResetConsumerGroupPositionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class ResetConsumerGroupPositionResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(ResetConsumerGroupPositionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class ResetThingRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(ResetThingRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class ResetThingResponse(TeaModel):
    def __init__(self, code=None, error_message=None, job_id=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.job_id = job_id  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(ResetThingResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class RetrySoundCodeLabelBatchRequest(TeaModel):
    def __init__(self, batch_code=None, iot_instance_id=None):
        self.batch_code = batch_code  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.batch_code, 'batch_code')

    def to_map(self):
        _map = super(RetrySoundCodeLabelBatchRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.batch_code is not None:
            result['BatchCode'] = self.batch_code
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BatchCode') is not None:
            self.batch_code = m.get('BatchCode')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class RetrySoundCodeLabelBatchResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(RetrySoundCodeLabelBatchResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class ReupgradeOTATaskRequest(TeaModel):
    def __init__(self, iot_instance_id=None, job_id=None, task_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str
        self.task_id = task_id  # type: list[str]

    def validate(self):
        self.validate_required(self.job_id, 'job_id')
        self.validate_required(self.task_id, 'task_id')

    def to_map(self):
        _map = super(ReupgradeOTATaskRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.task_id is not None:
            result['TaskId'] = self.task_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('TaskId') is not None:
            self.task_id = m.get('TaskId')
        return self


class ReupgradeOTATaskResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(ReupgradeOTATaskResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SaveDevicePropRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, product_key=None, props=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.props = props  # type: str

    def validate(self):
        self.validate_required(self.props, 'props')

    def to_map(self):
        _map = super(SaveDevicePropRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.props is not None:
            result['Props'] = self.props
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Props') is not None:
            self.props = m.get('Props')
        return self


class SaveDevicePropResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(SaveDevicePropResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SaveScriptRequest(TeaModel):
    def __init__(self, iot_instance_id=None, parser_id=None, script_draft=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.parser_id = parser_id  # type: long
        self.script_draft = script_draft  # type: str

    def validate(self):
        self.validate_required(self.parser_id, 'parser_id')
        self.validate_required(self.script_draft, 'script_draft')

    def to_map(self):
        _map = super(SaveScriptRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        if self.script_draft is not None:
            result['ScriptDraft'] = self.script_draft
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        if m.get('ScriptDraft') is not None:
            self.script_draft = m.get('ScriptDraft')
        return self


class SaveScriptResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(SaveScriptResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SetDeviceDesiredPropertyRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, items=None, product_key=None,
                 versions=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.items = items  # type: str
        self.product_key = product_key  # type: str
        self.versions = versions  # type: str

    def validate(self):
        self.validate_required(self.items, 'items')
        self.validate_required(self.versions, 'versions')

    def to_map(self):
        _map = super(SetDeviceDesiredPropertyRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.items is not None:
            result['Items'] = self.items
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.versions is not None:
            result['Versions'] = self.versions
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Items') is not None:
            self.items = m.get('Items')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Versions') is not None:
            self.versions = m.get('Versions')
        return self


class SetDeviceDesiredPropertyResponseData(TeaModel):
    def __init__(self, message_id=None, versions=None):
        self.message_id = message_id  # type: str
        self.versions = versions  # type: str

    def validate(self):
        self.validate_required(self.message_id, 'message_id')
        self.validate_required(self.versions, 'versions')

    def to_map(self):
        _map = super(SetDeviceDesiredPropertyResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.message_id is not None:
            result['MessageId'] = self.message_id
        if self.versions is not None:
            result['Versions'] = self.versions
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('MessageId') is not None:
            self.message_id = m.get('MessageId')
        if m.get('Versions') is not None:
            self.versions = m.get('Versions')
        return self


class SetDeviceDesiredPropertyResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: SetDeviceDesiredPropertyResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(SetDeviceDesiredPropertyResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = SetDeviceDesiredPropertyResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class SetDeviceGroupTagsRequest(TeaModel):
    def __init__(self, group_id=None, group_type=None, iot_instance_id=None, tag_string=None):
        self.group_id = group_id  # type: str
        self.group_type = group_type  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.tag_string = tag_string  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(SetDeviceGroupTagsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_type is not None:
            result['GroupType'] = self.group_type
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.tag_string is not None:
            result['TagString'] = self.tag_string
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupType') is not None:
            self.group_type = m.get('GroupType')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('TagString') is not None:
            self.tag_string = m.get('TagString')
        return self


class SetDeviceGroupTagsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(SetDeviceGroupTagsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SetDevicePropertyRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, items=None, product_key=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.items = items  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.items, 'items')

    def to_map(self):
        _map = super(SetDevicePropertyRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.items is not None:
            result['Items'] = self.items
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Items') is not None:
            self.items = m.get('Items')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class SetDevicePropertyResponseData(TeaModel):
    def __init__(self, message_id=None):
        self.message_id = message_id  # type: str

    def validate(self):
        self.validate_required(self.message_id, 'message_id')

    def to_map(self):
        _map = super(SetDevicePropertyResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.message_id is not None:
            result['MessageId'] = self.message_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('MessageId') is not None:
            self.message_id = m.get('MessageId')
        return self


class SetDevicePropertyResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: SetDevicePropertyResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(SetDevicePropertyResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = SetDevicePropertyResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class SetDevicesPropertyRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, items=None, product_key=None):
        self.device_name = device_name  # type: list[str]
        self.iot_instance_id = iot_instance_id  # type: str
        self.items = items  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.items, 'items')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(SetDevicesPropertyRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.items is not None:
            result['Items'] = self.items
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Items') is not None:
            self.items = m.get('Items')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class SetDevicesPropertyResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(SetDevicesPropertyResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SetEdgeInstanceDriverConfigsRequestConfigs(TeaModel):
    def __init__(self, content=None, format=None, key=None):
        self.content = content  # type: str
        self.format = format  # type: str
        self.key = key  # type: str

    def validate(self):
        self.validate_required(self.content, 'content')
        self.validate_required(self.format, 'format')

    def to_map(self):
        _map = super(SetEdgeInstanceDriverConfigsRequestConfigs, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.content is not None:
            result['Content'] = self.content
        if self.format is not None:
            result['Format'] = self.format
        if self.key is not None:
            result['Key'] = self.key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Content') is not None:
            self.content = m.get('Content')
        if m.get('Format') is not None:
            self.format = m.get('Format')
        if m.get('Key') is not None:
            self.key = m.get('Key')
        return self


class SetEdgeInstanceDriverConfigsRequest(TeaModel):
    def __init__(self, configs=None, driver_id=None, instance_id=None, iot_instance_id=None):
        self.configs = configs  # type: list[SetEdgeInstanceDriverConfigsRequestConfigs]
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.configs, 'configs')
        if self.configs:
            for k in self.configs:
                if k:
                    k.validate()
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(SetEdgeInstanceDriverConfigsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['Configs'] = []
        if self.configs is not None:
            for k in self.configs:
                result['Configs'].append(k.to_map() if k else None)
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.configs = []
        if m.get('Configs') is not None:
            for k in m.get('Configs'):
                temp_model = SetEdgeInstanceDriverConfigsRequestConfigs()
                self.configs.append(temp_model.from_map(k))
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class SetEdgeInstanceDriverConfigsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(SetEdgeInstanceDriverConfigsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SetProductCertInfoRequest(TeaModel):
    def __init__(self, iot_instance_id=None, issue_model=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.issue_model = issue_model  # type: int
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.issue_model, 'issue_model')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(SetProductCertInfoRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.issue_model is not None:
            result['IssueModel'] = self.issue_model
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('IssueModel') is not None:
            self.issue_model = m.get('IssueModel')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class SetProductCertInfoResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(SetProductCertInfoResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SetStudioProjectCooperationRequest(TeaModel):
    def __init__(self, iot_instance_id=None, status=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.status, 'status')

    def to_map(self):
        _map = super(SetStudioProjectCooperationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class SetStudioProjectCooperationResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: bool
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(SetStudioProjectCooperationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SetupStudioAppAuthModeOpenRequest(TeaModel):
    def __init__(self, app_id=None, auth_mode=None, iot_instance_id=None, project_id=None):
        self.app_id = app_id  # type: str
        self.auth_mode = auth_mode  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_id = project_id  # type: str

    def validate(self):
        self.validate_required(self.app_id, 'app_id')
        self.validate_required(self.auth_mode, 'auth_mode')
        self.validate_required(self.project_id, 'project_id')

    def to_map(self):
        _map = super(SetupStudioAppAuthModeOpenRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.app_id is not None:
            result['AppId'] = self.app_id
        if self.auth_mode is not None:
            result['AuthMode'] = self.auth_mode
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_id is not None:
            result['ProjectId'] = self.project_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AppId') is not None:
            self.app_id = m.get('AppId')
        if m.get('AuthMode') is not None:
            self.auth_mode = m.get('AuthMode')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectId') is not None:
            self.project_id = m.get('ProjectId')
        return self


class SetupStudioAppAuthModeOpenResponseDataTokenInfo(TeaModel):
    def __init__(self, biz_id=None, biz_type=None, is_enable=None, token=None, type=None):
        self.biz_id = biz_id  # type: str
        self.biz_type = biz_type  # type: str
        self.is_enable = is_enable  # type: str
        self.token = token  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.biz_id, 'biz_id')
        self.validate_required(self.biz_type, 'biz_type')
        self.validate_required(self.is_enable, 'is_enable')
        self.validate_required(self.token, 'token')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(SetupStudioAppAuthModeOpenResponseDataTokenInfo, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.biz_id is not None:
            result['BizId'] = self.biz_id
        if self.biz_type is not None:
            result['BizType'] = self.biz_type
        if self.is_enable is not None:
            result['IsEnable'] = self.is_enable
        if self.token is not None:
            result['Token'] = self.token
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BizId') is not None:
            self.biz_id = m.get('BizId')
        if m.get('BizType') is not None:
            self.biz_type = m.get('BizType')
        if m.get('IsEnable') is not None:
            self.is_enable = m.get('IsEnable')
        if m.get('Token') is not None:
            self.token = m.get('Token')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class SetupStudioAppAuthModeOpenResponseData(TeaModel):
    def __init__(self, auth_mode=None, token_info=None):
        self.auth_mode = auth_mode  # type: int
        self.token_info = token_info  # type: SetupStudioAppAuthModeOpenResponseDataTokenInfo

    def validate(self):
        self.validate_required(self.auth_mode, 'auth_mode')
        self.validate_required(self.token_info, 'token_info')
        if self.token_info:
            self.token_info.validate()

    def to_map(self):
        _map = super(SetupStudioAppAuthModeOpenResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.auth_mode is not None:
            result['AuthMode'] = self.auth_mode
        if self.token_info is not None:
            result['TokenInfo'] = self.token_info.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AuthMode') is not None:
            self.auth_mode = m.get('AuthMode')
        if m.get('TokenInfo') is not None:
            temp_model = SetupStudioAppAuthModeOpenResponseDataTokenInfo()
            self.token_info = temp_model.from_map(m['TokenInfo'])
        return self


class SetupStudioAppAuthModeOpenResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: SetupStudioAppAuthModeOpenResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(SetupStudioAppAuthModeOpenResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = SetupStudioAppAuthModeOpenResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class ShareSpeechByCombinationRequest(TeaModel):
    def __init__(self, audio_format=None, combination_list=None, device_name=None, iot_id=None,
                 iot_instance_id=None, product_key=None, speech_id=None):
        self.audio_format = audio_format  # type: str
        self.combination_list = combination_list  # type: list[str]
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.speech_id = speech_id  # type: str

    def validate(self):
        self.validate_required(self.combination_list, 'combination_list')

    def to_map(self):
        _map = super(ShareSpeechByCombinationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.combination_list is not None:
            result['CombinationList'] = self.combination_list
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.speech_id is not None:
            result['SpeechId'] = self.speech_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('CombinationList') is not None:
            self.combination_list = m.get('CombinationList')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SpeechId') is not None:
            self.speech_id = m.get('SpeechId')
        return self


class ShareSpeechByCombinationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(ShareSpeechByCombinationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SpeechByCombinationRequest(TeaModel):
    def __init__(self, audio_format=None, combination_list=None, device_name=None, enforce_flag=None, iot_id=None,
                 iot_instance_id=None, product_key=None, speech_id=None):
        self.audio_format = audio_format  # type: str
        self.combination_list = combination_list  # type: list[str]
        self.device_name = device_name  # type: str
        self.enforce_flag = enforce_flag  # type: bool
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.speech_id = speech_id  # type: str

    def validate(self):
        self.validate_required(self.combination_list, 'combination_list')

    def to_map(self):
        _map = super(SpeechByCombinationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.combination_list is not None:
            result['CombinationList'] = self.combination_list
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.enforce_flag is not None:
            result['EnforceFlag'] = self.enforce_flag
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.speech_id is not None:
            result['SpeechId'] = self.speech_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('CombinationList') is not None:
            self.combination_list = m.get('CombinationList')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('EnforceFlag') is not None:
            self.enforce_flag = m.get('EnforceFlag')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SpeechId') is not None:
            self.speech_id = m.get('SpeechId')
        return self


class SpeechByCombinationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(SpeechByCombinationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SpeechBySynthesisRequest(TeaModel):
    def __init__(self, audio_format=None, device_name=None, iot_id=None, iot_instance_id=None, product_key=None,
                 speech_id=None, speech_rate=None, text=None, voice=None, volume=None):
        self.audio_format = audio_format  # type: str
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.speech_id = speech_id  # type: str
        self.speech_rate = speech_rate  # type: int
        self.text = text  # type: str
        self.voice = voice  # type: str
        self.volume = volume  # type: int

    def validate(self):
        self.validate_required(self.audio_format, 'audio_format')
        self.validate_required(self.text, 'text')
        self.validate_required(self.voice, 'voice')

    def to_map(self):
        _map = super(SpeechBySynthesisRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.speech_id is not None:
            result['SpeechId'] = self.speech_id
        if self.speech_rate is not None:
            result['SpeechRate'] = self.speech_rate
        if self.text is not None:
            result['Text'] = self.text
        if self.voice is not None:
            result['Voice'] = self.voice
        if self.volume is not None:
            result['Volume'] = self.volume
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SpeechId') is not None:
            self.speech_id = m.get('SpeechId')
        if m.get('SpeechRate') is not None:
            self.speech_rate = m.get('SpeechRate')
        if m.get('Text') is not None:
            self.text = m.get('Text')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        if m.get('Volume') is not None:
            self.volume = m.get('Volume')
        return self


class SpeechBySynthesisResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(SpeechBySynthesisResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class StartParserRequest(TeaModel):
    def __init__(self, iot_instance_id=None, parser_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.parser_id = parser_id  # type: long

    def validate(self):
        self.validate_required(self.parser_id, 'parser_id')

    def to_map(self):
        _map = super(StartParserRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        return self


class StartParserResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(StartParserResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class StartRuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, rule_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: long

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(StartRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class StartRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(StartRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class StopParserRequest(TeaModel):
    def __init__(self, iot_instance_id=None, parser_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.parser_id = parser_id  # type: long

    def validate(self):
        self.validate_required(self.parser_id, 'parser_id')

    def to_map(self):
        _map = super(StopParserRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        return self


class StopParserResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(StopParserResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class StopRuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, rule_id=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: long

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(StopRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class StopRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(StopRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SubscribeTopicRequest(TeaModel):
    def __init__(self, device_name=None, iot_instance_id=None, product_key=None, topic=None):
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.topic = topic  # type: list[str]

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.topic, 'topic')

    def to_map(self):
        _map = super(SubscribeTopicRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.topic is not None:
            result['Topic'] = self.topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        return self


class SubscribeTopicResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(SubscribeTopicResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SyncSpeechByCombinationRequest(TeaModel):
    def __init__(self, audio_format=None, combination_list=None, device_name=None, enforce_flag=None, iot_id=None,
                 iot_instance_id=None, product_key=None, speech_id=None):
        self.audio_format = audio_format  # type: str
        self.combination_list = combination_list  # type: list[str]
        self.device_name = device_name  # type: str
        self.enforce_flag = enforce_flag  # type: bool
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.speech_id = speech_id  # type: str

    def validate(self):
        self.validate_required(self.combination_list, 'combination_list')

    def to_map(self):
        _map = super(SyncSpeechByCombinationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.combination_list is not None:
            result['CombinationList'] = self.combination_list
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.enforce_flag is not None:
            result['EnforceFlag'] = self.enforce_flag
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.speech_id is not None:
            result['SpeechId'] = self.speech_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('CombinationList') is not None:
            self.combination_list = m.get('CombinationList')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('EnforceFlag') is not None:
            self.enforce_flag = m.get('EnforceFlag')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SpeechId') is not None:
            self.speech_id = m.get('SpeechId')
        return self


class SyncSpeechByCombinationResponseData(TeaModel):
    def __init__(self, detail=None, device_error_code=None, device_error_message=None, id=None,
                 max_retry_count=None, retry_count=None, success=None):
        self.detail = detail  # type: str
        self.device_error_code = device_error_code  # type: str
        self.device_error_message = device_error_message  # type: str
        self.id = id  # type: str
        self.max_retry_count = max_retry_count  # type: int
        self.retry_count = retry_count  # type: int
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.detail, 'detail')
        self.validate_required(self.device_error_code, 'device_error_code')
        self.validate_required(self.device_error_message, 'device_error_message')
        self.validate_required(self.id, 'id')
        self.validate_required(self.max_retry_count, 'max_retry_count')
        self.validate_required(self.retry_count, 'retry_count')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(SyncSpeechByCombinationResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.detail is not None:
            result['Detail'] = self.detail
        if self.device_error_code is not None:
            result['DeviceErrorCode'] = self.device_error_code
        if self.device_error_message is not None:
            result['DeviceErrorMessage'] = self.device_error_message
        if self.id is not None:
            result['Id'] = self.id
        if self.max_retry_count is not None:
            result['MaxRetryCount'] = self.max_retry_count
        if self.retry_count is not None:
            result['RetryCount'] = self.retry_count
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Detail') is not None:
            self.detail = m.get('Detail')
        if m.get('DeviceErrorCode') is not None:
            self.device_error_code = m.get('DeviceErrorCode')
        if m.get('DeviceErrorMessage') is not None:
            self.device_error_message = m.get('DeviceErrorMessage')
        if m.get('Id') is not None:
            self.id = m.get('Id')
        if m.get('MaxRetryCount') is not None:
            self.max_retry_count = m.get('MaxRetryCount')
        if m.get('RetryCount') is not None:
            self.retry_count = m.get('RetryCount')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class SyncSpeechByCombinationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: SyncSpeechByCombinationResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(SyncSpeechByCombinationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = SyncSpeechByCombinationResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class TestSpeechRequest(TeaModel):
    def __init__(self, audio_format=None, enable_sound_code=None, iot_instance_id=None, project_code=None,
                 sound_code_config=None, speech_rate=None, speech_type=None, text=None, voice=None, volume=None):
        self.audio_format = audio_format  # type: str
        self.enable_sound_code = enable_sound_code  # type: bool
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_code = project_code  # type: str
        self.sound_code_config = sound_code_config  # type: dict[str, any]
        self.speech_rate = speech_rate  # type: int
        self.speech_type = speech_type  # type: str
        self.text = text  # type: str
        self.voice = voice  # type: str
        self.volume = volume  # type: int

    def validate(self):
        self.validate_required(self.project_code, 'project_code')
        self.validate_required(self.voice, 'voice')

    def to_map(self):
        _map = super(TestSpeechRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.enable_sound_code is not None:
            result['EnableSoundCode'] = self.enable_sound_code
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_code is not None:
            result['ProjectCode'] = self.project_code
        if self.sound_code_config is not None:
            result['SoundCodeConfig'] = self.sound_code_config
        if self.speech_rate is not None:
            result['SpeechRate'] = self.speech_rate
        if self.speech_type is not None:
            result['SpeechType'] = self.speech_type
        if self.text is not None:
            result['Text'] = self.text
        if self.voice is not None:
            result['Voice'] = self.voice
        if self.volume is not None:
            result['Volume'] = self.volume
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('EnableSoundCode') is not None:
            self.enable_sound_code = m.get('EnableSoundCode')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectCode') is not None:
            self.project_code = m.get('ProjectCode')
        if m.get('SoundCodeConfig') is not None:
            self.sound_code_config = m.get('SoundCodeConfig')
        if m.get('SpeechRate') is not None:
            self.speech_rate = m.get('SpeechRate')
        if m.get('SpeechType') is not None:
            self.speech_type = m.get('SpeechType')
        if m.get('Text') is not None:
            self.text = m.get('Text')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        if m.get('Volume') is not None:
            self.volume = m.get('Volume')
        return self


class TestSpeechShrinkRequest(TeaModel):
    def __init__(self, audio_format=None, enable_sound_code=None, iot_instance_id=None, project_code=None,
                 sound_code_config_shrink=None, speech_rate=None, speech_type=None, text=None, voice=None, volume=None):
        self.audio_format = audio_format  # type: str
        self.enable_sound_code = enable_sound_code  # type: bool
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_code = project_code  # type: str
        self.sound_code_config_shrink = sound_code_config_shrink  # type: str
        self.speech_rate = speech_rate  # type: int
        self.speech_type = speech_type  # type: str
        self.text = text  # type: str
        self.voice = voice  # type: str
        self.volume = volume  # type: int

    def validate(self):
        self.validate_required(self.project_code, 'project_code')
        self.validate_required(self.voice, 'voice')

    def to_map(self):
        _map = super(TestSpeechShrinkRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.audio_format is not None:
            result['AudioFormat'] = self.audio_format
        if self.enable_sound_code is not None:
            result['EnableSoundCode'] = self.enable_sound_code
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_code is not None:
            result['ProjectCode'] = self.project_code
        if self.sound_code_config_shrink is not None:
            result['SoundCodeConfig'] = self.sound_code_config_shrink
        if self.speech_rate is not None:
            result['SpeechRate'] = self.speech_rate
        if self.speech_type is not None:
            result['SpeechType'] = self.speech_type
        if self.text is not None:
            result['Text'] = self.text
        if self.voice is not None:
            result['Voice'] = self.voice
        if self.volume is not None:
            result['Volume'] = self.volume
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AudioFormat') is not None:
            self.audio_format = m.get('AudioFormat')
        if m.get('EnableSoundCode') is not None:
            self.enable_sound_code = m.get('EnableSoundCode')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectCode') is not None:
            self.project_code = m.get('ProjectCode')
        if m.get('SoundCodeConfig') is not None:
            self.sound_code_config_shrink = m.get('SoundCodeConfig')
        if m.get('SpeechRate') is not None:
            self.speech_rate = m.get('SpeechRate')
        if m.get('SpeechType') is not None:
            self.speech_type = m.get('SpeechType')
        if m.get('Text') is not None:
            self.text = m.get('Text')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        if m.get('Volume') is not None:
            self.volume = m.get('Volume')
        return self


class TestSpeechResponseData(TeaModel):
    def __init__(self, items=None):
        self.items = items  # type: list[str]

    def validate(self):
        self.validate_required(self.items, 'items')

    def to_map(self):
        _map = super(TestSpeechResponseData, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.items is not None:
            result['items'] = self.items
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('items') is not None:
            self.items = m.get('items')
        return self


class TestSpeechResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, data=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.data = data  # type: TestSpeechResponseData

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.data, 'data')
        if self.data:
            self.data.validate()

    def to_map(self):
        _map = super(TestSpeechResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.data is not None:
            result['Data'] = self.data.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('Data') is not None:
            temp_model = TestSpeechResponseData()
            self.data = temp_model.from_map(m['Data'])
        return self


class TransformClientIdRequest(TeaModel):
    def __init__(self, client_id=None, iot_id=None, iot_instance_id=None):
        self.client_id = client_id  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.client_id, 'client_id')
        self.validate_required(self.iot_id, 'iot_id')

    def to_map(self):
        _map = super(TransformClientIdRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.client_id is not None:
            result['ClientId'] = self.client_id
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ClientId') is not None:
            self.client_id = m.get('ClientId')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class TransformClientIdResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(TransformClientIdResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class TriggerSceneRuleRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None, rule_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: str

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(TriggerSceneRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class TriggerSceneRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(TriggerSceneRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UnbindApplicationFromEdgeInstanceRequest(TeaModel):
    def __init__(self, application_id=None, instance_id=None, iot_instance_id=None):
        self.application_id = application_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.application_id, 'application_id')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(UnbindApplicationFromEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.application_id is not None:
            result['ApplicationId'] = self.application_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ApplicationId') is not None:
            self.application_id = m.get('ApplicationId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class UnbindApplicationFromEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UnbindApplicationFromEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UnbindDriverFromEdgeInstanceRequest(TeaModel):
    def __init__(self, driver_id=None, instance_id=None, iot_instance_id=None):
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(UnbindDriverFromEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class UnbindDriverFromEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UnbindDriverFromEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UnbindLicenseProductRequest(TeaModel):
    def __init__(self, iot_instance_id=None, license_code=None, product_key=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.license_code = license_code  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.license_code, 'license_code')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(UnbindLicenseProductRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.license_code is not None:
            result['LicenseCode'] = self.license_code
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('LicenseCode') is not None:
            self.license_code = m.get('LicenseCode')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class UnbindLicenseProductResponse(TeaModel):
    def __init__(self, code=None, data=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.data = data  # type: bool
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.data, 'data')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UnbindLicenseProductResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.data is not None:
            result['Data'] = self.data
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('Data') is not None:
            self.data = m.get('Data')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UnbindRoleFromEdgeInstanceRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(UnbindRoleFromEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class UnbindRoleFromEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UnbindRoleFromEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UnbindSceneRuleFromEdgeInstanceRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None, rule_id=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_id = rule_id  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(UnbindSceneRuleFromEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        return self


class UnbindSceneRuleFromEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UnbindSceneRuleFromEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateConsumerGroupRequest(TeaModel):
    def __init__(self, group_id=None, iot_instance_id=None, new_group_name=None):
        self.group_id = group_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.new_group_name = new_group_name  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')
        self.validate_required(self.new_group_name, 'new_group_name')

    def to_map(self):
        _map = super(UpdateConsumerGroupRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.new_group_name is not None:
            result['NewGroupName'] = self.new_group_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('NewGroupName') is not None:
            self.new_group_name = m.get('NewGroupName')
        return self


class UpdateConsumerGroupResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateConsumerGroupResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateDestinationRequest(TeaModel):
    def __init__(self, configuration=None, description=None, destination_id=None, iot_instance_id=None, name=None,
                 type=None):
        self.configuration = configuration  # type: str
        self.description = description  # type: str
        self.destination_id = destination_id  # type: long
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.configuration, 'configuration')
        self.validate_required(self.destination_id, 'destination_id')
        self.validate_required(self.name, 'name')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(UpdateDestinationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        if self.description is not None:
            result['Description'] = self.description
        if self.destination_id is not None:
            result['DestinationId'] = self.destination_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('DestinationId') is not None:
            self.destination_id = m.get('DestinationId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class UpdateDestinationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateDestinationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateDeviceGroupRequest(TeaModel):
    def __init__(self, group_desc=None, group_id=None, group_type=None, iot_instance_id=None):
        self.group_desc = group_desc  # type: str
        self.group_id = group_id  # type: str
        self.group_type = group_type  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.group_id, 'group_id')

    def to_map(self):
        _map = super(UpdateDeviceGroupRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.group_desc is not None:
            result['GroupDesc'] = self.group_desc
        if self.group_id is not None:
            result['GroupId'] = self.group_id
        if self.group_type is not None:
            result['GroupType'] = self.group_type
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('GroupDesc') is not None:
            self.group_desc = m.get('GroupDesc')
        if m.get('GroupId') is not None:
            self.group_id = m.get('GroupId')
        if m.get('GroupType') is not None:
            self.group_type = m.get('GroupType')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class UpdateDeviceGroupResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateDeviceGroupResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateDeviceShadowRequest(TeaModel):
    def __init__(self, delta_update=None, device_name=None, iot_instance_id=None, product_key=None,
                 shadow_message=None):
        self.delta_update = delta_update  # type: bool
        self.device_name = device_name  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.shadow_message = shadow_message  # type: str

    def validate(self):
        self.validate_required(self.device_name, 'device_name')
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.shadow_message, 'shadow_message')

    def to_map(self):
        _map = super(UpdateDeviceShadowRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.delta_update is not None:
            result['DeltaUpdate'] = self.delta_update
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.shadow_message is not None:
            result['ShadowMessage'] = self.shadow_message
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeltaUpdate') is not None:
            self.delta_update = m.get('DeltaUpdate')
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ShadowMessage') is not None:
            self.shadow_message = m.get('ShadowMessage')
        return self


class UpdateDeviceShadowResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateDeviceShadowResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateEdgeDriverVersionRequest(TeaModel):
    def __init__(self, argument=None, config_check_rule=None, container_config=None, description=None,
                 driver_config=None, driver_id=None, driver_version=None, edge_version=None, iot_instance_id=None,
                 source_config=None):
        self.argument = argument  # type: str
        self.config_check_rule = config_check_rule  # type: str
        self.container_config = container_config  # type: str
        self.description = description  # type: str
        self.driver_config = driver_config  # type: str
        self.driver_id = driver_id  # type: str
        self.driver_version = driver_version  # type: str
        self.edge_version = edge_version  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.source_config = source_config  # type: str

    def validate(self):
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.driver_version, 'driver_version')
        self.validate_required(self.edge_version, 'edge_version')

    def to_map(self):
        _map = super(UpdateEdgeDriverVersionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.argument is not None:
            result['Argument'] = self.argument
        if self.config_check_rule is not None:
            result['ConfigCheckRule'] = self.config_check_rule
        if self.container_config is not None:
            result['ContainerConfig'] = self.container_config
        if self.description is not None:
            result['Description'] = self.description
        if self.driver_config is not None:
            result['DriverConfig'] = self.driver_config
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.driver_version is not None:
            result['DriverVersion'] = self.driver_version
        if self.edge_version is not None:
            result['EdgeVersion'] = self.edge_version
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.source_config is not None:
            result['SourceConfig'] = self.source_config
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Argument') is not None:
            self.argument = m.get('Argument')
        if m.get('ConfigCheckRule') is not None:
            self.config_check_rule = m.get('ConfigCheckRule')
        if m.get('ContainerConfig') is not None:
            self.container_config = m.get('ContainerConfig')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('DriverConfig') is not None:
            self.driver_config = m.get('DriverConfig')
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('DriverVersion') is not None:
            self.driver_version = m.get('DriverVersion')
        if m.get('EdgeVersion') is not None:
            self.edge_version = m.get('EdgeVersion')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('SourceConfig') is not None:
            self.source_config = m.get('SourceConfig')
        return self


class UpdateEdgeDriverVersionResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateEdgeDriverVersionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateEdgeInstanceRequest(TeaModel):
    def __init__(self, biz_enable=None, instance_id=None, iot_instance_id=None, name=None, spec=None, tags=None):
        self.biz_enable = biz_enable  # type: bool
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.spec = spec  # type: int
        self.tags = tags  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.name, 'name')

    def to_map(self):
        _map = super(UpdateEdgeInstanceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.biz_enable is not None:
            result['BizEnable'] = self.biz_enable
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.spec is not None:
            result['Spec'] = self.spec
        if self.tags is not None:
            result['Tags'] = self.tags
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('BizEnable') is not None:
            self.biz_enable = m.get('BizEnable')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('Spec') is not None:
            self.spec = m.get('Spec')
        if m.get('Tags') is not None:
            self.tags = m.get('Tags')
        return self


class UpdateEdgeInstanceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateEdgeInstanceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateEdgeInstanceChannelRequestConfigs(TeaModel):
    def __init__(self, content=None, format=None, key=None):
        self.content = content  # type: str
        self.format = format  # type: str
        self.key = key  # type: str

    def validate(self):
        self.validate_required(self.content, 'content')
        self.validate_required(self.format, 'format')

    def to_map(self):
        _map = super(UpdateEdgeInstanceChannelRequestConfigs, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.content is not None:
            result['Content'] = self.content
        if self.format is not None:
            result['Format'] = self.format
        if self.key is not None:
            result['Key'] = self.key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Content') is not None:
            self.content = m.get('Content')
        if m.get('Format') is not None:
            self.format = m.get('Format')
        if m.get('Key') is not None:
            self.key = m.get('Key')
        return self


class UpdateEdgeInstanceChannelRequest(TeaModel):
    def __init__(self, channel_id=None, channel_name=None, configs=None, driver_id=None, instance_id=None,
                 iot_instance_id=None):
        self.channel_id = channel_id  # type: str
        self.channel_name = channel_name  # type: str
        self.configs = configs  # type: list[UpdateEdgeInstanceChannelRequestConfigs]
        self.driver_id = driver_id  # type: str
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str

    def validate(self):
        self.validate_required(self.channel_id, 'channel_id')
        self.validate_required(self.channel_name, 'channel_name')
        self.validate_required(self.configs, 'configs')
        if self.configs:
            for k in self.configs:
                if k:
                    k.validate()
        self.validate_required(self.driver_id, 'driver_id')
        self.validate_required(self.instance_id, 'instance_id')

    def to_map(self):
        _map = super(UpdateEdgeInstanceChannelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.channel_id is not None:
            result['ChannelId'] = self.channel_id
        if self.channel_name is not None:
            result['ChannelName'] = self.channel_name
        result['Configs'] = []
        if self.configs is not None:
            for k in self.configs:
                result['Configs'].append(k.to_map() if k else None)
        if self.driver_id is not None:
            result['DriverId'] = self.driver_id
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ChannelId') is not None:
            self.channel_id = m.get('ChannelId')
        if m.get('ChannelName') is not None:
            self.channel_name = m.get('ChannelName')
        self.configs = []
        if m.get('Configs') is not None:
            for k in m.get('Configs'):
                temp_model = UpdateEdgeInstanceChannelRequestConfigs()
                self.configs.append(temp_model.from_map(k))
        if m.get('DriverId') is not None:
            self.driver_id = m.get('DriverId')
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        return self


class UpdateEdgeInstanceChannelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateEdgeInstanceChannelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateEdgeInstanceMessageRoutingRequest(TeaModel):
    def __init__(self, instance_id=None, iot_instance_id=None, name=None, route_id=None, source_data=None,
                 source_type=None, target_data=None, target_iot_hub_qos=None, target_type=None, topic_filter=None):
        self.instance_id = instance_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.route_id = route_id  # type: long
        self.source_data = source_data  # type: str
        self.source_type = source_type  # type: str
        self.target_data = target_data  # type: str
        self.target_iot_hub_qos = target_iot_hub_qos  # type: int
        self.target_type = target_type  # type: str
        self.topic_filter = topic_filter  # type: str

    def validate(self):
        self.validate_required(self.instance_id, 'instance_id')
        self.validate_required(self.route_id, 'route_id')
        self.validate_required(self.source_type, 'source_type')
        self.validate_required(self.target_type, 'target_type')

    def to_map(self):
        _map = super(UpdateEdgeInstanceMessageRoutingRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.instance_id is not None:
            result['InstanceId'] = self.instance_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.route_id is not None:
            result['RouteId'] = self.route_id
        if self.source_data is not None:
            result['SourceData'] = self.source_data
        if self.source_type is not None:
            result['SourceType'] = self.source_type
        if self.target_data is not None:
            result['TargetData'] = self.target_data
        if self.target_iot_hub_qos is not None:
            result['TargetIotHubQos'] = self.target_iot_hub_qos
        if self.target_type is not None:
            result['TargetType'] = self.target_type
        if self.topic_filter is not None:
            result['TopicFilter'] = self.topic_filter
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('InstanceId') is not None:
            self.instance_id = m.get('InstanceId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('RouteId') is not None:
            self.route_id = m.get('RouteId')
        if m.get('SourceData') is not None:
            self.source_data = m.get('SourceData')
        if m.get('SourceType') is not None:
            self.source_type = m.get('SourceType')
        if m.get('TargetData') is not None:
            self.target_data = m.get('TargetData')
        if m.get('TargetIotHubQos') is not None:
            self.target_iot_hub_qos = m.get('TargetIotHubQos')
        if m.get('TargetType') is not None:
            self.target_type = m.get('TargetType')
        if m.get('TopicFilter') is not None:
            self.topic_filter = m.get('TopicFilter')
        return self


class UpdateEdgeInstanceMessageRoutingResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateEdgeInstanceMessageRoutingResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateJobRequest(TeaModel):
    def __init__(self, description=None, iot_instance_id=None, job_id=None, rollout_config=None,
                 timeout_config=None):
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str
        self.rollout_config = rollout_config  # type: dict[str, any]
        self.timeout_config = timeout_config  # type: dict[str, any]

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(UpdateJobRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.rollout_config is not None:
            result['RolloutConfig'] = self.rollout_config
        if self.timeout_config is not None:
            result['TimeoutConfig'] = self.timeout_config
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('RolloutConfig') is not None:
            self.rollout_config = m.get('RolloutConfig')
        if m.get('TimeoutConfig') is not None:
            self.timeout_config = m.get('TimeoutConfig')
        return self


class UpdateJobShrinkRequest(TeaModel):
    def __init__(self, description=None, iot_instance_id=None, job_id=None, rollout_config_shrink=None,
                 timeout_config_shrink=None):
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.job_id = job_id  # type: str
        self.rollout_config_shrink = rollout_config_shrink  # type: str
        self.timeout_config_shrink = timeout_config_shrink  # type: str

    def validate(self):
        self.validate_required(self.job_id, 'job_id')

    def to_map(self):
        _map = super(UpdateJobShrinkRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.job_id is not None:
            result['JobId'] = self.job_id
        if self.rollout_config_shrink is not None:
            result['RolloutConfig'] = self.rollout_config_shrink
        if self.timeout_config_shrink is not None:
            result['TimeoutConfig'] = self.timeout_config_shrink
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('JobId') is not None:
            self.job_id = m.get('JobId')
        if m.get('RolloutConfig') is not None:
            self.rollout_config_shrink = m.get('RolloutConfig')
        if m.get('TimeoutConfig') is not None:
            self.timeout_config_shrink = m.get('TimeoutConfig')
        return self


class UpdateJobResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateJobResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateOTAModuleRequest(TeaModel):
    def __init__(self, alias_name=None, desc=None, iot_instance_id=None, module_name=None, product_key=None):
        self.alias_name = alias_name  # type: str
        self.desc = desc  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.module_name = module_name  # type: str
        self.product_key = product_key  # type: str

    def validate(self):
        self.validate_required(self.module_name, 'module_name')
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(UpdateOTAModuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.alias_name is not None:
            result['AliasName'] = self.alias_name
        if self.desc is not None:
            result['Desc'] = self.desc
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.module_name is not None:
            result['ModuleName'] = self.module_name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('AliasName') is not None:
            self.alias_name = m.get('AliasName')
        if m.get('Desc') is not None:
            self.desc = m.get('Desc')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ModuleName') is not None:
            self.module_name = m.get('ModuleName')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        return self


class UpdateOTAModuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateOTAModuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateParserRequest(TeaModel):
    def __init__(self, description=None, iot_instance_id=None, name=None, parser_id=None):
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.parser_id = parser_id  # type: long

    def validate(self):
        self.validate_required(self.parser_id, 'parser_id')

    def to_map(self):
        _map = super(UpdateParserRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.parser_id is not None:
            result['ParserId'] = self.parser_id
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('ParserId') is not None:
            self.parser_id = m.get('ParserId')
        return self


class UpdateParserResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateParserResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateParserDataSourceRequest(TeaModel):
    def __init__(self, data_source_id=None, description=None, iot_instance_id=None, name=None):
        self.data_source_id = data_source_id  # type: long
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str

    def validate(self):
        self.validate_required(self.data_source_id, 'data_source_id')
        self.validate_required(self.name, 'name')

    def to_map(self):
        _map = super(UpdateParserDataSourceRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.data_source_id is not None:
            result['DataSourceId'] = self.data_source_id
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DataSourceId') is not None:
            self.data_source_id = m.get('DataSourceId')
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        return self


class UpdateParserDataSourceResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateParserDataSourceResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateProductRequest(TeaModel):
    def __init__(self, description=None, iot_instance_id=None, product_key=None, product_name=None):
        self.description = description  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.product_name = product_name  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_name, 'product_name')

    def to_map(self):
        _map = super(UpdateProductRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.product_name is not None:
            result['ProductName'] = self.product_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ProductName') is not None:
            self.product_name = m.get('ProductName')
        return self


class UpdateProductResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateProductResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateProductFilterConfigRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None, property_timestamp_filter=None,
                 property_value_filter=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.property_timestamp_filter = property_timestamp_filter  # type: bool
        self.property_value_filter = property_value_filter  # type: bool

    def validate(self):
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.property_timestamp_filter, 'property_timestamp_filter')
        self.validate_required(self.property_value_filter, 'property_value_filter')

    def to_map(self):
        _map = super(UpdateProductFilterConfigRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.property_timestamp_filter is not None:
            result['PropertyTimestampFilter'] = self.property_timestamp_filter
        if self.property_value_filter is not None:
            result['PropertyValueFilter'] = self.property_value_filter
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('PropertyTimestampFilter') is not None:
            self.property_timestamp_filter = m.get('PropertyTimestampFilter')
        if m.get('PropertyValueFilter') is not None:
            self.property_value_filter = m.get('PropertyValueFilter')
        return self


class UpdateProductFilterConfigResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateProductFilterConfigResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateProductTagsRequestProductTag(TeaModel):
    def __init__(self, tag_key=None, tag_value=None):
        self.tag_key = tag_key  # type: str
        self.tag_value = tag_value  # type: str

    def validate(self):
        pass

    def to_map(self):
        _map = super(UpdateProductTagsRequestProductTag, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tag_key is not None:
            result['TagKey'] = self.tag_key
        if self.tag_value is not None:
            result['TagValue'] = self.tag_value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TagKey') is not None:
            self.tag_key = m.get('TagKey')
        if m.get('TagValue') is not None:
            self.tag_value = m.get('TagValue')
        return self


class UpdateProductTagsRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None, product_tag=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.product_tag = product_tag  # type: list[UpdateProductTagsRequestProductTag]

    def validate(self):
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.product_tag, 'product_tag')
        if self.product_tag:
            for k in self.product_tag:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(UpdateProductTagsRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        result['ProductTag'] = []
        if self.product_tag is not None:
            for k in self.product_tag:
                result['ProductTag'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        self.product_tag = []
        if m.get('ProductTag') is not None:
            for k in m.get('ProductTag'):
                temp_model = UpdateProductTagsRequestProductTag()
                self.product_tag.append(temp_model.from_map(k))
        return self


class UpdateProductTagsResponseInvalidProductTagsProductTag(TeaModel):
    def __init__(self, tag_key=None, tag_value=None):
        self.tag_key = tag_key  # type: str
        self.tag_value = tag_value  # type: str

    def validate(self):
        self.validate_required(self.tag_key, 'tag_key')
        self.validate_required(self.tag_value, 'tag_value')

    def to_map(self):
        _map = super(UpdateProductTagsResponseInvalidProductTagsProductTag, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.tag_key is not None:
            result['TagKey'] = self.tag_key
        if self.tag_value is not None:
            result['TagValue'] = self.tag_value
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('TagKey') is not None:
            self.tag_key = m.get('TagKey')
        if m.get('TagValue') is not None:
            self.tag_value = m.get('TagValue')
        return self


class UpdateProductTagsResponseInvalidProductTags(TeaModel):
    def __init__(self, product_tag=None):
        self.product_tag = product_tag  # type: list[UpdateProductTagsResponseInvalidProductTagsProductTag]

    def validate(self):
        self.validate_required(self.product_tag, 'product_tag')
        if self.product_tag:
            for k in self.product_tag:
                if k:
                    k.validate()

    def to_map(self):
        _map = super(UpdateProductTagsResponseInvalidProductTags, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        result['ProductTag'] = []
        if self.product_tag is not None:
            for k in self.product_tag:
                result['ProductTag'].append(k.to_map() if k else None)
        return result

    def from_map(self, m=None):
        m = m or dict()
        self.product_tag = []
        if m.get('ProductTag') is not None:
            for k in m.get('ProductTag'):
                temp_model = UpdateProductTagsResponseInvalidProductTagsProductTag()
                self.product_tag.append(temp_model.from_map(k))
        return self


class UpdateProductTagsResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None, invalid_product_tags=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool
        self.invalid_product_tags = invalid_product_tags  # type: UpdateProductTagsResponseInvalidProductTags

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')
        self.validate_required(self.invalid_product_tags, 'invalid_product_tags')
        if self.invalid_product_tags:
            self.invalid_product_tags.validate()

    def to_map(self):
        _map = super(UpdateProductTagsResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        if self.invalid_product_tags is not None:
            result['InvalidProductTags'] = self.invalid_product_tags.to_map()
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        if m.get('InvalidProductTags') is not None:
            temp_model = UpdateProductTagsResponseInvalidProductTags()
            self.invalid_product_tags = temp_model.from_map(m['InvalidProductTags'])
        return self


class UpdateProductTopicRequest(TeaModel):
    def __init__(self, desc=None, iot_instance_id=None, operation=None, topic_id=None, topic_short_name=None):
        self.desc = desc  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.operation = operation  # type: str
        self.topic_id = topic_id  # type: str
        self.topic_short_name = topic_short_name  # type: str

    def validate(self):
        self.validate_required(self.operation, 'operation')
        self.validate_required(self.topic_id, 'topic_id')
        self.validate_required(self.topic_short_name, 'topic_short_name')

    def to_map(self):
        _map = super(UpdateProductTopicRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.desc is not None:
            result['Desc'] = self.desc
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.operation is not None:
            result['Operation'] = self.operation
        if self.topic_id is not None:
            result['TopicId'] = self.topic_id
        if self.topic_short_name is not None:
            result['TopicShortName'] = self.topic_short_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Desc') is not None:
            self.desc = m.get('Desc')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Operation') is not None:
            self.operation = m.get('Operation')
        if m.get('TopicId') is not None:
            self.topic_id = m.get('TopicId')
        if m.get('TopicShortName') is not None:
            self.topic_short_name = m.get('TopicShortName')
        return self


class UpdateProductTopicResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateProductTopicResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateRuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, name=None, product_key=None, rule_desc=None, rule_id=None, select=None,
                 short_topic=None, topic=None, topic_type=None, where=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.product_key = product_key  # type: str
        self.rule_desc = rule_desc  # type: str
        self.rule_id = rule_id  # type: long
        self.select = select  # type: str
        self.short_topic = short_topic  # type: str
        self.topic = topic  # type: str
        self.topic_type = topic_type  # type: int
        self.where = where  # type: str

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(UpdateRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.rule_desc is not None:
            result['RuleDesc'] = self.rule_desc
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        if self.select is not None:
            result['Select'] = self.select
        if self.short_topic is not None:
            result['ShortTopic'] = self.short_topic
        if self.topic is not None:
            result['Topic'] = self.topic
        if self.topic_type is not None:
            result['TopicType'] = self.topic_type
        if self.where is not None:
            result['Where'] = self.where
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('RuleDesc') is not None:
            self.rule_desc = m.get('RuleDesc')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        if m.get('Select') is not None:
            self.select = m.get('Select')
        if m.get('ShortTopic') is not None:
            self.short_topic = m.get('ShortTopic')
        if m.get('Topic') is not None:
            self.topic = m.get('Topic')
        if m.get('TopicType') is not None:
            self.topic_type = m.get('TopicType')
        if m.get('Where') is not None:
            self.where = m.get('Where')
        return self


class UpdateRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateRuleActionRequest(TeaModel):
    def __init__(self, action_id=None, configuration=None, iot_instance_id=None, type=None):
        self.action_id = action_id  # type: long
        self.configuration = configuration  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.action_id, 'action_id')
        self.validate_required(self.configuration, 'configuration')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(UpdateRuleActionRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.action_id is not None:
            result['ActionId'] = self.action_id
        if self.configuration is not None:
            result['Configuration'] = self.configuration
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ActionId') is not None:
            self.action_id = m.get('ActionId')
        if m.get('Configuration') is not None:
            self.configuration = m.get('Configuration')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class UpdateRuleActionResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateRuleActionResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateSceneRuleRequest(TeaModel):
    def __init__(self, iot_instance_id=None, rule_content=None, rule_description=None, rule_id=None, rule_name=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.rule_content = rule_content  # type: str
        self.rule_description = rule_description  # type: str
        self.rule_id = rule_id  # type: str
        self.rule_name = rule_name  # type: str

    def validate(self):
        self.validate_required(self.rule_id, 'rule_id')

    def to_map(self):
        _map = super(UpdateSceneRuleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.rule_content is not None:
            result['RuleContent'] = self.rule_content
        if self.rule_description is not None:
            result['RuleDescription'] = self.rule_description
        if self.rule_id is not None:
            result['RuleId'] = self.rule_id
        if self.rule_name is not None:
            result['RuleName'] = self.rule_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('RuleContent') is not None:
            self.rule_content = m.get('RuleContent')
        if m.get('RuleDescription') is not None:
            self.rule_description = m.get('RuleDescription')
        if m.get('RuleId') is not None:
            self.rule_id = m.get('RuleId')
        if m.get('RuleName') is not None:
            self.rule_name = m.get('RuleName')
        return self


class UpdateSceneRuleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateSceneRuleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateSchedulePeriodRequest(TeaModel):
    def __init__(self, description=None, end_time=None, iot_instance_id=None, period_code=None,
                 sound_code_content=None, start_time=None):
        self.description = description  # type: str
        self.end_time = end_time  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.period_code = period_code  # type: str
        self.sound_code_content = sound_code_content  # type: str
        self.start_time = start_time  # type: str

    def validate(self):
        self.validate_required(self.period_code, 'period_code')

    def to_map(self):
        _map = super(UpdateSchedulePeriodRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.period_code is not None:
            result['PeriodCode'] = self.period_code
        if self.sound_code_content is not None:
            result['SoundCodeContent'] = self.sound_code_content
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('PeriodCode') is not None:
            self.period_code = m.get('PeriodCode')
        if m.get('SoundCodeContent') is not None:
            self.sound_code_content = m.get('SoundCodeContent')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        return self


class UpdateSchedulePeriodResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateSchedulePeriodResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateSoundCodeRequest(TeaModel):
    def __init__(self, duration=None, iot_instance_id=None, name=None, sound_code=None, sound_code_content=None):
        self.duration = duration  # type: int
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.sound_code = sound_code  # type: str
        self.sound_code_content = sound_code_content  # type: str

    def validate(self):
        self.validate_required(self.sound_code, 'sound_code')

    def to_map(self):
        _map = super(UpdateSoundCodeRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.duration is not None:
            result['Duration'] = self.duration
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.sound_code is not None:
            result['SoundCode'] = self.sound_code
        if self.sound_code_content is not None:
            result['SoundCodeContent'] = self.sound_code_content
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Duration') is not None:
            self.duration = m.get('Duration')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('SoundCode') is not None:
            self.sound_code = m.get('SoundCode')
        if m.get('SoundCodeContent') is not None:
            self.sound_code_content = m.get('SoundCodeContent')
        return self


class UpdateSoundCodeResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateSoundCodeResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateSoundCodeLabelRequest(TeaModel):
    def __init__(self, iot_instance_id=None, label=None, sound_code=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.label = label  # type: str
        self.sound_code = sound_code  # type: str

    def validate(self):
        self.validate_required(self.label, 'label')
        self.validate_required(self.sound_code, 'sound_code')

    def to_map(self):
        _map = super(UpdateSoundCodeLabelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.label is not None:
            result['Label'] = self.label
        if self.sound_code is not None:
            result['SoundCode'] = self.sound_code
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Label') is not None:
            self.label = m.get('Label')
        if m.get('SoundCode') is not None:
            self.sound_code = m.get('SoundCode')
        return self


class UpdateSoundCodeLabelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateSoundCodeLabelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateSoundCodeScheduleRequest(TeaModel):
    def __init__(self, description=None, end_date=None, end_time=None, iot_instance_id=None, name=None,
                 schedule_code=None, start_date=None, start_time=None, status=None):
        self.description = description  # type: str
        self.end_date = end_date  # type: str
        self.end_time = end_time  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.name = name  # type: str
        self.schedule_code = schedule_code  # type: str
        self.start_date = start_date  # type: str
        self.start_time = start_time  # type: str
        self.status = status  # type: str

    def validate(self):
        self.validate_required(self.schedule_code, 'schedule_code')

    def to_map(self):
        _map = super(UpdateSoundCodeScheduleRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.description is not None:
            result['Description'] = self.description
        if self.end_date is not None:
            result['EndDate'] = self.end_date
        if self.end_time is not None:
            result['EndTime'] = self.end_time
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.name is not None:
            result['Name'] = self.name
        if self.schedule_code is not None:
            result['ScheduleCode'] = self.schedule_code
        if self.start_date is not None:
            result['StartDate'] = self.start_date
        if self.start_time is not None:
            result['StartTime'] = self.start_time
        if self.status is not None:
            result['Status'] = self.status
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Description') is not None:
            self.description = m.get('Description')
        if m.get('EndDate') is not None:
            self.end_date = m.get('EndDate')
        if m.get('EndTime') is not None:
            self.end_time = m.get('EndTime')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Name') is not None:
            self.name = m.get('Name')
        if m.get('ScheduleCode') is not None:
            self.schedule_code = m.get('ScheduleCode')
        if m.get('StartDate') is not None:
            self.start_date = m.get('StartDate')
        if m.get('StartTime') is not None:
            self.start_time = m.get('StartTime')
        if m.get('Status') is not None:
            self.status = m.get('Status')
        return self


class UpdateSoundCodeScheduleResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateSoundCodeScheduleResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateSpeechRequest(TeaModel):
    def __init__(self, enable_sound_code=None, iot_instance_id=None, project_code=None, sound_code_config=None,
                 speech_code=None, speech_rate=None, voice=None, volume=None):
        self.enable_sound_code = enable_sound_code  # type: bool
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_code = project_code  # type: str
        self.sound_code_config = sound_code_config  # type: dict[str, any]
        self.speech_code = speech_code  # type: str
        self.speech_rate = speech_rate  # type: int
        self.voice = voice  # type: str
        self.volume = volume  # type: int

    def validate(self):
        self.validate_required(self.project_code, 'project_code')
        self.validate_required(self.speech_code, 'speech_code')
        self.validate_required(self.voice, 'voice')

    def to_map(self):
        _map = super(UpdateSpeechRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.enable_sound_code is not None:
            result['EnableSoundCode'] = self.enable_sound_code
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_code is not None:
            result['ProjectCode'] = self.project_code
        if self.sound_code_config is not None:
            result['SoundCodeConfig'] = self.sound_code_config
        if self.speech_code is not None:
            result['SpeechCode'] = self.speech_code
        if self.speech_rate is not None:
            result['SpeechRate'] = self.speech_rate
        if self.voice is not None:
            result['Voice'] = self.voice
        if self.volume is not None:
            result['Volume'] = self.volume
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('EnableSoundCode') is not None:
            self.enable_sound_code = m.get('EnableSoundCode')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectCode') is not None:
            self.project_code = m.get('ProjectCode')
        if m.get('SoundCodeConfig') is not None:
            self.sound_code_config = m.get('SoundCodeConfig')
        if m.get('SpeechCode') is not None:
            self.speech_code = m.get('SpeechCode')
        if m.get('SpeechRate') is not None:
            self.speech_rate = m.get('SpeechRate')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        if m.get('Volume') is not None:
            self.volume = m.get('Volume')
        return self


class UpdateSpeechShrinkRequest(TeaModel):
    def __init__(self, enable_sound_code=None, iot_instance_id=None, project_code=None,
                 sound_code_config_shrink=None, speech_code=None, speech_rate=None, voice=None, volume=None):
        self.enable_sound_code = enable_sound_code  # type: bool
        self.iot_instance_id = iot_instance_id  # type: str
        self.project_code = project_code  # type: str
        self.sound_code_config_shrink = sound_code_config_shrink  # type: str
        self.speech_code = speech_code  # type: str
        self.speech_rate = speech_rate  # type: int
        self.voice = voice  # type: str
        self.volume = volume  # type: int

    def validate(self):
        self.validate_required(self.project_code, 'project_code')
        self.validate_required(self.speech_code, 'speech_code')
        self.validate_required(self.voice, 'voice')

    def to_map(self):
        _map = super(UpdateSpeechShrinkRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.enable_sound_code is not None:
            result['EnableSoundCode'] = self.enable_sound_code
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.project_code is not None:
            result['ProjectCode'] = self.project_code
        if self.sound_code_config_shrink is not None:
            result['SoundCodeConfig'] = self.sound_code_config_shrink
        if self.speech_code is not None:
            result['SpeechCode'] = self.speech_code
        if self.speech_rate is not None:
            result['SpeechRate'] = self.speech_rate
        if self.voice is not None:
            result['Voice'] = self.voice
        if self.volume is not None:
            result['Volume'] = self.volume
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('EnableSoundCode') is not None:
            self.enable_sound_code = m.get('EnableSoundCode')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProjectCode') is not None:
            self.project_code = m.get('ProjectCode')
        if m.get('SoundCodeConfig') is not None:
            self.sound_code_config_shrink = m.get('SoundCodeConfig')
        if m.get('SpeechCode') is not None:
            self.speech_code = m.get('SpeechCode')
        if m.get('SpeechRate') is not None:
            self.speech_rate = m.get('SpeechRate')
        if m.get('Voice') is not None:
            self.voice = m.get('Voice')
        if m.get('Volume') is not None:
            self.volume = m.get('Volume')
        return self


class UpdateSpeechResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateSpeechResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateSubscribeRelationRequest(TeaModel):
    def __init__(self, consumer_group_ids=None, device_data_flag=None, device_life_cycle_flag=None,
                 device_status_change_flag=None, device_tag_flag=None, device_topo_life_cycle_flag=None, found_device_list_flag=None,
                 iot_instance_id=None, mns_configuration=None, ota_event_flag=None, ota_job_flag=None, ota_version_flag=None,
                 product_key=None, subscribe_flags=None, thing_history_flag=None, type=None):
        self.consumer_group_ids = consumer_group_ids  # type: list[str]
        self.device_data_flag = device_data_flag  # type: bool
        self.device_life_cycle_flag = device_life_cycle_flag  # type: bool
        self.device_status_change_flag = device_status_change_flag  # type: bool
        self.device_tag_flag = device_tag_flag  # type: bool
        self.device_topo_life_cycle_flag = device_topo_life_cycle_flag  # type: bool
        self.found_device_list_flag = found_device_list_flag  # type: bool
        self.iot_instance_id = iot_instance_id  # type: str
        self.mns_configuration = mns_configuration  # type: str
        self.ota_event_flag = ota_event_flag  # type: bool
        self.ota_job_flag = ota_job_flag  # type: bool
        self.ota_version_flag = ota_version_flag  # type: bool
        self.product_key = product_key  # type: str
        self.subscribe_flags = subscribe_flags  # type: str
        self.thing_history_flag = thing_history_flag  # type: bool
        self.type = type  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.type, 'type')

    def to_map(self):
        _map = super(UpdateSubscribeRelationRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.consumer_group_ids is not None:
            result['ConsumerGroupIds'] = self.consumer_group_ids
        if self.device_data_flag is not None:
            result['DeviceDataFlag'] = self.device_data_flag
        if self.device_life_cycle_flag is not None:
            result['DeviceLifeCycleFlag'] = self.device_life_cycle_flag
        if self.device_status_change_flag is not None:
            result['DeviceStatusChangeFlag'] = self.device_status_change_flag
        if self.device_tag_flag is not None:
            result['DeviceTagFlag'] = self.device_tag_flag
        if self.device_topo_life_cycle_flag is not None:
            result['DeviceTopoLifeCycleFlag'] = self.device_topo_life_cycle_flag
        if self.found_device_list_flag is not None:
            result['FoundDeviceListFlag'] = self.found_device_list_flag
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.mns_configuration is not None:
            result['MnsConfiguration'] = self.mns_configuration
        if self.ota_event_flag is not None:
            result['OtaEventFlag'] = self.ota_event_flag
        if self.ota_job_flag is not None:
            result['OtaJobFlag'] = self.ota_job_flag
        if self.ota_version_flag is not None:
            result['OtaVersionFlag'] = self.ota_version_flag
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.subscribe_flags is not None:
            result['SubscribeFlags'] = self.subscribe_flags
        if self.thing_history_flag is not None:
            result['ThingHistoryFlag'] = self.thing_history_flag
        if self.type is not None:
            result['Type'] = self.type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('ConsumerGroupIds') is not None:
            self.consumer_group_ids = m.get('ConsumerGroupIds')
        if m.get('DeviceDataFlag') is not None:
            self.device_data_flag = m.get('DeviceDataFlag')
        if m.get('DeviceLifeCycleFlag') is not None:
            self.device_life_cycle_flag = m.get('DeviceLifeCycleFlag')
        if m.get('DeviceStatusChangeFlag') is not None:
            self.device_status_change_flag = m.get('DeviceStatusChangeFlag')
        if m.get('DeviceTagFlag') is not None:
            self.device_tag_flag = m.get('DeviceTagFlag')
        if m.get('DeviceTopoLifeCycleFlag') is not None:
            self.device_topo_life_cycle_flag = m.get('DeviceTopoLifeCycleFlag')
        if m.get('FoundDeviceListFlag') is not None:
            self.found_device_list_flag = m.get('FoundDeviceListFlag')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('MnsConfiguration') is not None:
            self.mns_configuration = m.get('MnsConfiguration')
        if m.get('OtaEventFlag') is not None:
            self.ota_event_flag = m.get('OtaEventFlag')
        if m.get('OtaJobFlag') is not None:
            self.ota_job_flag = m.get('OtaJobFlag')
        if m.get('OtaVersionFlag') is not None:
            self.ota_version_flag = m.get('OtaVersionFlag')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('SubscribeFlags') is not None:
            self.subscribe_flags = m.get('SubscribeFlags')
        if m.get('ThingHistoryFlag') is not None:
            self.thing_history_flag = m.get('ThingHistoryFlag')
        if m.get('Type') is not None:
            self.type = m.get('Type')
        return self


class UpdateSubscribeRelationResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateSubscribeRelationResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateThingModelRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None, identifier=None, thing_model_json=None,
                 function_block_id=None, function_block_name=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.identifier = identifier  # type: str
        self.thing_model_json = thing_model_json  # type: str
        self.function_block_id = function_block_id  # type: str
        self.function_block_name = function_block_name  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')

    def to_map(self):
        _map = super(UpdateThingModelRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.identifier is not None:
            result['Identifier'] = self.identifier
        if self.thing_model_json is not None:
            result['ThingModelJson'] = self.thing_model_json
        if self.function_block_id is not None:
            result['FunctionBlockId'] = self.function_block_id
        if self.function_block_name is not None:
            result['FunctionBlockName'] = self.function_block_name
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('Identifier') is not None:
            self.identifier = m.get('Identifier')
        if m.get('ThingModelJson') is not None:
            self.thing_model_json = m.get('ThingModelJson')
        if m.get('FunctionBlockId') is not None:
            self.function_block_id = m.get('FunctionBlockId')
        if m.get('FunctionBlockName') is not None:
            self.function_block_name = m.get('FunctionBlockName')
        return self


class UpdateThingModelResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateThingModelResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class UpdateThingScriptRequest(TeaModel):
    def __init__(self, iot_instance_id=None, product_key=None, script_content=None, script_type=None):
        self.iot_instance_id = iot_instance_id  # type: str
        self.product_key = product_key  # type: str
        self.script_content = script_content  # type: str
        self.script_type = script_type  # type: str

    def validate(self):
        self.validate_required(self.product_key, 'product_key')
        self.validate_required(self.script_content, 'script_content')
        self.validate_required(self.script_type, 'script_type')

    def to_map(self):
        _map = super(UpdateThingScriptRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.script_content is not None:
            result['ScriptContent'] = self.script_content
        if self.script_type is not None:
            result['ScriptType'] = self.script_type
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('ScriptContent') is not None:
            self.script_content = m.get('ScriptContent')
        if m.get('ScriptType') is not None:
            self.script_type = m.get('ScriptType')
        return self


class UpdateThingScriptResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(UpdateThingScriptResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


class WriteDevicesHotStorageDataRequest(TeaModel):
    def __init__(self, device_name=None, iot_id=None, iot_instance_id=None, items=None, product_key=None,
                 user_topic=None):
        self.device_name = device_name  # type: str
        self.iot_id = iot_id  # type: str
        self.iot_instance_id = iot_instance_id  # type: str
        self.items = items  # type: str
        self.product_key = product_key  # type: str
        self.user_topic = user_topic  # type: str

    def validate(self):
        self.validate_required(self.iot_instance_id, 'iot_instance_id')
        self.validate_required(self.items, 'items')
        self.validate_required(self.user_topic, 'user_topic')

    def to_map(self):
        _map = super(WriteDevicesHotStorageDataRequest, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.device_name is not None:
            result['DeviceName'] = self.device_name
        if self.iot_id is not None:
            result['IotId'] = self.iot_id
        if self.iot_instance_id is not None:
            result['IotInstanceId'] = self.iot_instance_id
        if self.items is not None:
            result['Items'] = self.items
        if self.product_key is not None:
            result['ProductKey'] = self.product_key
        if self.user_topic is not None:
            result['UserTopic'] = self.user_topic
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('DeviceName') is not None:
            self.device_name = m.get('DeviceName')
        if m.get('IotId') is not None:
            self.iot_id = m.get('IotId')
        if m.get('IotInstanceId') is not None:
            self.iot_instance_id = m.get('IotInstanceId')
        if m.get('Items') is not None:
            self.items = m.get('Items')
        if m.get('ProductKey') is not None:
            self.product_key = m.get('ProductKey')
        if m.get('UserTopic') is not None:
            self.user_topic = m.get('UserTopic')
        return self


class WriteDevicesHotStorageDataResponse(TeaModel):
    def __init__(self, code=None, error_message=None, request_id=None, success=None):
        self.code = code  # type: str
        self.error_message = error_message  # type: str
        self.request_id = request_id  # type: str
        self.success = success  # type: bool

    def validate(self):
        self.validate_required(self.code, 'code')
        self.validate_required(self.error_message, 'error_message')
        self.validate_required(self.request_id, 'request_id')
        self.validate_required(self.success, 'success')

    def to_map(self):
        _map = super(WriteDevicesHotStorageDataResponse, self).to_map()
        if _map is not None:
            return _map

        result = dict()
        if self.code is not None:
            result['Code'] = self.code
        if self.error_message is not None:
            result['ErrorMessage'] = self.error_message
        if self.request_id is not None:
            result['RequestId'] = self.request_id
        if self.success is not None:
            result['Success'] = self.success
        return result

    def from_map(self, m=None):
        m = m or dict()
        if m.get('Code') is not None:
            self.code = m.get('Code')
        if m.get('ErrorMessage') is not None:
            self.error_message = m.get('ErrorMessage')
        if m.get('RequestId') is not None:
            self.request_id = m.get('RequestId')
        if m.get('Success') is not None:
            self.success = m.get('Success')
        return self


